#include <bits/stdc++.h>
   
using namespace std;
   
typedef long long ll;
 
vector <pair <int, int>> get_valid(int n, vector <vector <int>> &f) {
    vector <pair <int, int>> tr;
    int uk = 0;
    for (int i = n - 1; i >= 0; --i) {
        int last = uk;
        while (uk < n && f[i][uk] == 0) ++uk;
        //if (uk - 1 >= 0) tr.push_back({i, uk - 1});
        for (int j = last; j < uk; ++j) tr.push_back({i, j});
    }
    return tr;
}
 
mt19937 rnd(123);
 
vector <pair <int, int>> play_game(int n, int k, int m, string s) {
    vector <pair <int, int>> ans;
    vector <vector <int>> f(n, vector <int> (n));
    function <void(int, int)> pt = [&] (int x, int y) {
        if (f[x][y]) return;
        f[x][y] = 1;
        if (x + 1 < n && !f[x + 1][y]) pt(x + 1, y);
        if (y + 1 < n && !f[x][y + 1]) pt(x, y + 1);
    };
    //cout << "play" << endl;
    int uk = 0;
    int cnt_games = 0;
    int last = 0;
    while (uk < m) {
        int t = cnt_games % 2;
        ++cnt_games;
        for (int i = 0; i < n; ++i) for (int j = 0; j < n; ++j) f[i][j] = 0;
        while (true) {
            if (t == 0) {
                auto cr = get_valid(n, f);
                /*cout << "new it" << endl;
                for (auto p : cr) {
                    cout << p.first + 1 << ' ' << p.second + 1 << endl;
                }
                cout << endl;*/
                int go_x = -1, go_y = -1;
                if (cr.size() == 1) {
                    go_x = cr[0].first, go_y = cr[0].second;
                } else {
                    int b = 0;
                    while ((1 << b) <= (int)cr.size()) ++b;
                    --b;
                    b = min(b, m - uk);
                    //cout << "aaa " << b << endl;
                    if (b <= 0) {
                        go_x = 0, go_y = 0;
                    } else {
                        int need = 0;
                        for (int i = 0; i < b; ++i) {
                            if (s[uk + i] == '1') need |= (1 << i);
                        }
                        uk += b;
                        go_x = cr[need].first, go_y = cr[need].second;
                        //cout << "aaa " << need << ' ' << b << endl;
                    } 
                }
                #ifndef LOCAL
                cout << go_x + 1 << ' ' << go_y + 1 << endl;
                #endif
                //cout << go_x + 1 << ' ' << go_y + 1 << endl;
                ans.push_back({go_x, go_y});
                pt(go_x, go_y);
                if (go_x == 0 && go_y == 0) break;
            } else {
                int x = -1, y = -1;
                #ifndef LOCAL
                cin >> x >> y;
                --x, --y;
                #else
                for (int i = n - 1; i >= 0; --i) {
                    for (int j = n - 1; j >= 0; --j) {
                        if (f[i][j] == 0 && (x == -1 || rnd() % 5 == 0)) {
                            x = i, y = j;
                        }
                    }
                }
                #endif
                ans.push_back({x, y});
                pt(x, y);
                //cout << x + 1 << ' ' << y + 1 << endl;
                if (x == 0 && y == 0) break;
            }   
            t ^= 1;
        }
        last = uk;
    }
    if (cnt_games % 2 == 0) {
        #ifndef LOCAL
        cout << 0 << endl;
        #endif
        return ans;
    } else {
        #ifndef LOCAL
        int x, y;
        cin >> x >> y;
        cout << 0 << endl;
        #endif
        return ans;
    }
}
 
string get_string(int n, int k, int m, vector <pair <int, int>> tr) {
    vector <vector <int>> f(n, vector <int> (n));
    function <void(int, int)> pt = [&] (int x, int y) {
        if (f[x][y]) return;
        f[x][y] = 1;
        if (x + 1 < n && !f[x + 1][y]) pt(x + 1, y);
        if (y + 1 < n && !f[x][y + 1]) pt(x, y + 1);
    };
    int cnt_games = 0;
    string ans;
    int uk_t = 0;
    //cout << "gogo" << endl;
    while ((int)ans.size() < m) {
        int t = cnt_games % 2;
        for (int i = 0; i < n; ++i) for (int j = 0; j < n; ++j) f[i][j] = 0;
        //cout << t << endl;
        ++cnt_games;
        while (true) {
            //if (uk_t > tr.size()) while (true) {}
            assert(uk_t < tr.size());
            int go_x = tr[uk_t].first, go_y = tr[uk_t].second;
            ++uk_t;
            if (t == 0) {
                auto cr = get_valid(n, f);
                /*cout << "new jt" << endl;
                for (auto p : cr) {
                    cout << p.first + 1 << ' ' << p.second + 1 << endl;
                }*/
                if (cr.size() != 1) {
                    int b = 0;
                    while ((1 << b) <= (int)cr.size()) ++b;
                    --b;
                    b = min(b, m - (int)ans.size());
                    //cout << "bbb " << b << endl;
                    int id = -1;
                    for (int i = 0; i < (int)cr.size(); ++i) {
                        if (cr[i] == make_pair(go_x, go_y)) {
                            id = i;
                        }
                    }
                    //cout << "bbb " << id << endl;
                    for (int i = 0; i < b; ++i) {
                        if (id & (1 << i)) ans += '1';
                        else ans += '0';
                    }
                    //cout << ans << endl;
                }
            }
            //cout << go_x + 1 << ' ' << go_y + 1 << endl;
            pt(go_x, go_y);
            t ^= 1;
            if (go_x == 0 && go_y == 0) break;
        }
    }
    return ans;
}
 
void stress() {
    int tt = 10000;
    while (tt--) {
        int n = 10, k = 228, m = 10000;
        string s;
        for (int i = 0; i < m; ++i) s += char('0' + rnd() % 2);
        auto t = play_game(n, k, m, s);
        //cout << s << endl;
        /*for (auto p : t) {
            cout << p.first + 1 << ' ' << p.second + 1 << endl;
        }*/
        int rofl = 0;
        for (auto p : t) if (p.first == 0 && p.second == 0) ++rofl;
        //cout << rofl << endl;
        assert(get_string(n, k, m, t) == s);
        if (tt % 10 == 0) {
            cout << tt << endl;
        }
    }
    exit(0);
}
 
void run() {
    int t, n, k, m;
    cin >> t >> n >> k >> m;
    if (t == 1) {
        string s;
        cin >> s;
        auto ans = play_game(n, k, m, s);
    } else {
        int cnt;
        cin >> cnt;
        vector <pair <int, int>> tr;
        for (int i = 0; i < cnt; ++i) {
            while (true) {
                int x, y;
                cin >> x >> y;
                --x, --y;
                tr.push_back({x, y});
                if (x == 0 && y == 0) break;
            }
        }
        cout << get_string(n, k, m, tr) << endl;
    }
}
 
int main() {
    //freopen("/tmp/game.in", "r", stdin); 
    //freopen("/tmp/game.out", "w", stdout);
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    #endif
    //stress();
    run();
}