#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
constexpr int MAXK = 26;
constexpr int MAXN = (int)1e4;
string matr[MAXK];
bool dp[MAXN][MAXN + 1];
string dp1[MAXN + 1];

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i)
		cin >> matr[i];
	string s;
	cin >> s;

	for (int i = 0; i < n; ++i)
		dp[i][1] = true;
	for (int len = 2; len <= n; ++len) {
		for (int i = 0; i + len <= n; ++i) {
			dp[i][len] = false;
			for (int j = 1; j < len; ++j) {
				if (matr[s[i] - 'a'][s[i + j] - 'a'] == '1' && dp[i][j] && dp[i + j][len - j]) {
					dp[i][len] = true;
					break;
				}
			}
		}
	}

	for (int i = 0; i < n; ++i)
		dp1[i] = s.substr(i);
	for (int i = n - 1; i >= 0; --i) {
		for (int j = i + 1; j <= n; ++j) {
			if (!dp[i][j - i])
				continue;
			if (dp1[i] > s[i] + dp1[j])
				dp1[i] = s[i] + dp1[j];
		}
	}
	cout << dp1[0];

	return 0;
}