#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
constexpr int MAXN = (int)5e5;
constexpr int MAXK = 26;
string matr[MAXK];

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i)
		cin >> matr[i];
	string s;
	cin >> s;

	if (k == 1) {
		if (matr[0][0] == '1')
			cout << s[0];
		else
			cout << s;
	} else if (k == 2) {
		if (matr[1][1] == '1') {
			string buf;
			for (const char &c : s) {
				if (c == 'a') {
					buf.push_back('a');
				} else {
					if (buf.empty() || buf.back() == 'a')
						buf.push_back(c);
				}
			}
			n = buf.length();
			swap(buf, s);
		}

		if (matr[0][1] == '1') {
			bool found = false;
			string buf;
			for (const char &c : s) {
				if (c == 'a')
					found = true;
				if (!found && c == 'a')
					buf.push_back(c);
			}
			n = buf.length();
			swap(s, buf);
		}

		if (matr[1][0] == '1') {
			int ind = -1;
			for (int i = 0; i < n; ++i)
				if (s[i] == 'b')
					ind = i;
			if (ind != -1) {
				while (ind + 1 < n) {
					--n;
					s.pop_back();
				}
			}
		}
		
		if (matr[0][0] == '1') {
			while (n >= 2 && s[n - 1] == 'a' && s[n - 2] == 'a') {
				s.pop_back();
				--n;
			}
		}

		cout << s;
	}

	return 0;
}