#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    string s;
    cin >> n >> m >> s;
    vector<vector<int>> good(n), pos_bad(m);
    vector<int> bad(n);
    queue<int> can_use;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            --a;
            if (s[a] == c)
                good[i].push_back(a);
            else {
                ++bad[i];
                pos_bad[a].push_back(i);
            }
        }
        if (bad[i] == 0)
            can_use.push(i);
    }
    vector<bool> used(m, false);
    vector<int> ans;
    while (!can_use.empty()) {
        int p = can_use.front();
        ans.push_back(p);
        can_use.pop();
        for (int i: good[p]) {
            if (!used[i]) {
                used[i] = true;
                for (int j: pos_bad[i]) {
                    --bad[j];
                    if (bad[j] == 0)
                        can_use.push(j);
                }
            }
        }
    }
    for (bool u: used) {
        if (!u) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i: ans)
        cout << i + 1 << ' ';
}
