#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fs first
#define sc second
#define sz(x) (int)x.size()
#define pb push_back
#define MP make_pair

#ifdef FlameDragon
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(6236);
#endif

const int N = 1e5 + 10;
int n;
vector<int> g[N];
vector<int> doclads[N];
int chosen[N];
int L[N], R[N];

bool ok = true;

void dfs(int v) {
    for (auto u : g[v]) {
        dfs(u);
    }
    if (sz(g[v])) {
        int u = g[v][0];
        L[v] = L[u];
        R[v] = R[u];
    }
    for (auto u : g[v]) {
        for (auto w : g[v]) {
            if (u == w) continue;
            if (max(L[u], L[w]) <= min(R[u], R[w])) {
                ok = false;
            }
        }
        L[v] = min(L[v], L[u]);
        R[v] = max(R[v], R[u]);
    }
}

void check() {
    ok = true;
    dfs(0);
    if (ok) {
        for (int i = 0; i < n; i++) {
            cerr << i << ' ' << L[i] << ' ' << R[i] << endl;
        }
        cout << "Yes\n";
        exit(0);
    }
}


void rec(int pos) {
    if (pos == n) {
        check();
        return;
    }
    if (sz(doclads[pos])) {
        for (int i = 0; i < sz(doclads[pos]); i++) {
            L[pos] = R[pos] = chosen[pos] = doclads[pos][i];
            rec(pos + 1);
        }
    } else {
        rec(pos + 1);
    }
}


signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("inD.txt", "r", stdin);
#endif
    cin >> n;
    for (int i = 0; i < n; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int v;
                cin >> v;
                v--;
                g[i].push_back(v);
            }
        } else {
            int k;
            cin >> k;
            doclads[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> doclads[i][j];
            }
        }
    }
    memset(chosen, -1, sizeof chosen);
    rec(0);
    cout << "No\n";
}
