#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <utility>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    string s;
    cin >> n >> m >> s;
    vector<vector<int>> vec(n);
    vector<vector<pair<int, bool>>> AtThisPosition(m);
    set<pair<int, int>> cards;
    vector<int> wrongs(n, 0);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int pos;
            char symbol;
            cin >> pos >> symbol;
            pos--;
            vec[i].push_back(pos);
            AtThisPosition[pos].push_back({i, symbol == s[pos]});
            if (symbol != s[pos]) {
                wrongs[i]++;
            }
        }
        cards.insert({wrongs[i], i});
    }
    vector<int> ans;
    vector<bool> done(m, false);
    while (!cards.empty()) {
        int wrong, i;
        tie(wrong, i) = *cards.begin();
        cards.erase(cards.begin());
        if (wrong > 0) {
            cout << -1;
            return 0;
        }
        for (auto& j : vec[i]) {
            if (!done[j]) {
                for (auto& h : AtThisPosition[j]) {
                    if (!h.second) {
                        cards.erase({wrongs[h.first], h.first});
                        wrongs[h.first]--;
                        cards.insert({wrongs[h.first], h.first});
                    }
                }
                done[j] = true;
            }
        }
        ans.push_back(i);
    }
    for (auto& i : ans) {
        cout << i + 1 << ' ';
    }
/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa 2 1 a 2 b
2 1 b 2 a
*/
    return 0;
}
