#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <utility>
#include <algorithm>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int bit(int x, int i) {
    return (x >> i) & 1;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> can(k, vector<bool>(k));
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            can[j][i] = (s[j] == '1');
        }
    }
    string s;
    cin >> s;
    vector<vector<bool>> canDelete(n, vector<bool>(n, false));
    for (int i = 1; i < n; i++) {
        canDelete[i][i] = can[s[i] - 'a'][s[i - 1] - 'a'];
    }
    for (int len = 2; len < n; len++) {
        for (int l = 1; l + len <= n; l++) {
            int r = l + len - 1;
            for (int j = r - 1; j >= l - 1; j--) {
                if (can[s[r] - 'a'][s[j] - 'a'] && (j == r - 1 || canDelete[j + 1][r - 1]) && (j == l - 1 || canDelete[l][j])) {
                    canDelete[l][r] = true;
                    break;
                }
            }
        }
    }
    string ans = "{";
    vector<vector<string>> dp(n, vector<string>(n, "{"));
    for (int i = 0; i < n; i++) {
        dp[i][i] = s[i];
    }
    for (int len = 2; len <= n; len++) {
        for (int i = 0; i + len <= n; i++) {
            int r = i + len - 1;
            if (canDelete[i + 1][r]) {
                dp[i][r] = s[i];
                continue;
            }
            for (int l = i + 1; l <= r; l++) {
                if (l == i + 1 || canDelete[i + 1][l - 1]) {
                    dp[i][r] = min(dp[i][r], s[i] + dp[l][r]);
                }
            }

        }
    }
    cout << dp[0][n - 1];
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb

3 10
010
000
000
aabbbbcccc
*/
    return 0;
}
