#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <utility>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> can(k, vector<bool>(k));
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            can[j][i] = (s[j] == '1');
        }
    }
    string s;
    cin >> s;
    vector<vector<bool>> canDelete(n, vector<bool>(n, false));
    for (int i = 1; i < n; i++) {
        canDelete[i][i] = can[s[i] - 'a'][s[i - 1] - 'a'];
    }
    for (int len = 2; len < n; len++) {
        for (int l = 1; l + len <= n; l++) {
            int r = l + len - 1;
            for (int j = r - 1; j >= l - 1; j--) {
                if (can[s[r] - 'a'][s[j] - 'a'] && (j == r - 1 || canDelete[j + 1][r - 1]) && (j == l - 1 || canDelete[l][j])) {
                    canDelete[l][r] = true;
                    break;
                }
            }
        }
    }
    vector<string> dp(n, "{");
    dp[0] = s[0];
    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (j == i - 1 || canDelete[j + 1][i - 1]) {
                dp[i] = min(dp[i], dp[j] + s[i]);
            }
        }
    }
    string ans = "{";
    for (int i = 0; i < n; i++) {
        if (i == n - 1 || canDelete[i + 1][n - 1]) {
            ans = min(ans, dp[i]);
        }
    }
    cout << ans;
    /*
    vector<vector<string>> dp(n, vector<string>(27, "{"));
    dp[0][s[0]] = dp[0][26] = s0[0];
    for (int i = 1; i < n; i++) {
        int c = s[i];
        for (int j = i - 1; j >= 0; j--) {
            if (canDelete[j + 1][i]) {
                for (int t = 0; t < 26; t++) {
                    dp[i][t] = min(dp[i][t], dp[j][t]);
                    dp[i][26] = min(dp[i][26], dp[i][t]);
                }
            }
        }
        dp[i][c] = min(dp[i][c], dp[i - 1][26] + s0[i]);
        dp[i][26] = min(dp[i][26], dp[i][c]);
    }
    for (int i = 0; i < n; i++) {
        cout << "\ni == " << i << "\n";
        for (int j = 0; j < 27; j++) {
            cout << j << ": " << dp[i][j] << "\n";
        }
    }
    cout << "\n";
    cout << dp.back().back();
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/
    return 0;
}
