#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int can_clear(string s, vector<string> &a)
{
    while (s.size() > 1)
    {
        int pnt = s.size() - 1;
        while (pnt - 1 >= 0 && '0' == a[s[pnt - 1] - 'a'][s[pnt] - 'a'])
        {
            pnt--;
        }
        if (pnt == 0)
            return 0;
        while (pnt + 1 < s.size())
        {
            s[pnt] = s[pnt + 1];
            pnt++;
        }
        s.pop_back();
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int k, n;
    cin >> k >> n;
    vector<string> a(k);
    for (int i = 0; i < k; i++) cin >> a[i];

    string s;
    cin >> s;

    vector<string> dp(n);
    for (int i = n - 1; i >= 0; i--)
    {
        for (int j = i; j < n; j++) dp[i] += s[j];
        if (can_clear(dp[i], a))
        {
            dp[i] = "";
            dp[i] += s[i];
            continue;
        }
        string st = "";
        st += s[i];
        for (int pos = i + 1; pos < n; pos++)
        {
            if (can_clear(st, a)) dp[i] = min(dp[i], s[i] + dp[pos]);
            st += s[pos];
        }
    }
    cout << dp[0];
}
