#include <bits/stdc++.h>
#define cpair pair <int, char>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    string s; cin >> s;

    vector <pair <vector <cpair>, int> > lines(n);
    for (int i = 0; i < n; i++)
    {
        lines[i].second = i;
        int k; cin >> k;
        for (int j = 0; j < k; j++)
        {
            char ch; int p;
            cin >> p >> ch;
            lines[i].first.push_back({p - 1, ch});
        }
    }

    function <bool (vector<cpair>&, vector<cpair>&) > inter = [&](vector<cpair>&lhs, vector<cpair>& rhs) -> bool
    {
        vector <char> temp(m, ' ');
        for (auto p : lhs)
            temp[p.first] = p.second;
        for (auto p : rhs)
            if (s[p.first] == p.second && temp[p.first] != ' ' && temp[p.first] != p.second)
                return false;
        return true;
    };

    sort(lines.begin(), lines.end(), [&](auto& lhs, auto& rhs)
         {
             return inter(lhs.first, rhs.first) && !inter(rhs.first, lhs.first);
         });

    vector <int> ans;
    vector <bool> used(m, false);

    for (int i = 0; i < n; i++)
    {
        auto line = lines[i].first;
        bool good = true;
        for (auto p : line)
            if (!used[p.first] && s[p.first] != p.second)
            {
                good = false;
                break;
            }
        if (good)
        {
            ans.push_back(lines[i].second + 1);
            for (auto p : line)
                used[p.first] = true;
        } else
        {
            cout << "-1\n", exit(0);
        }
    }

    if (count(used.begin(), used.end(), true) == used.size())
    {
        copy(ans.begin(), ans.end(), ostream_iterator <int> (cout, " "));
        cout << "\n";
    } else
        cout << "-1\n";
}
