#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include<string>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<unordered_map>
#include <iomanip>
#include<unordered_set>
#include<random>
//#define int long long
using namespace std;
void solve1() {
	int n, k, m;
	cin >> n >> k >> m;
	string s;
	cin >> s;
	vector<vector<int>> a(n, vector<int>(n, 0));
	int turn = 1, curlen = 0, turns = 0;
	while (1) {
		if (turn == 0) {
			int j, i;
			cin >> j >> i;
			--j, --i;
			if (j == i && j == 0) {
				a.assign(n, vector<int>(n, 0));
				turns = 0;
			}
			else {
				for (int x = i; x < n; ++x) {
					for (int y = j; y < n; ++y) {
						a[x][y] = 1;
					}
				}
			}
			if (turns <= 1 && curlen == m) {
				cout << 0 << '\n';
				cout.flush();
				return;
			}
			turns++;
			turn = 1;
			continue;
		}
		int hsh = 0, lastlen = 0;
		int ii = -1, ij = -1;
		for (int len = 1; curlen + len - 1 < m; ++len) {
			hsh *= 2;
			hsh += (s[curlen + len - 1] - '0');
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if (i * j != hsh) continue;
					if (a[i][j] == 0) {
						lastlen = len;
						ii = i;
						ij = j;
					}
				}
			}
		}
		if (ii == -1) {
			ii = 0;
			ij = 0;
		}
		cout << ii + 1 << ' ' << ij + 1 << '\n';
		cout.flush();
		if (ii == 0 && ij == 0) {
			a.assign(n, vector<int>(n, 0));
			turns = 0;
		}
		else {
			curlen += lastlen;
			for (int i = ii; i < n; ++i) {
				for (int j = ij; j < n; ++j) {
					a[i][j] = 1;
				}
			}
			turns++;
		}
		turn = 0;
	}
}
void solve2() {
	int n, k, m;
	cin >> n >> k >> m;
	int games, turn = 1;
	cin >> games;
	string ans = "";
	int i, j;
	while (cin >> i >> j) {
		--j, --i;
		if (turn == 0) {
			turn = 1;
			continue;
		}
		int x = i * j;
		string cur = "";
		while (x > 0) {
			cur.push_back(x % 2 + '0');
			x /= 2;
		}
		if (cur.empty()) cur.push_back('0');
		reverse(cur.begin(), cur.end());
		for (auto x : cur) ans.push_back(x);
		turn = 0;
	}
	cout << ans << '\n';
	cout.flush();
	return;
}
signed main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int T;
	cin >> T;
	if (T == 1) {
		solve1();
	}
	else {
		solve2();
	}
	return 0;
} 