#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vi> a(n), b(n);
    vector <bool> word(m, 0);
    forn(i, n) {
        int k;
        cin >> k;
        forn(j, k) {
            int x;
            char y;
            cin >> x >> y;
            --x;
            word[x] = 1;
            b[i].eb(x);
            if (y != s[x]) {
                a[i].eb(x);
            }
        }
    }
    forn(i, m) {
        if (!word[i]) {
            cout << "-1";
            return;
        }
    }
    vector <int> order;
    vector <bool> deleted1(m, 0), deleted2(n, 0);
    while(true) {
        int pos = -1;
        forn(i, n) {
            if (deleted2[i]) {continue;}
            bool can = 1;
            for (auto u : a[i]) {
                if (!deleted1[u]) {
                    can = 0;
                    break;
                }
            }
            if (can) {
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            break;
        }
        deleted2[pos] = 1;
        order.eb(pos + 1);
        for (auto u : b[pos]) {
            deleted1[u] = 1;
        }
    }
    if (sz(order) != n) {
        cout << "-1";
    } else {
        cout << order;
    }
}

signed main() {
    IO();
    Solve();
    return 0;
}