#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 26;
const int MAXE = 25;

bool can[MAXN][MAXN];
vi adj[MAXE];
bool canEnd[MAXE];
vi a;
int cnt[MAXE];

bool Check(vi a) {
    if (!can[a[0]][a[1]]) {
        return false;
    }
    int fi = a[0];
    a.erase(a.begin());
    point:
    for (int i = sz(a) - 1; i > 0; --i) {
        if (can[a[i - 1]][a[i]]) {
            a.erase(a.begin() + i);
            goto point;
        }
    }
    for(auto u : a) {
        if (!can[fi][u]) {
            return false;
        }
    }
    return true;
}

void Solve() {
    int k, n;
    cin >> k >> n;
    forn(i, k) {
        forn(j, k) {
            char x;
            cin >> x;
            can[i][j] = (x - '0');
        }
    }
    forn(i, n) {
        char x;
        cin >> x;
        a.eb(x - 'a');
    }
    point:
    for (int i = 1; i < sz(a); ++i) {
        vi now;
        for (int j = i - 1; j < sz(a); ++j) {
            now.eb(a[j]);
        }
        if (Check(now)) {
            int x = sz(a);
            for (int k = i; k < x; ++k) {
                a.pop_back();
            }
            goto point;
            break;
        }
    }
    for (int j = 1; j < sz(a); ++j) {
        if (!can[a[j - 1]][a[j]]) {continue;}
        if (j == sz(a) - 1 || a[j] >= a[j + 1]) {
            a.erase(a.begin() + j);
            goto point;
        }
    }
    for (int i = 1; i < sz(a); ++i) {
        vi now;
        for (int j = i - 1; j < sz(a); ++j) {
            now.eb(a[j]);
        }
        if (Check(now)) {
            int x = sz(a);
            for (int k = i; k < x; ++k) {
                a.pop_back();
            }
            goto point;
            break;
        }
    }
    for (auto u : a) {
        cout << char(u + 'a');
    }
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}
