#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 1e5 + 15;

vi adj[MAXN];
vi can[MAXN];

void Solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int who;
        cin >> who;
        int k;
        cin >> k;
        if (who == 1) {
            forn(j, k) {
                int x;
                cin >> x;
                adj[i].eb(x);
            }
        } else {
            forn(j, k) {
                int x;
                cin >> x;
                can[i].eb(x);
            }
        }
    }
    cout << "Yes";
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}
