#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.end()

void solve1() {
	int n, k, m;
	cin >> n >> k >> m;
	string s;
	cin >> s;
	int st = 0;
	pair<int, int> lt;
	lt = { 10, 10 };
	for (int i{}; i < m;) {
		int t = st;
		bool step = false;
		while (1) {
			if (t & 1) {
				cin >> lt.x >> lt.y;
				if (lt.x == 1 && lt.y == 1) break;
			}
			else {
				if (lt.x == 1 || lt.y == 1 || i == m) {
					cout << "1 1" << endl;
					break;
				}
				if (s[i] == '0') cout << lt.x - 1 << " " << lt.y << endl;
				else cout << lt.x << " " << lt.y - 1 << endl;
				i++;
			}
			t ^= 1;
		}
		st ^= 1;
	}
	cout << 0 << endl;
}

void solve2() {
	int n, k, m;
	cin >> n >> k >> m;
	int q;
	cin >> q;
	vector<int> game(m);
	int gm = 1;
	string ans{};

	for (; gm <= m;) {
		int t = gm & 1;
		int x{}, y{};
		pair<int, int> lt{ 10, 10 };
		while (1) {
			cin >> x >> y;
			if (x == 1 && y == 1) break;
			if (t & 1) {
				if (x == lt.x - 1) ans += "0";
				else ans += "1";
			}
			else {
				lt = { x, y };
			}
			t ^= 1;
		}
		gm++;
	}
	
	cout << ans << endl;

}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int t;
	cin >> t;

	if (t == 1) solve1();
	else solve2();

	return 0;
}