#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

const int N = 10001;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}
int k, n;
bool can[27][27];
int a[N];
bool can_destroy[N][N];

string dp[N];

int main() {
    optimize();

    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        string s; cin >> s;
        for (int j = 0; j < k; ++j) {
            can[j][i] = s[j] == '1';
        }
    }
    string s; cin >> s;
    for (int i = 0; i < n; ++i) a[i] = s[i] - 'a';
    dp[n - 1] = s[n - 1];

    for (int len = 1; len <= n; ++len) {
        for (int i = 0; i < n; ++i) {
            int l = i, r = i + len - 1;
            if (r >= n) break;
            if (len == 1) {
                can_destroy[l][r] = 1;
                continue;
            }
            for (int j = i + 1; j <= r; ++j) {
                can_destroy[l][r] = can_destroy[l][r] || (can_destroy[l][j - 1] && can_destroy[j][r]
                        && can[s[j] - 'a'][s[i] - 'a']);
            }
        }
    }

    for (int i = n - 2; i >= 0; --i) {
        string smin = s[i] + dp[i + 1];
        for (int j = i + 1; j < n; ++j) {
            if (!can_destroy[i][j]) continue;
            smin = min(smin, s[i] + (j == n - 1 ? "" : dp[j + 1]));
        }
//        cout << i << " " << smin << endl;
        dp[i] = smin;
    }

    cout << dp[0] << '\n';


    return 0;
}
