#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;

const char el = '\n';
const int inf = 1000'000'000;

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define firn(i, n) for (int i = 1; i < (int)n; i++)
#define all(v) v.begin(), v.end()
#define x first
#define y second

template<typename T> bool uin(T &a, T b) { if (b < a) { a = b; return true; } return false; }
mt19937 rnd(time(nullptr));

const int N = 100'001;
vector<int> g[N], a[N], ans[N];
vector<int> d[256], fr[256], Q;
vector<vector<int>> msk[N];
void dfs(int v = 0) {
    if (g[v].empty()) return;
    for (auto to : g[v]) {
        dfs(to);
    }
    d[0].resize(Q.size());
    forn(i, Q.size()) d[0][i] = i;
    firn(mask, 1 << (int)g[v].size()) {
        d[mask].assign(Q.size(), inf);
        forn(i, g[v].size()) {
            if (!(mask & (1 << i))) continue;
            for (int j = 0; j < Q.size(); j++) {
                if (ans[g[v][i]][j] == inf) break;
                int it = ans[g[v][i]][j];
                if (uin(d[mask][j], d[mask - (1 << i)][it])) {
                    fr[mask][j] = i;
                }
            }
        }
    }
    msk[v].resize(Q.size());
    forn(i, Q.size()) {
        ans[v][i] = d[(1 << (int)g[v].size()) - 1][i];
        if (ans[v][i] == inf) break;
        int tmp = (1 << (int)g[v].size()) - 1, j = i;
        while(tmp > 0) {
            int u = fr[tmp][j];
            msk[v][i].push_back(g[v][u]);
            j = ans[g[v][u]][j];
            tmp -= 1 << u;
        }
    }
}
vector<int> findAns[N];
void zhfs(int v = 0, int l = 0) {
    if (g[v].empty()) {
        findAns[v].push_back(Q[*lower_bound(all(a[v]), l)]);
        return;
    }
    findAns[v] = msk[v][l];
    for (auto i : findAns[v]) {
        zhfs(i, l);
        l = ans[i][l];
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    forn(i, n) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            g[i].resize(k);
            forn(j, k) {
                cin >> g[i][j];
                g[i][j]--;
            }
        } else {
            int k;
            cin >> k;
            a[i].resize(k);
            forn(j, k) {
                cin >> a[i][j];
                Q.push_back(a[i][j]);
            }
            sort(all(a[i]));
        }
    }
    forn(i, 256) fr[i].resize(Q.size());
    sort(all(Q));
    forn(i, n) {
        ans[i].assign((int)Q.size(), inf);
        forn(j, a[i].size())
            a[i][j] = lower_bound(all(Q), a[i][j]) - Q.begin();
        if (!a[i].empty()) {
            forn(k, Q.size()) {
                int j = lower_bound(all(a[i]), k) - a[i].begin();
                if (j == (int)a[i].size()) break;
                ans[i][k] = a[i][j];
            }
        }
    }
    dfs();
    cout << (ans[0][0] == inf ? "No" : "Yes") << el;
    if (ans[0][0] < inf) {
        zhfs();
        forn(i, n) {
            if (g[i].empty())
                cout << findAns[i][0] << el;
            else {
                for (auto v : findAns[i])
                    cout << v + 1 << ' ';
                cout << el;
            }
        }
    }
    return 0;
}
