#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a)
{
    for (auto& x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int maxN = 100005;
const int smallN = 2003;
const int INF32 = 0x3f3f3f3f;
int n;
int tp[maxN];
vector<int> G[maxN];
int rv[maxN], cv[maxN], V;

int dp[smallN][smallN];
int dq[1 << 8];

void dfs(int v)
{
    if (tp[v] == 1)
    {
        for (int l = 0; l < V; ++l)
        {
            int k = G[v].size();
            fill(dq, dq + (1 << k), INF32);
            dq[0] = -1;
            for (int mask = 1; mask < (1 << k); ++mask)
            {
                for (int i = 0; i < k; ++i) if (mask & (1 << i))
                {
                    int u = G[v][i];
                    int subm = mask ^ (1 << i);
                    chkmin(dq[mask], dp[u][dq[subm]]);
                }
            }
            dp[v][l] = dq[(1 << k) - 1];
        }
    }
    else
    {
        for (int x : G[v])
        {
            dp[v][cv[x]] = v;
        }
    }
    for (int i = V - 1; i >= 0; --i)
        chkmin(dp[v][i], dp[v][i + 1]);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    cin >> n;
    for (int v = 1; v <= n; ++v)
    {
        cin >> tp[v];
        int k;
        cin >> k;
        G[v].resize(k);
        for (int& u : G[v])
            cin >> u;
        if (tp[v] == 2)
        {
            for (int& u : G[v])
                rv[V++] = u;
        }
    }
    sort(rv, rv + V);
    for (int i = 0; i < V; ++i)
        cv[rv[i]] = i;
    memset(dp, 0x3f, sizeof dp);
    dfs(1);
    if (dp[1][0] >= INF32)
    {
        cout << "No\n";
        exit(0);
    }
    cout << "Yes\n";

    return 0;
}