#include <iostream>
#include <vector>
#include <set>

using namespace std;

int k, n, INF = 1e9;
vector <int> s;
bool kek[26][26];
vector <int> nxt;

bool check (int l, int r) {
    if (l == r) return true;
    vector <pair <int, int> > a;
    for (int i = 0; i <= r - l; ++i) {
        a.push_back({i - 1 + l, i + 1 + l});
    }
    a[0].first = -1;
    a.back().second = -1;
    int now = r;
    while (a[0].second != -1) {
        if (now == l)
            return false;
        int q1 = a[now - l].first;
        int q2 = now;
        q1 = s[q1];
        q2 = s[q2];
        if (kek[q1][q2]) {
            int left = a[now - l].first;
            int right = a[now - l].second;
            a[left - l].second = right;
            if (right != -1){
                a[right - l].first = left;
            }
            if (right != -1)
                now = right;
            else
                now = left;
        }
        else {
            now = a[now - l].first;
        }
    }
    return true;
}

int main() {
    int t;
    cin >> t;
    if (t == 1) {
        int n, k, m;
        string s;
        cin >> n >> k >> m >> s;
        int now = 0;
        int game_id = 0;
        while (now < s.size()) {
            int turn = game_id % 2;
            vector <int> a(n + 1, n + 1);
            while (true) {
                int x = 1, y = 1;
                if (turn == 1) {
                    cin >> x >> y;
                }
                else {
                    for (int i = n; i > 0; --i) {
                        int kek;
                        if (now >= s.size()){
                            kek = a[i] - 1;
                        }
                        else
                            kek = a[i] - 1 - (i + a[i] + 1 + s[now] - '0') % 2;
                        if (kek >= 1) {
                            x = i;
                            y = kek;
                            cout << x << " " << y << endl;
                            now++;
                            break;
                        }
                    }
                }
                if (x == 1 && y == 1)
                    break;
                for (int i = x; i <= n; ++i) {
                    a[i] = min(a[i], y);
                }
                turn = (turn + 1) % 2;
            }
            game_id++;
        }
        if (game_id % 2 == 1) {
            int x, y;
            cin >> x >> y;
        }
        cout << 0 << endl;
    }
    if (t == 2) {
        int n, k, m;
        cin >> n >> k >> m;
        int id = 0;
        int now = id;
        int cnt;
        cin >> cnt;
        vector <int> ans;
        for (int i = 0; i < cnt; ++i) {
            int now = i % 2;
            while (true) {
                int a, b;
                cin >> a >> b;
                if (a == 1 && b == 1)
                    break;
                if (now == 0) {
                    ans.push_back((a + b) % 2);
                }
                now = (now + 1) % 2;
            }
        }
        for (int i = 0; i < m; ++i) {
            cout << ans[i];
        }
        cout << endl;
    }
}


