#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);

vector<int> tree;
int K = 0;
vector<string> dp;

void build() {
    tree.resize((1 << (K + 1)), -1);
}

void upd(int i) {
    tree[i + (1 << K)] = i;
    int v = i + (1 << K);
    v /= 2;
    while (v >= 1) {
        if (tree[v] == -1 || dp[i] <= dp[tree[v]]) {
            tree[v] = i;
            v /= 2;
            continue;
        }
        break;
    }
}

int mn_lr(int l, int r, int vl = 0, int vr = (1 << K), int v = 1) {
    if (l >= vr || vl >= r) return -1;
    if (l <= vl && vr <= r) return tree[v];
    int vm = (vl + vr) / 2;
    int k1 = mn_lr(l, r, vl, vm, 2 * v);
    int k2 = mn_lr(l, r, vm, vr, 2 * v + 1);
    if (k1 == -1) return k2;
    if (k2 == -1) return k1;
    if (dp[k1] < dp[k2]) return k1;
    return k2;
}

signed main() {
    fastio
    int k, n;
    cin >> k >> n;
    vector<string> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    string s;
    cin >> s;
    vector<int> can1(n);
    for (int i = 0; i < n; ++i) {
        can1[i] = i;
    }
    stack<int> b;
    b.push(0);
    for (int r = 1; r < n; ++r) {
        while (b.size() >= 1 && a[s[b.top()] - 'a'][s[r] - 'a'] == '0') {
            can1[b.top()] = r - 1;
            b.pop();
        }
        b.push(r);
    }
    while (b.size() >= 1) {
        can1[b.top()] = n - 1;
        b.pop();
    }
    dp.resize(n + 1);
    dp[n] = "";
    K = 0;
    while ((1 << K) < (n + 1)) ++K;
    build();
    upd(n);
    for (int i = n - 1; i >= 0; --i) {
        int ind = mn_lr(i + 1, can1[i] + 2);
        dp[i] = s[i] + dp[ind];
        upd(i);
    }
    cout << dp[0];
}