#include <iostream>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

typedef long long ll;

int main() {
	int n, m; cin >> n >> m;
	string s; cin >> s;
	vector<vector<int>> a(n, vector<int>(m, 0));

	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int pos; cin >> pos;
			pos--;
			char c; cin >> c;

			a[i][pos] = c;
		}
	}

	vector<int> buf(n);
	for (int i = 0; i < n; i++) {
		buf[i] = i;
	}

	do {
		bool flag = true;
		vector<bool> used(m);
		for (auto pos : buf) {
			for (int i = 0; i < m; i++) {
				if (a[pos][i] == 0)
					continue;
				if (a[pos][i] == s[i])
					used[i] = true;
				if (a[pos][i] != s[i] && !used[i]) {
					flag = false;
				}
			}
		}

		for (auto c : used) {
			if (!c) {
				flag = false;
			}
		}

		if (flag) {
			for (auto c : buf) {
				cout << c + 1 << ' ';
			}
			return 0;
		}

	} while (next_permutation(buf.begin(), buf.end()));

	cout << -1;

	return 0;
}