#include <iostream>

#include <algorithm>

#include <vector>
#include <string>
#include <unordered_map>
#include <queue>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int k, n; cin >> k >> n;
	vector<vector<char>> can(k, vector<char>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			cin >> can[i][j];
		}
	}
	string s; cin >> s;


	vector<string> dp(n);

	dp[0] = s[0];

	for (int i = 1; i < n; i++) {
		dp[i] = dp[i - 1] + s[i];

		for (int k = 1; k <= i; k++) {
			for (int j = i - k; j >= 0; j--) {
				if (can[s[j] - 'a'][s[j + 1] - 'a'] == '1') {
					string buf = "";
					for (int q = i - k + 2; q <= i; q++) {
						buf += s[q];
					}

					while (buf.size() > 0 && can[s[j] - 'a'][buf[0] - 'a'] == '1') {
						buf.erase(buf.begin());
						dp[i] = min(dp[i], dp[j] + buf);
					}

					if (buf.size() > 0 && can[s[j] - 'a'][buf[0] - 'a'] == '1')
						buf.erase(buf.begin());

					dp[i] = min(dp[i], dp[j] + buf);

				}
				else {
					break;
				}
			}
		}
	}

	cout << dp.back();

	return 0;
}