#include <bits/stdc++.h>

using namespace std;

vector<int> ans;


void add(pair<int, int> &v, set<pair<int, int>> &nb, vector<int> &used, vector<vector<pair<int, int>>> &all, vector<vector<pair<int, int>>> &all_n, vector<int> &cnt_need)
{
    int nm = v.second;
    for (auto &p : all_n[nm])
    {
        if (used[p.second] == 0)
        {
            used[p.second] = 1;
            for (int i = 0; i < (int)all[p.second].size(); i++)
            {
                if (all[p.second][i].first != p.first)
                {
                    auto it = nb.lower_bound({cnt_need[all[p.second][i].second], all[p.second][i].second});
                    nb.erase(it);
                    cnt_need[all[p.second][i].second]--;
                    nb.insert({cnt_need[all[p.second][i].second], all[p.second][i].second});
                }
            }
        }
    }
    ans.push_back(v.second);
}


int main()
{
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<vector<pair<int, int>>> all(m);
    vector<vector<pair<int, int>>> all_n(n);
    vector<int> used(m);
    vector<int> cnt_need(n);

    for (int i = 0; i < n; i++)
    {
        int k; cin >> k;
        cnt_need[i] = k;
        vector<pair<int, int>> lc;
        for (int j = 0; j < k; j++)
        {
            int a; char c; cin >> a >> c;
            all[a - 1].push_back({c - 'a', i});
            lc.push_back({c - 'a', a - 1});
        }
        for (int j = 0; j < (int)lc.size(); j++)
            if ((s[lc[j].second] - 'a') == lc[j].first)
                cnt_need[i]--;
        all_n[i] = lc;
    }
    set<pair<int, int>> nb;

    for (int i = 0; i < n; i++)
        nb.insert({cnt_need[i], i});

    while (!nb.empty())
    {
        auto v = *nb.begin();
        nb.erase(nb.begin());
        if (v.first != 0)
        {
            cout << -1 << endl;
            return 0;
        }
        add(v, nb, used, all, all_n, cnt_need);
    }

    bool check = true;
    for (int i = 0; i < m; i++)
        if (used[i] == 0)
            check = false;

    if (!check)
        cout << -1 << endl;
    else
    {
        for (int i = 0; i < (int)ans.size(); i++)
            cout << ans[i] + 1 << " ";
        cout << endl;
    }

    return 0;
}
