#define GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ll long long
#define X first
#define Y second
using namespace std;

int k, n;
vector<vector<int>> t;

bool ok(char a, char b) {
    return t[a - 'a'][b - 'a'];
}

bool cmp(string &a, string &b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i)
        if (a[i] != b[i])
            return a[i] < b[i];
    return a.size() < b.size();
}

bool cmp2(pair<string, int> &a, pair<string, int> &b) {
    if (cmp(a.X, b.X) || cmp(b.X, a.X))
        return cmp(a.X, b.X);
    return a.Y < b.Y;
}

vector<int> solve(string s) {
    vector<int> f(n);
    for (int i = n - 1; i >= 0; --i) {
        f[i] = n - i - 1;
        for (int j = i + 1; j < n; ++j) {
            if (!ok(s[i], s[j])) {
                f[i] = j - i - 1;
                break;
            }
            else {
                j += f[j];
            }
        }
    }
    for (int i = n - 1; i >= 1; --i)
        swap(f[i], f[i - 1]);
    f[0] = 0;
    vector<int> del(n);
    for (int i = n - 1; i >= 1; --i) {
        vector<pair<string, int>> v;
        for (int j = 0; j <= f[i]; ++j) {
            string add;
            add += s[i - 1];
            for (int jj = i + j; jj < n; ++jj)
                if (!del[jj])
                    add += s[jj];
            v.push_back({ add, i + j });
        }
        if (v.size() == 0)
            continue;
        auto pp = *min_element(all(v), cmp2);
        for (int j = i; j < pp.Y; ++j)
            del[j] = 1;
    }
    return del;
}

signed main() {
    cin >> k >> n;
    t.resize(k, vector<int>(k));
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            t[i][j] = c - '0';
        }
    string s;
    cin >> s;
    string w;
    w += s[0];
    for (int i = 1; i < s.size(); ++i)
        if (s[i] != w.back())
            w += s[i];
    int n1 = n;
    n = w.size();
    vector<int> del = solve(w);
    n = n1;
    int j = 0;
    for (int i = 0; i < del.size(); ++i) {
        for (; j < n && s[j] == w[i]; ++j) {
            if (!del[i])
                cout << s[j];
        }
    }
    cout << '\n';
}
