#define GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ll long long
#define X first
#define Y second
using namespace std;

vector<int> _q;
vector<int> par;
vector<vector<int>> ups;
vector<int> ids;
vector<int> nr;
vector<int> sizs;

vector<int> sort(vector<vector<int>> &v) {
    for (int i = 0; i < v.size(); ++i) {
        for (int j = 1; j < v[i].size(); ++j)
            if (v[i][j - 1] > v[i][j])
                return vector<int>();
    }
    vector<pair<pair<int, int>, int>> vv;
    for (int i = 0; i < v.size(); ++i)
        vv.push_back({{ v[i][0], v[i].back() }, i});
    sort(all(vv));
    vector<int> ans;
    for (int i = 0; i + 1 < vv.size(); ++i) {
        if (vv[i].X.Y > vv[i + 1].X.X) {
            return vector<int>();
        }
    }
    for (int i = 0; i < vv.size(); ++i)
        ans.push_back(vv[i].Y);
    return ans;
}

void solve(vector<int> nums) {
    queue<pair<int, int>> q;
    for (int i = 0; i < ids.size(); ++i) {
        q.push({ ids[i], ups[ids[i]][nums[i]] });
    }
    vector<vector<int>> ans(par.size());
    vector<vector<vector<int>>> tup(par.size());
    for (int i = 0; i < par.size(); ++i)
        if (!nr[i]) {
            vector<vector<int>> add(1, vector<int>(1));
            add[0][0] = ups[i][0];
            tup[i] = add;
        }
    while (q.size()) {
        int ver = q.front().X;
        int vec = q.front().Y;
        q.pop();
        if (!nr[ver]) {
            vector<int> ord = sort(tup[ver]);
            if (ord.size() == 0)
                return;
            for (int i : ord)
                ans[ver].push_back(i);
            vector<int> nv;
            for (int i : ord) {
                for (int j : tup[ver][i])
                    nv.push_back(j);
            }
            if (par[ver] != -1) {
                tup[par[ver]].push_back(nv);
                if (tup[par[ver]].size() == sizs[par[ver]])
                    q.push({ par[ver], -1 });
            }
        }
        else if (par[ver] != -1) {
            vector<int> add(1);
            add[0] = vec;
            tup[par[ver]].push_back(add);
        }
    }
    cout << "Yes\n";/*
    int id = 0;
    for (int i = 0; i < par.size(); ++i) {
        if (nr[i]) {
            for (int j : ans[i])
                cout << j + 1 << ' ';
            cout << '\n';
        }
        else {
            cout << ups[ids[id]][nums[id]] << '\n';
            ++id;
        }
    }*/
    exit(0);
}

void gen(vector<int> &sz, vector<int> &ans) {
    if (ans.size() == sz.size()) {
        solve(ans);
        return;
    }
    for (int i = 0; i < sz[ans.size()]; ++i) {
        ans.push_back(i);
        gen(sz, ans);
        ans.pop_back();
    }
}

signed main() {
    int n;
    cin >> n;
    par.resize(n, -1);
    ups.resize(n);
    nr.resize(n);
    sizs.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int go;
                cin >> go;
                --go;
                par[go] = i;
                sizs[i]++;
            }
            nr[i] = 1;
        }
        else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int x;
                cin >> x;
                ups[i].push_back(x);
            }
            _q.push_back(i);
        }
    }
    vector<int> sz;
    for (int i = 0; i < n; ++i) {
        if (!ups[i].size())
            continue;
        sz.push_back(ups[i].size());
        ids.push_back(i);
    }
    vector<int> ans;
    gen(sz, ans);
    cout << "No\n";
}