#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()

int field[40][40];
int n, k, m;

bool gameIsEnded = 0;


void clean() {
    gameIsEnded = 0;
    for(int i = 0; i < 40; i++) {
        for(int j = 0; j < 40; j++) {
            field[i][j] = 0;
        }
    }
}

void put(int x, int y) {
    if (x == 1 && y == 1) {
        gameIsEnded = 1;
    }
    for(int i = x; i <= n; i++) {
        for(int j = y; j <= n; j++) {
            field[i][j] = 1;
        }
    }
}

int get(int x, int y) {
    int ret = 0;
    for(int i = x; i <= n; i++) {
        for(int j = y; j <= n; j++) {
            if (!field[i][j]) {
                ret++;
            }
        }
    }
    return ret;
}

void play() {
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int cntOfGame = 0;
    int pos = 0;
    while (pos < m) {
        int turn = cntOfGame++ % 2 == 0;
        clean();
        while (!gameIsEnded) {
            if (turn) {
                vector<pair<int, int>> all;
                vector<pair<int, int>> turn1;
                for(int i = n; i >= 1; i--) {
                    for(int j = n; j >= 1; j--) {
                        if (!field[i][j] && get(i, j) == 1) {
                            turn1.emplace_back(i, j);
                        }
                        if (!field[i][j]) {
                            all.emplace_back(i, j);
                        }
                    }
                }
                sort(all(turn1));
                if (size(turn1) <= 1 || pos == m) {
                    put(all[0].first, all[0].second);
                    cout << all[0].first << ' ' << all[0].second << endl;
                } else {
                    if (s[pos++] == '1') swap(turn1[0], turn1.back());
                    put(turn1[0].first, turn1[0].second);
                    cout << turn1[0].first << ' ' << turn1[0].second << endl;
                }
            } else {
                int x, y;
                cin >> x >> y;
                put(x, y);
            }
            turn ^= 1;
        }

    }
    if (cntOfGame % 2) {
        int x, y;
        cin >> x >> y;
    }
    cout << 0 << endl;
}

void unplay() {
    int n, k, m;
    cin >> n >> k >> m;
    int gamePlayed;
    cin >> gamePlayed;
    string s;
    for(int i = 0; i < gamePlayed; i++) {
        int turn = (i % 2 == 0);
        clean();
        while (!gameIsEnded) {
            if (turn) {
                vector<pair<int, int>> turn1;
                for(int i = n; i >= 1; i--) {
                    for(int j = n; j >= 1; j--) {
                        if (!field[i][j] && get(i, j) == 1) {
                            turn1.emplace_back(i, j);
                        }
                    }
                }
                int x, y;
                cin >> x >> y;
                sort(all(turn1));
                if (size(turn1) > 1) {
                    if (turn1[0].first == x && turn1[0].second == y) {
                        s += '0';
                    } else {
                        s += '1';
                    }
                }
                put(x, y);
            } else {
                int x, y;
                cin >> x >> y;
                put(x, y);
            }
            turn ^= 1;
        }
    }
    cout << s << endl;
}

int main() {
#ifdef LOCAL
  //  freopen("input.txt", "r", stdin);
  //  freopen("output.txt", "w", stdout);
#endif
   // ios::sync_with_stdio(false);
  //  cin.tie(NULL);
    int t;
    cin >> t;
    if (t == 1) play();
    else unplay();
}

