#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
//#pragma GCC target("avx,sse,sse4.1,sse4.2,mmx,abm,popcnt")

vector<vector<int>> possible(26, vector<int> (26));

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			possible[j][i] = c - '0';
		}
	}
	vector<char> s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
		s[i] -= 'a';
	}
	vector<vector<vector<char>>> remove_possible(n + 1, vector<vector<char>>(n + 1, vector<char>(k, 0)));
	for (int i = 0; i < n; ++i) {
		for (int c = 0; c < k; ++c) {
			remove_possible[i][i][c] = 1;
			remove_possible[i + 1][i + 1][c] = 1;
			if (possible[(int)s[i]][c]) {
				remove_possible[i][i + 1][c] = 1;
			} else {
				remove_possible[i][i + 1][c] = 0;
			}
		}
	}
	for (int len = 2; len < n; ++len) {
		for (int seg_beg = 1; seg_beg + len <= n; ++seg_beg) {
			for (int c = 0; c < k; ++c) {
				for (int lst = seg_beg; lst < seg_beg + len; ++lst) {
					remove_possible[seg_beg][seg_beg + len][c] |=
						possible[(int)s[lst]][c] &
						remove_possible[seg_beg][lst][c] &
						remove_possible[lst + 1][seg_beg + len][(int)s[lst]];
				}
			}
//			cout << seg_beg << ':' << (int)remove_possible[seg_beg][seg_beg + len][(int)s[seg_beg - 1]] << ' ';
		}
//		cout << '\n';
	}
	vector<string> dp(n + 1, "{");
	dp[n] = "";
	for (int i = n - 1; i >= 0; --i) {
		dp[i] = (char) ('a' + s[i]) + dp[i + 1];
		if (i == 0) {
			break;
		}
		for (int j = i + 1; j <= n; ++j) {
			if (!remove_possible[i][j][(int)s[i - 1]]) {
				continue;
			}
			dp[i] = min(dp[i], dp[j]);
		}
//		cout << dp[i] << '\n';
	}
	cout << dp[0] << '\n';
}
