#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string> 
#include <cassert>

using namespace std;

#define ll long long
#define FOR(i, Left, Right) for (int i = (Left); i <= Right; ++i)
#define FOR_DOWN(i, Right, Left) for(int i = (Right)l i >= (Left); --i)
#define pii pair <int, int>

const int cnt = 2123456;
int n, m, a;
string s;
vector <int>  per_good[cnt];

vector <int> bad[cnt];
vector <int> ans;
int sum_bad[cnt];

bool used[cnt];
bool good[cnt];
bool res_used[cnt];
vector <int> turn;

int main()
{

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif // _DEBUG

	cin >> n >> m;
	cin >> s;
	char c;
	FOR(j, 1, n)
	{
		int k;
		cin >> k;
		FOR(i, 1, k) {
			cin >> a >> c;
			int h;
			if (c == s[a - 1]) {
				per_good[j].push_back(a);
			}
			else {
				bad[a].push_back(j);
				sum_bad[j]++;
				//per_bad[j].push_back(a);
			}
		}
		if (sum_bad[j] == 0) {
			turn.push_back(j);
			used[j] = 1;
		}
	}

	while (turn.size() != 0)
	{
		int num = *turn.rbegin();
		turn.pop_back();
		ans.push_back(num);
		assert(!res_used[num]);
		res_used[num] = 1;
		for (int g : per_good[num])
		{
			/*
			if (good[g])
				continue;*/
			good[g] = 1;
			for (int pos : bad[g])
			{
				sum_bad[pos]--;
				if (sum_bad[pos] == 0 && !used[pos]) {
					turn.push_back(pos);
					used[pos] = 1;
				}
			}
		}
	}
	assert(ans.size() <= n);
	FOR(i, 1, m)
		if (!good[i])
		{
			cout << -1;
			return 0;
		}
	if (ans.size() != n)
	{
		cout << -1;
		return 0;
	}
	for (int num : ans) {
		cout << num << " ";
	}
	return 0;
}