#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;

using ll = long long;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

ll n, m;
string s;
vector<vector<char>> p;
vector<bool> used;

vector<ll> get(const set<ll> &pos) {
    if (pos.empty()) {
        return {};
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        bool bad = false;
        auto newpos = pos;
        for (auto j: pos) {
            if (p[i][j] == 0) {

            } else if (p[i][j] == s[j]) {
                newpos.erase(j);
            } else {
                bad = true;
                break;
            }
        }
        if (bad) continue;
        used[i] = true;

        auto ans = get(newpos);
        ans.push_back(i);
        used[i] = false;

        return ans;
    }
    return {};
}

void solve() {
    cin >> n >> m;
    cin >> s;
    p.resize(n);
    used.resize(n, false);
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        p[i].resize(m);
        for (int j = 0; j < k; ++j) {
            ll a;
            char c;
            cin >> a >> c;
            p[i][a - 1] = c;
        }
    }
    set<ll> pos;
    for (int i = 0; i < m; ++i) {
        pos.insert(i);
    }
    auto ans = get(pos);
    while (!ans.empty()) {
//        bool bad = false;
//        for (auto e: ans.back()) {
//            if (e == -1) {
//                bad = true;
//                break;
//            }
//        }
//        if (bad) {
//            ans.pop_back();
//            continue;
//        }
        reverse(ans.begin(), ans.end());
        set<ll> have(ans.begin(), ans.end());
        for (int i = 0; i < n; ++i) {
            if (!have.count(i)) {
                ans.push_back(i);
                have.insert(i);
            }
        }
        for (auto e: ans) {
            cout << e + 1 << ' ';
        }
        cout << endl;
        return;
    }
    cout << -1 << endl;
}

//1 1
//a
//1 1 a

//3 4
//glhf
//3 1 r 3 h 4 i
//3 1 r 2 l 3 o
//2 1 g 4 f

//2 2
//aa
//2 1 a 2 b
//2 1 b 2 a

// ----

//3 4
//aaaa
//0
//1 2 a
//4 1 a 2 b 4 a 3 a
