#include <iostream>
#include <vector>
#include <set>

bool deletable(std::string str, int32_t k, bool** allow) {
    std::vector<int32_t> candidates = {0};
    for(int32_t i = 1; i < str.size(); i++) {
        bool ok = false;
        for(int32_t j = candidates.size() - 1; j >= 0; j--)
            if( allow[str[candidates[j]] - 'a'][str[i] - 'a']) {
                ok = true;
                for(int32_t p = candidates.size() - 1; p > j; p--)
                    candidates.pop_back();
                break;
            }
        if(!ok)
            return false;
        candidates.push_back(i);
    }
    return true;
}

int main() {
    int32_t k, n;
    std::cin >> k >> n;

    bool** allow = new bool*[k];
    for(int32_t i = 0; i < k; i++) {
        allow[i] = new bool[k];
        std::string str;
        std::cin >> str;

        for(int32_t j = 0; j < k; j++) {
            allow[i][j] = str[j] == '1';
        }
    }

    std::string str;
    std::cin >> str;

    std::string answer;
    for(int32_t i = 0; i < n;) {
        char obtainable = str[i + 1];
        int32_t to_delete = 0;
        for(int32_t j = 1; j < n - i; j++) {
            if(deletable(str.substr(i, j + 1), k, allow)) {
                if(j == n - i - 1 || str[i + j + 1] <= obtainable) {
                    obtainable = str[i + j + 1];
                    to_delete = j;
                }
            }
        }
        answer.push_back(str[i]);
        i = i + to_delete + 1;
    }
    std::cout << answer;
    return 0;
}