#include <iostream>
#include <vector>
#include <string>
#define int long long

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<bool>> a(n, vector<bool> (m, true));
    vector<vector<bool>> atoclose(n, vector<bool> (m));
    vector<bool> closed(m);
    vector<bool> used(n);
    for (int i(0); i < n; ++i)
    {
        int k;
        cin >> k;
        for (int j(0); j < k; ++j)
        {
            int pos;
            char c;
            cin >> pos >> c;
            pos--;
            if (c != s[pos]) a[i][pos] = false;
            if (c == s[pos]) atoclose[i][pos] = true;
        }
    }
    vector<int> result;
    for (int z(0); z < n; ++z)
    {
        for (int i(0); i < n; ++i)
        {
            if (used[i]) continue;
            bool ok = true;
            for (int j(0); j < m; ++j)
            {
                if (closed[j]) continue;
                if (!a[i][j])
                {
                    ok = false;
                    break;
                }
            }
            if (ok)
            {
                result.push_back(i + 1);
                used[i] = true;
                for (int j(0); j < m; ++j)
                {
                    if (atoclose[i][j]) closed[j] = true;
                }
                break;
            }
        }
    }
    bool all = true;
    for (bool i: closed)
    {
        if (!i)
        {
            all = false;
            break;
        }
    }
    if (all)
    {
        for (int i: result) cout << i << ' ';
        cout << endl;
    }
    else cout << -1 << endl;
    return 0;
}
