#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <iomanip>
#include <bitset>
#include <random>

using namespace std;

#define ll long long
#define pii pair<int,int>
#define BE(v) v.begin(), v.end()
#define endl '\n'
#define pb push_back

const int N = 6e5;
const int bes = 2e9;

vector<int> v[N];
vector<int> m[N];

int ch[N];

int n;
vector<int> p;
vector<int> now[N];
vector<int> por[N];

bool dfs(int i = 0)
{
	if (v[i].empty())
	{
		return true;
	}
	for (int j : v[i])
	{
		if (!dfs(j))
		{
			return false;
		}
	}
	vector<pii> mus;
	for (int j : v[i])
	{
		mus.push_back({ now[j].front(),j });
	}
	sort(BE(mus));
	set<int> v1;
	vector<int> v2;
	now[i].clear();
	por[i].clear();
	for (pii j : mus)
	{
		for (int u : now[j.second])
		{
			v1.insert(u);
			v2.push_back(u);
			now[i].pb(u);
		}
		por[i].push_back(j.second);
	}
	bool eq = true;
	auto it = v1.begin();
	for (int i = 0; i < v2.size(); i++)
	{
		if (v2[i] != *it)
		{
			eq = false;
			break;
		}
		it++;
	}
	return eq;
}

void rec(int ind)
{
	if (ind == p.size())
	{
		bool ok = dfs(0);
		if (ok)
		{
			cout << "Yes" << endl;
			for (int i = 0; i < n; i++)
			{
				if (v[i].size())
				{
					for (int j : por[i])
					{
						cout << j + 1 << " ";
					}
					cout << endl;
				}
				else
				{
					cout << now[i].front() << endl;
				}
			}
			exit(0);
		}
	}
	else
	{
		for (ch[p[ind]] = 0; ch[p[ind]] < m[p[ind]].size(); ch[p[ind]]++)
		{
			now[p[ind]].push_back(m[p[ind]][ch[p[ind]]]);
			rec(ind + 1);
			now[p[ind]].pop_back();
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int k;
			cin >> k;
			for (int j = 0; j < k; j++)
			{
				int a;
				cin >> a;
				a--;
				v[i].pb(a);
			}
		}
		else
		{
			int k;
			cin >> k;
			p.push_back(i);
			for (int j = 0; j < k; j++)
			{
				int a;
				cin >> a;
				m[i].pb(a);
			}
		}
	}
	rec(0);
	cout << "No";
}