#include <bits/stdc++.h>
using namespace std;

int n, k, m;
int a[33][33];

void f(int x, int y) {
    for (int i = x; i <= n; ++x) {
        for (int j = y; j <= n; ++y) {
            a[i][j] = 1;
        }
    }
}

int sum(int x, int y) {
    if (a[x][y] == 1) return -1;
    int cnt = 0;
    for (int i = x; i <= n; ++i) {
        for (int j = y; j <= n; ++j) {
            if (a[i][j] == 0) ++cnt;
        }
    }
    return cnt;
}

void play(int key, int who) {
    memset(a, 0, sizeof(a));
    if (key == 0) {
        if (who) {
            int x, y;
            cin >> x >> y;
        }
        cout << 2 << " " << 2 << endl;
        while (true) {
            int x, y;
            cin >> x >> y;
            if (x == 1 && y == 1) break;
            cout << y << " " << x << endl;
        }
    } else {
        if (who) {
            int x, y;
            cin >> x >> y;
            f(x, y);
        }
        int kekx, keky;
        for (int i = n - 7; i <= n; ++i) {
            for (int j = n - 7; j <= n; ++j) {
                if (sum(i, j) != -1) {
                    kekx = i, keky = j;
                }
            }
        }
        cout << kekx << " " << keky << endl;
        int x, y;
        cin >> x >> y;
        cout << 2 << " " << 2 << endl;
        while (true) {
            int x, y;
            cin >> x >> y;
            if (x == 1 && y == 1) break;
            cout << y << " " << x << endl;
        }
    }
}

void finish() {
    cout << 0 << endl;
    exit(0);
}

int main() {
    int run;
    cin >> run >> n >> k >> m;
    if (run == 1) {
        string s;
        cin >> s;
        for (int i = 0; i < m; ++i) {
            play(s[i] - '0', i % 2);
        }
        finish();
    }

    if (run == 2) {
        int games;
        cin >> games;
        int x, y;
        string ans = "";
        for (int i = 0; i < games; ++i) {
            bool flag = false;
            while (true) {
                cin >> x >> y;
                if (x == n && y == n) flag = true;
                if (x == 1 && y == 1) {
                    break;
                }
            }
            if (flag) {
                ans += "1";
            } else {
                ans += "0";
            }
        }
        cout << ans << endl;
    }
    return 0;
}
