#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

int st[N];

vector < int > g[N];

string s;

queue < int > q;

vector < int > ord;

vector < int > good[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int n, m;

	cin >> n >> m;

	cin >> s;

	s = '0' + s;

	for (int i = 1; i <= n; ++i) {
		int k;
		cin >> k;
		while (k--) {
			int a;
			char c;
			cin >> a >> c;
			if (s[a] != c)
				st[i]++, g[a].push_back(i);
			else
				good[i].push_back(a);
		}
		if (st[i] == 0)
			q.push(i);
	}

	while (!q.empty()) {
		int v = q.front();
		q.pop();
		ord.push_back(v);
		for (int s : good[v]) {
			for (int to : g[s]) {
				st[to]--;
				if (st[to] == 0)
					q.push(to);
			}
			g[s].clear();
		}
	}

	for (int i = 1; i <= n; ++i) {
		if (st[i] != 0) {
			cout << -1;
			return 0;
		}
	}

	for (int i : ord)
		cout << i << ' ';

}