#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
#include <cassert>
#include <map>

using namespace std;

typedef long long ll;

#ifndef _DEBUG
const int N = 500010;
#else
const int N = 100;
#endif
const int LOGN = 20;
const int ALP = 28;

string s;

int h[N];

string pr[32];

map < string, int > b;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	//freopen("Test.txt", "r", stdin);
#endif

	for (int i = 0; i < 32; ++i) {
		for (int j = 4; j >= 0; --j) {
			if ((i >> j) & 1)
				pr[i] += '1';
			else
				pr[i] += '0';
		}
	}

	for (int i = 0; i < 32; ++i) {
		b[pr[i]] = i;
	}

	int type;

	cin >> type;

	int n, m, k;

	cin >> n >> k >> m;

	fill(h, h + n, -1);

	if (type == 1) {
		cin >> s;
		while (s.size() % 5 != 0)
			s.push_back('0');
		int last = 0;
		int f = -1;
		int fh = 0;
		while (true) {
			if (f == -1)
				f = fh;
			if (f == 0) {
				if (last == s.size()) {
					fh ^= 1;
					f = -1;
					cout << "1 1" << endl;
					fill(h, h + n, -1);
					break;
				}
				string t;
				t += s[last];
				t += s[last + 1];
				t += s[last + 2];
				t += s[last + 3];
				t += s[last + 4];
				last += 5;
				int st = b[t];
				if (h[st] < n) {
					h[st]++;
					for (int j = 0; j <= st; ++j)
						h[j] = max(h[j], h[st]);
					cout << (31 - st) + 1 << ' ' << (31 - h[b[t]]) + 1 << endl;
				}
				else {
					fh ^= 1;
					f = -1;
					cout << "1 1" << endl;
					fill(h, h + n, -1);
				}
			}
			else {
				int x, y;
				cin >> x >> y;
				--x, --y;
				if (x == 0 && y == 0) {
					fh ^= 1;
					f = -1;
					fill(h, h + n, -1);
					continue;
				}
				y = 31 - y;
				x = 31 - x;
				for (int j = 0; j <= x; ++j)
					h[j] = max(h[j], y);
			}
			f ^= 1;
		}
	}
	else {
		int q;
		cin >> q;
		int f = -1, fh = 0;
		string s;
		while (q--) {
			while (true) {
				if (f == -1)
					f = fh;
				int x, y;
				cin >> x >> y;
				--x, --y;
				if (f == 0) {
					if (x != 0 || y != 0)
						s += pr[31 - x];
					else {
						f = -1, fh ^= 1;
						break;
					}
				}
				else {
					if (x == 0 && y == 0) {
						f = -1, fh ^= 1;
						break;
					}
				}
				f ^= 1;
			}
		}
		while (s.size() != m)
			s.pop_back();
		cout << s << endl;
	}
	
}