#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

#define endl '\n'

struct Card
{
	vector<int> right;
	vector<int> wrong;
};

void task()
{
	int n, m;
	cin >> n >> m;

	string str;
	cin >> str;

	vector<Card> v(n);

	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;

		for (int j = 0; j < k; j++)
		{
			int pos;
			char sym;


			cin >> pos >> sym;
			pos--;

			if (str[pos] == sym)
			{
				v[i].right.push_back(pos);
			}
			else
			{
				v[i].wrong.push_back(pos);
			}
		}
	}

	set<int> ost;

	for (int i = 0; i < m; i++)
	{
		ost.insert(i);
	}

	bool can = true;

	vector<int> order;
	set<int> were;

	while (can)
	{
		can = false;

		for (int i = 0; i < n; i++)
		{
			if (were.find(i) == were.end())
			{
				bool cur = true;

				for (int j = 0; j < v[i].wrong.size(); j++)
				{
					if (ost.find(v[i].wrong[j]) != ost.end())
					{
						cur = false;
						break;
					}
				}

				if (cur)
				{
					can = true;
					were.insert(i);

					order.push_back(i);

					for (int j = 0; j < v[i].right.size(); j++)
					{
						ost.erase(v[i].right[j]);
					}

					break;

				}
			}
		}
	}

	if (were.size() == n && ost.size() == 0)
	{
		for (int i = 0; i < n; i++)
		{
			cout << order[i] + 1 << ' ';
		}
		cout << endl;
	}
	else
	{
		cout << -1 << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}
