#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

#define endl '\n'

/*struct Node
{
	bool cons;
	vector<int> nums;
	vector<int> to;

	vector<int> allconsleft;
	vector<int> allconsright;
};

vector<Node> graph;

void dfs(int v)
{
	for (int i = 0; i < graph[v].to.size(); i++)
	{
		int u = graph[v].to[i];

		if (graph[u].cons)
		{
			if (i == 0)
			{
				graph[v].allconsleft.push_back(u);
			}
		}
		else
		{
			if (i == 0)
			{
				for (int j = 0; j < graph[u].allconsleft.size(); j++)
				{
					graph[v].allconsleft.push_back(graph[u].allconsleft[j]);
				}

				for (int j = 0; j < graph[u].allconsright.size(); j++)
				{
					graph[v].allconsleft.push_back(graph[u].allconsright[j]);
				}
			}
			else
			{
				for (int j = 0; j < graph[u].allconsleft.size(); j++)
				{
					graph[v].allconsright.push_back(graph[u].allconsleft[j]);
				}

				for (int j = 0; j < graph[u].allconsright.size(); j++)
				{
					graph[v].allconsright.push_back(graph[u].allconsright[j]);
				}
			}
		}
	}
}

void task()
{
	int n;
	cin >> n;

	graph.resize(n);

	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;

		if (t == 1)
		{
			graph[i].cons = false;

			int k;
			cin >> k;

			for (int j = 0; j < k; j++)
			{
				int x;
				cin >> x;
				x--;

				graph[i].to.push_back(x);
			}
		}
		else
		{
			graph[i].cons = true;

			int k;
			cin >> k;

			for (int j = 0; j < k; j++)
			{
				int x;
				cin >> x;

				graph[i].nums.push_back(x);
			}

			sort(graph[i].nums.begin(), graph[i].nums.end());
		}
	}

	dfs(0);
}*/

struct Card
{
	vector<int> right;
	vector<int> wrong;
};

void task()
{
	int n, m;
	cin >> n >> m;

	string str;
	cin >> str;

	vector<Card> v(n);

	vector<int> countwrong(n, 0);
	vector<vector<int>> allwronghere(m);

	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;

		for (int j = 0; j < k; j++)
		{
			int pos;
			char sym;

			cin >> pos >> sym;
			pos--;

			if (str[pos] == sym)
			{
				v[i].right.push_back(pos);
			}
			else
			{
				v[i].wrong.push_back(pos);

				countwrong[i]++;
				allwronghere[pos].push_back(i);
			}
		}
	}

	vector<int> allzero;

	for (int i = 0; i < n; i++)
	{
		if (countwrong[i] == 0)
		{
			allzero.push_back(i);
		}
	}

	vector<bool> visited(m, false);

	vector<int> ans;

	while (allzero.size() != 0)
	{
		int pos = allzero.back();
		allzero.pop_back();

		ans.push_back(pos);

		for (int i = 0; i < v[pos].right.size(); i++)
		{
			if (!visited[v[pos].right[i]])
			{
				visited[v[pos].right[i]] = true;

				int right = v[pos].right[i];

				for (int j = 0; j < allwronghere[right].size(); j++)
				{
					countwrong[allwronghere[right][j]]--;

					if (countwrong[allwronghere[right][j]] == 0)
					{
						allzero.push_back(allwronghere[right][j]);
					}
				}
			}
		}
	}

	bool flag = true;

	for (int i = 0; i < m; i++)
	{
		flag &= visited[i];
	}

	if (ans.size() == n)
	{
		for (int i = 0; i < ans.size(); i++)
		{
			cout << ans[i] + 1 << ' ';
		}
	}
	else
	{
		cout << -1 << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}
