#include <bits/stdc++.h>

using namespace std;
int M = 0;
vector <vector <int>> g, all, dp, suf;

void dfs(int v) {
    if (g[v].empty()) {
        for (int i : all[v]) {
            dp[v][i] = i;
        }
        suf[v].back() = dp[v].back();
        for (int i = M - 2; i >= 0; --i) {
            if (dp[v][i] == -1) suf[v][i] = suf[v][i + 1];
            else if (suf[v][i + 1] == -1) suf[v][i] = dp[v][i];
            else suf[v][i] = min(suf[v][i + 1], dp[v][i]);
        }
        return;
    }
    for (int i : g[v]) {
        dfs(i);
    }
    int kol = g[v].size();
    vector <vector <int>> dp1((1 << kol), vector <int> (M, -1));
    for (int i = 0; i < M; ++i) dp1[0][i] = i;
    for (int mask = 0; mask < (1 << kol); ++mask) {
        for (int r = 0; r < M; ++r) {
            if (dp1[mask][r] == -1) continue;
            for (int next = 0; next < kol; ++next) {
                if ((mask >> next) & 1) continue;
                int u = g[v][next];
                if (suf[u][r] == -1) continue;
                int new_mask = mask + (1 << next);
                int z = dp1[mask][r];
                if (dp1[new_mask][suf[u][r]] == -1) dp1[new_mask][suf[u][r]] = dp1[mask][r];
                else dp1[new_mask][suf[u][r]] = max(dp1[mask][r], dp1[new_mask][suf[u][r]]);
            }
        }
    }
    for (int r = 0; r < M; ++r) {
        if (dp1[(1 << kol) - 1][r] == -1) continue;
        if (dp[v][dp1[(1 << kol) - 1][r]] == -1) dp[v][dp1[(1 << kol) - 1][r]] = r;
        else dp[v][dp1[(1 << kol) - 1][r]] = min(dp[v][dp1[(1 << kol) - 1][r]], r);
    }
    suf[v].back() = dp[v].back();
    for (int i = M - 2; i >= 0; --i) {
        if (dp[v][i] == -1) suf[v][i] = suf[v][i + 1];
        else if (suf[v][i + 1] == -1) suf[v][i] = dp[v][i];
        else suf[v][i] = min(suf[v][i + 1], dp[v][i]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    g.resize(n);
    all.resize(n);
    vector <int> flex;
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            g[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> g[i][j]; --g[i][j];
            }
        } else {
            int m;
            cin >> m;
            M += m;
            all[i].resize(m);
            for (int j = 0; j < m; ++j) {
                cin >> all[i][j]; --all[i][j];
                flex.push_back(all[i][j]);
            }
        }
    }
    sort(flex.begin(), flex.end());
    map <int, int> d;
    for (int i = 0; i < M; ++i) d[flex[i]] = i;
    for (int i = 0; i < n; ++i) {
        for (int& j : all[i]) j = d[j];
    }
    dp.resize(n, vector <int> (M, -1));
    suf.resize(n, vector <int> (M, -1));
    dfs(0);
    if (suf[0][0] != -1) cout << "Yes";
    else cout << "No";
}
