#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()

int32_t main() {
    //ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, k;
    cin >> k >> n;
    vector<vector<int>> ok(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            ok[i][j] = s[j] == '1';
        }
    }


    string s;
    cin >> s;

    vector<vector<int>> del(n, vector<int>(n, 0));
    for (int l = 1; l < n; ++l) {
        for (int r = l; r < n; ++r) {
            string g = s.substr(l-1, r-l+2);
           // cout << l << ' ' << r << ' ' << g << endl;
            int x = 1;
            while (x) {
                x = 0;
                for (int i = (int)g.size()-1; i >= 1; --i) {
                    if (ok[ g[i-1]-'a' ][ g[i]-'a' ]) {
                        g.erase(g.begin() + i);
                        x = 1;
                        //if (l == 1 && r == 4) cout << g << endl;
                    }
                }
            }
            if (g.size() == 1) {
                del[l][r] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            //cout << del[i][j] << ' ';
        }
     //   cout << endl;
    }
    vector<string> dp(n);
    dp[0] = s[n-1];
    for (int i = 1; i < n; ++i) {
        dp[i] = string(1, char('z' + 1));
        for (int j = 0; j < i; ++j) {
            if ( j != i-1 && !del[n-j-1][n-i-1]) {
                continue;
            }
            string x = dp[j];
            dp[i] = min(dp[i], s[n-i-1] + x);
            while (x.size() >= 1 && ok[s[n-i-1]-'a'][x[0]-'a'] ) {
                x.erase(x.begin());
                dp[i] = min(dp[i], s[n-i-1] + x);
            }
        }
    }
    cout << dp[n-1];
}

/*
 * 3 5
010
001
100
bcacb
 */