#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    string pat;
    cin >> pat;
    vector<vector<int>> pos(m);
    vector<map<int, char>> strs(n);
    set<pair<int, int>> s; // {cnt_bad, ind}
    vector<int> cur_bad(n);
    for (int i = 0; i < n; i++) {
        int cnt_bad = 0;
        int k;
        cin >> k;
        while (k--) {
            int j;
            char c;
            cin >> j >> c;
            j--;
            pos[j].push_back(i);
            strs[i][j] = c;
            if (c != pat[j]) {
                cnt_bad++;
            }
        }
        s.insert({cnt_bad, i});
        cur_bad[i] = cnt_bad;
    }
    vector<int> done(m);
    vector<int> ord;
    while (!s.empty()) {
        if (s.begin()->first != 0) {
            cout << -1 << endl;
            return 0;
        }
        auto pp = *s.begin();
        int ind = pp.second;
        ord.push_back(ind + 1);
        s.erase(s.begin());
        for (auto &[el, cc] : strs[ind]) {
            if (done[el])
                continue;
            done[el] = 1;
            for (auto el2 : pos[el]) {
                if (strs[el2].count(el) && strs[el2][el] != pat[el] && s.count({cur_bad[el2], el2})) {
                    s.erase({cur_bad[el2], el2});
                    cur_bad[el2]--; 
                    s.insert({cur_bad[el2], el2});
                }
            }
        }
    }
    if (*min_element(done.begin(), done.end()) == 0) {
        cout << -1 << endl;
    } else {
        for (int el : ord) {
            cout << el << " ";
        }
        cout << endl;
    }
}
