#include <bits/stdc++.h>

using namespace std;
#define int long long

bool check(string &s, string &t){
    int i = 0, j = 0;
    for(; i < s.size() && j < t.size(); i++, j++){
        //cout << "check " << s[i] << ' ' << s[j] << endl;
        if(s[i] < t[j]) return true;
        if(s[i] > t[j]) return false;
    }
    return s.size() < t.size();
}

string solve(int k, int n, vector<vector<int> > &a, string &s){
    vector<vector<int> > dp(n, vector<int>(n, 0));
    for (int i = 1; i < n; i++) {
        dp[i][i] = a[s[i - 1] - 'a'][s[i] - 'a'];
    }
    for (int len = 2; len <= n; len++) {
        for (int l = 1; l + len - 1 < n; l++) {
            int r = l + len - 1;
            if(!dp[l][r - 1]) continue;
            if (dp[l][r - 1] && l && a[s[l - 1] - 'a'][s[r] - 'a']) dp[l][r] = true;
            if (dp[l][r - 1] && a[s[r - 1] - 'a'][s[r] - 'a']) dp[l][r] = true;
            for (int k = l; k < r; k++) {
                if(dp[l][k] && dp[k + 1][r]) dp[l][r] = true;
            }
        }
    }
//    for(int i = 0; i < n; i++){
//        for(int j = 0; j < n; j++){
//            if(dp[i][j]) cout << i + 1 << ' ' << j + 1 << endl;
//        }
//    }
    vector<string> d(n + 1);
    d[s.size() - 1] = string(1, s.back());
    for(int i = s.size() - 2; i >= 0; i--){
        d[i] = d[i + 1];
        for(int len = 1; len < s.size() - i; len++){
            if(dp[i + 1][i + len] && check(d[i + len + 1], d[i]))
                d[i] = d[i + len + 1];
        }
        d[i] = s[i] + d[i];
    }
//    for(int i = 0; i < n; i++){
//        cout << d[i] << endl;
//    }
    return d[0];
}

map<string, string> mem;
string rec(int k, int n, vector<vector<int> > &a, string &s){
    if(mem.find(s) != mem.end()) return mem[s];
    string ans = s;
    for(int i = 1; i < n; i++){
        if(a[s[i - 1] - 'a'][s[i] - 'a']){
            string t = s.substr(0, i) + s.substr(i + 1);
            string r = rec(k, n - 1, a, t);
            bool ok = true, f = false;
            for(int j = 0; j < min(ans.size(), r.size()); j++){
                if(r[j] == ans[j]) continue;
                if(r[j] > ans[j]) {
                    ok = false;
                    break;
                } else {
                    ok = true;
                    f = true;
                    break;
                }
            }
            if(!f && ans.size() < r.size()) ok = false;
            if(ok) ans = r;
        }
    }
    return (mem[s] = ans);
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int k, n;
    cin >> k >> n;
    vector<vector<int> > a(k, vector<int>(k, 0));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;
            //a[i][j] = rand() % 2;
            a[i][j] = (c == '1');
        }
    }
    srand(0);
    string s(n, 'a');/*
    for(int t = 0; t < 100; t++) {
        for (int i = 0; i < n; i++) {
            s[i] = 'a' + rand() % k;
        }
        //cin >> s;
        cout << s << endl;
        if(rec(k, n, a, s) != solve(k, n, a, s)){
            cout << s << "!!!" << endl;
            for(int i = 0; i < k; i++){
                for(int j = 0; j < k; j++) cout << a[i][j];
                cout << endl;
            }
            cout << rec(k, n, a, s) << ' ' << solve(k, n, a, s);
            break;
        }
    }*/
    cin >> s;
    cout << solve(k, n, a, s);
    return 0;
}