#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
vector<vector<bool> > pole;
int n, m, k;

void move(int x, int y)
{
	for(int i = x; i < n; i++)
	{
		for(int j = y; j < n; j++)
		{
			if(pole[i][j])
			{
				break;
			}
			pole[i][j] = true;
		}
	}
}
pair<int, int> code(int ch)
{
	int id1 = 1000;
	for(int i = n - 1; i >= ch; i--)
	{
		if(!pole[i][ch])
		{
			id1 = i;
			break;
		}
	}
	int id2 = 1000;
	for(int i = n - 1; i >= ch; i--)
	{
		if(!pole[ch][i])
		{
			id2 = i;
			break;
		}
	}
	if(id1 == 1000 && id2 == 1000)
	{
		return {-1, -1};
	}
	if(id1 > id2)
	{
		if(ch == 0 && id1 == 0)
		{
			return {-1, -1};
		}
		return {id1, ch};
	}
	else
	{
		if(ch == 0 && id2 == 0)
		{
			return {-1, -1};
		}
		return {ch, id2};
	}
}
vector<int> mass;
int here;

void play_game(bool first)
{
	pole.assign(n, vector<bool>(n, false));
	if(first)
	{
		int ch = mass[here];
		auto p = code(ch);
		int c1 = p.first;
		ch = p.second;
		move(c1, ch);
		++here;
		cout << c1 + 1 << ' ' << ch + 1 << endl;
	}
	while(true)
	{
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		if(a == 0 && b == 0)
		{
			return;
		}
		move(a, b);
		if(here == mass.size())
		{
			cout << "1 1" << endl;
			return;
		}
		int ch = mass[here];
		auto p = code(ch);
		int c1 = p.first;
		ch = p.second;
		if(c1 == -1)
		{
			cout << "1 1" << endl;
			return;
		}
		move(c1, ch);
		++here;
		cout << c1 + 1 << ' ' << ch + 1 << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	int now;
	cin >> now;
	cin >> n >> k >> m;
	if(now == 1)
	{
		string s;
		cin >> s;
		mass.resize(m / 5);
		for(int i = 0; i < m / 5; i++)
		{
			int now = 0;
			for(int j = 0; j < 5; j++)
			{
				if(s[5 * i + j] == '1')
				{
					now |= (1 << j);
				}
			}
			mass[i] = now;
		}
		here = 0;
		for(int i = 0;;i++)
		{
			if(here == mass.size())
			{
				break;
			}
			play_game(i % 2 == 0);
		}
		cout << 0 << endl;
	}
	else
	{
		int g;
		cin >> g;
		string s = "";
		for(int i = 0; i < g; i++)
		{
			int a, b;
			cin >> a >> b;
			bool ok = false;
			int j = 0;
			while(a != 1 || b != 1)
			{
				if((i + j) % 2 == 0)
				{
					--a;
					--b;
					b = min(a, b);
					for(int l = 0; l < 5; l++)
					{
						if((b >> l) & 1)
						{
							s += '1';
						}
						else
						{
							s += '0';
						}
					}
				}
				++j;
				cin >> a >> b;
			}
		}
		cout << s << endl;
	}
}