#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
int n;
vector<vector<int> > g;
vector<vector<int> > can;
vector<int> end1;
vector<int> now;
vector<vector<int> > ans;
vector<pair<int, int> > otr;

bool dfs(int v)
{
	if(g[v].size() == 0)
	{
		otr[v] = {now[v], now[v]};
		return true;
	}
	vector<pair<pair<int, int>, int> > here;
	for(int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i];
		if(!dfs(u))
		{
			return false;
		}
		here.push_back({otr[u], u});
	}
	sort(here.begin(), here.end());
	for(int i = 1; i < here.size(); i++)
	{
		if(here[i].first.first < here[i - 1].first.second)
		{
			return false;
		}
	}
	otr[v].first = here[0].first.first;
	otr[v].second = here[here.size() - 1].first.second;
	ans[v].clear();
	for(int i = 0; i < here.size(); i++)
	{
		ans[v].push_back(here[i].second);
	}
	return true;
}

bool rec(int here)
{
	int v = end1[here];
	for(int i = 0; i < can[v].size(); i++)
	{
		now[v] = can[v][i];
		if(here == end1.size() - 1)
		{
			if(dfs(0))
			{
				return true;
			}
		}
		else
		{
			if(rec(here + 1))
			{
				return true;
			}
		}
	}
	return false;
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n;
	g.resize(n);
	can.resize(n);
	for(int i = 0; i < n; i++)
	{
		int mod;
		cin >> mod;
		if(mod == 1)
		{
			int k;
			cin >> k;
			for(int j = 0; j < k; j++)
			{
				int c;
				cin >> c;
				--c;
				g[i].push_back(c);
			}
		}
		else
		{
			end1.push_back(i);
			int m;
			cin >> m;
			for(int j = 0; j < m; j++)
			{
				int c;
				cin >> c;
				can[i].push_back(c);
			}
		}
	}
	now.assign(n, -1);
	ans.resize(n);
	otr.resize(n);
	if(rec(0))
	{
		cout << "Yes\n";
		for(int i = 0; i < n; i++)
		{
			if(now[i] != -1)
			{
				cout << now[i] << '\n';
			}
			else
			{
				for(int j = 0; j < ans[i].size(); j++)
				{
					cout << ans[i][j] + 1 << ' ';
				}
				cout << '\n';
			}
		}
		return 0;
	}
	cout << "No";
}