#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>

using namespace std;

#define ll long long
#define S second
#define F first

ll a, b, c, d;
vector <ll> ar;

int main()
{
    cin >> a >> b;
    string s;
    cin >> s;
    vector <vector <pair <ll, char> > > arr(a);
    for (ll i = 0; i < a; ++i)
    {
        ll p;
        cin >> p;
        arr[i].resize(p);
        for (ll j = 0; j < p; ++j)
        {
            string s1;
            cin >> arr[i][j].F >> s1;
            arr[i][j].S = s1[0];
            --arr[i][j].F;
        }
    }
    vector <set <ll> > need_del(a);
    queue <ll> q;
    vector <bool> vis(a, false);
    vector <bool> vis_str(b, false);
    vector <ll> ans;
    vector <vector <ll> > pos(b);
    for (ll i = 0; i < a; ++i)
        for (ll j = 0; j < arr[i].size(); ++j)
        {
            pos[arr[i][j].F].push_back(i);
            if (s[arr[i][j].F] != arr[i][j].S)
                need_del[i].insert(arr[i][j].F);
        }
    for (ll i = 0; i < a; ++i)
        if (need_del[i].size() == 0)
        {
            q.push(i);
            vis[i] = 1;
        }
    while(!q.empty())
    {
        bool can = false;
        ll i = q.front();
        ans.push_back(i);
        q.pop();
        for (ll j = 0; j < arr[i].size(); ++j)
        {
            if (vis_str[arr[i][j].F] == false)
            {
                --b;
                for (auto v : pos[arr[i][j].F])
                {
                    if (vis[v] || need_del[v].find(arr[i][j].F) == need_del[v].end())
                        continue;
                    need_del[v].erase(arr[i][j].F);
                    if (need_del[v].size() == 0)
                    {
                        q.push(v);
                        vis[v] = 1;
                    }
                }
                vis_str[arr[i][j].F] = 1;
            }
        }
    }
    /*for (auto v : vis_str)
        cout << v << " ";
    cout << endl;*/
    if (b != 0)
        cout << -1;
    else
        for (auto v : ans)
            cout << v + 1 <<  " ";
}
