#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <random>

using namespace std;

bool a[30][30];

bool CanErase(string s)
{
	//cout << s << ' ';
	vector <int> last(s.size() + 1);
	for (int i = 0; i <= s.size(); ++i)
	{
		last[i] = i - 1;
	}
	bool flag = true;
	while (flag)
	{
		flag = false;
		int ll = s.size();
		for (int i = last[s.size()]; i > 0; i = last[i])
		{
			if (a[s[last[i]] - 'a'][s[i] - 'a'])
			{
				last[ll] = last[i];
				flag = true;
				break;
			}
			ll = i;
		}
	}
	//cout << ' ' << ((last[s.size()] == -1 || last[last[s.size()]] == -1) ? 1 : 0) << '\n';
	if (last[last[s.size()]] == -1)
	{
		return true;
	}
	return false;
}

string Smart(string s)
{
	int n = s.size();
	vector <bool> is(n, true);
	int last = 0;
	string delta = string(1, s[0]);
	for (int i = 1; i < n; ++i)
	{
		string now = "";
		for (int j = i + 1; j < n; ++j)
		{
			if (s[j] <= s[i])
			{
				break;
			}
			now += s[j];
		}

		delta += s[i];
		//cout << i << ' ' << delta << ' ' << now << ' ';
		if (CanErase(delta + now))
		{
			is[i] = false;
			continue;
		}

		delta = s[i];
		last = i;
	}
	int mi = 100;
	last = n;
	for (int i = n - 1; i >= 0; --i)
	{
		string ne = "";
		string ans = "";
		for (int i = 0; i < n; ++i)
		{
			if (is[i])
			{
				ans += s[i];
			}
		}
		is[i] = 1;
		for (int j = 0; j < n; ++j)
		{
			ne += s[j];
		}
		if (ne < ans)
		{
			is[i] = 1;
		}
	}
	string ans = "";
	for (int i = 0; i < n; ++i)
	{
		if (is[i])
		{
			ans += s[i];
		}
	}
	return ans;
}

unordered_set <string> mem;
string ans;

void Go(string s)
{
	if (mem.count(s))
	{
		return;
	}
	mem.insert(s);
	ans = min(ans, s);
	bool fir = true;
	for (int i = 1; i < s.size(); ++i)
	{
		if (a[s[i - 1] - 'a'][s[i] - 'a'])
		{
			string next;
			for (int j = 0; j < s.size(); ++j)
			{
				if (i != j)
				{
					next += s[j];
				}
			}
			Go(next);
		}
	}
}


string Stupid(string s)
{
	mem.clear();
	ans = s;

	Go(s);
	//cout << mem.size() << '\n';
	return ans;
}

mt19937 rnd(1337);

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i)
	{
		for (int j = 0; j < k; ++j)
		{
			char ch;
			cin >> ch;
			if (ch == '1')
			{
				a[i][j] = 1;
			}
		}
	}
	string s;
	cin >> s;
	/*
	int counter = 0;
	while (true)
	{
		if (counter % 1000 == 0)
		{
			cout << counter << '\n';
		}
		counter++;
		string s(n, 'a');
		for (int i = 0; i < n; ++i)
		{
			s[i] = (rnd() % k) + 'a';
		}
		if (Smart(s) != Stupid(s))
		{
			cout << s << '\n';
			cout << Smart(s) << '\n';
			cout << Stupid(s) << '\n';
			return 0;
		}
	}
	*/
	cout << Smart(s);
	return 0;
}