#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> matr(k, vector<bool> (k, false));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            matr[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    string res;
    int ptr = 0;
    vector<vector<bool>> can(n, vector<bool> (n, true));
    for (int i = 0; i < n; ++i) {
        for (int j = i + 2; j < n; ++j) {
            can[i][j] = false;
            for (int l = i + 1; l < j; ++l) {
                if (matr[s[i] - 'a'][s[l] - 'a'] && can[i][l] && can[l][j]) {
                    can[i][j] = true;
                    break;
                }
            }
        }
    }
    while (ptr < n) {
        int id = -1;
        for (int i = ptr; i < n; ++i) {
            if (id == -1 || s[id] > s[i]) {
                if (ptr == 0) {
                    if ((can[0][i] && matr[s[0] - 'a'][s[i] - 'a']) || i == 0) {
                        id = i;
                    }
                }
                else if (can[ptr - 1][i]) {
                    id = i;
                }
            }
        }
        res += s[id];
        if (can[id][n - 1] && matr[s[id] - 'a'][s[n - 1] - 'a']) {
            break;
        }
        ptr = id + 1;
    }
    cout << res;
}
/*
3 7
010
001
100
abacaba

 3 5
010
001
100
bcacb
 */