#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

const int MAXN = 500000;

const int MAXC = 26;

int nexta[MAXN][MAXC];

void solve() {
    int k, n;
    cin >> k >> n;
    vector<vector<int>> may(k, vector<int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            may[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < 26; ++i)
        nexta[MAXN - 1][i] = MAXN;
    for (int i = MAXN - 2; i >= n - 1; --i) {
        for (int j = 0; j < 26; ++j)
            nexta[i][j] = nexta[i + 1][j];
    }
    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < 26; ++j)
            nexta[i][j] = nexta[i + 1][j];
        nexta[i][s[i + 1] - 'a'] = i + 1;
    }
    vector<pair<int, char>> v;
    vector<int> jump(n);
    for (int i = n - 1; i >= 0; --i) {
        while (v.size() && may[s[i] - 'a'][v.back().y - 'a'])
            v.pop_back();
        if (v.size()) {
            jump[i] = v.back().x;
        } else {
            jump[i] = MAXN;
        }
        v.push_back({i, s[i]});
    }
    string ans;
    int pos = 0;
    while (pos != MAXN) {
        ans.push_back(s[pos]);
        int pos_ban = jump[pos];
        if (pos_ban == MAXN)
            break;
        for (int j = 0; j < k; ++j) {
            if (nexta[pos][j] <= pos_ban) {
                pos = nexta[pos][j];
                break;
            }
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
