#include <bits/stdc++.h>

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())

typedef long long ll;
typedef long double ld;

const char nl = '\n';

const ll inf = 1e9;
const ll inf2 = 1e18;
const ld eps = 1e-9;
const ll mod = 1e9+7;

const ll maxn = 1e6, maxm = 1e6;

using namespace std;

int main() {
	FAST;
	
	int k, n;
	cin >> k >> n;
	
	vector<vector<bool>> g(k, vector<bool>(k));
	for (int i = 0; i < k; i++) {
		string ts;
		cin >> ts;
		for (int j = 0; j < k; j++) {
			g[i][j] = (ts[j] == '1');
		}
	}
	
	string s;
	cin >> s;
	
	vector<int> dp(n, 0); // store the furthest reachable index
	dp[n - 1] = n - 1;
	for (int i = n - 2; i >= 0; i--) {
		dp[i] = i;
		vector<int> ma(k, -1);
			
		for (int j = i + 1; j < n; j++) {
			if (g[s[i] - 'a'][s[j] - 'a'] || dp[i] >= j) {
				dp[i] = max(dp[i], dp[j]);
			} else {
				break;
			}
		}
	}
	
	vector<string> dp2(n + 1);
	
	dp2[n] = "";
	//vector<vector<int>> comp(n, vector<int> (n, -1));
	for (int i = n - 1; i >= 0; i--) {
		string ts = dp2[i + 1];
		for (int j = i + 2; j <= dp[i] + 1; j++) {
			if (dp2[j] < ts) {
				ts = dp2[j];
			}
		}
		ts = s[i] + ts;
		dp2[i] = ts;
	}
	
	cout << dp2[0] << nl;
}
