#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<pair<int, int>>> a;
vector<vector<int>> gr;
vector<vector<int>> ans;

bool cmp(pair<vector<int>, int> f, pair<vector<int>, int> s) {
    return f.first[0] < s.first[0];
}

vector<int> dfs(int v, int mask) {
    if (gr[v].size() == 0) {
        for (int i = 0; i < a[v].size(); ++i) {
            if ((mask >> a[v][i].first) % 2 == 1) {
                ans[v] = {a[v][i].second};
                return {a[v][i].second};
            }
        }
        return {};
    }
    vector<pair<vector<int>, int>> b;
    for (auto u : gr[v]) {
        auto res = dfs(u, mask);
        if (res.size() == 0) {
            return {};
        }
        b.push_back({res, u});
    }
    sort(b.begin(), b.end(), cmp);
    for (int i = 0; i < b.size() - 1; ++i) {
        if (b[i].first[b[i].first.size() - 1] >= b[i + 1].first[b[i + 1].first.size() - 1]) {
            return {};
        }
    }
    vector<int> res;
    ans[v].clear();
    for (int i = 0; i < b.size(); ++i) {
        ans[v].push_back(b[i].second + 1);
        for (auto j : b[i].first){
            res.push_back(j);
        }
    }
    return res;
}

signed main() {
    int n;
    cin >> n;
    a.resize(n);
    gr.resize(n);
    ans.resize(n);
    int now = 0;
    for (int i = 0; i < n; ++i) {
        int q;
        cin >> q;
        if (q == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                gr[i].push_back(v - 1);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int c;
                cin >> c;
                a[i].push_back({now++, c});
            }
        }
    }
    for (int i = 0; i < (1 << now); ++i) {
        if (dfs(0, i).size() > 0) {
            cout << "Yes\n";
            /*for (int j = 0; j < n; ++j){
                for (auto elem : ans[j]){
                    cout << elem << " ";
                }
                cout << "\n";
            }
            return 0;*/
        }
    }
    cout << "No";
}
