#include <bits/stdc++.h>
using namespace std;

const int K = 27, N = 5e5 + 5;

int k, n;

vector<int> a, lft;


bool can[K][K];

string dp[N];

struct dsu {
  int size;
  vector<string> v;
  vector<int> par;
  dsu(int sz) : size(sz) {
    par.resize(size);
    iota(par.begin(), par.end(), 0);
    v.resize(size);
  }
  int gpar(int x) {
    if (par[x] == x) return x;
    return par[x] = gpar(par[x]);
  }
  void merge(int x, int y) {
    x = gpar(x), y = gpar(y);
    if (x == y) return;
//    if (v[x].size() > v[y].size())
//      swap(x, y);
    if (v[x] < v[y]) {
      par[y] = x;
    } else {
      par[x] = y;
    }
  }
};


int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);


  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    string ss;
    cin >> ss;
    for (int j = 0; j < k; ++j) {
      if (ss[j] == '1')
        can[i][j] = true;
    }
  }
  string ss;
  cin >> ss;
  a.resize(n);
  lft.resize(n);
  for (int i = 0; i < n; ++i) {
    a[i] = ss[i] - 'a';
  }

  for (int i = 0; i < n; ++i) {
    int l = i - 1;
    while (l != -1 && !can[a[l]][a[i]])
      l = lft[l];
    lft[i] = l;
  }

  for (int i = n - 1; i >= 0; --i) {
    int j = i + 1;
    while (j < n && lft[j] >= i) {
      if (dp[i].empty())
        dp[i] = dp[j];
      dp[i] = min(dp[i], dp[j]);
      j++;
    }
    if (dp[i].empty())
      dp[i] = dp[j];
    dp[i] = min(dp[i], dp[j]);
    reverse(dp[i].begin(), dp[i].end());
    dp[i] += 'a' + a[i];
    reverse(dp[i].begin(), dp[i].end());
  }

  cout << dp[0];

}