def read_perf(s):
    perf = {'good': set(), 'bad': set()}
    inp = input().split()
    k = int(inp[0])
    for i in range(k):
        n, ch = inp[i * 2 + 1:i * 2 + 3]
        n = int(n)
        if ch == s[n - 1]:
            perf['good'].add(n)
        else:
            perf['bad'].add(n)
    return perf


n, m = map(int, input().split())
s = input()
perfs = {i: read_perf(s) for i in range(n)}
covered = set()
q = len(covered)
prevq = -1
res = []
while q != prevq and len(perfs) != 0:
    for i, perf in list(perfs.items()):
        if perf['bad'].issubset(covered):
            covered.update(perf['good'])
            res.append(i + 1)
            del perfs[i]
    q, prevq = len(covered), q
if len(covered) != n:
    print(-1)
else:
    print(*res)

