#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

const int maxn = 1000 + 5;

bool dp[26][maxn][maxn];

void solve() {
    int k, n;
    cin >> k >> n;
    vector < vector <bool> > a(k, vector <bool> (k));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c; cin >> c;
            a[i][j] = (c == '1');
        }
    }
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        char c; cin >> c;
        s[i] = c - 'a';
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                dp[i][j][k] = (j > k);
            }
        }
    }
    for (int len = 1; len <= n; len++) {
        for (int t = 0; t < k; t++) {
            for (int i = 0; i + len <= n; i++) {
                int j = i + len - 1;
                for (int k = i; k <= j; k++) {
                    if (a[t][s[k]] && (k - 1 < 0 || dp[t][i][k - 1]) && (k + 1 >= n || dp[s[k]][k + 1][j])) {
                        dp[t][i][j] = true;
                        break;
                    }
                }
            }
        }
    }
    string ans = "";
    for (int j = 0; j < n; j++) {
        ans += (s[j] + 'a');
    }
    for (int mask = 1; mask < (1 << n); mask++) {
        vector <int> id;
        for (int j = 0; j < n; j++) {
            if (((mask >> j) & 1)) {
                id.push_back(j);
            }
        }
        if (id[0] != 0)
            continue;

        id.push_back(n);
        bool cur = true;
        for (int j = 0; j + 1 < (int)id.size(); j++) {
            if (id[j] + 1 < n && id[j + 1] - 1 >= 0 && !dp[s[id[j]]][id[j] + 1][id[j + 1] - 1]) {
                cur = false;
                /*
                if (id[0] == 0 && id[1] == 2 && id[2] == 3 && id[3] == 4) {
                    cout << s[id[j]] << ' ' << id[j] + 1 << ' ' << id[j + 1] - 1 << '\n';
                }
                */
            }
        }
        if (cur) {
            string t = "";
            for (int j = 0; j < n; j++) {
                if (((mask >> j) & 1))
                    t += (s[j] + 'a');
            }
            ans = min(ans, t);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}