#include <bits/stdc++.h>
using namespace std;
using ll = long long;
// #define int ll
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
 
const int N     = 1e5 + 10;
const int INF   = 1e9;
const int K     = 8;
 
int n;
vector<int> g[N];
vector<pair<int, int>> dp[N];
 
int bs(int v, int l) {
	auto it = lower_bound(all(dp[v]), mp(l, -INF));
	if (it == dp[v].end()) {
		return INF;
	} else {
		return it->y;
	}
}
 
int sub[1 << K];
 
 
void dfs(int v) {
	if (g[v].empty()) {
		return;
	}
	vector<int> s = g[v];
	int k = (int)s.size();
	vector<int> actual;
	for (int i = 0; i < k; ++i) {
		dfs(s[i]);
		for (auto e : dp[s[i]]) {
			actual.push_back(e.x);
		}
	}
	sort(all(actual));
	actual.erase(unique(all(actual)), actual.end());
	for (int from : actual) {
		fill_n(sub, 1 << k, INF);
		sub[0] = from - 1;
		for (int msk = 0; msk < (1 << k); ++msk) {
			if (sub[msk] >= INF) {
				continue;
			}
			for (int nxt = 0; nxt < k; ++nxt) {
				if ((msk >> nxt) & 1) {
					continue;
				}
				int val = bs(s[nxt], sub[msk] + 1);
				sub[msk | (1 << nxt)] = min(sub[msk | (1 << nxt)], val);
			}
		}
		int y = sub[(1 << k) - 1];
		if (y >= INF) {
			break;
		}
		while (dp[v].size() && dp[v].back().y >= y) {
			dp[v].pop_back();
		}
		dp[v].emplace_back(from, y);
	}
	if (dp[v].size() > 64) {
		dp[v] = {dp[v].front(), dp[v].back()};
	} else if (dp[v].size() > 10) {
		vector<pair<int, int>> tmp;
		for (int i = 0; i < (int)dp[v].size(); ++i) {
			if (i == 0 || i == (int)dp[v].size() - 1 || i % 2) {
				tmp.push_back(dp[v][i]);
			}
		}
		dp[v] = tmp;
	}
}
 
vector<int> saved[N];
 
void rec(int v, int l) {
	int r = bs(v, l);
	assert(r < INF);
	if (g[v].empty()) {
		saved[v] = {r - 1};
		return;
	}
	vector<int> per = g[v];
	sort(all(per));
	do {
		int ptr = l;
		for (int u : per) {
			ptr = bs(u, ptr) + 1;
		}
		if (ptr - 1 > r) {
			continue;
		}
		saved[v] = per;
		ptr = l;
		for (int u : per) {
			rec(u, ptr);
			ptr = bs(u, ptr) + 1;
		}
		return;
	} while (next_permutation(all(per)));
	assert(false);
}
 
signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n;
	for (int tp, k, i = 0; i < n; ++i) {
		cin >> tp;
		if (tp == 1) {
			cin >> k;
			g[i].resize(k);
			for (int &j : g[i]) {
				cin >> j;
				--j;
			}
		} else {
			cin >> k;
			dp[i].resize(k);
			for (auto &e : dp[i]) {
				cin >> e.x;
				e.y = e.x;
			}
			sort(all(dp[i]));
		}
	}
	dfs(0);
	if (dp[0].size()) {
		cout << "Yes\n";
		// assert(dp[0].size());
		// rec(0, dp[0][0].x);
 
		// for (int i = 0; i < n; ++i) {
		//     for (int j : saved[i]) {
		//         cout << j + 1 << " ";
		//     }
		//     cout << "\n";
		// }
	} else {
		cout << "No\n";
	}
	return 0;
}