#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <string>
using namespace std;
#pragma GCC optimize("O3")
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double

const int mod = 1e9 + 7;
int n;
vector <vector <int>> dp;
string ans = "", s;
void gen(string t, int cur) {
	if (cur == n) {
		int lst = 0;
		string here = "";
		here += s[0];
		for (int i = 1; i < n; ++i) {
			if (t[i] == '1') {
				if (lst + 1 <= i - 1 and !dp[lst + 1][i - 1])
					return;
				lst = i;
				here += s[i];
			}
			if (i == n - 1 and t[i] != '1') {
				if (!dp[lst + 1][n - 1]) return;
			}
			
		}
		ans = min(ans, here);
		return;
	}
	gen(t + '1', cur + 1);
	gen(t + '0', cur + 1);
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int k; cin >> k >> n;
	vector <string> a(k);
	for (auto& x : a) cin >> x;
	cin >> s;
	dp.resize(n, vector <int>(n));
	for (int len = 0; len < n; ++len) {
		for (int l = 1; l < n - len; ++l) {
			int r = l + len;
			dp[l][r] = 0;
			if (!len) {
				if (a[s[l - 1] - 'a'][s[l] - 'a'] == '1')
					dp[l][l] = 1;
			}
			else {
				for (int j = r - 1; j >= l - 1; --j) {
					if (a[s[j] - 'a'][s[r] - 'a'] != '1') continue;
					if ((j + 1 > r - 1 or dp[j + 1][r - 1]) and (l > j or dp[l][j]))
						dp[l][r] = true;
				}
			}
		}
	}
	ans = s;
	gen("1", 1);
	cout << ans << '\n';
}
/*
3 5
010
001
100
bcacb

3 7
010
001
100
abacaba
*/
