#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 1;

map<int, char> info[MAXN];
set<pair<int, char>> inp[MAXN];
set<int> pos[MAXN];
bool used[MAXN];
bool fil[MAXN];

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            char t;
            cin >> x >> t;
            info[i][x - 1] = t;
            if (s[x - 1] != t) {
                pos[x - 1].insert(i);
                inp[i].insert({x - 1, t});
            }
        }
    }
    vector<int> ok;
    for (int i = 0; i < n; ++i) {
        if (inp[i].size() == 0) ok.push_back(i);
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        /*for (auto it : ok) {
            cout << it << " ";
        }
        cout << "\n";*/
        if (ok.size() == 0) break;
        int now = ok.back();
        used[now] = true;
        ans.push_back(now);
        ok.pop_back();
        for (auto it : info[now]) {
            //cout << it.first << "\n";
            if (!fil[it.first]) {
                for (auto j : pos[it.first]) {
                    //cout << j << "\n";
                    //cout << it.first << " " <
                    inp[j].erase({it.first, info[j  ][it.first]});
                    if (inp[j].size() == 0) {
                        ok.push_back(j);
                    }
                }
            }
            fil[it.first] = true;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!fil[i]) {
            cout << "-1\n";
            return;
        }
    }
    for (auto it : ans) {
        cout << it + 1 << " ";
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
}

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f


2 2
aa
2 1 a 2 b
2 1 b 2 a
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

