#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

/**
vector<int> cnt -  
queue<int> -  ,   
vector<bool> used - ,   
**/

void solve() {
    int n, m;
    cin >> n >> m;
    string req;
    cin >> req;
    int a;
    char c;
    vector<vector<pair<int, char> > > sp(n);
    vector<bool> in_ans(n);
    vector<vector<int> > ind(m);
    vector<int> cnt(n);
    queue<int> nxt;
    vector<bool> used(m);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            cin >> a >> c;
            --a;
            ind[a].push_back(i);
            if (req[a] != c) {
                ++cnt[i];
            }
            sp[i].push_back({a, c});
        }
        if (cnt[i] == 0) {
            nxt.push(i);
        }
    }
    vector<int> ans;
    while(!nxt.empty()) {
        int now = nxt.front();
        nxt.pop();
        ans.push_back(now);
        for (auto p : sp[now]) {
            if (!used[p.first]) {
                used[p.first] = true;
                for (auto el : ind[p.first]) {
                    --cnt[el];
                    if (cnt[el] == 0) {
                        nxt.push(el);
                    }
                }
            }
        }
    }
    if (ans.size() != n) {
        cout << -1 << endl;
    }
    else {
        for (auto el : ans) {
            cout << el + 1 << " ";
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    ///freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    ///cin >> tests;
    while(tests--) {
        solve();
    }
}
