#include <bits/stdc++.h>

#define X first
#define Y second
#define int long long

const int INF = 1e9;

const int bits = 2;
const int R = 2;

using namespace std;

void encode() {
    int n, k, m;
    cin >> n >> k >> m;
    string message;
    cin >> message;

    int i = 0;
    int game = 0;

    while (message.size() % (2 * bits) != 0)
        message += "0";

    while (true) {
        vector<vector<bool>> used(n, vector<bool>(n));

        if (game & 1) {
            int besti, bestj;
            cin >> besti >> bestj;
            --besti, --bestj;
            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;
        }

        if (i >= message.size()) {
            cout << "0";
            exit(0);
        }
        while (true) {
            int besti = 0, bestj = 0, bestsq = INF;
            for (int x = n - 1; x >= 0 && bestsq > R; --x) {
                for (int y = n - 1; y >= 0 && bestsq > R; --y) {
                    if (used[x][y])
                        continue;


                    if (i < message.size()){
                        bool ok = true;
                        int ti = i;
                        for (int q = 0; q < bits && ok; ++q){
                            if (((x >> q) & 1) != message[ti + q] - '0')
                                ok = false;
                        }
                        ti += bits;
                        for (int q = 0; q < bits && ok; ++q){
                            if (((y >> q) & 1) != message[ti + q] - '0')
                                ok = false;
                        }
                        if (!ok)
                            continue;
                    }
                    else
                        continue;

                    int sq = 0;
                    for (int xx = x; xx < n && sq < bestsq; ++xx)
                        for (int yy = y; yy < n && sq < bestsq; ++yy)
                            sq += !used[xx][yy];


                    if (x != 0 && y != 0 && sq < bestsq) {
                        besti = x;
                        bestj = y;
                        bestsq = sq;
                    }
                }
            }

            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;


            cout << besti + 1 << " " << bestj + 1 << endl;

            if (besti == 0 && bestj == 0)
                break;

            i += 2 * bits;

            cin >> besti >> bestj;
            --besti, --bestj;

            for (int x = besti; x < n; ++x)
                for (int y = bestj; y < n; ++y)
                    used[x][y] = true;
            if (besti == 0 && bestj == 0)
                break;
        }
        ++game;
    }
}

void decode() {
    int n, k, m;
    cin >> n >> k >> m;
    vector<int> message(m);

    int t;
    cin >> t;

    int i = 0;
    int game = 0;

    while (t--) {
        ++game;

        if (game % 2 == 0) {
            int x, y;
            cin >> x >> y;
            --x, --y;
        }

        while (true) {
            int mi, mj;
            cin >> mi >> mj;
            --mi, --mj;

            if (mi == 0 && mj == 0)
                break;

            for (int o = 0; o < bits && o + i < message.size(); ++o){
                message[o + i] = (mi >> o) & 1;
            }
            i += bits;
            for (int o = 0; o < bits && o + i < message.size(); ++o){
                message[o + i] = (mj >> o) & 1;
            }
            i += bits;

            cin >> mi >> mj;
            --mi, --mj;
            if (mi == 0 && mj == 0)
                break;
        }

    }

    for (int d : message)
        cout << d;
}

void solve() {
    int t;
    cin >> t;
    if (t == 1)
        encode();
    else
        decode();
}

signed main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    //freopen("C:\\work\\temp\\clion\\log.txt", "r", stdin);
    solve();
    return 0;
}