#include <bits/stdc++.h>

using namespace std;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

struct letter {
    int ind;
    char c;
};

int main() {
    input();
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<letter>> rows(m);
    vector<vector<letter>> dict(n);
    vector<int> ok(n), ban(n);
    for (int i = 0; i < n; i++) {
        int k1;
        cin >> k1;
        dict[i].resize(k1);
        for (auto &k : dict[i]) {
            cin >> k.ind >> k.c;
            k.ind--;
            rows[k.ind].push_back({i, k.c});
            if (s[k.ind] == k.c)
                ok[i]++;
            else
                ban[i]++;
        }
    }
    set<pair<int, int>> card_ok, card_ban;
    for (int i = 0; i < n; i++) {
        if (ban[i] == 0)
            card_ok.insert({ok[i], i});
        else
            card_ban.insert({ok[i], i});
    }
    vector<int> ans;
    vector<int> mask(m);
    vector<int> used(n);
    while (!card_ok.empty()) {
        auto it = --card_ok.end();
        if (it->first == 0)
            break;
        ans.push_back(it->second + 1);
        used[ans.back() - 1] = 1;
        for (auto &k : dict[it->second]) {
            if (mask[k.ind] == 0) {
                mask[k.ind] = 1;
                for (auto &c : rows[k.ind])
                    if (c.c == s[k.ind]) {
                        pair<int, int> temp = {ok[c.ind], c.ind};
                        if (card_ok.find(temp) != card_ok.end()) {
                            card_ok.erase(temp);
                            temp.first--;
                            card_ok.insert(temp);
                        } else {
                            card_ban.erase(temp);
                            temp.first--;
                            card_ban.insert(temp);
                        }
                        ok[c.ind]--;
                    } else {
                        pair<int, int> temp = {ok[c.ind], c.ind};
                        card_ban.erase(temp);
                        ban[c.ind]--;
                        if (ban[c.ind] == 0)
                            card_ok.insert(temp);
                        else
                            card_ban.insert(temp);
                    }
            }
        }
    }
    bool flag = true;
    for (int i = 0; i < m; i++)
        flag &= mask[i];
    if (!flag) {
        cout << -1;
        return 0;
    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            ans.push_back(i + 1);
    for (auto &i : ans)
        cout << i << " ";
    return 0;
}
