#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
typedef long long ll;

constexpr int ML = 1e5 + 5;
int n, m;

bitset<ML> used;
unordered_set<int> pos;

string tom;

vector<pair<unordered_map<int, char>, int>> all;

int next() {
    int ans = -1;
    for (int j = 0; j < n; ++j) {
        if (used[j]) continue;
        bool fl = true;
        for (auto i: pos) {
            if (all[j].first.count(i) != 0 && all[j].first[i] != tom[i]) {
                fl = false;
                break;
            }
        }

        if (fl) {
            ans = j;
            break;
        }
    }

    if (ans != -1) {
        vector<int> del;
        for (auto i: pos) {
            if (all[ans].first.count(i) != 0 && all[ans].first[i] == tom[i]) {
                del.push_back(i);
            }
        }

        for (auto en: del) pos.erase(en);
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    all.resize(n);

    cin >> tom;

    for (int i = 0; i < m; ++i) {
        pos.insert(i);
    }

    for (int i = 0; i  < n; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int p;
            char ch;
            cin >> p >> ch;
            --p;

            all[i].first[p] = ch;
        }
        all[i].second = i;
    }

    shuffle(all(all), rng);

    vector<int> ans;
    while (!pos.empty()) {
        int nxt = next();

        if (nxt == -1) {
            cout << "-1\n";
            return;
        }

        ans.push_back(all[nxt].second);
        used[nxt] = true;
    }

    for (auto en: ans) {
        cout << en + 1 << ' ';
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cout << all[i].second + 1 << ' ';
        }
    }
}

signed main() {
    ioBoost;

    solve();

    return 0;
}