#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 1e5 + 5, M = 1e5 + 5;

int n, m;
string s;
vector<pair<int, char>> a[N];
bool used[M], alive[N];

int32_t main() {
#ifdef WINNER
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WINNER
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j].fi >> a[i][j].se;
            --a[i][j].fi;
        }
    }
    fill(used, used + m, false);
    fill(alive + 1, alive + n + 1, true);
    vector<int> ans;
    while (true) {
        int go = -1, cnt = 0;
        for (int i = 1; i <= n; ++i) if (alive[i]) {
            ++cnt;
            bool ok = true;
            for (auto &pp : a[i]) {
                int pos = pp.fi;
                char x = pp.se;
                if (used[pos]) continue;
                ok &= (s[pos] == x);
            }
            if (ok) {
                go = i;
                break;
            }
        }
        if (!cnt) break;
        if (go == -1) return cout << "-1\n", 0;
        ans.eb(go);
        alive[go] = false;
        for (auto &pp : a[go]) {
            int pos = pp.fi;
            used[pos] = true;
        }
    }
    for (int i = 0; i < m; ++i) if (!used[i]) return cout << "-1\n", 0;
    for (int i = 1; i <= n; ++i) if (alive[i]) ans.eb(i);
    for (int x : ans) cout << x << " ";
    cout << "\n";
    return 0;
}
