#include <bits/stdc++.h>
using namespace std;

vector<vector<bool>> table(32, vector<bool>(32, false));

void clear_table()
{
    table = vector<vector<bool>>(32, vector<bool>(32, false));
}

void draw(int x, int y)
{
    for (int x0 = 0; x0 < 32; x0++) {
        for (int y0 = 0; y0 < 32; y0++) {
            if (x0 >= x && y0 >= y)
                table[x0][y0] = true;
        }
    }
}

int i_will_draw(int x, int y)
{
    int ans = 0;
    for (int x0 = 0; x0 < 32; x0++) {
        for (int y0 = 0; y0 < 32; y0++) {
            if (x0 >= x && y0 >= y && !table[x0][y0])
                ans++;
        }
    }
    return ans;
}

int main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //ifstream cin("\\\\.\\pipe\\game.in");
    //ofstream cout("\\\\.\\pipe\\game.out");

    int q;
    cin >> q;
    if (q == 1) {
        int n, k, m;
        cin >> n >> k >> m;
        string message;
        cin >> message;
        int game = 0;
        int now = 0;
        while (now < m) {
            int x, y;
            if (game % 2 == 1) {
                cin >> x >> y;
                draw(x - 1, y - 1);
            }
            while (now < m) {
                int x0, y0;
                for (x0 = 3; x0 < 32; x0++) {
                    for (y0 = 3; y0 < 32; y0++) {
                        if ((x0 + y0) % 2 == (message[now] - '0')) {
                            if (!table[x0][y0] && i_will_draw(x0, y0) <= 3) {
                                cout << x0 + 1 << ' ' << y0 + 1 << endl;
                                draw(x0, y0);
                                x0 = 50;
                                y0 = 50;
                                now++;
                            }
                        }
                    }
                }
                if (x0 >= 50) {
                    cin >> x >> y;
                    draw(x - 1, y - 1);
                    if (now == m) {
                        cout << "2 1" << endl;
                        int x, y;
                        cin >> x >> y;
                        if (x == 1 && y == 1) {
                            game++;
                            clear_table();
                        }
                        else {
                            cout << "1 2" << endl;
                            cin >> x >> y;
                            game++;
                            clear_table();
                        }
                        break;
                    }
                }
                else {
                    cout << "2 1" << endl;
                    int x, y;
                    cin >> x >> y;
                    if (x == 1 && y == 1) {
                        game++;
                        clear_table();
                    }
                    else {
                        cout << "1 2" << endl;
                        cin >> x >> y;
                        game++;
                        clear_table();
                    }
                }
            }
        }
        cout << 0;
    }
    else {
        int n, k, m;
        cin >> n >> k >> m;
        int games;
        cin >> games;

        string result = "";
        for (int game = 0; game < games; game++) {

            if (game % 2 == 1) {
                int x, y;
                cin >> x >> y;
            }

            while (true) {
                int x, y;
                cin >> x >> y;
                if ((x == 1 && y == 2) || (x == 2 && y == 1)) {}
                else {
                    result += to_string((x + y) % 2);
                }
                cin >> x >> y;
                if (x == 1 && y == 1) break;
            }
        }
        cout << result << endl;
    }



    return 0;
}



/**

2
32 8 2
2
2 1
1 32
1 2
1 1
32 28
1 2
24 1
2 1
1 1

*/
