#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <stack>
#include <random>
#include <bitset>
#include <iomanip>

#define ll long long
#define ld long double 

using namespace std;

const int K = 30;
int a[K][K];

const int N = 1e+6;

string Ans(string& s) {
	string ans;
	ans = s;
	int n = s.size();
	for (int i = 1; i < n; ++i) {
		if (a[s[i - 1] - 'a'][s[i] - 'a'] == 1) {
			string w;
			for (int j = 0; j < n; ++j) {
				if (i != j) w += s[j];
			}
			string nw = Ans(w);
			ans = min(ans, nw);
		}
	}
	return ans;
}

int main()
{
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		string a1;
		cin >> a1;
		for (int j = 0; j < k; ++j) {
			a[i][j] = a1[j] - '0';
		}
	}
	string s;
	cin >> s;
	cout << Ans(s);
}
