#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>

using namespace std;

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<pair<int, vector<int>>> p(n);
	vector<int> ans(n, -1);
	vector<bool> cover(m);
	vector<vector<int>> bond(m);
	int cnt = 0;
	queue<int> q;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			if (c == s[a])
			{
				p[i].second.push_back(a);
			}
			else
			{
				++p[i].first;
				bond[a].push_back(i);
			}
		}
		if (p[i].first == 0)
			q.push(i);

	}
	while (cnt < n && q.size()) {
		int x = q.front();
		q.pop();
		ans[cnt++] = x;
		for (int j : p[x].second) {
			if (!cover[j])
			{
				cover[j] = true;
				for (int y : bond[j]) {
					if (--p[y].first == 0)
						q.push(y);
				}
			}
		}
	}
	for (bool b : cover) {
		if (!b)
		{
			cout << "-1\n";
			return 0;
		}
	}
	if (cnt < n) {
		cout << "-1\n";
	}
	else {
		for (int x : ans) {
			cout << x + 1 << ' ';
		}
	}
}