#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <bitset>

using namespace std;

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int k, n;
	cin >> k >> n;
	vector<vector<bool>> a(k + 1, vector<bool>(k + 1));
	vector<int> next(n + 1);
	vector<string> suf(n + 1);
	for (int i = 0; i < n; ++i)
	{
		next[i] = i + 1;
	}
	next[n] = -10000;
	for (int i = 1; i <= k; ++i)
		for (int j = 1; j <= k; ++j)
		{
			char tmp;
			cin >> tmp;
			tmp -= '0';
			a[i][j] = tmp;
		}
	vector<int> s(n + 1);
	for (int i = 0; i < n; ++i)
	{
		char c;
		cin >> c;
		s[i] = c - 'a' + 1;
	}
	s[n] = 0;
	suf[n] = "";
	for (int i = n - 1; i >= 0; --i) {
		int cur = next[i];
		vector<pair<string, int>> sufs;
		sufs.push_back({ suf[cur], cur });
		while (a[s[i]][s[cur]]) {
			cur = next[cur];
			sufs.push_back({ suf[cur], cur });
		}
		stable_sort(sufs.begin(), sufs.end());
		suf[i] = char(s[i] + 'a' - 1) + sufs[0].first;
		next[i] = sufs[0].second;
	}
	cout << suf[0] << endl;
}