#include <bits/stdc++.h>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()

inline void SOLVE() {
    int k, n;
    cin >> k >> n;
    vector<vector<int>> can_erase(k, vector<int>(k));
    vector<vector<int>> id(k);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            can_erase[i][j] = c - '0';
        }
    }
    string s;
    cin >> s;
    vector<int> prv(n), good(n);
    for (int i = 1; i < n; ++i) {
        good[i] = can_erase[s[i - 1] - 'a'][s[i] - 'a'];
    }
    for (int i = 0; i < n; ++i) {
        id[s[i] - 'a'].pb(i);
    }
    for (int i = 1; i < n; ++i) {
        if (good[i - 1])
            prv[i] = prv[i - 1];
        else
            prv[i] = i;
    }
    int suffix = 0;
    bool f = true;
    string ans = "";
    while (suffix < n && f) {
        f = false;
        bool stop = true;
        if (!ans.empty()) {
            for (int j = suffix; stop && j < n; ++j) {
                if (!can_erase[ans.back() - 'a'][s[j] - 'a'])
                    stop = false;
            }
            if (stop)
                break;
        }
        for (int i = 0; i < k; ++i) {
            auto it = lower_bound(all(id[i]), suffix);
            if (it != id[i].end()) {
                int v = *it;
                if (prv[v] <= suffix) {
                    ans.pb('a' + i);
                    f = true;
                    suffix = v + 1;
                    break;
                }
            }
        }
    }
    cout << ans;
}

inline void FASTIO() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);
}

int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    SOLVE();
}