#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

int main() {
  int k, n;
  cin >> k >> n;
  vvb mat(k, vb(k));
  for (int i = 0; i < k; i++) {
    for (int j = 0; j < k; j++) {
      char c;
      cin >> c;
      mat[i][j] = (c == '1');
    }
  }
  string s;
  cin >> s;
  s += (char)('a' - 1);
  vvi g(n + 1);
  for (int r = 0; r < n; r++) {
    vector <int> st;
    for (int i = r; i >= 0; i--) {
      while (!st.empty() && mat[s[i] - 'a'][st.back()]) {
        st.pop_back();
      }
      if (st.empty()) {
        g[i].push_back(r + 1);
      }
      st.push_back(s[i] - 'a');
    }
  }
  set <pair <string, int>> se;
  vector <string> d(n + 1, "{");
  d[0] = s[0];
  for (int i = 0; i <= n; i++) {
    se.insert({d[i], i});
  }
  while (!se.empty()) {
    int v = se.begin()->second;
    se.erase(se.begin());
    for (int u : g[v]) {
      if (d[v] + s[u] < d[u]) {
        se.erase({d[u], u});
        d[u] = d[v] + s[u];
        se.insert({d[u], u});
      }
    }
  }
  d.back().pop_back();
  cout << d.back();
  return 0;
}

/*
3 7
010
001
100
abacaba
 */


/*
3 5
 010
 001
 100
 bcacb
 */