#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;
using ll = long long;

ll n, m, k, q;

int main() {
	cin >> n >> m;
	string s;
	cin >> s;
	vector <set <ll>> opa(n);
	vector <set <ll>> popa(n);
	vector <bool> used(n);
	vector <ll> ans;
	string t(m, ' ');
	map <ll, vector <ll>> ban;
	set <ll> initial;
	queue <ll> q;

	for (int i = 0; i < n; ++i) {
		cin >> k;
		bool ok = true;
		for (int j = 0; j < k; ++j) {
			char c;
			ll p;
			cin >> p >> c;
			if (s[p - 1] != c) {
				ok = false;
				opa[i].insert(p - 1);
				ban[p - 1].push_back(i);
			}
			else {
				popa[i].insert(p - 1);
			}
		}
		if (ok) {
			used[i] = true;
			ans.push_back(i);
			for (auto& x : popa[i]) {
				initial.insert(x);
				t[x] = s[x];
			}
			popa[i].clear();
		}
	}

//	for (auto& x : initial) {
//		cout << x << ' ';
//	}
//	cout << '\n';

	for (auto& x : initial) {
//		cout << "Banning " << x << '\n';
		for (auto& y : ban[x]) {
//			cout << opa[y].size() << ' ' << popa[y].size() << '\n';
//			cout << "Erase it from " << y << '\n';
			ll cnt = opa[y].size();
			opa[y].erase(x);
			popa[y].erase(x);
//			cout << opa[y].size() << ' ' << popa[y].size() << '\n';
			if (cnt == 1 && opa[y].empty()) {
//				cout << "Now " << y << " is ok\n";
				q.push(y);
			}
		}
	}

	while (!q.empty()) {
		ll v = q.front();
		ans.push_back(q.front());
		q.pop();
		for (auto& x : popa[v]) {
			t[x] = s[x];
			for (auto& y : ban[x]) {
				ll cnt = opa[y].size();
				opa[y].erase(x);
				popa[y].erase(x);
				if (cnt == 1 && opa[y].empty()) {
					q.push(y);
				}
			}
		}
	}

//	cout << t << '\n';

	if (s != t) {
		cout << -1 << '\n';
	}
	else {
		for (auto& x : ans) {
			cout << x + 1 << ' ';
		}
		cout << '\n';
	}

	return 0;
}
/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 2 a
*/