#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <random>
#include <chrono>

using namespace std;
using ll = long long;

const ll INF = 1e15;

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll n, m, k, q;

vector <vector <ll>> g;
vector <vector <ll>> p;

vector <ll> dfs(ll v) {
//	cout << v << '\n';
	if (g[v].size() == 0) {
		vector <ll> res;
		for (int i = 0; i < p[v].size(); ++i) {
			res.push_back(1ll << p[v][i]);
		}
		return res;
	}
	vector <vector <ll>> opa;
	for (auto& x : g[v]) {
		opa.push_back(dfs(x));
	}
	if (opa.size() == 1) return opa[0];
	vector <ll> res;
	for (auto& x : opa[0]) {
		for (auto& y : opa[1]) {
			ll maxe1 = -INF, maxe2 = -INF, mine1 = INF, mine2 = INF;
			for (int i = 0; (1ll << i) <= x || (1ll << i) <= y; ++i) {
				if (x & (1 << i)) {
					mini(mine1, i);
					maxi(maxe1, i);
				}
				if (y & (1 << i)) {
					mini(mine2, i);
					maxi(maxe2, i);
				}
			}
			if (mine2 > maxe1 || mine1 > maxe2) {
				res.push_back(x | y);
			}
		}
	}
	return res;
}

int main() {
	cin >> n;

	map <ll, ll> ind;
	vector <ll> a;
	g.resize(n);
	p.resize(n);

	for (int i = 0; i < n; ++i) {
		ll t;
		cin >> t;
		if (t == 1) {
			cin >> k;
			g[i].resize(k);
			for (auto& x : g[i]) {
				cin >> x;
				--x;
			}
		}
		else if (t == 2) {
			cin >> k;
			p[i].resize(k);
			for (auto& x : p[i]) {
				cin >> x;
				--x;
				a.push_back(x);
			}
		} 
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < a.size(); ++i) {
		ind[a[i]] = i;
	}
	for (auto& x : p) {
		for (auto& y : x) {
			y = ind[y];
		}
	}

//	cout << "Opa\n";

	if (dfs(0).empty()) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n";
	}

	return 0;
}
/*
6
1 3 5 4 6
2

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/