#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <utility>
using namespace std;

const int MAXN = 1e5 + 123;
vector<int> ps[MAXN];
int cntfls[MAXN];
bool found[MAXN];
vector<int> rcntfls[MAXN];
vector<int> ans;
string psc[MAXN];

signed main(){
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	for(int i = 0; i < n; ++i){
		int k;
		cin >> k;
		ps[i].resize(k);
		psc[i].resize(k);
		for(int j = 0; j < k; ++j){
			cin >> ps[i][j] >> psc[i][j];
			--ps[i][j];
			if(s[ps[i][j]] != psc[i][j]){
				++cntfls[i];
				rcntfls[ps[i][j]].push_back(i);
			}
		}
	}
	set<pair<int, int>> st;
	for(int i = 0; i < n; ++i){
		st.insert({cntfls[i], i});
	}
	while(st.size()){
		if(st.begin()->first != 0){
			cout << -1;
			return 0;
		} else {
			int i = st.begin()->second;
			ans.push_back(i);
			st.erase(st.begin());
			for(auto j : ps[i]){
				if(!found[j]){
					found[j] = true;
					for(auto k : rcntfls[j]){
						st.erase({cntfls[k], k});
						--cntfls[k];
						st.insert({cntfls[k], k});
					}
				}
			}
		}
	}
	for(int i = 0; i < m; ++i){
		if(!found[i]){
			cout << -1;
			return 0;
		}
	}
	for(auto x : ans){
		cout << x + 1 << ' ';
	}
}
