#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
using namespace std;
int need[100];
int taken[100];
vector<pair<int, char>> cards[100];
void sol1(int n, int m, string s) {

    int passed = 0;
    fill(need, need + m, 1);
    vector<int> ans;
    int already = 0;
    while (already != n) {
        vector<int> take;
        for (int i = 0; i < n; i++) {
            if (taken[i]) {
                continue;
            }
            bool fl = true;
            for (int j = 0; j < cards[i].size(); j++) {
                if (need[cards[i][j].first] && cards[i][j].second != s[cards[i][j].first]) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                take.push_back(i);
                taken[i] = true;
                already++;
            }
        }
        if (take.size() == 0) {
            cout << -1;
            return;
        }
        for (auto i : take) {
            ans.push_back(i + 1);
            for (int j = 0; j < cards[i].size(); j++) {
                if (need[cards[i][j].first]) {
                    need[cards[i][j].first] = 0;
                    passed++;
                }
            }
        }
        if (passed == m) {
            for (auto x : ans) {
                cout << x << ' ';
            }
            for (int i = 0; i < n; i++) {
                if (!taken[i]) {
                    cout << i + 1 << ' ';
                }
            }
        }

    }
}
int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        cards[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> cards[i][j].first >> cards[i][j].second;
            cards[i][j].first--;
        }
    }
    vector<int> purm(n);
    iota(purm.begin(), purm.end(), 0);
    do  {
        vector<int> passed(m);
        bool fl = true;
        for (auto i : purm) {
            for (int j = 0; j < cards[i].size(); j++) {
                if (!passed[cards[i][j].first]) {
                    if (cards[i][j].second == s[cards[i][j].first]) {
                        passed[cards[i][j].first] = 1;
                    }
                    else {
                        fl = false;
                        break;
                    }
                }
            }
            if (!fl) {
                break;
            }
        }
        if (fl) {
            if (count(passed.begin(), passed.end(), 1) == m) {
                for (int i = 0; i < n; i++) {
                    cout << purm[i] + 1 << ' ';
                }
                return 0;
            }
        }
    } while (next_permutation(purm.begin(), purm.end()));
    cout << -1;
}
