#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define ll long long
#define size(x) (int)(x).size()

int n, m;
string s;

const int maxn = 400000;
vector<int> adj[maxn];

vector<int> us, top;

void dfs(int v) {
    us[v] = 1;
    for (auto it : adj[v]) {
        int to = it;
        if (us[to] == 0) dfs(to);
    }
    top.push_back(v);
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            if (s[p] != c) {
                adj[p].push_back(m + i);
            } else {
                adj[m + i].push_back(p);
            }
        }
    }
    us.resize(n + m);

    for (int i = 0; i < n + m; ++i) {
        if (us[i] == 0) dfs(i);
    }

    reverse(all(top));
    vector<int> ss(m);
    vector<int> ans;
    for (int i = 0; i < size(top); ++i) {
        int v = top[i];
        if (v >= m) {
            ans.push_back(v - m + 1);
            for (auto to : adj[v]) {
                ss[to] = 1;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (ss[i] == 0) {
            cout << "-1\n";
            exit(0);
        }
    }
    for (int i = 0; i < size(ans); ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}
