//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define ll long long
#define size(x) (int)(x).size()

int n;
vector<int> adj[1000];
vector<int> m[100];

const int con = 20;
bool dp[100][con][con];

vector<int> was, pp, pp2;

void pereb2(int l, int r, int v, int pos) {
    if (dp[v][l][r]) return;
    if (pos == size(pp2)) {
        int lst = r;
        for (int i = size(pp2) - 1; i >= 0; --i) {
            if (!dp[pp[i]][pp2[i]][lst]) return;
            lst = pp2[i] - 1;
        }
        dp[v][l][r] = true;
        return;
    }
    for (int i = pp2[pos - 1] + 1; i <= r; ++i) {
        pp2[pos] = i;
        pereb2(l, r, v, pos + 1);
    }
}

void pereb(int v, int pos) {
    if (pos == size(adj[v])) {
        for (int i = 0; i < con; ++i) {
            for (int j = i; j < con; ++j) {
                if (j != i && dp[v][i][j - 1]) {
                    dp[v][i][j] = true;
                    continue;
                }
                pp2.resize(size(was));
                pp2[0] = i;
                pereb2(i, j, v, 1);
            }
        }
        return;
    }
    for (int i = 0; i < size(was); ++i) {
        if (was[i] == 0) {
            was[i] = 1;
            pp[pos] = adj[v][i];
            pereb(v, pos + 1);
            was[i] = 0;
        }
    }
}

void dfs(int v) {
    for (auto to : adj[v]) {
        dfs(to);
    }
    if (size(adj[v]) == 0) {
        for (auto w : m[v]) {
            for (int i = 0; i <= w; ++i) {
                for (int j = w; j < con; ++j) {
                    dp[v][i][j] = true;
                }
            }
        }
        return;
    }
    if (size(adj[v]) == 2) {
        int s1 = adj[v][0], s2 = adj[v][1];
        for (int i = 0; i < con; ++i) {
            for (int j = con - 1; j >= i; --j) {
                for (int k = i; k < j; ++k) {
                    if (dp[s1][i][k] && dp[s2][k + 1][j]) {
                        dp[v][i][j] = true;
                        break;
                    }
                    if (dp[s2][i][k] && dp[s1][k + 1][j]) {
                        dp[v][i][j] = true;
                        break;
                    }
                }
                if (!dp[v][i][j]) break;
            }
        }
        return;
    }
    was.clear();
    pp.clear();
    was.resize(size(adj[v]));
    pp.resize(size(adj[v]));
    pereb(v, 0);
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n;

    map<int, int> mp;
    vector<int> xx;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            x--;
            if (t == 1) adj[i].push_back(x);
            else {
                m[i].push_back(x);
                xx.push_back(x);
            }
        }
    }
    sort(all(xx));
    for (int i = 0; i < size(xx); ++i) {
        mp[xx[i]] = i;
    }
    for (int i = 0; i < 100; ++i) {
        for (int j = 0; j < size(m[i]); ++j) {
            m[i][j] = mp[m[i][j]];
        }
    }
    dfs(0);
    for (int i = 0; i < con; ++i) {
        for (int j = i; j < con; ++j) {
            if (dp[0][i][j]) {
                cout << "Yes\n";
                exit(0);
            }
        }
    }
    cout << "No\n";

}
