#include <bits/stdc++.h>

using namespace std;

const int ALF = 28, MAXN = 2000 + 10;

bool f[ALF][ALF];
string s;

int deletable[MAXN][MAXN];

bool calc(int L, int R) {
    if (L == R) {
        return deletable[L][R] = 1;
    }
    if (deletable[L][R] != -1) {
        return deletable[L][R];
    }
    if (f[s[L] - 'a'][s[R] - 'a'] && calc(L, R - 1)) {
        deletable[L][R] = true;
    } else {
        deletable[L][R] = false;
    }
    for (int M = L + 1; M < R; M++) {
        if (f[s[M] - 'a'][s[R] - 'a']) {
            deletable[L][R] |= calc(L, M) & calc(M, R);
        }
    }
    return deletable[L][R];
}

signed main() {
    //freopen("input.txt", "r", stdin);
    memset(deletable, -1, sizeof(deletable));
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        string t;
        cin >> t;
        for (int j = 0; j < k; j++) {
            if (t[j] == '1') {
                f[i][j] = 1;
            }
        }
    }
    cin >> s;
    int pred[n + 1];
    memset(pred, -1, sizeof(pred));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = n; j > i; j--) {
            if (calc(i, j - 1)) {
                if (pred[i] == -1 || (s[pred[i]] > s[j])) {
                    pred[i] = j;
                }
                //dp[i] = (dp[i].empty() ? s[i] + dp[j] : min(dp[i], s[i] + dp[j]));
            }
        }
    }
    int v = 0;
    while (v != -1) {
        cout << s[v];
        v = pred[v];
    }
}
