#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100;

vector<int> g[MAXN], ans[MAXN];
vector<int> docs[MAXN];
int pred[MAXN], n;

vector<int> kek;

vector<int> dfs(int v) {
    if (g[v].empty()) {
        return {docs[v][kek[v]]};
    }
    vector<pair<vector<int>, int>> b;
    for (auto u : g[v]) {
        b.push_back({dfs(u), u});
    }
    sort(b.begin(), b.end());
    vector<int> jopa;
    ans[v].clear();
    for (auto &p : b) {
        ans[v].push_back(p.second);
        for (auto x : p.first) {
            jopa.push_back(x);
        }
    }
    return jopa;
}

void gen(int i) {
    if (i == n) {
        vector<int> jopa = dfs(0);
        bool isok = true;
        for (int i = 1; i < jopa.size(); i++) {
            if (jopa[i - 1] > jopa[i]) {
                isok = false;
                break;
            }
        }
        if (isok) {
            cout << "Yes\n";
            for (int v = 0; v < n; v++) {
                if (g[v].size()) {
                    for (auto u : ans[v]) {
                        cout << u + 1 << " ";
                    }
                    cout << endl;
                } else {
                    cout << docs[v][kek[v]] << endl;
                }
            }
            exit(0);
        }
    } else {
        if (docs[i].empty()) {
            kek.push_back(-1);
            gen(i + 1);
            kek.pop_back();
        } else {
            for (int k = 0; k < docs[i].size(); k++) {
                kek.push_back(k);
                gen(i + 1);
                kek.pop_back();
            }
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int v;
                cin >> v;
                v--;
                g[i].push_back(v);
                pred[v] = i;
            }
        } else {
            int m;
            cin >> m;
            while (m--) {
                int x;
                cin >> x;
                docs[i].push_back(x);
            }
        }
    }
    gen(0);
    cout << "No";
}
