#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
#include <cassert>
using namespace std;
//#define int long long

void solve() {
	int k, n;
	cin >> k >> n;
	vector <vector <int>> able(k, vector <int>(k));
	for (int i = 0; i < k; ++i) {
		string tmp;
		cin >> tmp;
		for (int j = 0; j < k; ++j) {
			able[i][j] = (tmp[j] - '0');
		}
	}
	string s;
	cin >> s;
	vector <vector <int>> can(n, vector <int>(n));
	vector <vector <int>> kopt(n, vector <int>(n));
	for (int r = 0; r < n; ++r) {
		for (int l = r; l >= 0; --l) {
			//if (clock() >= 0.6 * CLOCKS_PER_SEC) {
				//break;
			//}
			int len = r - l + 1;
			if (len == 1) {
				if (l != 0 && able[s[l - 1] - 'a'][s[l] - 'a']) {
					can[l][r] = 1;
					kopt[l][r] = -1;
				}
			}
			else {
				int cll = max(0, l - 1);
				if (kopt[l][r - 1] != -1) cll = max(cll, kopt[l][r - 1]);
				int crr = min(n - 1, r - 1);
				if (kopt[l + 1][r] != -1) {
					crr = min(crr, kopt[l + 1][r]);
				}
				for (int k = cll; k <= crr && k < kopt[l + 1][r] && can[l][r] == 0; ++k) {
					bool ok = true;
					if (!able[s[k] - 'a'][s[r] - 'a']) ok = false;
					if (k < r - 1 && can[k + 1][r - 1] == 0) ok = false;
					if (k != l - 1 && can[l][k] == 0) ok = false;
					if (ok) {
						can[l][r] = 1;
						kopt[l][r] = k;
						break;
					}
				}
			}
		}
	}
	for (int l = 0; l < n; ++l) {
		bool wasZero = false;
		for (int r = l; r < n; ++r) {
			if (can[l][r] == 0) {
				wasZero = true;
			}
			if (can[l][r] == 1 && wasZero == true) {
				assert(false);
			}
		}
	}
	vector <string> d(n);
	set <pair <string, int>> st;
	d[n - 1] = s[n - 1];
	st.insert({ d[n - 1], n - 1 });
	st.insert({ "", n });
	for (int i = n - 2; i >= 0; --i) {
		for (auto& vt : st) {
			if (vt.second == i + 1 || can[i + 1][vt.second - 1] == 1) {
				d[i] = s[i] + vt.first;
				break;
			}
		}
		st.insert({ d[i], i });
	}
	string ans = d[0];
	for (int i = 1; i < n; ++i) {
		if (can[0][i - 1] && d[i] < ans) {
			ans = d[i];
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	while (test--) {
		solve();
	}
}