#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<random>
using namespace std;

mt19937 gen(0);
vector<vector<int>> g, new_g;

int bit(int mask, int pos) {
	return (mask >> pos) & 1;
}

vector<int> way;

void dfs(int v, int p) {
	for (auto u : new_g[v]) {
		dfs(u, v);
	}
	if (new_g[v].size() == 0) {
		way.push_back(v);
	}
}

int main() {
	int n;
	cin >> n;
	g.resize(n);
	vector<vector<pair<int, int>>> tasks(n);
	vector<int> mend;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int v;
				cin >> v;
				--v;
				g[i].push_back(v);
			}
			mend.push_back(i);
		}
		else {
			int m;
			cin >> m;
			for (int j = 0; j < m; ++j) {
				int ts;
				cin >> ts;
				tasks[i].push_back({ ts, j });
			}
			sort(tasks[i].begin(), tasks[i].end());
		}
	}
	for (int mask = 0; mask < (1 << mend.size()); ++mask) {
		new_g = g;
		for (int i = 0; i < mend.size(); ++i) {
			if (bit(mask, i)) {
				reverse(new_g[mend[i]].begin(), new_g[mend[i]].end());
			}
			way.clear();
			dfs(0, -1);
			int last_min = 0;
			int is_ans = 1;

			vector<int> ans(n);
			for (auto x : way) {
				int good = 0;
				for (auto ts: tasks[x]) {
					if (ts.first > last_min) {
						last_min = ts.first;
						ans[x] = ts.first;
						good = 1;
						break;
					}
				}
				if (good == 0) {
					is_ans = 0;
					break;
				}
			}
			if (is_ans) {
				cout << "YES" << '\n';
				for (int i = 0; i < n; ++i) {
					if (g[i].size() != 0) {
						for (auto u: new_g[i]) {
							cout << u + 1 << ' ';
						}
					}
					else {
						cout << ans[i];
					}
					cout << '\n';
				}
				return 0;
			}
		}
	}
	cout << "NO";
}
	


//3 7
//010
//001
//100
//abacaba

//3 5
//010
//001
//100
//bcacb