//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

#include <iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<cassert>

using namespace std;

bool check(int i, int j, int st, int ind, string& s) {
	if (st == 0 && (i + j) % 2 == s[ind] - '0')
		return true;
	if (st == 1 && (i + j) % 2 == 0)
		return true;
	if (st == 2 && (i + j) % 2 == 1)
		return true;
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t, n, k, m;
	cin >> t >> n >> k >> m;
	if (t == 1) {
		string s;
		cin >> s;
		int ind = 0;
		int first = 1;
		int st = 0;
		while (ind < s.size()) {
			vector<vector<int>> fld(n, vector<int>(n));
			if (first && s[ind] == '0') {
				cout << n << ' ' << n << endl;
				fld[n - 1][n - 1] = 1;
			}
			else if (first) {
				cout << n << ' ' << n - 1 << endl;
				fld[n - 1][ n -1] = 1;
				fld[n - 1][ n - 2] = 1;
			}
			for (;;) {
				int x, y;
				cin >> x >> y;
				--x, --y;
				if (x == 0 && y == 0)
					break;
				for (int i = x; i < n; ++i)
					for (int j = y; j < n; ++j)
						fld[i][j] = 1;
				if (ind == s.size()) {
					cout << "1 1" << endl;
					break;
				}
				bool flag = false;
				pair<int, int> sm = {-1, -1};
				for (int i = n - 1; i >= 0; --i) {
					if (flag)
						break;
					for (int j = n - 1; j >= 0; --j) {
						if (sm.first == -1 && fld[i][j])
							sm = { i, j };
						if (fld[i][j] == 0 && check(i, j, st, ind, s)) {
							x = i, y = j;
							flag = true;
							if (st == 2)
								++ind;
							st = (st + 1) % 3;
							break;
						}
					}
				}
				if (!flag)
					x = sm.first, y = sm.second;
				for (int i = x; i < n; ++i)
					for (int j = y; j < n; ++j)
						fld[i][j] = 1;
				cout << x + 1 << ' ' << y+ 1 << endl;
				if (x == 0 && y == 0)
					break;
			}
			first = (first + 1) % 2;
		}
		if (!first) {
			int te;
			cin >> te >> te;
		}
		cout << 0 << endl;
	}
	if (t == 2) {
		assert(false);
		string ans;
		ans.reserve(m);
		int g;
		cin >> g;
		int first = 1;
		for (int i = 0; i < g; ++i) {
			vector<pair<int, int>> trn;
			while (trn.empty() || trn.back() != make_pair(1, 1)) {
				int temp1, temp2;
				cin >> temp1 >> temp2;
				trn.emplace_back(temp1, temp2);
			}
			for (int i = (first == 1 ? 0 : 1); i + 5 < trn.size(); i += 6) {
				if ((trn[i + 3].first + trn[i + 3].second) % 2 == 0 &&
					(trn[i + 5].first + trn[i + 5].second) % 2 == 1)
					ans += ('0' + (trn[i].first + trn[i].second) % 2);
				else
					break;
			}
			first = (first + 1) % 2;
		}
		cout << ans << endl;
	}
}