#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <assert.h>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


int n;
int k;
int m;

void fil(int i, int j, vector<vector<bool>>& filed) {
	for (int t1 = i; t1 < n; t1++) {
		for (int t2 = j; t2 < n; t2++) {
			filed[t1][t2] = true;
		}
	}
}

int main() {
	int t;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1) {
		string inf;
		cin >> inf;

		int pnt = 0;

		int player = 1;

		while (true) {
			vector<vector<bool>> filed(n, vector<bool>(n));
			player ^= 1;

			if (pnt >= m && player == 0) {
				cout << "0" << endl;
				return 0;
			}

			while (true) {

				if (player == 0) {
					int col = 0;
					if (pnt >= m) {
						col = -1;
					}
					else {
						rep(l, 4) {
							col *= 2;
							col += inf[pnt + l] - '0';
						}
					}

					vpii cand;
					per(i, n) {
						per(j, n) {
							if (filed[i][j] == 0 && (i + j) != 0) {
								if ((i + j) % 16 == col) {
									cand.pb({ i, j });
								}
							}
						}
					}
					sort(all(cand), [&](pii a, pii b) {return a.ff + a.ss > b.ff + b.ss; });


					if (cand.empty()) {
						cout << "1 1" << endl;
						break;
					}
					else {
						int pt = 0;
						int i = cand[pt].ff;
						int j = cand[pt].ss;
						cout << i + 1 << " " << j + 1 << endl;
						fil(i, j, filed);
					}
					pnt += 4;
					int x, y;
					cin >> x >> y;
					x--; y--;
					if (x + y == 0) {
						break;
					}


					fil(x, y, filed);
				}
				if (player == 1) {
					int x, y;
					cin >> x >> y;
					x--; y--;
					if (x + y == 0) {
						break;
					}
					fil(x, y, filed);
					int col = 0;
					if (pnt >= m) {
						col = -1;
					}
					else {
						rep(l, 4) {
							col *= 2;
							col += inf[pnt + l] - '0';
						}
					}
					vpii cand;
					per(i, n) {
						per(j, n) {
							if (filed[i][j] == 0 && (i + j) != 0) {
								if ((i + j) % 16 == col) {
									cand.pb({ i, j });
								}
							}
						}
					}
					sort(all(cand), [&](pii a, pii b) {return a.ff + a.ss > b.ff + b.ss; });


					if (cand.empty()) {
						cout << "1 1" << endl;
						break;
					}
					else {
						int pt = 0;
						int i = cand[pt].ff;
						int j = cand[pt].ss;
						cout << i + 1 << " " << j + 1 << endl;
						fil(i, j, filed);
					}
					pnt += 4;

				}
			}
		}
	}
	else {
		int games;
		cin >> games;
		string ans(m, '0');
		int pnt = 0;
		int player = 1;
		while (games--) {
			player ^= 1;
			int move = player;
			while (true) {
				int x, y;
				cin >> x >> y;
				x--; y--;
				if (x + y == 0) {
					break;
				}
				if (move == 0) {
					int p = (x + y) % 16;
					rep(l, 4) {
						if ((1 << l) && p) {
							ans[pnt++] = '1';
						}
					}
				}
				move ^= 1;
			}
		}
		cout << ans << endl;
	}
	return 0;
}