#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef  pair<int, int> pii;
typedef vector<pii> vpii;


int n;
int k;
int m;

void fil(int i, int j, vector<vector<bool>>& filed) {
	for (int t1 = i; t1 < n; t1++) {
		for (int t2 = j; t2 < n; t2++) {
			filed[t1][t2] = true;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1) {

		string inf;
		cin >> inf;

		int pnt = 0;

		int player = 1;

		while (pnt < m) {
			vector<vector<bool>> filed(n, vector<bool>(n));
			player ^= 1;

			while (true) {

				if (player == 0) {
					if (pnt == m) {
						cout << "0" << endl;
						break;
					}

					int col = inf[pnt] - '0';
					pnt++;
					bool found = false;
					per(i, n) {
						if (found) break;
						per(j, n) {
							if (filed[i][j] == 0 && (i + j) != 0) {
								if ((i + j) % 2 == col) {
									cout << i + 1 << " " << j + 1 << endl;
									fil(i, j, filed);
									found = true;
									break;
								}
							}
						}
					}

					if (!found) {
						cout << "1 1" << endl;
						break;
					}

					int x, y;
					cin >> x >> y;
					x--; y--;
					if (x + y == 0) {
						break;
					}


					fil(x, y, filed);
				}
				if (player == 1) {
					int x, y;
					cin >> x >> y;
					x--; y--;
					if (x + y == 0) {
						break;
					}
					fil(x, y, filed);
					if (pnt == m) {
						cout << "0" << endl;
						break;
					}
					

					int col = inf[pnt] - '0';
					pnt++;
					bool found = false;
					per(i, n) {
						if (found) break;
						per(j, n) {
							if (filed[i][j] == 0 && (i + j) != 0) {
								if ((i + j) % 2 == col) {
									cout << i + 1 << " " << j + 1 << endl;
									fil(i, j, filed);
									found = true;
									break;
								}
							}
						}
					}

					if (!found) {
						cout << "1 1" << endl;
						break;
					}
				}
			}
		}
	}
	else {
		int games;
		cin >> games;
		string ans(m, '0');
		int pnt = 0;
		int player = 1;
		while (games--) {
			player ^= 1;
			int move = player;
			while (true) {
				int x, y;
				cin >> x >> y;
				x--; y--;
				if (x + y == 0) {
					break;
				}
				if (move == 0) {
					if ((x + y) % 2) {
						ans[pnt++] = '1';
					}
					else {
						ans[pnt++] = '0';
					}
				}
				move ^= 1;
			}
		}
		cout << ans;
	}
	return 0;
}