#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define int long long


const int inf = 1e18;
vector<int> val;
vector<vector<int>> dp;
vector<vector<pii>> pr;

void relax(int i, int l, int b) {
	if (l >= b) {
		if (dp[i + 1][b] + val[l] > dp[i][l]) {
			dp[i][l] = dp[i + 1][b] + val[l];
			pr[i][l] = {l, b};
		}
		
	} else {
		if (dp[i + 1][b] - val[l] > dp[i][l]) {
			dp[i][b] = dp[i + 1][b] - val[l];
			pr[i][b] = {l, b};
		}
	}
}

void solve() {
	string s;
	cin >> s;

	int n = s.size();

	dp.assign(n + 1, vector<int>(26, -inf));
	pr.assign(n + 1, vector<pii>(26, {-1, -1}));


	dp[n][0] = 0;

	for (int i = n - 1; i >= 0; i--) {
		for (int a = 0; a < 26; a++) {
			if (s[i] == '?') {
				for (int b = 0; b < 26; b++) {
					relax(i, b, a);
				}
			} else {
				relax(i, s[i] - 'A', a);
			}
		}
	}

	int pmx = 0;

	for (int i = 0; i < 26; i++) {
		if (dp[0][pmx] < dp[0][i]) pmx = i;
	}
	cout << dp[0][pmx] << '\n';


	pii h = pr[0][pmx];
	for (int i = 1; i <= n; i++) {
		cout << (char)('A' + h.first);
		h = pr[i][h.second];
	}
	cout << '\n';
}




signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	val.resize(26);
	val[0] = 1;
	val[1] = 5;
	for (int i = 2; i < 26; i++) {
		val[i] = 10 * val[i - 2];
		// cout << val[i] << '\n';
	}

	int t;
	cin >> t;
	while (t--) {
		solve();
	}


	return 0;
}
