#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 500005;
int n, q;
int x[MAX_N], h[MAX_N];

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> q;
	for (int i = 1; i <= n; i++)
	{
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];

	vector<int> v;
	int l, r, res;
	for (int qq = 0; qq < q; qq++)
	{
		cin >> l >> r;
		res = 0;
		v.clear();
		v.push_back(l - 1);
		for (int i = l; i <= r; i++)
		{
			while (v.size() > 1 && x[v.back()] + h[v.back()] <= x[i])
			{
				v.pop_back();
				res++;
			}

			if (x[i] - h[i] >= x[v.back()])
			{
				res++;
			}
			else
			{
				v.push_back(i);
			}
		}
		while (v.size() > 1 && x[v.back()] + h[v.back()] <= x[r + 1])
		{
			v.pop_back();
			res++;
		}
		cout << res << endl;
	}

	return 0;
}