#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int maxn = 150000;

map<pair<int, int>, pair<int, int>> edg;
vector<int> g[maxn];

int dp[maxn];
bool used[maxn];
pair<int, int> dp1[maxn];
vector<pair<pair<int, int>, pair<int, int>>> ans;

void dfs(int v, int pr) {
    used[v] = 1;
    vector<pair<int, int>> up, down;
    for (auto u: g[v]) {
        if (!used[u]) {
            dfs(u, v);
            int val = dp[u];
            if (edg[{v, u}].f != 1 || edg[{v, u}].s != 1) {
                if (val == 0) {
                    if (edg[{v, u}].f == 1) {
                        down.pb({v, u});
                    } else {
                        up.pb({u, v});
                    }
                }
                if (val == -1 && edg[{v, u}].f == 1) {
                    ans.pb({dp1[u], {v, u}});
                    val = 0;
                }
                if (val == 1 && edg[{v, u}].s == 1) {
                    ans.pb({dp1[u], {u, v}});
                    val = 0;
                }
                if (val != 0) {
                    cout << "No";
                    exit(0);
                }
            }
            if (edg[{v, u}].f == 1 && edg[{v, u}].s == 1) {
                if (val == 0) {
                    ans.pb({{v, u}, {u, v}});
                }
                if (val == -1) {
                    ans.pb({dp1[u], {v, u}});
                    up.pb({u, v});
                }
                if (val == 1) {
                    ans.pb({dp1[u], {u, v}});
                    down.pb({v, u});
                }
            }
        }
    }
    while (up.size() > 0 && down.size() > 0) {
        ans.pb({up.back(), down.back()});
        up.pop_back();
        down.pop_back();
    }
    if (up.size() > 1 || down.size() > 1) {
        cout << "No";
        exit(0);
    }
    if (up.size()) {
        dp[v] = 1;
        dp1[v] = up[0];
    }
    if (down.size()) {
        dp[v] = -1;
        dp1[v] = down[0];
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
        edg[{u, v}].f = 1;
        edg[{v, u}].s = 1;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i, i);
            if (dp[i] != 0) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto kek: ans) {
        cout << kek.f.f + 1 << ' ' << kek.f.s + 1 << ' ' << kek.s.f + 1 << ' ' << kek.s.s + 1 << '\n';
    }
    return 0;
}
