#include <iostream>
#include <vector>
#include <unordered_map>
#pragma GCC optimize("Ofast")
#pragma GCC optimization("avx,avx2,fma")

using namespace std;

#define v vector
#define int long long
#define pr pair<int, int>
#define x first
#define h second

int n, q;

v<pr> tr;

void init() {
    cin >> n >> q;
    tr.resize(n);
    for (int i = 0; i < n; i++) cin >> tr[i].x >> tr[i].h;
}

void get_ans(int l, int r) {
    v<int> cur;
    for (int i = l; i <= r; i++) cur.push_back(i);
    while (true) {
        int id = -1;
        for (int i = 0; i < cur.size(); i++) {
            int j = cur[i];
            int L_X = tr[j].x - tr[j].h;
            int R_X = tr[j].x + tr[j].h;
            bool ok1 = true, ok2 = true;
            if (l - 1 >= 0 && tr[l - 1].x > L_X) ok1 = false;
            if (i - 1 >= 0 && tr[cur[i - 1]].x > L_X) ok1 = false;
            if (tr[0].x > L_X) ok1 = false;

            if (r + 1 < n && R_X > tr[r + 1].x) ok2 = false;
            if (i + 1 < cur.size() && R_X > tr[cur[i + 1]].x) ok2 = false;
            if (R_X > tr[n - 1].x) ok2 = false;

            if (ok1 || ok2) {
                id = i;
                break;
            }
        }
        if (id == -1) break;
        v<int> new_cur;
        for (int i = 0; i < cur.size(); i++) {
            if (i != id) {
                new_cur.push_back(i);
            }
        }
        cur = new_cur;
    }
    cout << r - l + 1 - cur.size() << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init();

    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r; l--; r--;
        get_ans(l, r);
    }
    return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
 */

/*
5 3
1 5
3 1
4 2
5 3
6 1

1 5
5 5
1 1
 */

/*
1 1
100 100
1 1
 */
