#include <bits/stdc++.h>
using namespace std;
#define int long long
#define app push_back
#define vi vector <int>
#define ii pair <int, int>
#define FOR(i,n) for (int i = 0; i < n; ++i)
#define FORN(i,n) for (int i = 1; i <= n; ++i)
#define x first
#define y second
#define mp make_pair
#define debug(x) cout<<#x<<": "<<x<<endl;
#define trav(e,a) for (auto &e : a)
#define all(a) a.begin(),a.end()

void ckmin(int &a, int b) {
    a = min(a, b);
}	

const int N = 3e5+7, LG = 20;
vector <vi> g[N];

int n, m;
int ans[N];
const int INF = 1e18, C = 1000 * 1000 * 1000;

int h[N];
bool used[N];
int up[N];
int can[N];

vi tree[N];
bool brid[N];

vi root;
int par[N];
void dfs(int u, int p) {
	par[u] = p;
  	used[u] = 1;
  	can[u] = h[u];
  	trav (e, g[u]) {
  	    int v = e[0], i = e[2];
  	    if (!used[v]) {
  	    	tree[u].app(v);
  	    	h[v] = h[u] + 1;
  	    	up[v] = i;
  	        dfs(v, u);
  	    }	
  	    else if (i != up[u]) {
  	        ckmin(can[u], h[v]);
  	    }	
  	}
  	if (can[u] == h[u]) {
  		root.app(u);
	}	
}	
                    
int comp[N];
void calc(int u, int c) {
	comp[u] = c;
    trav (v, tree[u]) {
        if (!brid[v]) {
            calc(v, c);
        }	
    }	
}	

vi t[N];
int tin[N], tout[N], ptr = 0;
void jfs(int u) {
	tin[u] = ptr++;
    trav (v, t[u]) {
    	h[v] = h[u] + 1;
     	jfs(v);
    }	
    tout[u] = ptr++;
}	

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}	

int prop[N];
void relax(int u) {
    trav (v, t[u]) {
        ckmin(prop[v], prop[u]);
        relax(v);
    }	
}	

signed main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);  
    #endif

   	FOR (i, N)
   		prop[i] = INF;

	cin >> n >> m;
	vector <vi> sc;
	FOR (i, m) {
	    int u, v, c;
	    cin >> u >> v >> c;
	    g[u].app({v, c, i});
	    g[v].app({u, c, i});
	    sc.app({u, v, c});
    }	
	dfs(1, 1);

	trav (u, root) {
		calc(u, u);	 	
	}

	for (int i = 2; i <= n; ++i) {
	    if (brid[i]) {
	    	t[comp[par[i]]].app(comp[i]);
	    }	
	}	

	h[1] = 0;
	jfs(1);

	trav (e, sc) {              	
		int u = e[0], v = e[1];

	    int down = comp[u];
	    if (h[comp[v]] > h[comp[u]])
	    	down = comp[v];

	    ckmin(prop[down], e[2]);
	}	

	relax(1);
	for (int i = 2; i <= n; ++i) {
	    int c = comp[i];
	    ans[i] = prop[c];
	}	

	for (int i = 2; i <= n; ++i) {
		cout << C + ans[i] << endl;
	}	
}