#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 100;
vector<vector<pair<int, int>>> g;
vector<int> mn, mx;

void dfs(int u, int p, int _mn, int _mx) {
    mn[u] = _mn;
    mx[u] = _mx;
    for (auto to: g[u]) {
        if (to.first != p)
            dfs(to.first, u, min(_mn, to.second), max(_mx, to.second));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    mn.resize(n);
    mx.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u;
        --v;
        g[u].emplace_back(v, t);
        g[v].emplace_back(u, t);
    }
    int _mn = INF, _mx = 0;
    for (int i = 0; i < n; ++i) {
        if (i > 0)
            cout << _mn + _mx << '\n';
        int minim = INF;
        for (auto to: g[i]) {
            if (to.first == i + 1)
                minim = min(minim, to.second);
        }
        _mn = min(_mn, minim);
        _mx = max(_mx, minim);
    }
}
