#include <bits/stdc++.h> 
//#define int long long

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 3e5 + 7; 
const ll inf = 2e9 + 7; 
int n, m;  

struct edge {
    int to, w, id; 
}; 

vector<pii> gr[maxn]; 
int dist[maxn]; 
void dj() {
    set<pii> q; 
    q.insert({0, 0});
    for (int i = 1; i < n; ++i) {
        dist[i] = inf; 
    }
    while (q.size()) {
        pii u = *q.begin(); 
        q.erase(q.begin()); 
        for (auto v : gr[u.ss]) {
            if (dist[v.ff] > max(u.ff, v.ss)) {
                q.erase({dist[v.ff], v.ff}); 
                dist[v.ff] = max(u.ff, v.ss); 
                q.insert({dist[v.ff], v.ff}); 
            }
        }
    }        
}

void solve() {
    cin >> n >> m; 
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t, --u, --v; 
        gr[u].pb({v, t}); 
        gr[v].pb({u, t}); 
    }
    dj(); 
    for (int i = 1; i < n; ++i) cout << dist[i] << '\n'; 
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}