#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll opr(char x) {
    return pow(10, (x - 'A') / 2) * pow(5, (x - 'A') % 2);
}


void solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<vector<ll>> dp(n + 1, vector<ll> (26, -2e18));
    vector<vector<pair<int, char>>> p(n + 1, vector<pair<int, char>> (26, {-1, '-'}));
    for (int i = 0; i < 26; i++) dp[n][i] = 0;
    for (int i = n - 1; i > -1; i--) {
        if (s[i] != '?') {
            for (int let = 0; let <= s[i] - 'A'; ++let) {
                if (dp[i][s[i] - 'A'] < dp[i + 1][let] + opr(s[i])) {
                    dp[i][s[i] - 'A'] = dp[i + 1][let] + opr(s[i]);
                    p[i][s[i] - 'A'] = {let, s[i]};
                }
            }
            for (int let = s[i] - 'A' + 1; let < 26; let++) {
                if (dp[i][let] < dp[i + 1][let] - opr(s[i])) {
                    dp[i][let] = dp[i + 1][let] - opr(s[i]);
                    p[i][let] = {let, s[i]};
                }
            }
        } else {
            for (int j = 0; j < 26; j++) {
                s[i] = (char) ('A' + j);
                for (int let = 0; let <= s[i] - 'A'; ++let) {
                    if (dp[i][s[i] - 'A'] < dp[i + 1][let] + opr(s[i])) {
                        dp[i][s[i] - 'A'] = dp[i + 1][let] + opr(s[i]);
                        p[i][s[i] - 'A'] = {let, s[i]};
                    }
                }
                for (int let = s[i] - 'A' + 1; let < 26; let++) {
                    if (dp[i][let] < dp[i + 1][let] - opr(s[i])) {
                        dp[i][let] = dp[i + 1][let] - opr(s[i]);
                        p[i][let] = {let, s[i]};
                    }
                }
            }
        }
    }
    int best = 0;
    for (int i = 1; i < 26; i++) {
        if (dp[0][i] > dp[0][best]) best = i;
    }
    string snew;
    for (int lev = 0; lev < n; lev++) {
        snew += p[lev][best].second;
        best = p[lev][best].first;
    }
    ll sum = 0;
    char ma = 'A';
    for (int i = n - 1; i > -1; i--) {
        if (ma > snew[i]) sum -= opr(snew[i]);
        else sum += opr(snew[i]);
        ma = max(ma, snew[i]);
    }
    cout << sum << '\n' << snew << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
