#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gnew;
vector<bool> used;
vector<pair<pair<int, int>, pair<int, int>>> ans;
map<pair<int, int>, int> f;

pair<bool, pair<int, int>> dfs(int now, int p) {
    if (used[now]) return {true, {-1, -1}};
    used[now] = true;
    vector<pair<int, int>> indown;
    vector<pair<int, int>> outdown;
    for (auto i : gnew[now]) {
        pair<bool, pair<int, int>> res = dfs(i, now);
        if ((pair<int, int>) {-1, -1} != res.second) {
            if (res.first) indown.push_back(res.second);
            else outdown.push_back(res.second);
        }
    }
    while (!indown.empty() && !outdown.empty()) {
        ans.push_back({indown.back(), outdown.back()});
        indown.pop_back();
        outdown.pop_back();
    }
    pair<int, int> upin = {-1, -1};
    pair<int, int> upout = {-1, -1};
    int x = f[{min(now, p), max(now, p)}];
    if (x == 3 || (x == 1 && now < p) || (x == 2 && now > p)) upin = {p, now};
    if (x == 3 || (x == 1 && now > p) || (x == 2 && now < p)) upout = {now, p};
    if (!indown.empty()) {
        if ((pair<int, int>) {-1, -1} == upout || indown.size() > 1) {
            cout << "No";
            exit(0);
        }
        ans.push_back({indown.back(), upout});
        upout = {-1, -1};
    }
    if (!outdown.empty()) {
        if ((pair<int, int>) {-1, -1} == upin || outdown.size() > 1) {
            cout << "No";
            exit(0);
        }
        ans.push_back({outdown.back(), upin});
        upin = {-1, -1};
    }
    if ((pair<int, int>) {-1, -1} != upin && (pair<int, int>) {-1, -1} != upout) {
        ans.push_back({upin, upout});
        upin = {-1, -1};
        upout = {-1, -1};
    }
    if ((pair<int, int>) {-1, -1} != upin)
        return {false, upin};
    return {true, upout};
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    gnew.resize(n);
    used.assign(n, false);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gnew[u].push_back(v);
        gnew[v].push_back(u);
        if (f[{min(u, v), max(u, v)}] != 0) f[{min(u, v), max(u, v)}] = 3;
        else {
            if (min(u, v) == v) f[{min(u, v), max(u, v)}] = 1;
            else f[{min(u, v), max(u, v)}] = 2;
        }
    }
    for (int i = 0; i < n; i++) {
        if ((pair<int, int>) {-1, -1} != dfs(i, -1).second) {
            cout << "No";
            exit(0);
        }
    }
    cout << "Yes \n";
    for (auto i : ans) cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << '\n';
}