#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> ans;
vector<pair<int, int>> best;

void dfs(int now, int p, int cost) {
    best[now].first = min(best[p].first, cost);
    best[now].second = max(best[p].second, cost);
    ans[now] = best[now].first + best[now].second;
    for (auto i : g[now]) {
        if (i.first == p) continue;
        dfs(i.first, now, i.second);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    ans.resize(n);
    best.assign(n, {1e9, 0});
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        g[v - 1].push_back({u - 1, t});
        g[u - 1].push_back({v - 1, t});
    }
    if (m == n - 1) dfs(0, 0, 0);
    for (int i = 1; i < n; i++) cout << ans[i] << ' ';
}
