#include <bits/stdc++.h>

using namespace std;

struct tree {
    int x, h;

    tree(int x = 0, int h = 0) : x(x), h(h) {}
};

#define left left228
#define right right228
#define MAXN 5000
tree trees[MAXN];
int left[MAXN];
int right[MAXN];
vector<int> need_r[MAXN];
int n;

int arr[MAXN];

void reset(int v = 1, int l = 0, int r = n) {
    if (r - l == 1) {
        arr[v] = 1;
        return;
    }
    int m = (r + l) / 2;
    reset(v * 2, l, m);
    reset(v * 2 + 1, m, r);
    arr[v] = arr[v * 2] + arr[v * 2 + 1];
}

void upd(int pos, int v = 1, int l = 0, int r = n) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r - l == 1) {
        arr[v] = 0;
        return;
    }
    int m = (r + l) / 2;
    upd(pos, v * 2, l, m);
    upd(pos, v * 2 + 1, m, r);
    arr[v] = arr[v * 2] + arr[v * 2 + 1];
}

int sum(int l, int r, int v = 1, int tl = 0, int tr = n) {
    if (r <= tl || tr <= l) {
        return 0;
    }
    if (l <= tl && tr <= r) {
        return arr[v];
    }
    int m = (tl + tr) / 2;
    return sum(l, r, v * 2, tl, m) + sum(l, r, v * 2 + 1, m, tr);
}

int solve(int l, int r) {
    reset();
    while (true) {
        int pos = -1;
        for (int i = l; i < r; ++i) {
            if (sum(i, i + 1) == 0) {
                continue;
            }
            bool canl = trees[i].x - trees[i].h >= trees[0].x;
            canl &= sum(left[i], i) == 0;
            bool canr = trees[i].x + trees[i].h <= trees[n - 1].x;
            canr &= sum(i + 1, right[i]) == 0;
            if (canl || canr) {
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            break;
        }
        upd(pos);
    }
    return n - sum(0, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        trees[i] = {x, h};
    }
    for (int i = 0; i < n; ++i) {
        left[i] = i;
        for (int j = i - 1; j >= 0; --j) {
            if (trees[i].x - trees[i].h < trees[j].x) {
                left[i] = j;
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        right[i] = i + 1;
        for (int j = i + 1; j < n; ++j) {
            if (trees[i].x + trees[i].h > trees[j].x) {
                right[i] = j + 1;
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << solve(l, r) << "\n";
    }
    return 0;

}