#include <bits/stdc++.h>

using namespace std;

struct tree {
    int x, h;

    tree(int x = 0, int h = 0) : x(x), h(h) {}
};

#define MAXN 5000
tree trees[MAXN];
int n;

int solve(int l, int r) {
    stack<int> cur;
    for (int i = l; i < r; ++i) {
        while (!cur.empty() && trees[cur.top()].x + trees[cur.top()].h <= trees[i].x) {
            cur.pop();
        }
        bool can_l = trees[i].x - trees[i].h >= trees[max(0, l - 1)].x;
        if (!cur.empty()) {
            can_l &= trees[i].x - trees[i].h >= trees[cur.top()].x;
        }
        if (!can_l) {
            cur.push(i);
        }
    }
    while (!cur.empty() && trees[cur.top()].x + trees[cur.top()].h <= trees[min(r, n - 1)].x) {
        cur.pop();
    }
    return r - l - cur.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        trees[i] = {x, h};
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << solve(l, r) << "\n";
    }
    return 0;

}