#include <bits/stdc++.h>
#define ll long long
#define ipair pair <int, int>
#define dpair pair <int, pair <int, int> >
using namespace std;

const int inf = pow(10, 9);

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector <vector <dpair> > g(n);
    for (int i = 0; i < m; i++)
    {
        int from, to, w;
        cin >> from >> to >> w;
        from--; to--;
        g[from].push_back({i, {to, w}});
        g[to].push_back({i, {from, w}});
    }

    for (int last = 1; last < n; last++)
    {
        ipair ans = {inf, inf};
        function <void (int, int, int, int) > dfs = [&](int cur, int mask, int wmin, int wmax)
        {
            if (cur == last)
            {
                if (ans.first + ans.second > wmin + wmax)
                    ans = {wmin, wmax};
            }

            for (auto edge : g[cur])
            {
                int id = edge.first, to = edge.second.first;
                int w = edge.second.second;

                if (!(mask & (1 << id)))
                {
                    int w1 = min(w, wmin);
                    int w2 = max(w, wmax);
                    dfs(to, mask + (1 << id), w1, w2);
                }
            }
        };

        dfs(0, 0, inf, -inf);
        cout << ans.first + ans.second << "\n";
    }
}

