#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > gr;
vector<vector<pair<int, int> > > adj;

vector<bool> used, up;

vector<vector<int> > result;

pair<int, int> dfs(int x)
{
    used[x] = true;
    vector<pair<int, int> > all1, all2;
    for (pair<int, int> w : adj[x])
    {
        int to = w.first;
        bool ed = w.second;
        if (used[to])
        {
            if (ed) up[x] = true;
            continue;

        }
        else
        {
            pair<int, int> tmp = dfs(to);
            if (tmp.first == -1)
            {
                if (up[to])
                    all2.push_back({to, x});
                if (ed)
                    all1.push_back({x, to});
            }
            else if (tmp.first == to)
            {
                if (!ed)
                {
                    cout << "No" << endl;
                    exit(0);
                }
                // pair x to tmp.first tmp.second
                result.push_back({x, to, tmp.first, tmp.second});
                if (up[to]) all2.push_back({to, x});
            }
            else
            {
                if (up[to])
                {
                    // pair tmp.first tmp.second to x
                    result.push_back({tmp.first, tmp.second, to, x});
                }
                else
                {
                    cout << "No" << endl;
                    exit(0);
                }
                if (ed) all1.push_back({x, to});
            }
        }
    }
    while (all1.size() && all2.size())
    {
        // pair all1.back() all2.back()
        result.push_back({all2.back().first, all2.back().second, all1.back().first, all1.back().second});
        all1.pop_back();
        all2.pop_back();
    }
    if (all1.size() > 1 || all2.size() > 1)
    {
        cout << "No" << endl;
        exit(0);
    }
    if (all1.size() == 1) return all1[0];
    if (all2.size() == 1) return all2[0];
    return {-1, -1};
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    adj.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        gr[u].push_back(v);
        adj[u].push_back({v, 1});
        adj[v].push_back({u, 0});
    }
    for (int i = 0; i < n; ++i)
    {
        sort(adj[i].begin(), adj[i].end());
        vector<pair<int, int> > nw = {adj[i][0]};
        for (int j = 1; j < adj[i].size(); ++j)
            if (adj[i][j].first != adj[i][j - 1].first)
                nw.push_back(adj[i][j]);
            else nw.back().second = 1;
        adj[i] = nw;
    }
    up.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i)
        if (!used[i])
        {
            if (dfs(i).first != -1)
            {
                cout << "No" << endl;
                exit(0);
            }
        }
    if (result.size() != m / 2)
    {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (auto i : result)
    {
        for (auto j : i) cout << j + 1 << " ";
        cout << endl;
    }
}
