#include <bits/stdc++.h>

using namespace std;


#define int long long

const int inf = 1e18;

vector<vector<pair<int, int> > > gr;

vector<pair<int, int> > res;
vector<bool> used;
void dfs(int x)
{
    used[x] = true;
    for (int i = 0; i < gr[x].size(); ++i)
    {
        int to = gr[x][i].first;
        int w = gr[x][i].second;
        if (used[to]) continue;
        res[to] = {min(res[x].first, w), max(res[x].second, w)};
        dfs(to);
    }
}

signed main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        gr[u].push_back({v, w});
        gr[v].push_back({u, w});
    }
    used.resize(n, false);
    res.resize(n);
    res[0] = {1e9, 0};

    dfs(0);
    for (int i = 1; i < n; ++i) cout << res[i].first + res[i].second << endl;
}
