#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100, K = 26, INF = 2e18;

int n, m, d[N], p[N];
vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<pair<int, int>> ed;
vector<int> g[N];
bool a0[N], a1[N];
bool used[N];

void dfs1(int v, int pa) {
    p[v] = pa;
    for (int to : g[v]) {
        if (to == pa) continue;
        d[to] = d[v] + 1;
        dfs1(to, v);
    }
}

int dfs2(int v) {
//    cout << v + 1 << " " << p[v] << " in" << endl;
    vector<pair<int, int>> e0, e1;
    for (int to : g[v]) {
        if (to == p[v]) continue;
        int z = dfs2(to);
        if (z == 0) {
            e0.push_back({v, to});
        } else if (z == 1) {
            e1.push_back({to, v});
        }
    }
    while (!e0.empty() && !e1.empty()) {
        ans.push_back({e1.back(), e0.back()});
        e0.pop_back();
        e1.pop_back();
    }
    if (e0.size() >= 2 || e1.size() >= 2 || (e0.size() == 1 && !a0[v]) || (e1.size() == 1 && !a1[v])) {
        cout << "No";
        exit(0);
    }
    if (e0.size() == 1) {
        ans.push_back({{p[v], v}, e0[0]});
        a0[v] = false;
    }
    if (e1.size() == 1) {
        ans.push_back({e1[0], {v, p[v]}});
        a1[v] = false;
    }
    if (a0[v] && a1[v]) {
        ans.push_back({{v, p[v]}, {p[v], v}});
        a0[v] = false;
        a1[v] = false;
    }
    if (a0[v] == a1[v]) return -1;
    if (a0[v]) return 0;
    else return 1;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s;
        cin >> f >> s;
        f--, s--;
        g[f].push_back(s);
        ed.push_back({f, s});
    }
    fill(d, d + n, -1);
    for (int i = 0; i < n; i++) {
        if (d[i] == -1) {
            d[i] = 0;
            dfs1(i, -1);
        }
    }
    for (auto x : ed) {
        if (d[x.first] > d[x.second]) {
            a1[x.first] = true;
        } else {
            a0[x.second] = true;
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i] == 0) {
            if (dfs2(i) != -1) {
                cout << "No";
                exit(0);
            }
        }
    }
    cout << "Yes" << '\n';
    for (auto x : ans) {
        cout << x.first.first + 1 << " " << x.first.second + 1 << " " << x.second.first + 1 << " " << x.second.second + 1 << '\n';
    }
}
