#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 3e5 + 100, K = 26, INF = 2e18;

int n, m, ans[N], ans1[N], ans2[N];
vector<pair<int, int>> a[N];
bool used[N];
int cc[N];

void dfs(int v, int mn, int mx) {
    ans1[v] = min(ans1[v], mn);
    ans2[v] = max(ans2[v], mx);
    ans[v] = min(ans[v], mn + mx);
    for (auto to : a[v]) {
        if (used[to.second]) continue;
        used[to.second] = true;
        if (ans1[to.first] > min(mn, cc[to.second]) || ans2[to.first] < max(mx, cc[to.second])) {
            dfs(to.first, min(mn, cc[to.second]), max(mx, cc[to.second]));
        }
        used[to.second] = false;
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s, c;
        cin >> f >> s >> c;
        f--, s--;
        a[f].push_back({s, i});
        a[s].push_back({f, i});
        cc[i] = c;
    }
    fill(ans, ans + n, INF);
    fill(ans1, ans1 + n, INF);
    fill(ans1, ans1 + n, -INF);
    dfs(0, INF, -INF);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}