#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <set>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


int n, m;
vector<vector<int>> g;
vector<vector<int>> t;
vector<int> res;
vector<int> ts;
vector<int> d;



void bfs() {
	d.resize(n, 1e18);
	d[0] = 0;
	set<pair<int, int>> q;
	vector<bool> usd(n, false);
	q.emplace(0, 0);
	while (!q.empty()) {
		int v = q.begin()->second;
		q.erase(q.begin());
		if (usd[v]) {
			continue;
		}
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i];
			int tm = t[v][i];
			if (!usd[to] && d[to] >= max(tm, d[v])) {
				q.erase(make_pair(d[to], to));
				d[to] = max(tm, d[v]);
				q.emplace(d[to], to);
			}
		}
	}
	res = d;
}


int32_t main() {
	cin >> n >> m;
	g.resize(n);
	t.resize(n);
	res.resize(n);
	ts.resize(m);
	for (int i = 0; i < m; ++i) {
		int u, v, tm;
		cin >> u >> v >> tm;
		ts[i] = tm;
		--u;
		--v;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back(v);
		t[u].push_back(tm);
		g[v].push_back(u);
		t[v].push_back(tm);
	}
	bfs();
	for (int i = 1; i < n; ++i) {
		cout << res[i] << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/