#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <set>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


int n, m;
vector<vector<int>> nmb;
vector<vector<int>> g;
vector<vector<int>> t;
vector<int> res;
vector<int> ts;
vector<int> d;
vector<int> fup;
vector<int> tin;
vector<int> usd;
vector<bool> mst;
int x;



void dfs1(int v, int px) {
	usd[v] = true;
	tin[v] = x++;
	fup[v] = tin[v];
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (nmb[v][i] != px) {
			if (!usd[to]) {
				dfs1(to, nmb[v][i]);
				fup[v] = min(fup[v], fup[to]);
				if (fup[to] > tin[v]) {
					mst[nmb[v][i]] = true;
				}
			}
			else {
				fup[v] = min(fup[v], tin[to]);
			}
		}
	}
}


int dfs2(int v) {
	usd[v] = true;
	int rs = 1e9;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (!mst[nmb[v][i]] && !usd[to]) {
			rs = min({ dfs2(to), rs, t[v][i]});
		}
	}
	return rs;
}


void dfs3(int v) {
	usd[v] = true;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (!mst[nmb[v][i]] && !usd[to]) {
			res[to] = res[v];
			dfs3(to);
		}
	}
}


void dfs4(int v) {
	usd[v] = true;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (!usd[to]) {
			res[to] = min({ res[to], res[v], t[v][i] });
			dfs4(to);
		}
	}
}


void get_res() {
	fup.resize(n);
	tin.resize(n);
	usd.resize(n, false);
	mst.resize(m, false);
	x = 0;
	dfs1(0, -1);
	usd.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!usd[i]) {
			res[i] = dfs2(i);
		}
	}
	usd.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!usd[i]) {
			dfs3(i);
		}
	}
	usd.assign(n, false);
	dfs4(0);
}


int32_t main() {
	cin >> n >> m;
	g.resize(n);
	t.resize(n);
	res.resize(n);
	ts.resize(m);
	nmb.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, tm;
		cin >> u >> v >> tm;
		ts[i] = tm;
		--u;
		--v;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back(v);
		t[u].push_back(tm);
		g[v].push_back(u);
		t[v].push_back(tm);
		nmb[v].push_back(i);
		nmb[u].push_back(i);
	}
	get_res();
	for (int i = 1; i < n; ++i) {
		cout << res[i] + (ll)(1e9) << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/


/*
5 5
1 2 4
2 3 3
3 5 2
3 4 1
4 5 0
*/