#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <set>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


int n, m;
vector<vector<int>> g;
vector<vector<int>> t;
vector<vector<int>> nmb;
vector<int> res;
vector<int> ts;
vector<bool> usd;


void dfs(int v, int mn, int mx) {
	res[v] = min(res[v], mn + mx);
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		int tm = t[v][i];
		if (!usd[nmb[v][i]]) {
			usd[nmb[v][i]] = true;
			dfs(to, min(mn, tm), max(mx, tm));
			usd[nmb[v][i]] = false;
		}
	}
}


void get_res() {
	res.assign(n, 1e9);
	usd.assign(m, false);
	dfs(0, 1e9, 0);
}


int32_t main() {
	cin >> n >> m;
	g.resize(n);
	t.resize(n);
	res.resize(n);
	ts.resize(m);
	nmb.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, tm;
		cin >> u >> v >> tm;
		ts[i] = tm;
		--u;
		--v;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back(v);
		t[u].push_back(tm);
		g[v].push_back(u);
		t[v].push_back(tm);
		nmb[v].push_back(i);
		nmb[u].push_back(i);
	}
	get_res();
	for (int i = 1; i < n; ++i) {
		cout << res[i] << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/