#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int n;
vector<vector<pair<int, int>>> a;


int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int m;
	cin >> n >> m;
	a.resize(n);
	t.resize(n, { -inf, inf });
	int x, y, w;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		a[x].push_back({ y, w });
		a[y].push_back({ x, w });
	}

	vector<int> dp(n, inf);
	set<pair<int, int>> st;
	dp[0] = 0;
	st.insert({ 0, 0 });

	while (!st.empty()) {
		auto v = st.begin()->y;
		st.erase(st.begin());
		for (auto i : a[v]) {
			int t = dp[v];
			if (i.y > t) t = i.y;
			if (t < dp[i.x]) {
				st.erase({ dp[i.x], i.x });
				dp[i.x] = t;
				st.insert({ dp[i.x], i.x });
			}
		}
	}

	for (int i{ 1 }; i < n; ++i) {
		cout << dp[i] << '\n';
	}

	return 0;
}