#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

typedef long long ll;

const int N = 300100;
const int A = 26;
ll val[A];
int s[N];
ll dp[N][A];
int p[N][A];
int p2[N][A];

int main() {
	val[0] = 1;
	for (int i = 1; i < A; i++) {
		val[i] = val[i - 1] * (i % 2 == 0 ? 2 : 5);
	}
	int q;
	cin >> q;
	while (q--) {
		string temp;
		cin >> temp;
		int n = temp.size();
		for (int i = 0; i < n; i++) {
			s[i] = (temp[i] == '?' ? -1 : (temp[i] - 'A'));
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < A; j++) {
				dp[i][j] = -1e18;
			}
		}
		dp[n][0] = 0;
		for (int i = n - 1; i >= 0; i--) {
			for (int j = 0; j < A; j++) {
				if (s[i] != -1 && s[i] != j) continue;
				for (int mx = 0; mx < A; mx++) {
					int cur = max(j, mx);
					ll d = (mx > j ? -val[j] : val[j]);
					if (dp[i][cur] < dp[i + 1][mx] + d) {
						dp[i][cur] = dp[i + 1][mx] + d;
						p[i][cur] = mx;
						p2[i][cur] = j;
					}
				}
			}
		}

		string res;
		int pos = 0;
		for (int i = 0; i < A; i++) {
			if (dp[0][i] > dp[0][pos]) {
				pos = i;
			}
		}
		cout << dp[0][pos] << '\n';
		for (int i = 0; i < n; i++) {
			res += (char)(p2[i][pos] + 'A');
			pos = p[i][pos];
		}

		cout << res << '\n';
	}
	return 0;
}