#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

int n, m;
void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}
const int N = 3e5 + 5;
const ll INF = 1e18;

vector<pll> g[N];
ll d[N];
bool used[N];

void dfs(int v, ll mn, ll mx) {
    d[v] = mn + mx;
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u.first]) continue;
        dfs(u.first, min(mn, u.second), max(mx, u.second));
    }
}

int main() {
    optimize();
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll u, v, w; cin >> u >> v >> w; --u; --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    d[0] = 0; dfs(0, INF, -INF);

    for (int i = 1; i < n; ++i) cout << d[i] << '\n';

    return 0;
}
