#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

int n, m;
void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}
const int N = 3e5 + 5;
const ll INF = 1e18;

vector<pair<pll, int>> g[N];
ll d[N];

void dfs(int v, ll mn, ll mx, bitset<20> &b) {
    d[v] = min(mn + mx, d[v]);
    for (auto u : g[v]) {
        if (b[u.second]) continue;
        b[u.second] = 1;
        dfs(u.first.first, min(mn, u.first.second), max(mx, u.first.second), b);
        b[u.second] = 0;
    }
}

int main() {
    optimize();
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll u, v, w; cin >> u >> v >> w; --u; --v;
        g[u].push_back({{v, w}, i});
        g[v].push_back({{u, w}, i});
    }
    bitset<20> b;
    fill(d, d + n, INF);
    d[0] = 0; dfs(0, INF, -INF, b);

    for (int i = 1; i < n; ++i) cout << d[i] << '\n';

    return 0;
}
