#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e5 + 100, INF = 1e9;
vector<array<int, 2>> g[MAXN];
int w[MAXN];
int n, m;

namespace gr1
{
    int ans[MAXN];
    vector<array<int, 2>> path;

    array<int, 2> op(array<int, 2> a, array<int, 2> b) {
        return {min(a[0], b[0]), max(a[1], b[1])};
    }

    int used[MAXN];

    void dfs(int v) {
        used[v] = true;
        ans[v] = path.back()[0] + path.back()[1];
        for (auto e : g[v]) {
            int u = e[0], i = e[1];
            if (!used[u]) {
                path.push_back({op(path.back(), {w[i], w[i]})});
                dfs(u);
                path.pop_back();
            }
        }
    }

    void solve() {
        path.push_back({INF, -INF});
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << endl;
        }
    }
}

main() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        cin >> w[i];
    }
    if (m == n - 1) {
        gr1::solve();
    }
    return 0;
}
