#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
#define int ll
using namespace std;

const int maxn = 3e5 + 50;
vector<pii> r[maxn];
int used[maxn];
int tin[maxn];
int fup[maxn];
int t = 1;

map<pii, int> mp;

void dfs(int v, int p = -1) {
    tin[v] = fup[v] = t++;
    used[v] = 1;
    for (auto &[u, w] : r[v]) {
        if (u == p) {
            p = -1;
            continue;
        }
        if (!used[u]) {
            dfs(u, v);
            fup[v] = min(fup[v], fup[u]);
            if (fup[u] > tin[v]) {
                mp[{v, u}] = mp[{u, v}] = 1;
            }
        } else {
            fup[v] = min(fup[v], tin[u]);
        }
    }
}

int W[maxn];
int comp[maxn];
vector<pii> r2[maxn];
void dfs2(int v, int c) {
    comp[v] = c;
    used[v] = 1;
    for (auto &[u, w]: r[v]) {
        if (!mp[{v, u}] && !used[u]) {
            dfs2(u, c);
            W[c] = min(W[c], w);
        }
    }
}

int p[maxn];
int s[maxn];

int get(int v) {
    return (p[v] == v ? v : p[v] = get(p[v]));
}
int merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a != b) {
        if (s[a] > s[b])
            swap(a, b);
        p[a] = b;
        s[b] += s[a];
        return 1;
    }
    return 0;
}

void dfs3(int v) {
    used[v] = 1;
    for (auto &[u, w] : r2[v]) {
        if (!used[u]) {
            W[u] = min({W[u], W[v], w});
            dfs3(u);
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    iota(p, p + n, 0);
    fill(s, s + n, 1);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int w;
        cin >> w;
        r[a].pb({b, w});
        r[b].pb({a, w});
    }

    for (int i = 0; i < n; ++i) {
        sort(r[i].begin(), r[i].end(), [&] (pii a, pii b) {
            return a.s < b.s;
        });
    }
    dfs(0);
    memset(W, 127, sizeof(W));
    memset(used, 0, sizeof(used));
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs2(i, c++);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto &[u, w] : r[i]) {
            if (comp[i] != comp[u]) {
                r2[comp[i]].pb({comp[u], w});
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(r2[i].begin(), r2[i].end(), [&] (pii a, pii b) {
            return a.s < b.s;
        });
    }
    memset(used, 0, sizeof(used));
    dfs3(comp[0]);
    for (int i = 1; i < n; ++i) {
        cout << int(1e9 + W[comp[i]]) << '\n';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--)
        solve();
}
