#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define firn(i, n) for (int i = 1; i < (int)n; i++)
#define all(v) v.begin(), v.end()
#define x first
#define y second

mt19937 rnd(time(nullptr));

const char el = '\n';
const ll llinf = 1e18;

struct edge {
    int u, t, i;
    edge() {}
    edge(int u, int t, int i): u(u), t(t), i(i) {}
};
const int N = 300'001;
vector<edge> g[N];
int st[N], d[N], used[N];
vector<pair<int, int>> ans;
vector<int> cnt[2];
bool dfs(int v, int p = -1) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (to.u == p) continue;
        st[to.u] += 1 << to.t;
    }
    for (auto to : g[v]) {
        if (used[to.u]) continue;
        if (!dfs(to.u, v))
            return false;
    }
    cnt[0].clear(); cnt[1].clear();
    for (auto to : g[v]) {
        if (to.u == p) continue;
        if (st[to.u] == 3) {
            if (d[to.u] == 2 && to.t == 1) {
                cnt[1].push_back(to.i);
            }
            if (d[to.u] == 3 && to.t == 0) {
                cnt[0].push_back(to.i);
            }
        } else {
            if (d[to.u] == 1) {
                cnt[to.t].push_back(to.i);
            } else {
                if (d[to.u] != 2 + to.t)
                    return false;
            }
        }
    }
    if (abs((int)cnt[0].size() - (int)cnt[1].size()) > 1)
        return false;
    if ((int)cnt[0].size() == (int)cnt[1].size()) {
        d[v] = 1;
        forn(i, cnt[0].size())
            ans.emplace_back(cnt[0][i], cnt[1][i]);
        if (st[v] == 3) {
            int fr = -1, sc = -1;
            for (auto to : g[v]) {
                if (to.u == p && to.t == 0)
                    fr = to.i;
                if (to.u == p && to.t == 1)
                    sc = to.i;
            }
            if (fr == -1 || sc == -1) return false;
            assert(fr != -1 && sc != -1);
            ans.emplace_back(fr, sc);
        }
    } else {
        forn(i, min(cnt[0].size(), cnt[1].size())) {
            ans.emplace_back(cnt[0][i], cnt[1][i]);
        }
        if (cnt[0].size() > cnt[1].size()) {
            d[v] = 2;
            bool ok = false;
            for (auto to : g[v]) {
                if (to.u == p && to.t == 1) {
                    ans.emplace_back(cnt[0].back(), to.i);
                    ok = true;
                }
            }
            if (!ok) return false;
        } else {
            d[v] = 3;
            bool ok = false;
            for (auto to : g[v]) {
                if (to.u == p && to.t == 0) {
                    ans.emplace_back(cnt[1].back(), to.i);
                    ok = true;
                }
            }
            if (!ok) return false;
        }
    }
    return true;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> r(m);
    forn(i, m) {
        cin >> r[i].x >> r[i].y;
        r[i].x--; r[i].y--;
        g[r[i].x].emplace_back(r[i].y, 0, i);
        g[r[i].y].emplace_back(r[i].x, 1, i);
    }
    bool ok = true;
    forn(i, n) {
        if (used[i]) continue;
        ok &= dfs(i);
    }
    if (!ok) {
        cout << "No" << el;
    } else {
        cout << "Yes" << el;
        forn(i, m / 2)
            cout << r[ans[i].x].x + 1 << ' ' << r[ans[i].x].y + 1 << ' '
                 << r[ans[i].y].x + 1 << ' ' << r[ans[i].y].y + 1 << el;
    }
    return 0;
}
