
#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct wood{
    int x, h;
};

int MAXN = 10003;
vector <bool> visited(MAXN);
vector <wood> trees;
int n, q;

bool check(int id) {
    int x = trees[id].x, h = trees[id].h;
    bool ch_l = true, ch_r = true;
    for (int i = 0; i < n + 2; ++i) {
        if (visited[i])
            continue;
        ch_l = ch_l && !(x - h < trees[i].x && trees[i].x < x);
        ch_r = ch_r && !(x < trees[i].x && trees[i].x < x + h);
    }
    return ch_l || ch_r;
}

signed main() {
    int lf, rg, x1, h;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (i == 0)
            trees.push_back({x, y});
        trees.push_back({x, y});
    }
    trees.push_back(trees.back());
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        int ans = 0;
        queue <int> a;
        vector <pair <int, int>> b(y - x + 1);
        for (int j = x; j <= y; ++j) {
            a.push(j);
            b[j - x] = {j - 1, j + 1};
        }

        while (a.size() > 0) {
            int j = a.front();
            a.pop();
            if (visited[j])
                continue;
            x1 = trees[j].x;
            h = trees[j].h;
            //cout << j << " " << check(j) << endl;
            bool chh = false;
            //cout << b[j - x].first << " " << x1 << endl;
            if (b[j - x].first == 0) {
                chh = chh || !(x1 - h < trees[b[j - x].first].x);
            }
            else {
                chh = chh || !(x1 - h < trees[b[j - x].first].x && trees[b[j - x].first].x < x1);
            }
            //cout << chh << endl;
            if (b[j - x].second == n + 1) {
                chh = chh || !(trees[b[j - x].second].x < x1 + h);
            }
            else {
                chh = chh || !(x1 < trees[b[j - x].second].x && trees[b[j - x].second].x < x1 + h);
            }
            if (chh) {
                visited[j] = true;
                ans++;
                lf = b[j - x].first;
                rg = b[j - x].second;
                if (lf != x - 1){
                    b[lf - x].second = rg;
                    a.push(lf);
                }
                if (rg != y + 1) {
                    b[rg - x].first = lf;
                    a.push(rg);
                }
            }
        }
        for (int j = x; j <= y; ++j) {
            visited[j] = false;
        }
        cout << ans << "\n";
    }
}
