#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0);

vector<int> mn;
vector<int> mx;
vector<bool> used;
vector<vector<pair<int, int>>> g;

void dfs(int v) {
    used[v] = true;
    for (auto p : g[v]) {
        int u = p.first;
        if (used[u]) continue;
        int w = p.second;
        mn[u] = min(mn[v], w);
        mx[u] = max(mx[v], w);
        dfs(u);
    }
}

signed main() {
    fastio
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, int>> a(m);
    g.resize(n);
    bool ok = true;
    bool ok2 = true;
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first.first >> a[i].first.second >> a[i].second;
        --a[i].first.first;
        --a[i].first.second;
        if (a[i].first.first == 0 || a[i].first.second == 0) {
            if (a[i].second != 0) ok = false;
        }
        if (a[i].first.first == 0 || a[i].first.second == 0) {
            if (a[i].second != 1000000000) ok2 = false;
        }
        g[a[i].first.first].push_back({a[i].first.second, a[i].second});
        g[a[i].first.second].push_back({a[i].first.first, a[i].second});
    }
    if (ok) {
        set<pair<int, int>> b;
        for (int i = 0; i < m; ++i) {
            if (a[i].first.first == 0) {
                b.insert({a[i].second, a[i].first.second});
            } else if (a[i].first.second == 0) {
                b.insert({a[i].second, a[i].first.first});
            }
        }
        used.resize(n, false);
        used[0] = true;
        vector<int> sm(n, 1000000000);
        while (!b.empty()) {
            auto p = (*b.begin());
            b.erase(b.begin());
            int v = p.second;
            int w = p.first;
            if (used[v]) continue;
            sm[v] = w;
            used[v] = true;
            for (auto p2 : g[v]) {
                int u = p2.first;
                if (used[u]) continue;
                int w2 = p2.second;
                b.insert({max(w2, w), u});
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << sm[i] << '\n';
        }
        return 0;
    }

    if (ok2) {
        set<pair<int, int>> b;
        for (int i = 0; i < m; ++i) {
            if (a[i].first.first == 0) {
                b.insert({a[i].second, a[i].first.second});
            } else if (a[i].first.second == 0) {
                b.insert({a[i].second, a[i].first.first});
            }
        }
        used.resize(n, false);
        used[0] = true;
        vector<int> sm(n, 1000000000);
        while (!b.empty()) {
            auto p = (*b.begin());
            b.erase(b.begin());
            int v = p.second;
            int w = p.first;
            sm[v] = min(sm[v], w);
            used[v] = true;
            for (auto p2 : g[v]) {
                int u = p2.first;
                int w2 = p2.second;
                if (sm[v] <= min(w2, w)) continue;
                b.insert({min(w2, w), u});
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << sm[i] + 1000000000 << '\n';
        }
        return 0;
    }
    if (m == n - 1) {
        used.resize(n, false);
        mn.resize(n, 0);
        mx.resize(n, 0);
        mn[0] = 1000000000;
        mx[0] = 0;
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << mn[i] + mx[i] << '\n';
        }
        return 0;
    }
    if (m <= 20) {
        vector<vector<int>> auf(n, vector<int>(n, -1));
        for (int i = 0; i < m; ++i) {
            if (auf[a[i].first.first][a[i].first.second] == -1) {
                auf[a[i].first.first][a[i].first.second] = a[i].second;
            }
            auf[a[i].first.first][a[i].first.second] = auf[a[i].first.second][a[i].first.first] = min(
                    auf[a[i].first.first][a[i].first.second], a[i].second);
        }
        vector<int> sm(n, 2000000000);
        vector<vector<bool>> can(1 << m, vector<bool>(n, false));
        for (int ms = 0; ms < (1 << m); ++ms) {
            if (ms == 0) {
                for (int i = 0; i < m; ++i) {
                    if (a[i].first.first == 0) {
                        sm[a[i].first.second] = min(sm[a[i].first.second], 2 * a[i].second);
                        can[1 << i][a[i].first.second] = true;
                    } else if (a[i].first.second == 0) {
                        sm[a[i].first.first] = min(sm[a[i].first.first], 2 * a[i].second);
                        can[1 << i][a[i].first.first] = true;
                    }
                }
            } else {
                int mn1 = 1000000000;
                int mx1 = 0;
                for (int i = 0; i < m; ++i) {
                    if ((ms >> i) & 1) {
                        mx1 = max(mx1, a[i].second);
                        mn1 = min(mn1, a[i].second);
                    }
                }
                for (int i = 0; i < m; ++i) {
                    if (((ms >> i) & 1)) {
                        for (int j = 0; j < m; ++j) {
                            if ((ms >> j) & 1) continue;
                            if ((a[i].first.first == a[j].first.first && can[ms][a[i].first.first]) ||
                                (a[i].first.second == a[j].first.first && can[ms][a[i].first.second])) {
                                sm[a[j].first.second] = min(sm[a[j].first.second],
                                                            min(mn1, a[j].second) + max(mx1, a[j].second));
                                can[ms + (1 << j)][a[j].first.second] = true;
                            } else if ((a[i].first.first == a[j].first.second && can[ms][a[i].first.first]) ||
                                       (a[i].first.second == a[j].first.second && can[ms][a[i].first.second])) {
                                sm[a[j].first.first] = min(sm[a[j].first.first],
                                                           min(mn1, a[j].second) + max(mx1, a[j].second));
                                can[ms + (1 << j)][a[j].first.first] = true;
                            }
                        }
                    }
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << sm[i] << '\n';
        }
        return 0;
    }
    if (n <= 2000 && m <= 2000) {
        vector<vector<int>> auf(n, vector<int>(n, -1));
        vector<vector<int>> auf2(n, vector<int>(n, -1));
        for (int i = 0; i < m; ++i) {
            int v = a[i].first.first;
            int u = a[i].first.second;
            int w = a[i].second;
            if (auf[v][u] == -1) {
                auf[v][u] = auf[u][v] = w;
            } else if (auf[a[i].first.first][a[i].first.second] > w) {
                auf2[v][u] = auf2[u][v] = auf[v][u];
                auf[v][u] = auf[u][v] = w;
            } else {
                if (auf2[v][u] == -1 || auf2[v][u] > w) {
                    auf2[v][u] = auf2[u][v] = w;
                }
            }
        }
        int mx1 = 0;
        int mn1 = 1000000000;
        vector<int> sm (n, 2000000000);
        for (int i = 1; i < n; ++i) {
            mx1 = max(mx1, auf[i - 1][i]);
            mn1 = min(mn1, auf[i - 1][i]);
            sm[i] = mn1 + mx1;
            int mn2 = mn1;
            int mx2 = mx1;
            for (int j = i - 1; j >= 0; --j) {
                if (auf2[j][j + 1] == -1) break;
                mn2 = min(mn2, auf2[j][j + 1]);
                mx2 = max(mx2, auf2[j][j + 1]);
                sm[j] = min(sm[j], mx2 + mn2);
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << sm[i] << '\n';
        }
        return 0;
    }
}