#include <iostream>

#include <algorithm>

#include <vector>

using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>> g;
vector<int> used;

int ans;

void dfs(int v, int f, int a, int b) {
	if (v == f) {
		ans = min(ans, a + b);
	}

	used[v]++;

	random_shuffle(g[v].begin(), g[v].end());
	int to = g[v][0].first, c = g[v][0].second;

	if (used[to] < 5) {
		dfs(to, f, min(a, c), max(a, c));
	}
}
int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c; cin >> v >> u >> c;
		v--; u--;

		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}

	for (int i = 1; i < n; i++) {
		used.assign(n, 0);
		ans = 2e9;
		dfs(0, i, 1e9, 0);
		cout << ans << '\n';
	}
	return 0;
}