#include <iostream>
#include <vector>
#include <set>
#include <random>
#include <algorithm>
#define int long long

using namespace std;
vector <set<int>> gr;
vector <pair<int, int>> edges;
int n, m;
void f(vector <bool> used, int it, vector <pair<int, int>> ans) {
//    cout << it << endl;
    if (it == m / 2) {
        cout << "Yes\n";
        for (auto c: ans) {
            cout << edges[c.first].first << " " << edges[c.first].second << " " << edges[c.second].first << " " << edges[c.second].second << "\n";
        }
        exit(0);
    }
    for (int i =0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i] or used[j]) continue;
            if (edges[i].second == edges[j].first) {
                used[i] = true;
                used[j] = true;
                it++;
                ans.push_back({i, j});
                f(used, it, ans);
                ans.pop_back();
                it--;
                used[i] = false;
                used[j] = false;
            }
        }
    }
}

signed main() {

    cin >> n >> m;
    gr.resize(n + 1);
    vector <int> vf(n + 1, 0);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        gr[a].insert(b);
        edges.push_back({a, b});
        vf[b]++;
    }
    for (int i = 1; i <= n; ++i) {
        if (abs((vf[i] - (int)gr[i].size())) > 1) {
            cout << "No\n";
            return 0;
        }
    }
    random_shuffle(edges.begin(), edges.end());
    vector <bool> used(m, false);
    f(used, 0, {});
    cout << "No";
    return 0;
}
