#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline-functions")

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()


int n, q;

const int N = 5e5 + 1;
int x[N], h[N];

inline bool canL(int pos, int part) {
    if (pos == 0) return 0;
    part = max(part, 0);
    return x[pos] - x[part] >= h[pos];
}

inline bool canR(int pos, int part) {
    if (pos == n - 1) return 0;
    part = min(part, n - 1);
    return x[part] - x[pos] >= h[pos];
}

bool dead[N];
int l[N];
int r[N];

inline int getL(int f) {
    if (l[f] == -1) return l[f];
    if (!dead[l[f]]) return l[f];
    return l[f] = getL(l[f]);
}

inline int getR(int f) {
    if (!dead[r[f]]) return r[f];
    return r[f] = getR(r[f]);
}

inline bool can(int pos) {
    int e = getL(pos);
    if (canL(pos, e)) return 1;
    e = getR(pos);
    if (canR(pos, e)) return 1;
    return 0;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q;
    for(int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
    }
    bitset<10000> kek;
    while (q--) {
        kek.reset();
        int le, re;
        cin >> le >> re;
        --le; --re;
        for(int i = le; i <= re; i++) {
            kek[i] = 1;
        }
        int ans = 0;
        fill(l, l + n, -1);
        fill(r, r + n, -1);
        for(int i = le; i <= re; i++) {
            r[i] = i + 1;
            l[i] = i - 1;
        }
        fill(dead, dead + n, 0);
        for(int run = 1; run; ) {
            run = 0;
            int ce = (re - le + 1) - ans;
            int f = ce;
            int la = -1;
            while (f--) {
                int ne = kek._Find_next(la);
                if (can(ne)) {
                    dead[ne] = 1;
                    ans++;
                    run = 1;
                }
                la = ne;
            }
            la = n;
            f = ce;
        }
        cout << ans << '\n';
    }
}