#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int K = 26;

int val[K] = { 1 };
string ans = "", cur;

int calc(string& s) {
	int n = s.size();
	int ans = 0, cmx = 1;
	for (int i = n - 1; i >= 0; --i) {
		cmx = max(cmx, val[s[i] - 'A']);
		if (val[s[i] - 'A'] < cmx)
			ans -= val[s[i] - 'A'];
		else
			ans += val[s[i] - 'A'];
	}
	return ans;
}

void recurs(int pos, int mx) {
	if (pos == cur.size()) {
		if (ans == "" || calc(cur) > calc(ans))
			ans = cur;
		return;
	}
	if (cur[pos] == '?') {
		for (int i = mx; i >= 0; --i) {
			cur[pos] = i + 'A';
			recurs(pos + 1, i);
		}
		cur[pos] = '?';
	}
	else
		recurs(pos + 1, mx);
}

void solve() {
	cin >> cur;
	recurs(0, K - 1);
	cout << calc(ans) << "\n" << ans << "\n";
	ans = "";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	loop1(i, K - 1)
		val[i] = (i & 1 ? val[i - 1] * 5 : val[i - 2] * 10);
	int t; cin >> t; loop(i, t)
		solve();
	return 0;
}
