#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 3e5 + 7, K = 26, INF = 8e18;

int dp[K][N], p[K][N];
int val[K] = { 1 };

void solve() {
	string s; cin >> s;
	int n = s.size();
	loop1(i, n)
		loop(j, K)
			dp[j][i] = -INF;
	vector <bool> mns(n);
	int ans = 0, cmx = 1;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] != '?') {
			cmx = max(cmx, val[s[i] - 'A']);
			if (val[s[i] - 'A'] < cmx) {
				ans -= val[s[i] - 'A'];
				mns[i] = 1;
			}
			else
				ans += val[s[i] - 'A'];
		}
	}
	int cnt[K][K] = { 0 };
	loop1(i, n) {
		if (s[i] != '?') {
			loop(j, K) {
				for (int k = j; k >= 0; --k)
					if (dp[j][i] < dp[k][i - 1]) {
						dp[j][i] = dp[k][i - 1];
						p[j][i] = k;
					}
			}
			if (!mns[i]) {
				loop(j, K)
					++cnt[j][s[i] - 'A'];
			}
			continue;
		}
		loop(j, K) {
			int cmns = 0;
			for (int k = j - 1; k >= 0; --k) {
				cmns += cnt[j][k] * val[k];
				cnt[j][k] = 0;
			}
			for (int k = j; k >= 0; --k)
				if (dp[j][i] < dp[k][i - 1] + cmns) {
					dp[j][i] = dp[k][i - 1] + cmns;
					p[j][i] = k;
				}
		}
	}
	string anss = "";
	int pos = 0;
	loop(i, K)
		if (dp[pos][n] < dp[i][n])
			pos = i;
	for (int i = n - 1; i >= 0; --i) {
		anss.push_back(s[i] == '?' ? pos + 'A' : s[i]);
		pos = p[pos][i];
	}
	reverse(all(anss));
	cout << anss << "\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	loop1(i, K - 1)
		val[i] = (i & 1 ? val[i - 1] * 5 : val[i - 2] * 10);
	int t; cin >> t; loop(i, t)
		solve();
	return 0;
}