#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#ifndef DEBUG
#define endl '\n'
#endif

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--)
        solve();
}

unordered_map<char, ll> dict{
        {'A', 1e0},
        {'B', 5e0},
        {'C', 1e1},
        {'D', 5e1},
        {'E', 1e2},
        {'F', 5e2},
        {'G', 1e3},
        {'H', 5e3},
        {'I', 1e4},
        {'J', 5e4},
        {'K', 1e5},
        {'L', 5e5},
        {'M', 1e6},
        {'N', 5e6},
        {'O', 1e7},
        {'P', 5e7},
        {'Q', 1e8},
        {'R', 5e8},
        {'S', 1e9},
        {'T', 5e9},
        {'U', 1e10},
        {'V', 5e10},
        {'W', 1e11},
        {'X', 5e11},
        {'Y', 1e12},
        {'Z', 5e12},
};


template<class Iterator>
__int128 calc(Iterator rbegin, Iterator rend) {
//    cerr << "calc(" << rend - rbegin << ")" << endl;
    ll ret = 0;
    char mx = 0;
    for (auto e = rbegin; e != rend; ++e) {
        if (*e == '?') continue;
        assert(dict.count(*e));
        mx = max(mx, *e);
        if (mx > *e) {
            ret -= dict[*e];
        } else {
            ret += dict[*e];
        }
    }
    return ret;
}


void solve() {
    string s;
    cin >> s;
    ll n = s.size();

    for (int i = 0; i < n; ++i) {
        ll mx = -9e18;
        char mc = 0;
        if (s[i] == '?') {
            for(char c = 'A'; c <= 'Z'; ++c) {
                s[i] = c;
                ll v = calc(s.rbegin(), s.rend());
                if (v > mx) {
                    mx = v;
                    mc = c;
                }
            }
            s[i] = mc;
        }
    }

    ll clc = calc(s.rbegin(), s.rend());
    cout << clc << endl;
    cout << s << endl;
}
