#include <iostream>
#include <string>
#include <cmath>


using namespace std;



long long ten_pow[] = {1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 10000000000, 100000000000, 1000000000000};
long long five_pow[] = {5, 50, 500, 5000, 50000, 500000, 5000000, 50000000, 500000000, 5000000000, 50000000000, 500000000000, 5000000000000};

long long per_char(char ch){
    if ((ch - 'A') % 2 == 0)
        return ten_pow[(ch - 'A') / 2];
    else
        return five_pow[(ch - 'A') / 2];
}

long long per_string(string &s){
    char mx = 'A';
    long long rez = 0;
    for (int i = s.size() - 1; i >= 0; i--){
        if (s[i] < mx){
            rez -= per_char(s[i]);
        }
        else{
            rez += per_char(s[i]);
            if (s[i] > mx){
                mx = s[i];
            }
        }
    }
    return rez;
}

void f(string &s){
    for (int i = 0; i < s.size(); i++){
        if (s[i] == '?'){
            s[i] = 'Z';
        }
    }
}

void y(string &s, int num){
    int p = 0;
    for (int i = 0; i < s.size(); i++){
        if (s[i] == '?'){
            s[i] = 'A' + (long long) (num / pow(26, p)) % 26;
            p++;
        }
    }
}

int main() {
    int t;
    cin >> t;
    while (t--){

        string s;
        cin >> s;
        int cnt = 0;
        for (int i = 0; i < s.size(); i++){
            if (s[i] == '?'){
                cnt++;
            }
        }
        if (cnt <= 3){
            string mxs;
            long long mx = -1000000000000000;
            for (int i = 0; i < 17576; i++){
                string s1 = s;
                y(s1, i);
                long long tmp = per_string(s1);
                if (tmp > mx){
                    mx = tmp;
                    mxs = s1;
                }
            }
            cout << mx << "\n" << mxs << "\n";
        }
        else{
            f(s);
            cout << per_string(s) << "\n" << s << "\n";
        }

    }
    return 0;
}
