#include <bits/stdc++.h>

using namespace std;

int timer = 1;
int used[150000];
int col[150000];
int take[150000];
int bal = 0;
set<int> g[150000];

int kun(int v) {
    if (used[v] == timer) {
        return 0;
    }
    used[v] = timer;
    for (int to : g[v]) {
        if (take[to] == -1 || kun(take[to]) == 1) {
            take[to] = v;
            return 1;
        }
    }
    return 0;
}

void dfs(int v, int c) {
    used[v] = 1;
    col[v] = c;
    if (c == 0) {
        ++bal;
    } else {
        --bal;
    }
    c = (c + 1) % 2;
    for (int to : g[v]) {
        if (used[to] == 0) {
            dfs(to, c);
        }
    }
}


int main() {
    int n, m;
    cin >> n >> m;
    int edges[m][2];
    vector<int> start[n];
    vector<int> end[n];
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        edges[i][0] = a;
        edges[i][1] = b;
        start[a - 1].push_back(i);
        end[b - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        for (int from : start[i]) {
            for (int to : end[i]) {
                g[from].insert(to);
                g[to].insert(from);
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (used[i] == 0) {
            dfs(i, 0);
        }
    }
    if (bal != 0) {
        cout << "No";
        return 0;
    }
    for (int i = 0; i < m; ++i) {
        take[i] = -1;
    }
    for (int i = 0; i < m; ++i) {
        if(col[i] == 1){
            continue;
        }
        ++timer;
        if (kun(i) == 0) {
           cout << "No";
            return 0;
        }
    }
    cout << "Yes" << '\n';
    for (int i = 0; i < m; ++i) {
        if (take[i] != -1) {
            int j = take[i];
           cout << edges[i][0] << ' ' << edges[i][1] << ' ' << edges[j][0] << ' ' << edges[j][1] << '\n';
        }
    }
    return 0;
}
