#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<p>> d;
vector<bool> was;
vector<vector<int>> s;

void DFS(int vertex, int parent){
    was[vertex] = true;
    for (p q: d[vertex]){
        if (!was[q.first]){
            DFS(q.first, vertex);
        }
    }
    int down = 0, up = 0;
    for (p q11: d[vertex]){
        int q = q11.first, q1 = q11.second;
        if (q == parent){
            continue;
        }
        if (s[q][0] == 0 && s[q][1] == 0 && s[q][2] == 0){
            s[vertex] = {0, 0, 0};
            return;
        }
        if ((s[q][1] == 1 && q1 == 1) || (s[q][2] == 2 && q1 == 0)){
            s[vertex] = {0, 0, 0};
            return;
        }
        if (q1 != 2 && s[q][0] == 1){
            down += (q1 == 0), up += (q1 == 1);
        }else if (q1 == 2 && s[q][0] == 0){
            down += (s[q][2] == 1), up += (s[q][1] == 1);
        }
    }
    if (down == up){
        s[vertex] = {1, 0, 0};
    }else if (down == up+1){
        s[vertex] = {0, 1, 0};
    }else if (up == down+1){
        s[vertex] = {0, 0, 1};
    }else{
        s[vertex] = {0, 0, 0};
    }
}

void DFS_ans(int vertex, int parent){
    was[vertex] = true;
    for (p q: d[vertex]){
        if (!was[q.first]){
            DFS_ans(q.first, vertex);
        }
    }
    vector<p> down, up;
    for (p q11: d[vertex]){
        int q = q11.first, q1 = q11.second;
        if (q == parent){
            continue;
        }
        if (q1 != 2 && s[q][0] == 1 && q1 == 0) {
            down.push_back({vertex, q});
        }else if (q1 != 2 && s[q][0] == 1){
            up.push_back({q, vertex});
        }else if (q1 == 2 && s[q][0] == 0 && s[q][2] == 1) {
            down.push_back({vertex, q});
        }else if (q1 == 2 && s[q][0] == 0){
            up.push_back({q, vertex});
        }else if (q1 == 2){
            cout << vertex+1 << ' ' << q+1 << ' ' << q+1 << ' ' << vertex+1 << endl;
        }
    }
    for (int q = 0; q < min(down.size(), up.size()); q++){
        cout << down[q].first+1 << ' ' << down[q].second+1 << ' ' << up[q].first+1 << ' ' << up[q].second+1 << endl;
    }
    if (down.size() == up.size()+1){
        cout << down.back().first+1 << ' ' << down.back().second+1 << ' ' << parent+1 << ' ' << vertex+1 << endl;
    }else if (up.size() == down.size()+1){
        cout << up.back().first+1 << ' ' << up.back().second+1 << ' ' << vertex+1 << ' ' << parent+1 << endl;
    }
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    d.assign(n, {});
    map<p, int> edge;
    for (int q = 0; q < m; q++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        if (edge.find({x, y}) != edge.end()){
            edge[{x, y}] = edge[{y, x}] = 2;
        }else{
            edge[{x, y}] = 0, edge[{y, x}] = 1;
        }
    }
    for (pair<p, int> q: edge){
        d[q.first.first].push_back({q.first.second, q.second});
    }
    was.assign(n, false), s.assign(n, vector<int>(3));
    for (int q = 0; q < n; q++){
        if (!was[q]){
            DFS(q, -1);
            if (s[q][0] == 0){
                cout << "No" << endl;
                return 0;
            }
        }
    }
    cout << "Yes" << endl;
    was.assign(n, false);
    for (int q = 0; q < n; q++){
        if (!was[q]){
            DFS_ans(q, -1);
        }
    }
    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3

*/
