#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;
const int INFi = 2e9;
vector<pair<int, int>> g[maxN];
int dist[maxN];

void dfs(int v, int p, int mx, int mn) {
    dist[v] = mx + mn;
    for(auto &[u, w] : g[v]) {
        if (u == p) continue;
        dfs(u, v, max(mx, w), min(mn, w));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    range(_, m) {
        int u, v, w; cin >> u >> v >> w;
        g[min(u, v)].emplace_back(w, v);
    //    g[v].emplace_back(u, w);
    }
    for(int i = 1; i <= n; ++i) sort(all(g[i]));
    int mx = -INFi;
    int mn = INFi;
    for(int i = 1; i < n; ++i) {
        mx = max(mx, g[i].front().first);
        mn = min(mn, g[i].front().first);
        int res = mn + mx;
        int mn2 = mn;
        int mx2 = mx;
        for(int j = i + 1; j < n; ++j) {
            if (g[j].size() < 2) break;
            mx2 = max(mx2, g[i][1].first);
            mn2 = min(mn2, g[j].front().first);
            res = min(res, mx2 + mn2);
        }
        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}