#include <iostream>
#include <map>
#include <cmath>
#include <vector>

#define int long long
using namespace std;

int search(vector<bool> a, int n) {
    for (auto it = n + 1; it < a.size(); ++it) {
        if (a[it]) {
            return it;
        }
    }
    return -1;
}

int32_t main() {
    int n;
    cin >> n;
    map<string, int> a;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int best_ans = -1e18;
        string bests = s;
        vector<bool> a(26, false);
        int first = -1, second = -1, third = -1, fourth = -1;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] == '?') {
                if (first == -1) {
                    first = j;
                } else if (second == -1) {
                    second = j;
                } else if (third == -1) {
                    third = j;
                } else if (fourth == -1){
                    fourth = j;
                }
            }
        }
        for (int k = 25; k >= 0; --k) {
            int ans = 0, max_elem = 0;
            if (first != -1) {
                s[first] = (char) (k + 65);
            }
            if (second != -1) {
                s[second] = (char) (k + 65);
            }
            if (third != -1) {
                s[third] = (char) (k + 65);
            }
            if (fourth != -1) {
                s[fourth] = (char) (k + 65);
            }
            for (int j = s.size() - 1; j >= 0; --j) {
                a[(int) s[j] - 65] = true;
                int cur = (int) s[j] - 65;
                if (cur % 2 == 0) {
                    if (cur == 0) {
                        cur = 1;
                    } else {
                        cur = pow(10, cur / 2);
                    }
                } else {
                    cur = 5 * pow(10, cur / 2);
                }
                if (max_elem <= (int) s[j] - 65) {
                    ans += cur;
                    max_elem = (int) s[j] - 65;
                } else {
                    ans -= cur;
                }
            }
            if (ans > best_ans) {
                best_ans = ans;
                bests = s;
            }
        }
        cout << best_ans << "\n";
        cout << bests << "\n";
    }
    return 0;
}
