#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int MAXN = 300020;
const long long INF = 4e18;

long long getNumFromChar(char c) {
	int k = c - 'A';
	long long ans = 1;
	for (int i = 0; i < k / 2; ++i) {
		ans *= 10;
	}
	if (k & 1) {
		ans *= 5;
	}
	return ans;
}

long long dp[MAXN]['z' - 'a' + 1];
pair<char, int> pref[MAXN]['z' - 'a' + 1];

pair<string, long long> solve1(string s) {
	int posLastQ = -1;
	int qcnt = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '?') {
			posLastQ = i;
		}
	}
	int n = s.size();
	if (false) {
		long long ans = 0;
		char maxC = 'A';
		for (int i = (int)s.size() - 1; i >= 0; --i) {
			if (s[i] >= maxC) {
				ans += getNumFromChar(s[i]);
				maxC = s[i];
			}
			else {
				ans -= getNumFromChar(s[i]);
			}
		}
		return make_pair(s, ans);
	}
	else {
		for (int i = 0; i < 'z' - 'a' + 1; ++i) {
			dp[n][i] = 0;
		}
		for (int i = n - 1; i >= 0; --i) {
			if (s[i] != '?') {
				for (int c = 0; c < s[i] - 'A'; ++c) {
					dp[i][c] = -INF;
				}
				/*dp[i][s[i] - 'A'] = max(-INF, dp[i + 1][s[i] - 'A'] + getNumFromChar(s[i]));
				for (int c = s[i] - 'A' + 1; c < 'z' - 'a' + 1; ++c) {
					dp[i][c] = max(-INF, dp[i + 1][c] - getNumFromChar(s[i]));
				}*/
				int c = s[i] - 'A';
				dp[i][c] = -INF;
				pref[i][c] = make_pair(c + 'A', c);
				for (int cmax = 0; cmax <= c; ++cmax) {
					if (dp[i + 1][cmax] + getNumFromChar('A' + c) > dp[i][c]) {
						pref[i][c].second = c;
						dp[i][c] = dp[i + 1][cmax] + getNumFromChar('A' + c);
					}
				}
				for (int cmax = c + 1; cmax < 'z' - 'a' + 1; ++cmax) {
					dp[i][cmax] = max(-INF, dp[i + 1][cmax] - getNumFromChar('A' + c));
					pref[i][cmax] = make_pair(c + 'A', cmax);
				}
			}
			else {
				for (int c = 0; c < 'z' - 'a' + 1; ++c) {
					/*for (int j = 0; j < c; ++j) {
						dp[i][j] = -INF;
					}*/
					dp[i][c] = -INF;
					pref[i][c] = make_pair(c + 'A', c);
					for (int cmax = 0; cmax <= c; ++cmax) {
						if (dp[i + 1][cmax] + getNumFromChar('A' + c) > dp[i][c]) {
							pref[i][c].second = c;
							dp[i][c] = dp[i + 1][cmax] + getNumFromChar('A' + c);
						}
					}
					for (int cmax = c + 1; cmax < 'z' - 'a' + 1; ++cmax) {
						dp[i][cmax] = max(-INF, dp[i + 1][cmax] - getNumFromChar('A' + c));
						pref[i][cmax] = make_pair(c + 'A', cmax);
					}
				}
			}
		}
		//cout << "!" << dp[6]['Y' - 'A'] << "\n";
		long long ans = -INF;
		int posMax = -1;
		for (int c = 0; c < 'z' - 'a' + 1; ++c) {
			if (dp[0][c] > ans) {
				ans = dp[0][c];
				posMax = c;
			}
		}
		string sans;
		for (int i = 0; i < n; ++i) {
			sans += pref[i][posMax].first;
			posMax = pref[i][posMax].second;
		}
		return make_pair(sans, ans);
	}
}

signed main() {
	long long t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;
		auto ans = solve1(s);
		cout << ans.second << "\n" << ans.first << "\n";
	}
}