#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 150000;
vector<int> g[maxn];
set<pair<int, int>> st;
int pr[maxn];
int m;
int tin[maxn];
int tout[maxn];
int timer = 0;

void dfs(int v, int p) {
    tin[v] = timer++;
    pr[v] = p;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (to == p)continue;
        dfs(to, v);
    }
    tout[v] = timer++;
}

bool ispredok(int fath, int son) {
    return tin[fath] <= tin[son] && tout[fath] >= tout[son];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn * 2; ++i) {
        pr[i] = -1;
    }
    int n;
    cin >> n >> m;
    vector<pair<int, int>> edges;

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        st.insert({a, b});
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i) {
        if (pr[i] == -1)dfs(0, 0);
    }
    bool was[n];
    int v1 = -1;
    bool up = false;
    int v2 = -1;
    bool up2 = false;
    for (int i = 0; i < n; ++i) {
        if (pr[i] != i) {
            if (st.count({i, pr[i]}) == 1 && st.count({pr[i], i}) == 1)continue;
            if (v1 != -1) {
                swap(v1, v2);
                swap(up, up2);
            }
            if (st.count({i, pr[i]}) == 1) {
                up = true;
                v1 = i;
            } else {
                up = false;
                v1 = i;
            }
        }
    }
    if (v1 == -1) {
        cout << "Yes" << "\n";
        for (int i = 0; i < n; ++i) {
            if (pr[i] != i) {
                cout << i << " " << pr[i] << " " << pr[i] << " " << i << "\n";
            }
        }
    } else {
        was[v1] = true;
        was[v2] = true;
        vector<pair<pair<int, int>, pair<int, int>>> ans;
        while (!ispredok(pr[v1], v2)) {
            if (up) {
                ans.push_back({{v1,     pr[v1]},
                               {pr[v1], pr[pr[v1]]}});

            } else {
                ans.push_back({{pr[v1],     v1},
                               {pr[pr[v1]], pr[v1]}});
            }
            v1 = pr[v1];
            was[v1] = true;
            up = !up;
        }
        while (!ispredok(pr[v2], v1)) {
            if (up2) {
                ans.push_back({{v2,     pr[v2]},
                               {pr[v2], pr[pr[v2]]}});

            } else {
                ans.push_back({{pr[v2],     v2},
                               {pr[pr[v2]], pr[v2]}});
            }
            v2 = pr[v2];
            was[v1] = true;
            up2 = !up2;
        }
        if (up == up2) {
            cout << "No";
            exit(0);
        }
        if (up) {
            ans.push_back({{v1,     pr[v1]},
                           {pr[v1], v2}});
        }
        for (int i = 0; i < n; ++i) {
            if (!was[i] && pr[i] != i) {
                ans.push_back({{i,     pr[i]},
                               {pr[i], i}});
            }
        }
        cout << "Yes" << "\n";
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " "
                 << ans[i].second.second + 1 << "\n";
        }
    }
}