#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 5e5;
int le[maxn];
int ri[maxn];
int x[maxn];
int h[maxn];
int n;

bool check(int i) {
    if (le[i] != -1) {
        if (x[i] - x[le[i]] >= h[i]) {
            return true;
        }
    }
    if (ri[i] != n) {
        if (x[ri[i]] - x[i] >= h[i]) {
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        cin >> h[i];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        for (int i = 0; i < n; ++i) {
            le[i] = max(i - 1, 0ll);
            ri[i] = min(i + 1, n - 1);
        }

        deque<int> good;
        bool used[n];
        for (int i = 0; i < n; ++i) {
            used[i] = false;
        }
        for (int i = l; i <= r; ++i) {
            if (check(i)) {
                good.push_back(i);
                used[i] = true;
            }
        }
        int ans = 0;
        while (!good.empty()) {
            int id = good.front();
            good.pop_front();
            ans++;
            if (le[id] != -1) {
                ri[le[id]] = ri[id];
                if (check(le[id]) && le[id] >= l && !used[le[id]]) {
                    good.push_back(le[id]);
                    used[le[id]] = true;
                }
            }
            if (ri[id] != n) {
                le[ri[id]] = le[id];
                if (check(ri[id]) && ri[id] <= r && !used[ri[id]]) {
                    good.push_back(ri[id]);
                    used[ri[id]] = true;
                }
            }
        }
        cout << ans << "\n";
    }
}
