#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 3e5;
const int inf = 1e15;
vector<pair<int, pair<int, int>>> g[maxn];
int ans[maxn];
bool used[maxn];

int k = -1;
int x = inf;
int y = -inf;

void dfs(int v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if (used[to] || g[v][i].second.first < x || g[v][i].second.first > y)continue;
        dfs(to);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn; ++i) {
        ans[i] = inf;
    }
    int n, m;
    cin >> n >> m;
    vector<int> tt;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int t;
        cin >> t;
        g[a].push_back({b, {t, i}});
        g[b].push_back({a, {t, i}});
        tt.push_back(t);
    }
    sort(tt.begin(), tt.end());
    for (int j = 0; j < tt.size(); ++j) {
        for (int l = j; l < tt.size(); ++l) {
            x = tt[j];
            y = tt[l];
            for (int i = 0; i < n; ++i) {
                used[i] = false;
            }
            dfs(0);
            for (int i = 0; i < n; ++i) {
                if (used[i]) {
                    ans[i] = min(ans[i], x + y);
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout<<ans[i]<<"\n";
    }
}
