#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <queue>

using namespace std;

#define endl '\n'
#define int long long

struct Sos
{
	vector<int> plus= vector<int>(26, 0);
	vector<int> minus = vector<int>(26, 0);
};

vector<int> pos;
vector<Sos> all;

int ans = LLONG_MIN;
string ansput;

int binpow(int k, int n)
{
	if (n == 1)
	{
		return k;
	}
	else if (n == 0)
	{
		return 1;
	}
	else
	{
		return binpow(k, n / 2) * binpow(k, n - n / 2);
	}
}

long long count(Sos c)
{
	long long ret = 0;

	for (long long i = 0; i < 26; i++)
	{
		if (i % 2 == 1)
		{
			ret += c.plus[i] * 5 * (int)binpow(10, i / 2);
			ret -= c.minus[i] * 5 * (int)binpow(10, i / 2);
		}
		else
		{
			ret += c.plus[i] * (int)binpow(10, i / 2);
			ret -= c.minus[i] * (int)binpow(10, i / 2);
		}
	}

	return ret;
}

void rec(string put)
{
	if (put.size() == pos.size())
	{
		Sos s;

		for (int i = 0; i < put.size(); i++)
		{
			char maxx = put[0];
			for (int j = i; j < put.size(); j++)
			{
				maxx = max(maxx, put[j]);
			}

			for (int j = 0; j < maxx - 'A'; j++)
			{
				s.minus[j] += all[i].plus[j];
			}

			for (int j = maxx - 'A'; j < 26; j++)
			{
				s.plus[j] += all[i].plus[j];
			}

			for (int j = 0; j < 26; j++)
			{
				s.minus[j] += all[i].minus[j];
			}

			char nmaxx = 'A';

			for (int j = i + 1; j < put.size(); j++)
			{
				nmaxx = max(nmaxx, put[j]);
			}

			if (put[i] < nmaxx)
			{
				s.minus[put[i] - 'A']++;
			}
			else
			{
				s.plus[put[i] - 'A']++;
			}
		}

		for (int i = 0; i < 26; i++)
		{
			s.plus[i] += all.back().plus[i];
			s.minus[i] += all.back().minus[i];
		}

		long long c = count(s);

		if (c > ans)
		{
			ans = c;
			ansput = put;
		}
	}
	else
	{
		for (int i = 0; i < 26; i++)
		{
			put.push_back('A' + i);
			rec(put);
			put.pop_back();
		}
	}
}

void task()
{
	int t;
	cin >> t;

	while (t--)
	{
		string str;
		cin >> str;

		Sos cur;

		for (int i = 0; i < str.size(); i++)
		{
			if (str[i] == '?')
			{
				pos.push_back(i);
				all.push_back(cur);
				cur = Sos();
			}
			else
			{
				cur.plus[str[i] - 'A']++;
				for (int j = 0; j < str[i] - 'A'; j++)
				{
					cur.minus[j] += cur.plus[j];
					cur.plus[j] = 0;
				}
			}
		}
		all.push_back(cur);

		ans = LLONG_MIN;
		ansput = "";
		rec("");

		cout << ans << endl;

		int pos = 0;
		for (int j = 0; j < str.size(); j++)
		{
			if (str[j] == '?')
			{
				cout << ansput[pos++];
			}
			else
			{
				cout << str[j];
			}
		}
		cout << endl;
	}
}

long main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}