#include <bits/stdc++.h>

using namespace std;

int cost[300000];
bool where[300000];
vector<int> g[300000];
vector<int> ge[300000];
vector<pair<int, int>> edges;
bool used[300000];

void dfs(int v, int p = -1) {
	if (used[v]) {
		return;
	}
	vector<int> kek;
	used[v] = true;
	for (auto ind: g[v]) {
		int u = edges[ind].second;
		if (u != p) {
			dfs(u, v);
		} else {
			kek.push_back(ind);
		}
	}
	for (auto ind: ge[v]) {
		int u = edges[ind].first;
		if (u != p) {
			dfs(u, v);
		} else {
			kek.push_back(ind);
		}
	}

	if (cost[v] < 0 || cost[v] > kek.size()) {
		cout << "No";
		exit(0);
	}
	int was = cost[v];
	for (int i = 0; i < was; i++) {
		where[kek[i]] = true;
		cost[v]--;
		if (p != -1) {
			cost[p] -= 1;
		}
	}
}

vector<vector<int>> good(300000);
vector<vector<int>> bad(300000);

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		cost[a]++;
		edges.push_back(make_pair(a, b));
		g[a].push_back(i);
		ge[b].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	for (int i = 0; i < m; i++) {
		if (where[i] == false) {
			good[edges[i].first].push_back(i);
		} else {
			bad[edges[i].second].push_back(i);
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < (int)good[i].size(); j++) {
			cout << edges[good[i][j]].first + 1 << " " << edges[good[i][j]].second + 1 << " ";
			cout << edges[bad[i][j]].first + 1 << " " << edges[bad[i][j]].second + 1 << endl;
		}
	}
	/*int lol = 0;
	while (ans.size() < m / 2) {
		bool was = false;
		lol++;
		for (int i = 0; i < m; i++) {
			if (!used1[i]) {
				int a = edges[i].first;
				int b = edges[i].second;
				if (cnt[b] >= 1 && cnte[a] == 0) {
					was = true;
					for (auto ind: g[b]) {
						if (!used1[ind]) {
							int c = edges[ind].second;
							ans.push_back(make_pair(make_pair(a, b), make_pair(b, c)));
							used1[i] = true;
							used1[ind] = true;
							cnt[a]--;
							cnt[b]--;
							cnte[b]--;
							cnte[c]--;
							break;
						}
					}
					break;
				}
			}
		}
		if (was) {
			continue;
		}
		for (int i = 0; i < m; i++) {
			if (!used1[i]) {
				int a = edges[i].first;
				int b = edges[i].second;
				if (cnte[a] >= 1 && cnt[b] == 0) {
					was = true;
					for (auto ind: ge[a]) {
						if (!used1[ind]) {
							int c = edges[ind].first;
							ans.push_back(make_pair(make_pair(a, b), make_pair(c, a)));
							used1[i] = true;
							used1[ind] = true;
							cnte[b]--;
							cnt[a]--;
							cnte[a]--;
							cnt[c]--;
							break;
						}
					}
					break;
				}
			}
		}

		if (!was) {
			break;
		}
	}

	for (int i = 0; i < m; i++) {
		if (!used1[i]) {
			for (int j = 0; j < m; j++) {
				if (!used1[j]) {
					int a = edges[i].first;
					int b = edges[i].second;
					int c = edges[j].first;
					int d = edges[j].second;
					if (a == d && b == c) {
						used1[i] = true;
						used1[j] = true;
						ans.push_back(make_pair(make_pair(a, b), make_pair(c, d)));
					}
				}
			}
		}
	}
	if (ans.size() == m / 2) {
		cout << "Yes" << endl;
		for (auto p: ans) {
			cout << p.first.first + 1 << " " << p.first.second + 1<< " ";
			cout << p.second.first + 1 << " " << p.second.second + 1 << endl;
		}
	} else {
		cout << "No";
	}*/
}