#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

string pl(string a, string b) {
	if (a.size() < b.size())
		swap(a, b);
	string c;
	int cur=0;
	for (int i = 0; i < a.size(); i++) {
		int x = a[a.size() - 1 - i] - '0';
		int y = 0;
		if (b.size() - 1 >= i)
			y = b[b.size() - 1 - i] - '0';
		char f = '0' + (x + y + cur) % 10;
		if (x + y + cur >= 10)
			cur = 1;
		else
			cur = 0;
		c += f;
	}
	if (cur)
		c += '1';
	reverse(begin(c), end(c));
	return c;
}
string mn(string a, string b) {
	bool otr = 0;
	if (a.size() < b.size() || (a.size() == b.size() && a < b))
	{
		otr = 1;
		swap(a, b);
	}
	if (a == b) {
		return "0";
	}
	vector<int>fr,sc;
	for (auto c : a)
		fr.push_back(c - '0');
	for (auto c : b)
		sc.push_back(c - '0');
	vector<int>ans;
	int last = fr.size() - 2;
	for (int i = 0; i < fr.size(); i++) {
		int x = fr[fr.size() - 1 - i];
		int y = 0;
		if (sc.size() - 1 >= i)
			y = sc[sc.size() - 1 - i];
		if (x >= y)
			ans.push_back(x - y);
		else {
			int j = last;
			while (fr[j] == 0)
				j--;
			last = j;
			fr[last]--;
			for (int z = last + 1; z < fr.size() - 1 - i; z++)
				fr[last] += 9;
			x += 10;
			ans.push_back(x - y);
		}
	}
	reverse(begin(ans), end(ans));
	bool ok = 0;
	string res;
	if (otr)
		res += '-';
	for (auto c : ans) {
		if (ok == false && c == 0)
			continue;
		if (c > 0)
			ok = 1;
		if (ok)
		{
			char e = '0' + c;
			res += e;
		}
	}
	return res;
}

map<char, long long>cnt;
void solve() {
	string s;
	cin >> s;
	int n = s.size();
	vector<char>mx(n);
	mx[n - 1] = s[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		if (s[i] == '?') {
			mx[i] = mx[i + 1];
			continue;
		}
		if (mx[i + 1] == '?') {
			mx[i] = s[i];
			continue;
		}
		mx[i] = max(s[i], mx[i + 1]);
	}
	char good = '-';
	long long best = -1000000000000000000;
	for (int i = 0; i < 26; i++) {
		char now = 'A' + i;
		vector<char>all(n);
		for (int y = 0; y < n; y++) {
			if (s[y] == '?')
				all[y] = now;
			else
				all[y] = s[y];
		}
		mx[n - 1] = all[n - 1];
		for (int i = n - 2; i >= 0; i--)
			mx[i] = max(mx[i + 1], all[i]);
		long long res = 0;
		for (int i = 0; i < n; i++) {
			if (i<n - 1 && mx[i + 1]>all[i])
				res -= cnt[all[i]];
			else
				res += cnt[all[i]];
		}
		if (res > best) {
			best = res;
			good = now;
		}
	}
	cout << best << '\n';
	for (auto c : s) {
		if (c == '?')
			cout << good;
		else
			cout << c;
	}
	cout << '\n';
	
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	cnt['A'] = 1;
	cnt['B'] = 5;
	cnt['C'] = 10;
	cnt['D'] = 50;
	cnt['E'] = 100;
	cnt['F'] = 500;
	cnt['G'] = 1000;
	cnt['H'] = 5000;
	cnt['I'] = 10000;
	cnt['J'] = 50000;
	cnt['K'] = 100000;
	cnt['L'] = 500000;
	cnt['M'] = 1000000;
	cnt['N'] = 5000000;
	cnt['O'] = 10000000;
	cnt['P'] = 50000000;
	cnt['Q'] = 100000000;
	cnt['R'] = 500000000;
	cnt['S'] = 1000000000;
	cnt['T'] = 5000000000;
	cnt['U'] = 10000000000;
	cnt['V'] = 50000000000;
	cnt['W'] = 100000000000;
	cnt['X'] = 500000000000;
	cnt['Y'] = 1000000000000;
	cnt['Z'] = 5000000000000;
	int t;
	cin >> t;
	while (t) {

		t--;
		solve();
	}
}
