#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 7e18;

vector <int> smth = {1, 5, 10, 50, 100, 500, 1000, (int)5e3, (int)1e4, (int)5e4, (int)1e5, (int)5e5, (int)1e6, (int)5e6, (int)1e7, (int)5e7, (int)1e8, (int)5e8, (int)1e9, (int)5e9, (int)1e10, (int)5e10, (int)1e11, (int)5e11, (int)1e12, (int)5e12};

void solve() {
    string s;
    cin >> s;
    int n = (int)s.size();
    vector <int> used(26);
    vector <vector <int> > dp(n, vector <int> (26, -INF)), par(n, vector <int> (26));
    if (s.back() == '?') {
        for (int i = 0; i < 26; i++)
            dp[n - 1][i] = smth[i];
    }
    else
        dp[n - 1][s[n - 1] - 'A'] = smth[s[n - 1] - 'A'];
    for (int i = n - 2; i >= 0; i--) {
        if (s[i] != '?') {
            int a = s[i] - 'A';
            for (int pm = 0; pm <= a; pm++) {
                if (dp[i][a] < dp[i + 1][pm] + smth[a])
                    par[i][a] = pm;
                dp[i][a] = max(dp[i][a], dp[i + 1][pm] + smth[a]);
            }
            for (int pm = a + 1; pm < 26; pm++) {
                if (dp[i][pm] < dp[i + 1][pm] - smth[a])
                    par[i][pm] = pm;
                dp[i][pm] = max(dp[i][pm], dp[i + 1][pm] - smth[a]);
            }
        }
        else {
            for (int a = 0; a < 26; a++) {
                for (int pm = 0; pm <= a; pm++) {
                    if (dp[i][a] < dp[i + 1][pm] + smth[a])
                        par[i][a] = pm;
                    dp[i][a] = max(dp[i][a], dp[i + 1][pm] + smth[a]);
                }
                for (int pm = a + 1; pm < 26; pm++) {
                    if (dp[i][pm] < dp[i + 1][pm] - smth[a])
                        par[i][pm] = pm;
                    dp[i][pm] = max(dp[i][pm], dp[i + 1][pm] - smth[a]);
                }
            }
        }
    }
    int ans = -INF;
    for (int a = 0; a < 26; a++)
        ans = max(ans, dp[0][a]);
    int now = 0, pm = -1;
    string res = "";
    for (int a = 0; a < 26; a++) {
        if (dp[0][a] == ans) {
            if (s[0] != '?')
                res += s[0];
            else
                res += (char)'A' + a;
            pm = a;
            break;
        }
    }
    while (now < n - 1) {
        pm = par[now][pm];
        now++;
        if (s[now] != '?')
            res += s[now];
        else
            res += (char)'A' + pm;
    }
    cout << res << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int i = 0; i < 26; i++)
        smth[i] = (int)smth[i];
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
