#include <bits/stdc++.h>
//#define int long long

using namespace std;

const int INF = 2e9 + 7;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <vector <vector <int> > > gr(n);
    vector <vector <int> > edges;
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].push_back({b, w, i});
        gr[b].push_back({a, w, i});
    }
    int M = (1 << m);
    pair <int, int> dp[n][M];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < M; j++) {
            dp[i][j] = {INF, INF};
        }
    }
    dp[0][0] = {INF, 0};
    for (int mask = 0; mask < M; mask++) {
        for (int i = 0; i < n; i++) {
            for (auto el : gr[i]) {
                int to = el[0], w = el[1], pos = el[2];
                if ((mask >> pos) & 1)
                    continue;
                if ((long long)min(dp[i][mask].first, w) + max(dp[i][mask].second, w) < (long long)dp[to][mask ^ (1 << pos)].first + dp[to][mask ^ (1 << pos)].second) {
                    dp[to][mask ^ (1 << pos)] = {min(dp[i][mask].first, w), max(dp[i][mask].second, w)};
                }
            }
        }
    }
    for (int i = 1; i < n; i++) {
        long long res = (long long)3 * INF;
        for (int mask = 0; mask < M; mask++) {
            res = min(res, (long long)dp[i][mask].first + dp[i][mask].second);
        }
        cout << res << "\n";
    }
    return 0;
}
