#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e18;

int n, m;
vector <vector <pair <int, int> > > gr;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].push_back({b, w});
        gr[b].push_back({a, w});
    }
    vector <int> dist(n, INF);
    dist[0] = 0;
    set <pair <int, int> > all;
    for (int i = 0; i < n; i++) {
        all.insert({dist[i], i});
    }
    while (!all.empty()) {
        pair <int, int> cur = *all.begin();
        all.erase(cur);
        int v = cur.second;
        for (auto el : gr[v]) {
            int to = el.first;
            if (max(cur.first, el.second) < dist[to]) {
                all.erase({dist[to], to});
                dist[to] = max(cur.first, el.second);
                all.insert({dist[to], to});
            }
        }
    }
    for (int i = 1; i < n; i++)
        cout << dist[i] << "\n";
    return 0;
}
