#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define pii pair<int, int>
#define vi vector<int>
#define vpii vector<pii>
#define vvi vector<vi>

const int N = 5005;
const ll INF = 1e18;

vpii a[N];
int dp[N][N];
void solve() {
	vi b;
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y, t; cin >> x >> y >> t;
		--x, --y;
		a[x].push_back({y, t});
		a[y].push_back({x, t});
		b.push_back(t);
	}
	sort(b.begin(), b.end());
	map<int, int> c;
	vi r{b[0]};
	int id = c[b[0]] = 0;
	for (int i = 1; i < b.size(); ++i) {
		if (b[i] != b[i - 1]) {
			c[b[i]] = ++id;
			r.push_back(b[i]);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (auto& p : a[i]) {
			p.second = c[p.second];
		}
	}
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			dp[i][j] = r.size() - 1;
		}
	}
	for (auto u : a[0]) {
		dp[u.first][u.second] = u.second;
	}
	for (int c = 0; c < r.size(); ++c) {
		for (int i = 0; i < n; ++i) {
			for (auto j : a[i]) {
				dp[j.first][max(c, j.second)] = min({ dp[j.first][max(c, j.second)], dp[i][c], j.second });
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		int ans = INF;
		for (int j = 0; j < r.size(); ++j) {
			ans = min(ans, r[j] + r[dp[i][j]]);
		}
		cout << ans << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}

/*

3 3
1 2 2
1 3 1
2 3 1


*/