#include <bits/stdc++.h>
// #pragma optimaze("Ofast")
using namespace std;

typedef long long ll;


void dfs(int v, int p, vector<vector<pair<int, int>>> & g, vector<int> & mn, vector<int> & mx) {
    for (auto to : g[v]) {
        if (to.first == p) continue;
        mx[to.first] = max(mx[to.first], max(mx[v], to.second));
        mn[to.first] = min(mn[to.first], min(mn[v], to.second));
        dfs(to.first, v, g, mn, mx);
    }
    return;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    int inf = 1e9;
    vector<int> mn(n, inf), mx(n);
    dfs(0, -1, g, mn, mx);
    for (int i = 1; i < n; i++) cout << mn[i] + mx[i] << endl;
    return 0;
}
