#include <iostream>
#include "vector"
#include "map"

using namespace std;

long long INF = 1e18;

map<char, long long> mp = {{'A', 1}, {'B', 5}, {'C', 10}, {'D', 50}, {'E', 100}, {'F', 500}, {'G', 1000}, {'H', 5000}, {'I', 10000}, {'J', 50000}, {'K', 1e5}, {'L', 5 * 1e5}, {'M', 1e6}, {'N', 5 * 1e6}, {'O', 1e7}, {'P', 5 * 1e7}, {'Q', 1e8}, {'R', 5 * 1e8}, {'S', 1e9}, {'T', 5 * 1e9}, {'U', 1e10}, {'V', 5 * 1e10}, {'W', 1e11}, {'X', 5 * 1e11}, {'Y', 1e12}, {'Z', 5 * 1e12}};

signed main() {
    long long t; cin >> t;
    for (long long i = 0; i < t; ++i) {
        string s; cin >> s;
        long long n = s.size();
        vector<vector<long long>> prev(n, vector<long long>(26, -1));
        vector<vector<long long>> dp(n, vector<long long>(26, -INF));
        if (s[n - 1] == '?') {
            for (long long j = 0; j < 26; ++j) {
                dp[n - 1][j] = mp[(char)(j + 'A')];
            }
        } else {
            dp[n - 1][s[n - 1] - 'A'] = mp[s[n - 1]];
        }
        for (long long j = n - 2; j >= 0; --j) {
            if (s[j] == '?') {
                for (long long k = 0; k < 26; ++k) {
                    for (long long l = 0; l <= k; ++l) {
                        if (dp[j + 1][l] != -INF) {
                            if (dp[j + 1][l] + mp[(char)(k + 'A')] > dp[j][k]) {
                                dp[j][k] = dp[j + 1][l] + mp[(char)(k + 'A')];
                                prev[j][k] = l;
                            }
                            //dp[j][k] = max(dp[j][k], dp[j + 1][l] + mp[(char)(k + 'A')]);
                        }
                    }
                }
            } else {
                for (long long k = 0; k <= s[j] - 'A'; ++k) {
                    if (dp[j + 1][k] != -INF) {
                        if (dp[j + 1][k] + mp[s[j]] > dp[j][s[j] - 'A']) {
                            dp[j][s[j] - 'A'] = dp[j + 1][k] + mp[s[j]];
                            prev[j][s[j] - 'A'] = k;
                        }
                        //dp[j][s[j] - 'A'] = max(dp[j][s[j] - 'A'], dp[j + 1][k] + mp[s[j]]);
                    }
                }
                for (long long k = s[j] - 'A' + 1; k < 26; ++k) {
                    if (dp[j + 1][k] != -INF) {
                        dp[j][k] = dp[j + 1][k] - mp[s[j]];
                        prev[j][k] = k;
                    }
                }
            }
        }
        long long ans = -INF;
        for (long long j = 0; j < 26; ++j) {
            ans = max(ans, dp[0][j]);
        }
        cout << ans << endl;
        string s1;
        for (long long j = 0; j < 26; ++j) {
            if (dp[0][j] == ans) {
                long long x = 0, y = j;
                for (long long k = 0; k < n; ++k) {
                    if (s[k] == '?') {
                        s1 += (char)(y + 'A');
                    } else {
                        s1 += s[k];
                    }
                    y = prev[x][y];
                    x++;
                }
                break;
            }
        }
        cout << s1 << endl;
    }
}