#include <iostream>
#include <vector>

using namespace std;

int n, m;
vector <int> sum;
vector <vector <pair <int, int>>> g;

void dfs(int v, int p, int mn, int mx) {
    sum[v] = mn + mx;
    for (auto &[u, t]: g[v]) {
        if (u != p) {
            int t1 = min(t, mn), t2 = max(t, mx);
            dfs(u, v, t1, t2);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--, u--;
        g[v].push_back(make_pair(u, t));
        g[u].push_back(make_pair(v, t));
    }

    sum.resize(n);
    dfs(0, 0, 1e9, 0);
    for (int i = 1; i < n; i++)
        cout << sum[i] << endl;

    return 0;
}
