#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 25;
const int INF = 1e18 + 118;

vector<vector<pair<int, int>>> g(MAXN);

int dist[MAXN];

const int K = 1e9;

int mn[20][(1 << 20)];
int mx[20][(1 << 20)];
int f[20][(1 << 20)];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, int>> edges;
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        edges.push_back({{u, v}, w});
    }
    mn[0][0] = INF;
    mx[0][0] = -INF;
    f[0][0] = true;
    for (int msk = 0; msk < (1 << m); ++msk)
    {
        vector<pair<pair<int, int>, int>> cur;
        for (int i = 0; i < m; ++i)
        {
            if (msk & (1 << i))
            {
                cur.push_back({{edges[i].first.first, edges[i].first.second}, i});
                cur.push_back({{edges[i].first.second, edges[i].first.first}, i});
            }
        }
        for (auto el : cur)
        {
            if (!f[el.first.second][msk ^ (1 << el.second)])
            {
                continue;
            }
            f[el.first.first][msk] = true;
            mn[el.first.first][msk] = min(mn[el.first.second][msk ^ (1 << el.second)], edges[el.second].second);
            mx[el.first.first][msk] = max(mx[el.first.second][msk ^ (1 << el.second)], edges[el.second].second);
        }
    }
    for (int i = 1; i < n; ++i)
    {
        int ans = INF;
        for (int msk = 0; msk < (1 << m); ++msk)
        {
            if (f[i][msk])
            {
                ans = min(ans, mn[i][msk] + mx[i][msk]);
            }
        }
        cout << ans << endl;
    }
    return 0;
}

