#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e3 + 25;
const int INF = 1e18 + 118;

vector<vector<pair<int, int>>> g(MAXN);

int a[MAXN];
int b[MAXN];
int mn[MAXN];
int mx[MAXN];
int dist[MAXN];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        a[i] = INF;
        b[i] = INF;
    }
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        if (u > v)
        {
            swap(u, v);
        }
        if (w < a[v])
        {
            a[v] = w;
            b[v] = a[v];
        }
        else if (w < b[v])
        {
            b[v] = w;
        }
    }
    mx[0] = -INF;
    mn[0] = INF;
    for (int i = 1; i < n; ++i)
    {
        mx[i] = max(mx[i - 1], a[i]);
        mn[i] = min(mn[i - 1], a[i]);
        dist[i] = mn[i] + mx[i];
        int cur_mn = mn[i];
        int cur_mx = mx[i];
        for (int j = i + 1; j < n; ++j)
        {
            cur_mn = min(cur_mn, a[j]);
            cur_mx = max(cur_mx, b[j]);
            dist[i] = min(dist[i], cur_mn + cur_mx);
        }
    }
    for (int i = 1; i < n; ++i)
    {
        cout << dist[i] << endl;
    }
    return 0;
}
