#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 500 * 1000 + 7;

int n, q;

int x[N], h[N];
bool fall[N];

bool can_left(int i) {
	if (x[i] - h[i] < x[1]) {
		return false;
	}
	for (int j = i - 1; j >= 1; --j) {
		if (x[j] > x[i] - h[i]) {
			if (!fall[j]) {
				return false;
			}
		} else break;
	}
	return true;
}

bool can_right(int i) {
	if (x[i] + h[i] > x[n]) {
		return false;
	}
	for (int j = i + 1; j <= n; ++j) {
		if (x[j] < x[i] + h[i]) {
			if (!fall[j]) {
				return false;
			}
		} else break;
	}
	return true;
}

void solve() {
	int l, r;
	cin >> l >> r;
	for (int i = 1; i <= n; ++i) {
		fall[i] = false;
	}
	
	int res = 0;

	while (true) {
		int __ = 0;
		for (int i = l; i <= r; ++i) {
			if (fall[i]) continue;
			if (can_left(i) || can_right(i)) {
				fall[i] = true;
				++res;
				++__;
			}
		}
		if (__ == 0) {
			break;
		}
	}

	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> x[i] >> h[i];
	}

	while(q--) {
		solve();
	}
	return 0;
}


/*


*/