#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int K = 26;
const int INF = 1e9 + 1;
const ll INFLL = 2e18 + 1;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<ll> c(K);
    c[0] = 1;
    for (int i = 1; i < K; i++) {
        if (i % 2 == 1) c[i] = 5 * c[i - 1];
        else c[i] = 2 * c[i - 1];
    }
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<ll>> dp(n, vector<ll>(K, -INFLL));
        vector<vector<pii>> p(n, vector<pii>(K, {-1, -1}));
        if (s[n - 1] == '?') {
            for (int j = 0; j < K; j++) {
                dp[n - 1][j] = c[j];
                p[n - 1][j] = {j, -1};
            }
        } else {
            dp[n - 1][s[n - 1] - 'A'] = c[s[n - 1] - 'A'];
            p[n - 1][s[n - 1] - 'A'] = {s[n - 1] - 'A', -1};
        }
        for (int i = n - 2; i >= 0; i--) {
            if (s[i] == '?') {
                for (int j = 0; j < K; j++) {
                    for (int mx = 0; mx < K; mx++) {
                        if (dp[i][max(mx, j)] < dp[i + 1][mx] + (mx <= j ? c[j] : -c[j])) {
                            dp[i][max(mx, j)] = dp[i + 1][mx] + (mx <= j ? c[j] : -c[j]);
                            p[i][max(mx, j)] = {j, mx};
                        }
                    }
                }
            } else {
                int j = s[i] - 'A';
                for (int mx = 0; mx < K; mx++) {
                    if (dp[i][max(mx, j)] < dp[i + 1][mx] + (mx <= j ? c[j] : -c[j])) {
                        dp[i][max(mx, j)] = dp[i + 1][mx] + (mx <= j ? c[j] : -c[j]);
                        p[i][max(mx, j)] = {j, mx};
                    }
                }
            }
        }
        ll ans = -INFLL;
        int best = -1;
        for (int j = 0; j < K; j++) {
            if (ans < dp[0][j]) {
                ans = dp[0][j];
                best = j;
            }
        }
        cout << ans << "\n";
        string s1 = "";
        int i = 0;
        while (i < n) {
            s1 += 'A' + p[i][best].fi;
            best = p[i][best].se;
            i++;
        }
        cout << s1 << "\n";
    }
    return 0;
}
/*
4
BCCC
????
A?B?C?D
YYYYY?
*/
