#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;

struct edge {
    int to, id, t;
    edge() {}
    edge(int to, int id, int t) : to(to), id(id), t(t) {}
};

vector<vector<edge>> g;

void dfs_tree(int v, int p, vector<int> &ans, int mx, int mn) {
    if (v != 0) ans[v] = mx + mn;
    for (auto &e : g[v]) {
        if (e.to == p) continue;
        dfs_tree(e.to, v, ans, max(mx, e.t), min(mn, e.t));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        a--; b--;
        g[a].pb(b, i, t);
        g[b].pb(a, i, t);
    }
    if (m == n - 1) {
        vector<int> ans(n);
        dfs_tree(0, -1, ans, 0, INF);
        for (int i = 1; i < n; i++) cout << ans[i] << "\n";
        return 0;
    }
    return 0;
}
