#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e5 + 10;
const ll LINF = 1e18 + 10;

string s;

ll c[26];
int from[N][26];

void print(int it) {
    int i = 0;
    for (auto ch : s) {
        if (ch == '?') {
            cout << char('A' + it);
            it = from[i][it];
        } else {
            cout << ch;
        }
        i++;
    }
}

void solve() {
    c[0] = 1;
    for(int i = 1; i < 26; i++) {
        if (i&1) {
            c[i] = c[i-1] * 5;
        } else {
            c[i] = c[i-1] * 2;
        }
    }

    cin >> s;
    int len = s.length();
    from[len][0] = -1;
    ll last[26];
    int mx[26];
    for (int i=  0; i < 26; i++) {
        last[i] = 0;
        mx[i] = 0;
    }
    for (int i = len-1; i >= 0; i--) {
        if (s[i] != '?') {
            for (int j = 0; j < 26; j++) {
                if (s[i]-'A' >= mx[j]) {
                    last[j] += c[s[i]-'A'];
                    mx[j] = s[i]-'A';
                } else {
                    last[j] -= c[s[i]-'A'];
                }
            }
        } else {
            ll cur[26];
            ll curmx[26];
            for (int j = 0; j < 26; j++) {
                cur[j] = -LINF;
                curmx[j] = 0;
            }
            for (int j = 0; j < 26; j++) {
                for (int k = 0; k < mx[j]; k++) {
                    if (cur[k] < last[j] - c[k]) {
                        cur[k] = last[j] - c[k];
                        curmx[k] = mx[j];
                        from[i][k] = j;
                    }
                }
                for (int k = mx[j]; k < 26; k++) {
                    if (cur[k] < last[j] + c[k]) {
                        cur[k] = last[j] + c[k];
                        curmx[k] = k;
                        from[i][k] = j;
                    }
                }
            }
            for (int j = 0; j < 26; j++) {
                last[j] = cur[j];
                mx[j] = curmx[j];
            }
        }
    }
    ll ans = -LINF;
    int it;
    for (int i = 0; i < 26; i++) {
        if (last[i] > ans) {
            ans = last[i];
            it = i;
        }
    }
    cout << ans << "\n";
    print(it);
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
