#include <bits/stdc++.h>

using namespace std;

//#define  int long long
#define  x first
#define  y second

const int MAXN = 150000;

int used[MAXN];

vector<pair<int, int>> g[MAXN];

void dfs(int v, int p = -1) {
    used[v] = 1;
    if (p != -1) {
        for (int i = 0; i + 1 < g[v].size(); ++i)
            if (g[v][i].x == p)
                swap(g[v][i], g[v][g[v].size() - 1]);
        g[v].pop_back();
    }
    for (auto x : g[v])
        dfs(x.x, v);
}

void gg() {
    cout << "No\n";
    exit(0);
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

int status[MAXN], gore[MAXN];

void dfs_ans(int v) {
    used[v] = 1;
    for (auto x : g[v])
        dfs_ans(x.x);
    vector<int> input, output;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].x;
        int mask = g[v][i].y;
        if (status[to] == 1) {
            if ((mask & 1) == 0)
                gg();
            --g[v][i].y;
            --mask;
            status[to] = 0;
            ans.push_back({{v, to}, {to, gore[to]}});
        } else if (status[to] == 2) {
            if ((mask & 2) == 0)
                gg();
            g[v][i].y -= 2;
            mask -= 2;
            status[to] = 0;
            ans.push_back({{gore[to], to}, {to, v}});
        }
        if ((mask & 2) != 0) {
            input.push_back(to);
        }
        if ((mask & 1) != 0) {
            output.push_back(to);
        }
    }
    while (input.size() && output.size()) {
        int A = input.back();
        input.pop_back();
        int C = output.back();
        output.pop_back();
        ans.push_back({{A, v}, {v, C}});
    }
    if (input.size() > 1)
        gg();
    if (output.size() > 1)
        gg();
    if (input.size() == 1) {
        status[v] = 2;
        gore[v] = input.back();
    }
    if (output.size() == 1) {
        status[v] = 1;
        gore[v] = output.back();
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    set<pair<int, int>> rebs;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (rebs.find({a, b}) == rebs.end() && rebs.find({b, a}) == rebs.end()) {
            g[a].push_back({b, 0});
            g[b].push_back({a, 0});
        }
        rebs.insert({a, b});
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            if (rebs.find({i, g[i][j].x}) != rebs.end())
                g[i][j].y += 1;
            if (rebs.find({g[i][j].x, i}) != rebs.end())
                g[i][j].y += 2;
        }
    }
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    for (int i = 0; i < n; ++i)
        if (!used[i]) {
            dfs_ans(i);
        }
    for (int i = 0; i < n; ++i)
        if (status[i] != 0)
            gg();
    cout << "Yes\n";
    for (auto x : ans)
        cout << x.x.x + 1 << ' ' << x.x.y + 1 << ' ' << x.y.x + 1 << ' ' << x.y.y + 1 << '\n';
}

signed main() {
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}