#include <bits/stdc++.h>

using namespace std;

//#define  int long long
#define  x first
#define  y second

const int MAXN = 500000;

pair<int, int> info[MAXN];

void del(vector<pair<int, int>> &v, int pos) {
    for (int i = pos + 1; i < v.size(); ++i)
        swap(v[i - 1], v[i]);
    v.pop_back();
}

int solver(vector<pair<int, int>> tree, int Xl, int Xr) {
    int ans = 0;
    while (tree.size()) {
        int id = -1;
        for (int i = 0; i < tree.size(); ++i) {
            int Xprev = Xl;
            if (i != 0)
                Xprev = tree[i - 1].x;
            int Xnex = Xr;
            if (i + 1 != tree.size())
                Xnex = tree[i + 1].x;
            if (max(Xnex - tree[i].x, tree[i].x - Xprev) >= tree[i].y) {
                id = i;
                break;
            }
        }
        if (id == -1)
            break;
        ++ans;
        del(tree, id);
    }
    return ans;
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
        cin >> info[i].x >> info[i].y;
    for (int i = 0; i < q; ++i) {
        int le, re;
        cin >> le >> re;
        --le;
        vector<pair<int, int>> task;
        for (int j = le; j < re; ++j)
            task.push_back(info[j]);
        int Xl = info[le].x;
        if (le != 0)
            Xl = info[le - 1].x;
        int Xr = info[re - 1].x;
        if (re != n - 1)
            Xr = info[re].x;
        cout << solver(task, Xl, Xr) << '\n';
    }
}

signed main() {
#ifdef  LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}