#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vtm")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

const int INF = 1e9 + 9;

int n, m, tmp1, tmp2;
vector <vector <pair <int, int> > > g;
vector <int> used, ans;

void dfs1(int v, int mn, int mx) {
    used[v] = 1;
    for (auto &e : g[v]) {
        if (!used[e.first]) {
            tmp1 = min(mn, e.second), tmp2 = max(mx, e.second);
            ans[e.first] = tmp1 + tmp2;
            dfs1(e.first, tmp1, tmp2);
        }
    }
}

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    cin >> n >> m;
    g.resize(n); used.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }
    if (m == n - 1) {
        dfs1(0, INF, -INF);
    }
    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
