#include <iostream>
#include <string>
#include <climits>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>
int64_t val(char c)
{
	if(c == 'A') return int64_t(1e0); c--;
	if(c == 'A') return int64_t(5e0); c--;
	if(c == 'A') return int64_t(1e1); c--;
	if(c == 'A') return int64_t(5e1); c--;
	if(c == 'A') return int64_t(1e2); c--;
	if(c == 'A') return int64_t(5e2); c--;
	if(c == 'A') return int64_t(1e3); c--;
	if(c == 'A') return int64_t(5e3); c--;
	if(c == 'A') return int64_t(1e4); c--;
	if(c == 'A') return int64_t(5e4); c--;
	if(c == 'A') return int64_t(1e5); c--;
	if(c == 'A') return int64_t(5e5); c--;
	if(c == 'A') return int64_t(1e6); c--;
	if(c == 'A') return int64_t(5e6); c--;
	if(c == 'A') return int64_t(1e7); c--;
	if(c == 'A') return int64_t(5e7); c--;
	if(c == 'A') return int64_t(1e8); c--;
	if(c == 'A') return int64_t(5e8); c--;
	if(c == 'A') return int64_t(1e9); c--;
	if(c == 'A') return int64_t(5e9); c--;
	if(c == 'A') return int64_t(1e10); c--;
	if(c == 'A') return int64_t(5e10); c--;
	if(c == 'A') return int64_t(1e11); c--;
	if(c == 'A') return int64_t(5e11); c--;
	if(c == 'A') return int64_t(1e12); c--;
	if(c == 'A') return int64_t(5e12); c--;
	return 0;
}
int64_t sval(std::string s)
{
	int n = s.size();
	int64_t ans = 0;
	for(int i = 0; i < n; i++)
	{
		bool neg = false;
		for(int j = i; j < n; j++)
			if(s[j] > s[i]) neg = true;
		ans += (neg?-1:1) * val(s[i]);
	}
	//printf("%s: %lld\n", s.data(), ans);
	return ans;
}
int64_t dsolve(std::string s)
{
	std::string s2 = s;
	int64_t time = 1;
	int n = s.size();
	std::vector<char> cur(n, 0);
	for(int i = 0; i < n; i++)
		if(s[i] == '?') time *= 26;
	int64_t ans = LLONG_MIN;
	std::string best_s;
	while(time --> 0)
	{
		if(sval(s2) > ans)
			ans = sval(s2), best_s = s2;
		//ans = std::max(ans, sval(s2));
		for(int j = 0; j < n; j++)
		{
			cur[j]++;
			if(s[j] == '?') s2[j] = cur[j] + 'A';
			if(cur[j] == (s[j]=='?'?26:1))
			{
				cur[j] = 0;
				if(s[j] == '?') s2[j] = cur[j] + 'A';
			}
			else break;
		}
	}
	//printf("%s\n", best_s.data());
	return ans;
}
std::mt19937 mt;
int main(int argc, char*argv[])
{
	int T; std::cin >> T;
	while(T --> 0)
	{
		std::string s; std::cin >> s;
		int n = s.size();
		//int n = 20;
		//std::string s;
		//int qc = 0;
		//for(int i = 0; i < n; i++)
		//{
		//	 if(mt() % 8) s += (mt() % 4 + 22) + 65; else s += '?', qc++;
		//}
		//std::string s2 = s;
		////printf("s=%s, qc=%d\n", s.data(), qc);
		//if(qc > 3) continue;
		//printf("%lld\n", dsolve(s));
		//int64_t a2 = dsolve(s);
		//replace greedily left-to-right
		int64_t ans = 0;
		char maxc = 'A';
		std::vector<char> already_neg(n);
		//for each position for each question mark calculate the value
		//choose a decreasing path
		//also calculate the max for each suffix and the min for each prefix
		std::vector<char> smax(n, 0);
		for(int i = n; i --> 0;)
			smax[i] = std::max<char>(i==n-1?0:smax[i+1], s[i]);
		std::vector<int64_t[26]> data(n);
		int pq = 0;
		for(int i = 0; i < n; i++)
		{
			if(s[i] != '?')
			{
				bool neg = false;
				if(smax[i] > s[i]) neg = true;
				if(neg) already_neg[i] = true;
				ans += (neg?-1:1) * val(s[i]);
				continue;
			}
			//for(char c = 'A'; c <= 'Z'; c++)
			int64_t maxval = LLONG_MIN;
			for(char c = maxc; c <= 'Z'; c++)
			{
				int64_t cval = val(c);
				bool neg = false;
				if(smax[i] > c) neg = true;
				if(neg) cval = -cval;
				//find characters that will become negative
				//they must be after the previous ?, because otherwise they are already negative!
				for(int j = pq; j < i; j++)
				{
					if(s[j] != '?' && s[j] < c && !already_neg[j]) cval -= 2*val(s[j]);
				}
				data[i][c-'A'] = cval;
				//if(cval > maxval)
				//	maxval = cval, maxc = c;
			}
			//s[i] = maxc; ans += maxval;
			pq = i;
		}
		std::vector<std::vector<int64_t>> dp(n+1, {LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN, LLONG_MIN});
		std::vector<std::vector<int>> prev(n+1, std::vector<int>(26, -1));
		for(int i = 0; i < 26; i++)
			dp[0][i] = 0;
		for(int i = 0; i < n; i++)
			for(char cur = 0; cur < 26; cur++)
			{
				if(dp[i][cur] == LLONG_MIN) continue;
				if(s[i] != '?') { dp[i+1][cur] = dp[i][cur]; prev[i+1][cur] = cur; continue; }
				//try each smaller character
				//printf("dp[%d][%d] = %lld (%lld)\n", i, cur, dp[i][cur], dp[i][cur] + ans);
				for(int j = 0; j <= cur; j++)
				{
					int64_t nval = dp[i][cur] + data[i][j];
					if(nval > dp[i+1][j])
						dp[i+1][j] = nval, prev[i+1][j] = cur;
				}
				//dp[i+1][j] = std::max(dp[i+1][j], dp[i][cur] + data[i][j];
			}
		int maxi = 0;
		for(int i = 0; i < 26; i++)
		{
			//printf("%c: %lld, %d\n", char(i+65), dp[n][i], prev[n][i]);
			if(dp[n][i] > dp[n][maxi]) maxi = i;
		}
		//printf("maxi=%d\n", maxi);
		char cur = maxi;
		char ncur = maxi;
		for(int i = n+1; i --> 0;)
		{
			//printf("i=%d, cur=%d\n", i, cur);
			int pcur = prev[i][cur];
			if(s[i] == '?') s[i] = ncur + 'A';// printf("setting to %c\n", char(pcur+65));
			ncur = cur;
			cur = pcur;
		}
		//printf("%lld\n", dp[n][maxi]);
		//for(int i = 0; i < n; i++)
		//{
		//	if(s[i] != '?')
		//	{
		//		//ans += val(s[i]);
		//		bool neg = false;
		//		int64_t nval = val(s[i]);
		//		for(int j = i+1; j < n; j++)
		//			if(s[j] != '?' && s[j] > s[i]) neg = true;
		//		if(neg) already_neg[i] = true;
		//		if(neg) nval = -nval;
		//		ans += nval;
		//	}
		//	else
		//	{
		//		int64_t maxval = LLONG_MIN;
		//		for(char c = maxc; c <= 'Z'; c++)
		//		{
		//			//get value
		//			bool neg = false;
		//			int64_t nval = val(c);
		//			for(int j = i+1; j < n; j++)
		//				if(s[j] != '?' && s[j] > c) neg = true;
		//			if(neg) nval = -nval;
		//			for(int j = i; j --> 0;)
		//			{
		//				if(s[j] != '?' && s[j] < c && !already_neg[j]) nval -= 2*val(s[j]);
		//			}
		//			if(nval > maxval)
		//				maxval = nval, maxc = c;
		//		}
		//		s[i] = maxc;
		//		ans += maxval;
		//	}
		//	for(int j = i; j --> 0;)
		//	{
		//		if(s[j] != '?' && s[j] < s[i] && !already_neg[j]) already_neg[j] = true;
		//	}
		//	//printf("i=%d, ans=%lld\n", i, ans);
		//}
		ans += dp[n][maxi];
		//if(ans != a2 || ans != sval(s))
		//{
			//printf("%lld\n", a2);
			printf("%lld\n", ans);
			//printf("%lld\n", sval(s));
			printf("%s\n", s.data());
			//printf("%s\n", s2.data());
		//}
	}
}
