#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <cmath>

using namespace std;


signed main() {
    int n, m;
    cin >> n >> m;
    vector <set<int>> graph(n);
    int ch = 0;
    vector <pair<pair<int, int>, pair<int, int>>> s;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        graph[v].insert(u);
        if (graph[u].find(v) != graph[u].end()) {
            ch += 1;
            s.push_back({{u, v}, {v, u}});
        }
    }
    if (ch == n - 2) {
        cout << "Yes\n";
        for (auto now : s) {
            cout << now.first.first << " " << now.first.second << " " << now.second.first << " " << now.second.second << "\n";
        }
    }
    else {
        cout << "No\n";
    }
}
