#pragma  GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

inline void solve() {
    int n, q;
    cin >> n >> q;

    int x, h;
    vector <pair <int, int>> trees(n);
    for (auto &tree:  trees)
        cin >> tree.first >> tree.second;

    int l, r;
    vector <bool> cut;

    auto can_cut = [&] (int i) {
        int frx = trees[i].first + trees[i].second;
        bool rc = i + 1 < n && (cut[i + 1] || frx <= trees[i + 1].first) && frx <= trees[n - 1].first;

        int flx = trees[i].first - trees[i].second;
        bool lc = i - 1 >= 0 && (cut[i - 1] || flx >= trees[i - 1].first) && flx >= trees[0].first;

        return rc || lc;
    };

    while (q--) {
        cut.assign(n, false);

        cin >> l >> r;
        l--; r--;

        int answer = 0;
        for (int k = l; k < r + 1; k++) {
            bool fucked = true;
            for (int i = l; i < r + 1; i++) {
                if (cut[i]) continue;

                if (can_cut(i)) {
                    cut[i] = true;
                    answer++;
                    fucked = false;
                }
            }

            if (fucked) break;
        }

        cout << answer << '\n';
    }
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
