#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> val = {
    1LL,
    5LL,
    10LL,
    50LL,
    100LL,
    500LL,
    1000LL,
    5000LL,
    10000LL,
    50000LL,
    100000LL,
    500000LL,
    1000000LL,
    5000000LL,
    10000000LL,
    50000000LL,
    100000000LL,
    500000000LL,
    1000000000LL,
    5000000000LL,
    10000000000LL,
    50000000000LL,
    100000000000LL,
    500000000000LL,
    1000000000000LL,
    5000000000000LL,
};

int count(string &a) {
    int cnt = 0;
    int ma = -1;
    for (int i = a.size() - 1; i >= 0; --i) {
        int p = a[i] - 'A';
        if (p < ma) {
            cnt -= val[p];
        } else {
            ma = p;
            cnt += val[p];
        }
    }
    return cnt;
}

void solve() {
    string kal;
    cin >> kal;
    vector<int> kals;
    for (size_t i = 0; i < kal.size(); ++i) {
        if (kal[i] == '?') {
            kals.push_back(i);
        }
    }
    if (kals.size() == 0) {
        cout << count(kal) << "\n" << kal << "\n";
        return;
    }
    vector<int> cnts(kal.size(), 0);
    int be = -1;
    string ans = kal;
    for (int i = 0; i < pow(26, kals.size()); ++i) {
        int j = 0;
        while (j < kals.size() && cnts[j] == 25) {
            cnts[j] = 0;
            j++;
        }
        if (j != kals.size()) {
            cnts[j]++;
        }
        for (j = 0; j < kals.size(); ++j) {
            kal[kals[j]] = (char)(cnts[j] + 'A');
        }
        int now = count(kal);
        if (be < now) {
            be = now;
            ans = kal;
        }
    }
    cout << be << "\n" << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout.flush();
    }
}
