#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define maxN 300000

bool used[maxN];
long long n, m, u, v, t, ans[maxN];
std::vector<std::pair<long long, long long>> gr[maxN];

void dfs(long long u, long long min, long long max) {
	used[u] = true;
	ans[u] = min + max;
	for (std::pair<long long, long long> v : gr[u]) {
		if (!used[v.first]) {
			dfs(v.first, std::min(min, v.second), std::max(max, v.second));
		}
	}
	return;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> m;
	for (long long i = 0; i < m; i++) {
		std::cin >> u >> v >> t;
		gr[--u].push_back({ --v, t });
		gr[v].push_back({ u, t });
	}
	dfs(0, 1000000001, -1);
	for (long long i = 1; i < n; i++) {
		std::cout << ans[i] << "\n";
	}
	return 0;
}