#include <bits/stdc++.h>

#define eb emplace_back

using namespace std;

typedef long long ll;

const int MAXN = 503;
int x[MAXN];
int h[MAXN];
int n, Q;

void read(){
    cin >> n >> Q;
    for (int i = 1; i <= n; i++){
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    x[n+1] = x[n];
}


int used[MAXN];

bool check(int i){
    for (int j = i - 1; j >= 0; j--){
        if (used[j]) continue;
        if (x[i] >= x[j] + h[i]) return true;
        break;
    }
    for (int j = i + 1; j <= n+1; j++){
        if (used[j]) continue;
        if (x[i] + h[i] <= x[j]) return true;
        break;
    }
    return false;
}

void go(deque<int> q, int l, int r){
    while (!q.empty()){
        int v = q.front();
        q.pop_front();
        //used[v] = 1;
        //for (int i = v; i <= r; i++){
            for (int j = v; j <= r; j++){
                if (used[j]) continue;
                if (check(j)){
                    used[j] = 1;
                    q.eb(j);
                }
                break;
            }
            for (int j = v; j >= l; j--){
                if (used[j]) continue;
                if (check(j)){
                    used[j] = 1;
                    q.eb(j);
                }
                break;
            }
        //}
    }
}

void solve(){
    read();
    while (Q--){
        memset(used, 0, sizeof used);
        int l, r;
        cin >> l >> r;
        deque<int> q;
        for (int i = l; i <= r; i++){
            if (check(i)){
                used[i] = 1;
                q.eb(i);
            }
        }
        go(q, l ,r);
        int ok = 0;
        for (int i = l; i <= r; i++){
            if (used[i]) ok++;
        }
        cout << ok << '\n';
    }
}

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

1 1
100 100
1 1

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
 */