#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 1.5e5 + 10;

vector<pair<int, int>> g[N];
vector<pair<int, int>> gans;
char used[N];
//	   [u] = {none, used_into_subtree, used_from_subtree}
char dp[N][3];

struct Data {
	int a[3];

	int &operator[](int i) {
		return a[i];
	}

	int operator[](int i) const {
		return a[i];
	}
};

struct Data2 {
	pair<int, int> a[3];

	pair<int, int> &operator[](int i) {
		return a[i];
	}

	pair<int, int> operator[](int i) const {
		return a[i];
	}
};

bool calc(const vector<Data> &raw) {
	int cnt[8]{};
	int n = sz(raw);
	for (int i = 0; i < n; ++i)
		++cnt[(raw[i][0] << 2) | (raw[i][1] << 1) | raw[i][2]];
	// cout << "pairing for ";
	// for (int i = 0; i < 8; ++i)
	// 	cout << cnt[i] << " ";
	// cout << "\n";
	if (cnt[0])
		return false;
	while (1) {
		int mx1 = -1, mx2 = -1;
		for (int i = 1; i < 4; ++i) {
			if (mx1 == -1 || cnt[mx1] < cnt[i]) {
				mx2 = mx1, mx1 = i;
			} else if (mx2 == -1 || cnt[mx2] < cnt[i]) {
				mx2 = i;
			}
		}
		if (cnt[mx2] == 0)
			break;
		--cnt[mx1];
		--cnt[mx2];
	}
	while (cnt[3] > 1)
		cnt[3] -= 2;
	// for (int i = 0; i < 8; ++i)
	// 	cout << cnt[i] << " ";
	// cout << endl;
	// assert(cnt[1] + cnt[2] + cnt[3] < 2);
	if (cnt[1]) {
		return cnt[1] <= cnt[6] + cnt[7];
	}
	if (cnt[2]) {
		return cnt[2] <= cnt[5] + cnt[7];
	}
	if (cnt[3]) {
		return cnt[3] <= cnt[5] + cnt[6] + cnt[7];
	}
	return true;
	// cout << "step1 ";
	// for (int i = 0; i < 8; ++i)
	// 	cout << cnt[i] << " ";
	// cout << "\n";
	// cout << "paired" << endl;
	// return true;
}

int retc[N];

int dfs(int u, int p = -1) {
	used[u] = 1;
	int tu = 0;
	vector<Data> ch;
	for (auto e : g[u]) {
		if (e.x == p) {
			tu = e.y;
			continue;
		}
		int ret = dfs(e.x, u);
		retc[e.x] = ret;
		ch.push_back({{
			(dp[e.x][0] & e.y & ret) ||
			(dp[e.x][1] & e.y & !ret) ||
			(dp[e.x][2] & !e.y & ret),
			e.y & ((dp[e.x][0] & !ret) | (dp[e.x][2] & ret)),
			ret & ((dp[e.x][0] & !e.y) | (dp[e.x][1] & e.y))
		}});
	}
	if (sz(ch) == 0) {
		dp[u][0] = 1;
		dp[u][1] = dp[u][2] = 0;
	} else {
		dp[u][0] = calc(ch);
		
		ch.push_back({{0, 0, 1}});
		dp[u][1] = calc(ch);
		ch.pop_back();

		ch.push_back({{0, 1, 0}});
		dp[u][2] = calc(ch);
		ch.pop_back();
	}
	return tu;
}


void back_dfs(int u, int flag, int p = -1);

void merge_two(int u, Data2 a, Data2 b) {
	if (a[1].x != -1 && b[2].x != -1) {
		gans.push_back({u, a[1].x});
		if (a[1].y != -1)
			back_dfs(a[1].x, a[1].y, u);
		gans.push_back({b[2].x, u});
		if (b[2].y != -1)
			back_dfs(b[2].x, b[2].y, u);
	}
	swap(a, b);
	if (a[1].x != -1 && b[2].x != -1) {
		gans.push_back({u, a[1].x});
		if (a[1].y != -1)
			back_dfs(a[1].x, a[1].y, u);
		gans.push_back({b[2].x, u});
		if (b[2].y != -1)
			back_dfs(b[2].x, b[2].y, u);
	}
	assert(false);
}

void calc_ans(int u, const vector<Data2> &raw) {
	vector<Data2> cnt[8]{};
	int n = sz(raw);
	for (int i = 0; i < n; ++i)
		cnt[(int(raw[i][0].x != -1) << 2) |
			(int(raw[i][1].x != -1) << 1) |
			int(raw[i][2].x != -1)].push_back(raw[i]);
	// assert(sz(cnt[0]) == 0);
	while (1) {
		int mx1 = -1, mx2 = -1;
		for (int i = 1; i < 4; ++i) {
			if (mx1 == -1 || sz(cnt[mx1]) < sz(cnt[i])) {
				mx2 = mx1, mx1 = i;
			} else if (mx2 == -1 || sz(cnt[mx2]) < sz(cnt[i])) {
				mx2 = i;
			}
		}
		if (sz(cnt[mx2]) == 0)
			break;
		merge_two(u, cnt[mx1].back(), cnt[mx2].back());
		cnt[mx1].pop_back();
		cnt[mx2].pop_back();
	}
	while (sz(cnt[3]) > 1) {
		merge_two(u, cnt[3].back(), cnt[3][sz(cnt[3]) - 2]);
		cnt[3].pop_back();
		cnt[3].pop_back();
	}
	#define mrg(a, b) merge_two(u, cnt[a].back(), cnt[b].back()), cnt[a].pop_back(), cnt[b].pop_back()
	while (sz(cnt[1])) {
		if (sz(cnt[6]))
			mrg(1, 6);
		else if (sz(cnt[7]))
			mrg(1, 7);
		// else
		// 	assert(false);
		// return cnt[1] <= cnt[6] + cnt[7];
	}
	while (sz(cnt[2])) {
		if (sz(cnt[5]))
			mrg(2, 5);
		else if (sz(cnt[7]))
			mrg(2, 7);
		// else
		// 	assert(false);
		// return cnt[2] <= cnt[5] + cnt[7];
	}
	while (sz(cnt[3])) {
		if (sz(cnt[5]))
			mrg(2, 5);
		else if (sz(cnt[7]))
			mrg(2, 7);
		else if (sz(cnt[6]))
			mrg(2, 6);
		else
			assert(false);
		// return cnt[2] <= cnt[5] + cnt[7];
	}
	// if (cnt[3]) {
	// 	return cnt[3] <= cnt[5] + cnt[6] + cnt[7];
	// }
	for (int it = 4; it < 8; ++it) {
		while (sz(cnt[it])) {
			gans.push_back({u, cnt[it].back()[0].x});
			gans.push_back({cnt[it].back()[0].x, u});
			back_dfs(cnt[it].back()[0].x, cnt[it].back()[0].y);
			cnt[it].pop_back();
		}
	}
}

void back_dfs(int u, int flag, int p) {
	assert(dp[u][flag]);
	vector<Data2> ch;
	for (auto e : g[u]) {
		if (e.x == p) {
			continue;
		}
		int ret = retc[e.x];
		ch.push_back(Data2{{{-1, 0}, {-1, 0}, {-1, 0}}});
		if (dp[e.x][0] & e.y & ret)
			ch.back()[0] = {e.x, 0};
		if (dp[e.x][1] & e.y & !ret)
			ch.back()[0] = {e.x, 1};
		if (dp[e.x][2] & !e.y & ret)
			ch.back()[0] = {e.x, 2};
		if (e.y) {
			if (dp[e.x][0] & !ret)
				ch.back()[1] = {e.x, 0};
			if (dp[e.x][2] & ret)
				ch.back()[1] = {e.x, 2};
		}
		if (ret) {
			if (dp[e.x][0] & !e.y)
				ch.back()[2] = {e.x, 0};
			if (dp[e.x][1] & e.y)
				ch.back()[2] = {e.y, 0};
		}
		// ch.push_back({{
		// 	(dp[e.x][0] & e.y & ret) ||
		// 	(dp[e.x][1] & e.y & !ret) ||
		// 	(dp[e.x][2] & !e.y & ret),
		// 	e.y & ((dp[e.x][0] & !ret) | (dp[e.x][2] & ret)),
		// 	ret & ((dp[e.x][0] & !e.y) | (dp[e.x][1] & e.y))
		// }});
	}
	if (flag == 0) {
		calc_ans(u, ch);
	} else if (flag == 1) {
		ch.push_back(Data2{{{-1, 0}, {-1, 0}, {p, -1}}});
		calc_ans(u, ch);
	} else {
		assert(flag == 2);
		ch.push_back(Data2{{{-1, 0}, {p, -1}, {-1, 0}}});
		calc_ans(u, ch);
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	set<pair<int, int>> has;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		
		if (has.count({u, v}))
			has.erase({u, v});
		else
			has.insert({v, u});

		g[u].push_back({v, 1});
	}
	for (auto e : has) {
		// cout << e.x << " " << e.y << endl;
		g[e.x].push_back({e.y, 0});
	}

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
			if (!dp[i][0])
				return cout << "No", 0;
			back_dfs(i, 0);
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < 3; ++j)
	// 		cout << +dp[i][j] << " ";
	// 	cout << endl;
	// }
	cout << "Yes\n";
	for (int i = 0; i < sz(gans); ++i) {
		cout << gans[i].x << " " << gans[i].y << " ";
		if (i & 1)
			cout << "\n";
	}
	return 0;
}