#include <iostream>
#include <vector>
using namespace std;

vector<vector<pair<int, int>>> adj;
vector<int> min_answer, max_answer;

void dfs(int v, int min_ans = 1000000000, int max_ans = -1, int pre = -1) {
    min_answer[v] = min_ans;
    max_answer[v] = max_ans;
    for (auto p: adj[v]) {
        if (p.first != pre) dfs(p.first, min(min_ans, p.second), max(max_ans, p.second));
    }
}

int main() {
    int n, m, a, b, t;
    cin >> n >> m;

    min_answer.resize(n + 1);
    max_answer.resize(n + 1);
    adj.resize(n + 1);
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> t;
        adj[a].emplace_back(b, t);
        adj[b].emplace_back(a, t);
    }

    dfs(1);
    for (int k = 2; k <= n; k++) {
        cout << max_answer[k] + min_answer[k] << endl;
    }

}