#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()
#define int long long

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;

void solve();
int st[16];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    st[0] = 1;
    for (int i = 1; i < 15; ++i) {
        st[i] = st[i - 1] * 10;
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

string s;


inline int kek(char c) {
    int x = st[(c - 'A') / 2];
    if ((c - 'A') % 2 == 1)
        x *= 5;
    return x;
}

int dp[300010][27];

int get() {
    int ans = 0;
    char mx = 'A';
    for (int i = sz(s) - 1; i >= 0; --i) {
        if (s[i] < mx) {
            ans -= kek(s[i]);
        } else {
            mx = s[i];
            ans += kek(s[i]);
        }
    }
    return ans;
}

bool used[300010][26];

void solve() {
    cin >> s;
    for (int i = 0; i < 26; ++i)
        used[sz(s)][i] = 1;
    for (int i = sz(s) - 1; i >= 0; --i) {
        if (s[i] >= 'A' && s[i] <= 'Z') {
            dp[i][s[i] - 'A'] = -1e18;
            for (int j = 0; j <= s[i] - 'A'; ++j) {
                if (used[i + 1][j])
                    dp[i][s[i] - 'A'] = max(dp[i + 1][j] + kek(s[i]), dp[i][s[i] - 'A']), used[i][s[i] - 'A'] = 1;
            }
            for (int j = s[i] - 'A' + 1; j < 26; ++j) {
                if (used[i + 1][j])
                    dp[i][j] = dp[i + 1][j] - kek(s[i]), used[i][j] = 1;
            }
        } else {
            for (int j = 0; j < 26; ++j)
                dp[i][j] = -1e18;
            for (int z = 0; z < 26; ++z) {
                for (int j = 0; j <= z; ++j) {
                    if (used[i + 1][j])
                        dp[i][z] = max(dp[i + 1][j] + kek((char)('A' + z)), dp[i][z]), used[i][z] = 1;
                }
                for (int j = z + 1; j < 26; ++j) {
                    if (used[i + 1][j])
                        dp[i][j] = max(dp[i + 1][j] - kek((char)('A' + z)), dp[i][j]), used[i][j] = 1;
                }
            }
        }
    }
    int mx = -1e18, ind;
    for (int i = 0; i < 26; ++i) {
        if (dp[0][i] > mx && used[0][i]) {
            mx = dp[0][i], ind = i;
        }
    }
    cout << dp[0][ind] << '\n';
    cout << s << '\n';
}

/*/
4
BBBC
????
A?B?C?D
YYYYY?
/*/
