#include<bits\stdc++.h>
using namespace std;

const int MAXN = 3e5 + 1;
const int INF = 1e9 + 1;
vector<pair<int, int>> g[MAXN];
int mx[MAXN], mn[MAXN];

void dfs(int u, int p) {
    for (auto it : g[u]) {
        int v = it.first, w = it.second;
        if (v != p) {
            mx[v] = max(mx[u], w);
            mn[v] = min(mn[u], w);
            dfs(v, u);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        mx[i] = -INF;
        mn[i] = INF;
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].push_back({v - 1, w});
        g[v - 1].push_back({u - 1, w});
    }
    dfs(0, -1);
    for (int i = 1; i < n; ++i) {
        cout << mx[i] + mn[i] << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

