#include<bits\stdc++.h>
using namespace std;

const int MAXN = 3e5 + 1;
const int INF = 1e9 + 1;
vector<pair<pair<int, int>, int>> g[MAXN];
int ans[MAXN];
bool used[MAXN];

void dfs(int u, int tmn, int tmx, int gl) {
    if (u == 6 && tmn + tmx == 8) cout << u << " " << tmn << " " << tmx << "\n";
    ans[u] = min(ans[u], tmn + tmx);
    for (auto it : g[u]) {
        int v = it.first.first, w = it.first.second, i = it.second;
        if (used[i]) continue;
        int mx = max(tmx, w);
        int mn = min(tmn, w);
        used[i] = true;
        dfs(v, mn, mx, gl + 1);
        used[i] = false;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) ans[i] = 2 * INF;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].push_back({{v - 1, w}, i});
        g[v - 1].push_back({{u - 1, w}, i});
    }
    dfs(0, INF, -INF, 0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
/*
7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

