#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define pb push_back
#define all(x) (x).begin(), (x).end()
const int maxN = 150000 + 9;
const int maxM = 2 * maxN;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
vector<int> g[maxM * 2];
int pr[maxM * 2];
pii e[maxM * 2];
bool vis[maxM * 2];
bool kuhn(int v) {
    if(vis[v]) return false;
    vis[v] = true;
    for(auto &i: g[v]) {
        if(pr[i] == -1 || kuhn(pr[i])) {
            pr[i] = v;
            return true;
        }
    }
    return true;
}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m; cin >> n >> m;
    for(int i = 1; i <= m; ++i) {
        int u, v; cin >> u >> v;
        e[i] = {u, v};
        pr[i] = pr[i + m] = -1;
    }
    for(int i = 1; i <= m; ++i) {
        for(int j = i + 1; j <= m; ++j) {
            if(e[j].first == e[i].second) {
                g[i].pb(j + m);
            }
        }
    }
    for(int i = 1; i <= m; ++i) {
        shuffle(all(g[i]), rng);
    }
    for(int i = 1; i <= m; ++i) {
        memset(vis + 1, false, sizeof(bool) * m);
        kuhn(i);
    }
    vector<pii> ans;
    for(int i = m + 1; i <= 2 * m; ++i) {
        if(pr[i] == -1) continue;
        ans.pb({pr[i], i});
    }
    if(ans.size() != m / 2) {
        cout << "No\n";
        return 0;
    }
    cout << "Yes\n";
    for(auto &i: ans) {
        cout << e[i.first].first << ' ' << e[i.first].second << ' ' << e[i.second - m].first << ' ' << e[i.second - m].second << '\n';
    }

}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3

7 6
1 2
2 5
5 7
2 3
4 6
2 4

 */