#include <bits/stdc++.h>
using namespace std;

int n;
vector <pair <int, int> > a(300100), b(300100);

void solve () {
    int l, r;
    vector <bool> u(10100, 0);
    cin >> l >> r;
    l--;
    r--;
    for (int i = l; i <= r; i++) {
        b[i].first = max(0, i - 1);
        b[i].second = min(i + 1, n - 1);
//        cout << "i = " << i << ":  " << b[i].first << ' ' << b[i].second << '\n';
    }
    queue <int> q;
    for (int i = l; i <= r; i++) {
        if (a[i].first - a[b[i].first].first >= a[i].second || a[b[i].second].first - a[i].first >= a[i].second) {
            u[i] = 1;
            q.push(i);
        }
    }
    int ll = l, rr = r;
    while (!q.empty()) {
        int p = q.front();
        u[p] = 1;
        q.pop();
        l = b[p].first;
        b[l].second = b[p].second;
        if (l >= ll && l <= rr && !u[l] && a[b[l].second].first - a[l].first >= a[l].second) {
            u[l] = 1;
            q.push(l);
        }
        r = b[p].second;
        b[r].first = b[p].first;
        if (r >= ll && r <= rr && !u[r] && a[r].first - a[b[r].first].first >= a[r].second) {
            u[r] = 1;
            q.push(r);
        }
    }
    int k = 0;
    for (int i = l; i <= r; i++)
        k += u[i];
    cout << k << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int m, k, q;

    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < q; i++) {
        solve();
    }

    return 0;
}
