#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll power(ll base, int exp) {
    if (exp == 0) return 1;
    return base * power(base, exp - 1);
}

ll value(char c) {
    int ord = c - 'A';
    if (ord % 2 == 0) return power(10, ord / 2);
    return 5 * power(10, ord / 2);
}

void solve();

signed main() {
    int t;
    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

const int k = 26;
void solve() {
    string p;
    cin >> p;
    vector<vector<ll>> dp(p.size() + 1, vector<ll>(26, -1e18));
    dp[p.size()][0] = 0;
    for (int i = (int)p.size() - 1; i >= 0; --i) {
        if (p[i] != '?') {
            ll lower = -1e18;
            for (char c = 'A'; c <= 'Z'; ++c){
                if (c <= p[i]) lower = max(lower, dp[i + 1][c - 'A']);
                if (c > p[i]) dp[i][c - 'A'] = dp[i + 1][c - 'A'] - value(p[i]);
            }
            dp[i][p[i] - 'A'] = lower + value(p[i]);
        } else {
            ll lower = -1e18;
            for (char c = 'A'; c <= 'Z'; ++c) {
                lower = max(lower, dp[i + 1][c - 'A']);
                dp[i][c - 'A'] = lower + value(c);
            }
        }
    }
    cout << *max_element(dp[0].begin(), dp[0].end()) << '\n';

}