#include<bits/stdc++.h>
using namespace std;
#define X first
#define Y second
#define sz(a) (int)a.size()

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n  >> q;
    vector <int> x(n), h(n);
    for(int i = 0; i < n; i++)
    {
        cin >> x[i] >> h[i];
    }
    vector <bool> used(n);
    vector <int> nxt(n), pred(n);
    while(q--)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        queue <int> q;
        for(int i = l; i <= r; i++)
        {
            nxt[i] = i + 1;
            pred[i] = i - 1;
            used[i] = 0;
            if(i != 0 && x[i] - h[i] >= x[i - 1] || i != n - 1 && x[i] + h[i] <= x[i + 1])
            {
                q.push(i);
                used[i] = 1;
            }
        }
        int ans = 0;
        while(sz(q) > 0)
        {
            ans++;
            int v = q.front();
            int t1 = pred[v];
            int t2 = nxt[v];
            q.pop();
            if(t1 >= l && !used[t1] && (t2 >= n && x[t1] + h[t1] <= x[n - 1] || t2 < n && x[t1] + h[t1] <= x[t2]))
            {
                used[t1] = 1;
                q.push(t1);
            }
            if(t2 <= r && !used[t2] && (t1 < 0 && x[t2] - h[t2] >= x[0] || t1 >= 0 && x[t2] - h[t2] >= x[t1]))
            {
                used[t2] = 1;
                q.push(t2);
            }
            if(t1 >= 0)
            {
                nxt[t1] = t2;
            }
            if(t2 < n)
            {
                pred[t2] = t1;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}

