#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define eb emplace_back

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const int N = 3e5 + 5;
const int INF = 1e18;

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

vector<vector<pair<int, int>>> g(N);
vector<int> res(N);

void dfs(int v, int p, int mn, int mx) {
//    debug(v);
    res[v] = mn + mx;
    for (auto &to : g[v]) {
        if (to.x == p) continue;
        int new_mn = min(mn, to.y);
        int new_mx = max(mx, to.y);
        dfs(to.x, v, new_mn, new_mx);
    }
}

void solve() {
     int n, m;
     cin >> n >> m;
     for (int i = 0; i < m; i++) {
         int u, v, c;
         cin >> u >> v >> c;
         --u, --v;
         g[u].eb(v, c);
         g[v].eb(u, c);
     }
     dfs(0, -1, INF, -INF);
    for (int i = 1; i < n; i++) {
        cout << res[i] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
//    cin >> T;

    while (T-- > 0) {
        solve();
    }

    return 0;
}
