#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>

#define int long long
#define x first
#define y second

using namespace std;

#pragma GCC optimize("O3")
#pragma warning(disable:4996)


vector<int> zn = {1, 5, 10, 50, 100, 500, 1000, 5000, (int)1e4, (int)5e4, (int)1e5, (int)5e5, (int)1e6, (int)5e6, (int)1e7, (int)5e7, (int)1e8, (int)5e8, (int)1e9, (int)5e9, (int)1e10, (int)5e10, (int)1e11, (int)5e11, (int)1e12, (int)5e12};
const int maxn = 3e5 + 10;


int dp[maxn][27];
pair<int, int> p[maxn][27];


void solve() {
	string s;
	cin >> s;
	int n = s.size();
	for (int i = 0; i <= n; i++)
		for (int j = 0; j < 27; j++)
			dp[i][j] = -1e18;
	dp[n][0] = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] != '?') {
			int x = s[i] - 'A' + 1;
			for (int j = 0; j < 27; j++) {
				if (dp[i][max(j, x)] < dp[i + 1][j] + zn[x - 1] * (x >= j) - zn[x - 1] * (x < j)) {
					dp[i][max(j, x)] = dp[i + 1][j] + zn[x - 1] * (x >= j) - zn[x - 1] * (x < j);
					p[i][max(j, x)] = { j, x };
				}
			}
		}
		else {
			for (int x = 1; x < 27; x++) {
				for (int j = 0; j < 27; j++) {
					if (dp[i][max(j, x)] < dp[i + 1][j] + zn[x - 1] * (x >= j) - zn[x - 1] * (x < j)) {
						dp[i][max(j, x)] = dp[i + 1][j] + zn[x - 1] * (x >= j) - zn[x - 1] * (x < j);
						p[i][max(j, x)] = { j, x };
					}
				}
			}
		}
	}
	int ans = -1e18;
	int st = -1;
	for (int i = 0; i < 27; i++) {
		if (ans < dp[0][i]) {
			st = i;
			ans = dp[0][i];
		}
	}
	cout << ans << '\n';
	for (int i = 0; i < n; i++) {
		cout << (char)(p[i][st].y + 'A' - 1);
		st = p[i][st].x;
	}
	cout << '\n';
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}