#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>


#define x first
#define y second


using namespace std;


#pragma warning(disable:4996)


bool dp[1 << 20][20];
const int maxn = 21;
vector<pair<int, int>> g[maxn];
int w[maxn];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, m;
	cin >> n >> m;
	if (n > 20)
		return 0;
	for (int i = 0; i < m; i++) {
		int u, v, ww;
		cin >> u >> v >> ww;
		u--;
		v--;
		w[i] = ww;
		g[u].push_back({ v, i });
		g[v].push_back({ u, i });
	}
	dp[0][0] = 1;
	for (int mask = 0; mask < (1 << m); mask++) {
		for (int j = 0; j < n; j++) {
			if (!dp[mask][j])
				continue;
			for (auto e : g[j]) {
				if ((mask >> e.y) & 1)
					continue;
				dp[mask ^ (1 << e.y)][e.x] = 1;
			}
		}
	}
	for (int i = 1; i < n; i++) {
		int ans = 2e9;
		for (int mask = 0; mask < (1 << m); mask++) {
			if (!dp[mask][i])
				continue;
			int mn = 1e9;
			int mx = -1;
			for (int j = 0; j < m; j++) {
				if ((mask >> j) & 1) {
					mn = min(mn, w[j]);
					mx = max(mx, w[j]);
				}
			}
			ans = min(ans, mx + mn);
		}
		cout << ans << '\n';
	}
}
