#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2");
//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("unrol-loops");

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
oredered_set;
*/

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

const ll INF = 1e18;
const int C = 26;

ll val[C];
vector<int> ind;
vector<int> st;
vector<int> ans;

ll mx = -INF;

void build() {
    val[0] = 1;
    for (int i = 1; i < C; ++i) {
        if (i % 2 == 1) {
            val[i] = val[i - 1] * 5;
        } else {
            val[i] = val[i - 1] * 2;
        }
    }
}

void upd(string s) {
    int n = s.size();

    for (int i = 0; i < ind.size(); ++i) {
        s[ind[i]] = st[i] + 'A';
    }

    vector<int> suf_mx(n);
    for (int i = n - 1; i >= 0; --i) {
        if (i == n - 1) {
            suf_mx[i] = s[i] - 'A';
        } else {
            suf_mx[i] = max(s[i] - 'A', suf_mx[i + 1]);
        }
    }

    ll ret = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] - 'A' >= suf_mx[i]) ret += val[s[i] - 'A'];
        else ret -= val[s[i] - 'A'];
    }

    if (ret > mx) {
        mx = ret;
        ans = st;
    }
}

void backtracking(string &s) {
    if (st.size() == ind.size()) {
        upd(s);
        return;
    }

    for (int c = 0; c < C; ++c) {
        st.pb(c);
        backtracking(s);
        st.pop_back();
    }
}

void solve() {
    mx = -INF;
    ind.clear();

    string s;
    cin >> s;

    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '?') ind.pb(i);
    }

    backtracking(s);

    for (int i = 0; i < ind.size(); ++i) {
        s[ind[i]] = ans[i] + 'A';
    }
    cout << mx << "\n";
    cout << s << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    cin >> tests;
    build();
    while (tests--) {
        solve();
    }
}
