#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> values = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000,
                      50000000, 100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000,
                      500000000000, 1000000000000, 5000000000000};

int compute(const vector<int> &a) {
    int mx = -1;
    int res = 0;
    int n = a.size();
    for (int i = n - 1; i >= 0; --i) {
        mx = max(mx, a[i]);
        if (mx > a[i]) {
            res -= values[a[i]];
        } else {
            res += values[a[i]];
        }
    }

    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    assert(values.size() == (int) ('Z' - 'A' + 1));


    int tests;
    cin >> tests;


    for (int test = 0; test < tests; ++test) {
        string s;
        cin >> s;
        vector<int> a;
        int lst_q = -1;
        int frst_q = -1;
        int n = s.size();

        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                a.push_back(-1);
                if (frst_q == -1) {
                    frst_q = i;
                }
                lst_q = i;
            } else {
                a.push_back(s[i] - 'A');
            }
        }
        vector<int> res;
        int res_value = INT64_MIN;
        if (lst_q == -1) {
            res = a;
            res_value = compute(res);
        } else {
            int mx = 0;
            vector<int> mxes(n);
            for (int i = n - 1; i >= 0; --i) {
                if (a[i] != -1) {
                    mx = max(mx, a[i]);
                }
                mxes[i] = mx;
            }

            int cur_mx = 25;
            vector<int> cnt(26, 0);
            for (int i = 0; i < n; ++i) {
//                cerr << cur_mx << ' ' << mxes[i] << endl;
                if (a[i] != -1) {
                    cnt[a[i]]++;
                } else {
                    int cur_best_res = -1;
                    int old_cur_mx = cur_mx;
                    for (int num = old_cur_mx; num >= mxes[i]; --num) {
//                        cerr << num << endl;
                        int cur_res = 0;
                        cur_res += values[num];
                        for (int j = 0; j < values.size(); ++j) {
                            if (j < num) {
                                cur_res -= values[j] * cnt[j];
                            } else {
                                cur_res += values[j] * cnt[j];
                            }
                        }
                        if (cur_res > cur_best_res) {
                            a[i] = num;
                            cur_mx = num;
                            cur_best_res = cur_res;
                        }
                    }
                    cnt[a[i]]++;
                }
            }
            res = a;
            res_value = compute(res);
        }

        cout << res_value << '\n';
        for (auto e : res) {
            assert(e >= 0);
            assert(e + 'A' <= 'Z');
            cout << (char) ('A' + e);
        }
        cout << '\n';

    }
}
