#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
//#define int ll
const int MAXN = 3e5 + 1000;
const int INF = 1e9;

struct Edge {
    int to, w, usd = 0;
};
vector<Edge> g[MAXN];
int usd[MAXN];
int dst[MAXN];
void dfs(int v, int mx, int mn) {
    dst[v] = min(dst[v], mx + mn);
    for (auto &e: g[v]) {
        if (usd[e.usd]) continue;
        usd[e.usd] = 1;
        dfs(e.to, max(mx, e.w), min(mn, e.w));
        usd[e.usd] = 0;
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        dst[i] = INF;
    }
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w, i});
        g[v].push_back({u, w, i});
    }
    dfs(0, 0, INF);
    for (int i = 1; i < n; ++i) {
        cout << dst[i] << '\n';
    }

}
signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();

}