#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <string>


using namespace std;
using ll = long long;

#define look1(a) cerr << (#a) << ": " << a  << "\n"; 
#define look2(a, b) cerr << (#a) << ": " << a  << " " << (#b) << ": " << b << "\n"; 
#define ve vector
#define vll ve <ll> 
#define ft first
#define sd second
#define pb push_back
#define INF 3e18
#define print(h) for (auto ijkl:h) cout << ijkl << " "; cout << "\n";

ll pown(ll n, ll cnt) {
	if (cnt == 0) return 1ll;
	if (cnt == 1) return n;
	ll k = pown(n, cnt / 2);
	if (cnt % 2) return k * k * n;
	return  k * k;
}

ll get_cnt(char c) {
	ll k = c - 'A';
	ll cnt = pown(10, k / 2);
	if (k % 2) cnt *= 5;
	return cnt;
}


ll get_cht(string s) {
	ll ans = 0;
	char last = 'A';
	for (int i = s.size() - 1; i >= 0; --i) {
		if (s[i] >= last) {
			last = s[i];
			ans += get_cnt(s[i]);
		}
		else {
			ans -= get_cnt(s[i]);
		}
	}
	return ans;
}

ll anss = -2e18;
string tr;
vll anft;

void get_ans(ll id, vll inds, string s) {
	if (id == inds.size()) {
		if (get_cht(s) > anss) {
			anss = get_cht(s);
			tr = s;
			anft = inds;
		}
	}
	else {
		for (char i = 'A'; i <= 'Z'; ++i) {
			s[inds[id]] = i;
			get_ans(id + 1, inds, s);
		}
	}
}

pair <ll, string> solv1(string s) {
	vll inds;
	anss = -3e18;
	tr = "";
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '?') {
			inds.pb(i);
		}
	}
	get_ans(0, inds, s);
	return { anss, tr };
}

pair <ll, string> solv2(string s) {
	ll n = s.size();
	string tec = "";
	multiset <char> al;
	for (auto it : s) {
		al.insert(it);
	}
	ll add = 0;
	vll inds;
	for (int i = 0; i < n; ++i) {
		al.erase(al.find(s[i]));
		if (s[i] == '?') {
			tec += s[i];
			inds.pb(i);
		}
		else {
			if (al.empty() || *(--al.end()) <= s[i]) {
				tec += s[i];
			}
			else {
				add += get_cnt(s[i]);
			}
		}
	}
	ll rt = 0;
	vll len;
	if (tec[0] == '?') ++rt;
	for (int i = 1; i < tec.size(); ++i) {
		if (tec[i] == '?') {
			++rt;
		}
		else {
			if (rt) len.pb(rt);
			rt = 0;
		}
	}
	if (rt) len.pb(rt);
	ll id = 0;
	ll ans = 0;
	ll anscnt = 0;
	char last = 'Z';
	for (int i = 0; i < tec.size(); ++i) {
		if (tec[i] != '?') {
			last = tec[i];
		}
		else {
			s[inds[id]] = last;
			++id;
		}
		ans += get_cnt(last);
	}
	ll cnt = ans;
	ll ind = 0;
	last = 'Z';
	for (int i = 0; i < tec.size(); ++i) {
		if (tec[i] == '?') {
			cnt -= get_cnt(last) * len[ind];
			cnt += get_cnt('Z') * len[ind];
			i += len[ind] - 1;
			++ind;
		}
		else {
			if (tec[i] != 'Z') {
				cnt -= 2 * get_cnt(tec[i]);
				last = tec[i];
			}
		}
		if (cnt > ans) {
			ans = cnt;
			anscnt = ind;
		}
	}
	ll to_er = 0;
	for (int i = 0; i < anscnt; ++i) {
		to_er += len[i];
	}
	for (int i = 0; i < to_er; ++i) {
		s[inds[i]] = 'Z';
	}
	return { ans - add, s };
}

pair <ll, string> solv3(string s) {
	string t = "";
	s += '?';
	ve <vll> dp(s.size(), vll(26, 0));
	ve <vll> prev(s.size(), vll(26, -1));
	ve <vll> prev2(s.size(), vll(26, -1));
	vll cnt(26, 0);
	ll last = -1;
	ll add = 0;
	multiset <char> al;
	for (auto it : s) {
		al.insert(it);
	}
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] != '?') {
			al.erase(al.find(s[i]));
			if (al.empty() || *(--al.end()) <= s[i]) {
				add += get_cnt(s[i]);
				++cnt[s[i] - 'A'];
			}
			else {
				add -= get_cnt(s[i]);
			}
		}
		else {
			if (last == -1) {
				dp[i][0] = add + get_cnt('A');
				//look1(add - 2 * get_cnt('Y') * cnt[24]);
				for (int j = 1; j < 26; ++j) {
					//look1(get_cnt('A' - j + 1));
					dp[i][j] = add + get_cnt('A' + j) - 2 * get_cnt(char('A' + j - 1)) * cnt[j - 1];
				}
			}
			else {
				multiset <pair <ll, ll>> maxn;
				for (int j = 0; j < 26; ++j) {
					maxn.insert({ -dp[last][j], j });
				}
				dp[i][0] = -((*(maxn.begin())).ft) + get_cnt('A') + add;
				prev[i][0] = ((*(maxn.begin())).sd);
				prev2[i][0] = last;
				for (int j = 1; j < 26; ++j) {
					maxn.erase(maxn.find({ -dp[last][j - 1], j - 1 }));
					dp[i][j] = add + -((*(maxn.begin())).ft) + get_cnt('A' + j) - 2 * get_cnt(char('A' + j - 1)) * cnt[j - 1];
					prev[i][j] = ((*(maxn.begin())).sd);
					prev2[i][j] = last;
				}
			}
			last = i;
			add = 0;
			cnt.assign(26, 0);
		}
		//look1(add);
	}
	/*for (int i = 0; i < s.size(); ++i) {
		print(prev2[i]);
	}
	cout << "\n";
	for (int i = 0; i < s.size(); ++i) {
		print(prev[i]);
	}
	cout << "\n";*/
	/*for (int i = 0; i < s.size(); ++i) {
		print(dp[i]);
	}*/
	ll ind = last;
	ll p = 0;
	while (ind != -1) {
		//look2(ind, p);
		s[ind] = 'A' + p;
		ll o = ind;
		ind = prev2[ind][p];
		p = prev[o][p];
	}
	for (int i = 0; i < s.size() - 1; ++i) {
		t += s[i];
	}
	return { dp[s.size() - 1][0] - 1, t };
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		string s = "";
		cin >> s;
		//auto p1 = solv1(s);
		auto p2 = solv3(s);
		//cout << p1.ft << " " << p1.sd << "\n";
		cout << p2.ft << "\n" << p2.sd << "\n";
	}
}