#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>


using namespace std;
using ll = long long;

#define look1(a) cerr << (#a) << ": " << a  << "\n"; 
#define look2(a, b) cerr << (#a) << ": " << a  << " " << (#b) << ": " << b << "\n"; 
#define ve vector
#define vll ve <ll> 
#define ft first
#define sd second
#define pb push_back
#define print(h) for (auto ijkl:h) cout << ijkl << " "; cout << "\n";


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, q;
	cin >> n >> q;
	vll x(n), h(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}
	while (q--) {
		ll ans = 0;
		ll l, r;
		vll used(n, 0);
		cin >> l >> r;
		--l; --r;
		vll nex(n, n), pre(n, -1);
		for (int i = l; i < r; ++i) {
			nex[i] = i + 1;
		}
		for (int i = l + 1; i <= r; ++i) {
			pre[i] = i - 1;
		}
		queue <ll> w;
		for (int i = l; i <= r; ++i) {
			ll k1 = x[i] - h[i], k2 = x[i] + h[i];
			if (k1 >= x[0] && k1 >= x[i - 1]) {
				used[i] = 1;
				w.push(i);
			}
			else if (k2 <= x[n - 1] && k2 <= x[i + 1]) {
				used[i] = 1;
				w.push(i);
			}
		}
		while (!w.empty()) {
			ll v = w.front();
			w.pop();
			++ans;
			if (nex[v] !=n) {
				pre[nex[v]] = pre[v];
			}
			if (pre[v] != -1) {
				nex[pre[v]] = nex[v];
			}
			if (pre[v] != -1 && !used[pre[v]]) {
				ll i = pre[v];
				ll k1 = x[i] - h[i], k2 = x[i] + h[i];
				if (k1 >= x[0] && k1 >= x[max(pre[i] - 1, 0ll)]) {
					used[pre[v]] = 1;
					w.push(i);
				}
				else if (k2 <= x[n - 1] && k2 <= x[min(nex[i] + 1, n - 1)]) {
					used[pre[v]] = 1;
					w.push(i);
				}
			}
			if (nex[v] != n && !used[nex[v]]) {
				ll i = nex[v];
				ll k1 = x[i] - h[i], k2 = x[i] + h[i];
				if (k1 >= x[0] && k1 >= x[max(pre[i] - 1, 0ll)]) {
					used[nex[v]] = 1;
					w.push(i);
				}
				else if (k2 <= x[n - 1] && k2 <= x[min(nex[i] + 1, n - 1)]) {
					used[nex[v]] = 1;
					w.push(i);
				}
			}
		}
		cout << ans << "\n";
	}
}
