#include<bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int const maxn = 5005, maxN = 3e5 + 5;
multiset < pair < int, int > > g[maxN];
int inf = 1e9 + 7;
int ans[maxN], best[maxN], cur, timer;
int used[maxN], tin[maxN], up[maxN];
int cnt[maxn][maxn];
int f[maxn][maxn];
int cmp[maxN], imin[maxN], numb, goal[maxN];
vector < pair < int, int > > go[maxN];
int check[maxN], w;

void dfss(int v, int p, int val1, int val2) {
    ans[v] = val1 + val2;
    for (auto u : g[v]) {
        if (u.first != p) {
            dfss(u.first, v, min(val1, u.second), max(val2, u.second));
        }
    }
}

void dfs2(int v, int p, int d) {
    d = min(d, imin[v]);
    goal[v] = d;
    check[v] = w;
    for (auto u : go[v]) {
        if (u.first == p || check[u.first] == w) continue;
        dfs2(u.first, v, min(d, u.second));
    }
}

void dfs(int v, int p) {
    used[v] = cur;
    tin[v] = timer++, up[v] = tin[v];
    for (auto u : g[v]) {
        if (u.first == p) continue;
        if (used[u.first] == cur) {
            up[v] = min(up[v], tin[u.first]);
        }
        else {
            dfs(u.first, v);
            up[v] = min(up[v], up[u.first]);
            if (up[u.first] > tin[v] && cnt[min(u.first, v)][max(u.first, v)] == 1) {
                f[min(u.first, v)][max(u.first, v)] = cur;
            }
        }
    }
}

void dfs1(int v, int p) {
    cmp[v] = numb;
    for (auto u : g[v]) {
        if (cmp[u.first] == 0 && f[min(u.first, v)][max(u.first, v)] != cur) dfs1(u.first, v);
    }
}

void build(int n) {
    cur++;
    for (int i = 1; i <= n; ++i) {
        go[i] = {};
        if (used[i] != cur) dfs(i, 0);
    }
    numb = 0;
    for (int i = 1; i <= n; ++i) cmp[i] = 0;
    for (int i = 1; i <= n; ++i) {
        if (cmp[i] == 0) {
            numb++;
            imin[numb] = inf;
            dfs1(i, 0);
        }
    }
    for (int i = 1; i <= n; ++i) {
        best[i] = inf;
        goal[i] = inf;
        for (auto key : g[i]) {
            if (cmp[i] == cmp[key.first]) imin[cmp[i]] = min(imin[cmp[i]], key.second);
            else {
                go[cmp[i]].push_back({cmp[key.first], key.second});
                go[cmp[key.first]].push_back({cmp[i], key.second});
            }
        }
    }
    w++;
    dfs2(cmp[1], 0, imin[1]);
    for (int i = 1; i <= n; ++i) {
        best[i] = goal[cmp[i]];
    }
}

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, u, v, l, r, t;
    cin >> n >> m;
    vector < vector < int > > Q;
    for (int i = 1; i <= n; ++i) ans[i] = 2 * inf;
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v >> t;
        if (u > v) swap(u, v);
        if (n <= 5000) cnt[u][v]++;
        g[u].insert({v, t});
        g[v].insert({u, t});
        Q.push_back({t, u, v});
    }
    if (m == n - 1) {
        dfss(1, 0, inf, -inf);
        for (int i = 2; i <= n; ++i) cout << ans[i] << '\n';
        exit(0);
    }
    sort(Q.rbegin(), Q.rend());
    build(n);
    for (int i = 2; i <= n; ++i) cout << best[i] + 1000000000 << '\n';
    exit(0);
    for (int i = 0; i < (int)Q.size(); i++) {
        u = Q[i][1], v = Q[i][2], t = Q[i][0];
        if (cnt[u][v] <= 2) {
            for (int j = 2; j <= n; ++j) {
                if (best[j] != inf) ans[j] = min(ans[j], Q[i][0] + best[j]);
            }
            g[u].erase(g[u].find({v, t}));
            g[v].erase(g[v].find({u, t}));
            cnt[u][v]--;
            build(n);
        }
        else {
            g[u].erase(g[u].find({v, t}));
            g[v].erase(g[v].find({u, t}));
            cnt[u][v]--;
        }
    }
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}

