#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<pii> g[300009];
int dist[300009];
int answ[300009];

const int inf = 1e9 + 7;

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
        freopen("wa.txt", "w", stdout);
    #endif // localfile

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        if (a < b)
        g[a].push_back({b, c});
        else
        g[b].push_back({a, c});
    }

    for (int i = 1; i < n; i++) {
        sort(g[i].begin(), g[i].end());
    }

    int way1mx = g[1][0].y;
    int way1mn = g[1][0].y;

    for (int i = 2; i <= n; i++) {
        int mx = way1mx, mn = way1mn;
        for (int j = i + 1; j <= n; j++) {
            if (g[j - 1].size() <= 1) break;
            mx = max(mx, g[j - 1][1].y);
            mn = min(mn, g[j - 1][0].y);
        }

        cout << mx + mn << "\n";

        if (i != n) {
        way1mx = max(way1mx, g[i][0].y);
        way1mn = min(way1mn, g[i][0].y);
        }
    }

    return 0;
}
