#include <bits/stdc++.h>
#define x first
#define y second
#define int long long

using namespace std;
vector<pair<int, int>> * e;
int n, m;


int * col;
int * tin;
int * tup;
int timer = 1;
vector<pair<int, int>> * e1;
int * val;
int * ans;
bool * used;

void dfsbridge(int v, int p){
    tin[v] = timer++;
    tup[v] = tin[v];
    for(auto u0:e[v]){
        int u = u0.x;
        if(p!=u0.y){
            if(!tin[u]){
                dfsbridge(u, u0.y);
            }
            tup[v] = min(tup[v], tup[u]);
        }
    }
}

void dfscolor(int v, int c){
    used[v] = 1;
    col[v] = c;
    for(auto u0:e[v]){
        int u = u0.x;
        if(!used[u]){
            if(tup[u]>tin[v])
                dfscolor(u, timer++);
            else dfscolor(u, c);
        }
    }
}

void dfs(int v, int p, int x){
    x = min(x, val[v]);
    ans[v] = x;
    for(auto u:e1[v]){
        if(u.x!=p){
            dfs(u.x, v, min(x, u.y));
        }
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    e = new vector<pair<int, int>>[n];
    vector<pair<pair<int, int>, int>> all;
    for(int i = 0; i<m; i++){
        int v1, v2, l = 1;
        cin >> v1 >> v2;
        cin >> l;
        v1--;
        v2--;
        all.push_back({{v1, v2}, l});
        e[v1].push_back({v2, i});
        e[v2].push_back({v1, i});
    }


    col = new int[n];
    tin = new int[n];
    tup = new int[n];
    used = new bool[n];
    for(int i = 0; i<n; i++){
        col[i] = -1;
        tin[i] = 0;
        tup[i] = INT_MAX;
        used[i] = 0;
    }
    dfsbridge(0, -1);
    timer = 1;
    dfscolor(0, 0);
    int k = timer;
    e1 = new vector<pair<int, int>>[k];
    val = new int[k];
    ans = new int[k];
    for(int i = 0; i<k; i++)
        val[i] = INT_MAX;
    for(auto z:all){
        if(col[z.x.x]==col[z.x.y]){
            val[col[z.x.x]] = min(val[col[z.x.x]], z.y);
        } else {
            e1[col[z.x.x]].push_back({col[z.x.y], z.y});
            e1[col[z.x.y]].push_back({col[z.x.x], z.y});
        }
    }
    dfs(0, -1, val[0]);
    for(int i = 1; i<n; i++){
        cout << ans[col[i]]+1000000000 << "\n";
    }
    return 0;
}

/*

//11
7 8
1 2 1000000000
1 3 1000000000
3 4 2
2 4 1
4 5 -2
5 6 -3
5 7 1000
6 7 -4







7 21
1 2
1 3
1 4
1 5
1 6
1 7
2 3
2 4
2 5
2 6
2 7
3 4
3 5
3 6
3 7
4 5
4 6
4 7
5 6
5 7
6 7


3 3
1 2 2
1 3 1
2 3 1


7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9


4 4
1 2 2
3 2 0
2 4 3
4 3 1


//tree
5 8
1 2 1000000000
1 3 1000000000
2 4 3
2 5 4
1 2 1000000000
1 3 1000000000
2 4 3
2 5 4

//10
4 4
1 2 0
1 3 0
3 4 2
2 4 1
*/
