#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const ll INF = 1e18;

ll value[26];

ll get_cost(string s) {
    ll ans = 0;
    for (int i = 0; i < sz(s); ++i) if (s[i] != '?') {
        bool have_greater = false;
        for (int j = i + 1; j < sz(s); ++j) if (s[j] != '?') {
            have_greater |= (s[i] < s[j]);
        }
        if (have_greater) ans -= value[s[i] - 'A'];
        else ans += value[s[i] - 'A'];
    }
    return ans;
}

void solve() {
    string s;
    cin >> s;
    for (int i = 0; i < sz(s); ++i) if (s[i] == '?') {
        pair<ll, int> mx = mp(-INF, -1);
        for (int x = 'A'; x <= 'Z'; ++x) {
            s[i] = x;
            mx = max(mx, mp(get_cost(s), x - 'A'));
            s[i] = '?';
        }
        assert(mx.se != -1);
        s[i] = char('A' + mx.se);
    }
    cout << get_cost(s) << "\n" << s << "\n";
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    value[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i & 1) value[i] = value[i - 1] * 5;
        else value[i] = value[i - 1] * 2;
    }
    int T;
    cin >> T;
    while (T--) solve();
    return 0;
}
