#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <numeric>
#include <random>
#include <list>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll LINF = 1e18;
const int INF = 1e9 + 7;
//const int N = 20;
//vector <int> tin, tout;
//vector <bool> colors;
//vector <vector <int>> ps;
//
//void Dfs(int v, int p, bool color, vector <set <int>>& g, int& tm) {
//	colors[v] = color;
//	tin[v] = tm++;
//	for (auto i : g[v]) {
//		if (i != p)
//			Dfs(i, v, !color, g, tm);
//	}
//	ps[v][0] = p;
//	for (int i = 1; i < N; i++)
//		ps[v][i] = ps[ps[v][i - 1]][i - 1];
//	tout[v] = tm++;
//}
//
//bool is_lower(int a, int b) {
//	return tin[b] <= tin[a] && tout[a] <= tout[b];
//}
//
//void Solve() {
//	int n, m;
//	cin >> n >> m;
//	vector <set <int>> g(n);
//	vector <set <int>> h(n);
//	vector <set <int>> t(n);
//	tin.resize(n); tout.resize(n); colors.resize(n);
//	ps.resize(n, vector <int>(N, 0));
//	for (int i = 0; i < m; i++) {
//		int a, b;
//		cin >> a >> b;
//		g[a - 1].insert(b - 1);
//		h[b - 1].insert(a - 1);
//		t[a - 1].insert(b - 1);
//		t[b - 1].insert(a - 1);
//	}
//	int _time = 0;
//	Dfs(0, -1, 0, t, _time);
//
//	// hypot -- we will destroy by MIN LCA
//
//	
//}

struct node {
	node* l = nullptr;
	node* r = nullptr;
	int x;
	node(int x) : x(x) {}
};

void Solve() {
	int n, q;
	cin >> n >> q;
	vector <pair <int, int>> v(n);
	for (auto& i : v) cin >> i.first >> i.second;
	v.push_back(v.back());
	v.insert(v.begin(), v.front());
	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		vector <node *> wh;
		for (int j = a-1; j <= b+1; j++) {
			wh.push_back(new node(j));
		}
		set <pair <int, int>> l;
		for (int j = a; j <= b; j++) {
			wh[j - a + 1]->l = wh[j - a];
			wh[j - a+1 ]->r = wh[j -a + 2];
			l.insert({ v[j].second - (v[j].first - v[j-1].first), j });
			l.insert({ v[j].second - (v[j+1].first - v[j].first), j });
		}

		int ans = 0;
		vector <bool> was(n+5);

		while (!l.empty()) {
			auto lb = *l.begin();

			if (lb.first >= 0) {
				l.erase(l.begin());
				if (was[lb.second]) continue;
				was[lb.second] =true;
				int j = lb.second;
				
				int pr = wh[j - a+1]->l->x;
				int nx = wh[j - a+1]->r->x;
				if (pr >= a && !was[pr]) {
					l.insert({ v[pr].second - (v[nx].first - v[pr].first), pr });
				}

				if (nx <= b && !was[nx]) {
					l.insert({ v[nx].second - (v[nx].first - v[pr].first), nx });
				}

				wh[j - a + 1]->l->r = wh[j - a + 1]->r;
				wh[j - a + 1]->r->l = wh[j - a + 1]->l;

				ans++;
				continue;
			}

			break;
		}
		cout << ans << '\n';
	}
	
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}