#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define mp make_pair
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
const ll inf = 2e18;

using namespace std;

vi values{
    1
};

void solve() {
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 0) values.push_back(values.back() * 2);
        else values.push_back(values.back() * 5);
    }
    string s; cin >> s;
    reverse(all(s));
    int n = s.size();
    vvi dp(n + 1, vi(26, -inf));
    vector<vector<pii>> p(n + 1, vector<pii>(26, mp(-1, -1)));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 26; ++j) {
            if (dp[i][j] == -inf) continue;
            if (s[i] == '?') {
                for (int d = j; d < 26; ++d) {
                    if (dp[i + 1][d] < dp[i][j] + values[d]) {
                        dp[i + 1][d] = dp[i][j] + values[d];
                        p[i + 1][d] = mp(j, d);
                    }
                }
            } else {
                int d = s[i] - 'A';
                if (dp[i + 1][max(d, j)] < dp[i][j]  + (d < j? -values[d]: values[d])) {
                    dp[i + 1][max(d, j)] = dp[i][j] + (d < j? -values[d]: values[d]);
                    p[i + 1][max(d, j)] = mp(j, d);
                }
            }
        }
    }
    int bans = 0;
    for (int j = 0; j < 26; ++j) {
        if (dp[n][bans] < dp[n][j]) bans = j;
    }
    int i = n, j = bans;
    cout << dp[i][j] << "\n";
    string ans = "";
    for (; i > 0; j = p[i][j].first, --i) {
        ans.push_back('A' + p[i][j].second);
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);

    int t; cin >> t;
    while (t--)
    solve();

    return 0;
}
