#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define mp make_pair
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define pb push_back

const ll inf = 2e18;
const ll INF = 1e9;
const ll MAXN = 3e5 + 10;

using namespace std;

int ans[MAXN];
int used[MAXN];

struct edge{
    int v, u, t, ind;
    edge(int v, int u, int t, int ind): v(v), u(u), t(t), ind(ind) {}
    edge() {}
};

vector<edge> edges;
int cnt = 0;
vector<edge> graph[MAXN];

void dfs(int v, int mine = INF, int maxe = 0) {
    used[v] = 1;
    mn(ans[v], mine + maxe);
    for (auto e : graph[v]) {
        if (used[e.u]) continue;
        dfs(e.u, min(mine, e.t), max(maxe, e.t));
    }
    used[v] = 0;
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < MAXN; ++i) ans[i] = INF + 1;
    for (int i = 0; i < m; ++i) {
        int v, u, t; cin >> v >> u >> t;
        --v, --u;
        graph[v].pb(edge(v, u, t, cnt));
        graph[u].pb(edge(u, v, t, cnt));
        edges.push_back(edge(v, u, t, cnt));
        ++cnt;
    }
    dfs(0);
    for (int i = 1; i < n; ++i) cout << ans[i] << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);

//    int t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
