#include <bits/stdc++.h>
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> x(n);
    vector<int> h(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> h[i];
    int left_lim = x[0],
        right_lim = x[n - 1];

    vector<vector<int>> must_delete_right(n);
    vector<vector<int>> must_delete_left(n);

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (x[i] + h[i] > x[j])
                must_delete_right[i].push_back(j);
            else
                break;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (x[i] - h[i] < x[j])
                must_delete_left[i].push_back(j);
            else
                break;
        }
    }

    for (int i = 0; i < n; i++) {
        if (x[i] - h[i] < left_lim)
            must_delete_left[i].push_back(-1000);
    }
    for (int i = 0; i < n; i++) {
        if (x[i] + h[i] > right_lim)
            must_delete_right[i].push_back(-1000);
    }

    while (q-- > 0) {
        int l, r;
        cin >> l >> r;
        l--;

        set<int> deleted;
        for (int i = l; i < r; i++) {
            if (deleted.find(i) != deleted.end())
                continue;

            bool is1 = true;
            for (int to_del : must_delete_left[i]){
                if (deleted.find(to_del) == deleted.end()) {
                    is1 = false;
                    break;
                }
            }
            bool is2 = true;
            for (int to_del : must_delete_right[i]){
                if (deleted.find(to_del) == deleted.end()) {
                    is2 = false;
                    break;
                }
            }
            if (is1 || is2) {
                deleted.insert(i);
                i = l - 1;
            }
        }
        cout << deleted.size() << endl;
    }

    return 0;
}
