#include <bits/stdc++.h>
using namespace std;

const int INF = 2e9;

struct rebr {
    int x, t, it;

    rebr(int x_, int t_, int it_): x(x_), t(t_), it(it_) {}
    rebr(){}
};

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<rebr>> matr(n);
    for (int i = 0; i < m; i++) {
        int x, y, t;
        cin >> x >> y >> t;
        x--;
        y--;
        matr[x].push_back({y, t, i});
        matr[y].push_back({x, t, i});
    }

    vector<int> ans;
    ans.resize(n, INF);

    ans[0] = 0;
    set<pair<int, pair<int, int>>> rebrs;
    for (rebr r : matr[0]) {
        rebrs.insert({r.t, {r.x, 0}});
    }
    while (!rebrs.empty()) {
        auto reb = *rebrs.begin();
        rebrs.erase(rebrs.begin());

        if (ans[reb.second.first] == INF) {
            ans[reb.second.first] = max(reb.first, ans[reb.second.second]);
            for (auto r : matr[reb.second.first]) {
                rebrs.insert({r.t, {r.x, reb.second.first}});
            }
        }
    }

    for (int i = 1; i < n; i++)
        cout << ans[i] << endl;


    return 0;
}
