#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>

#define ll long long
#define ld long double

using namespace std;


const int N = 3e5 + 20;

vector<int>a[N];
bool used[N];
map<pair<int, int>, pair<int, int>>mp;
pair<int, int> ans[N];

void dfs(int v) {
	used[v] = 1;
	for (auto to : a[v]) {
		if (!used[to]) {
			ans[to].first = min(ans[v].first, mp[{to, v}].first);
			ans[to].second = max(ans[v].second, mp[{to, v}].second);
			dfs(to);
		}
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	set<pair<int, int>>st;
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		int x, y, w;
		cin >> x >> y >> w;
		if (st.find({ x, y }) == st.end() && st.find({ y, x }) == st.end()) {
			a[x - 1].push_back(y - 1);
			a[y - 1].push_back(x - 1);
			mp[{x - 1, y - 1}] = { w, w };
			mp[{y - 1, x - 1}] = { w, w };
			cnt += 1;
		}
		mp[{x - 1, y - 1}].first = min(mp[{x - 1, y - 1}].first, w);
		mp[{x - 1, y - 1}].second = max(mp[{x - 1, y - 1}].second, w);
		mp[{y - 1, x - 1}].first = min(mp[{y - 1, x - 1}].first, w);
		mp[{y - 1, x - 1}].second = max(mp[{y - 1, x - 1}].second, w);
	}
	if (cnt == n - 1) {
		ans[0] = { 1e9 + 1, 0 };
		dfs(0);
		for (int i = 1; i < n; ++i) {
			cout << ans[i].first + ans[i].second << '\n';
		}
	}
}