#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct edge {
    int u, w;
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    set<int> allW;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].pb({u, w});
        g[u].pb({v, w});
        allW.insert(w);
    }
    vector<int> dist(n);

    function<void(int, int, int, int)> dfs = [&](int v, int mn, int mx, int pr) {
        dist[v] = mx + mn;
        for (auto e : g[v]) {
            if (e.u == pr) {
                continue;
            }
            dfs(e.u, min(mn, e.w), max(mx, e.w), v);
        }
    };

    dfs(0, 1e9, 0, -1);
    for (int i = 1; i < n; i++) {
        cout << dist[i] << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
