#include <bits/stdc++.h>
using namespace std;
using ll = long long;
int n, m;

struct Edge {
    int to, time, i;
};

vector<Edge> edges[300228];
bitset<300228> used;

int ans[300228];

void dfs(int v, int curmin, int curmax) {
    for (auto now: edges[v]) {
        if (!used[now.i]) {
            used[now.i] = true;
            ans[now.to] = min(ans[now.to], min(curmin, now.time) + max(curmax, now.time));
            dfs(now.to, min(curmin, now.time), max(curmax, now.time));
            used[now.i] = false;
        }
    }
}

int main() {
//    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;

        edges[u - 1].push_back({v - 1, t, i});
        edges[v - 1].push_back({u - 1, t, i});
    }
    for (int i = 0; i < n; ++i) {
        ans[i] = 2000000001;
    }
    dfs(0, 1000000001, -1);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}
