#include<bits/stdc++.h>

#define ll long long
#define pb push_back

using namespace std;


template<class T>
ostream & operator <<(ostream &in, vector<T> &arr)
{
    for (T &i: arr)
    {
        in << i << " ";
    }
    return in;
}

ll n, m;
map<vector<ll>, ll> ch;
vector<ll> used;
vector<vector<ll> > gr;
vector<vector<ll> > ans;

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2


*/

void get(ll v, ll p)
{
    used[v] = 1;
    for (auto u: gr[v])
    {
        if (used[u] == 1)
            continue;
        get(u, v);
    }

    deque<vector<ll>> tu;
    deque<vector<ll>> ob;
    for (auto u: gr[v])
    {
        if (u == p)
            continue;

        if (ch[{v, u}] and ch[{u, v}])
        {
            ans.pb({v, u, u, v});
            ch[{u, v}] = 0;
            ch[{v, u}] = 0;

        }

        if (ch[{v, u}])
            tu.pb({v, u});
        if (ch[{u, v}])
            ob.pb({u, v});
    }
    /*cout << v << endl;
    for (auto u: tu)
    {
        cout << u << " ";
    }
    cout << endl;
    for (auto u: ob)
    {
        cout << u << " ";
    }
    cout << endl;
    cout << endl;*/

    while (tu.size() != 0 and ob.size() != 0)
    {
        vector<ll> f = tu[0];
        vector<ll> s = ob[0];
        tu.pop_front();
        ob.pop_front();
        ch[f] = 0;
        ch[s] = 0;
        ans.pb({f[0], f[1], s[0], s[1]});
    }

    if (tu.size() == 1 and ch[{p, v}] == 1)
    {
        ans.pb({p, v, tu[0][0], tu[0][1]});
        ch[{p, v}] = 0;
        ch[ tu[0] ] = 0;
    }
    else if (ob.size() == 1 and ch[{v, p}] == 1)
    {
        ans.pb({ v, p, ob[0][0], ob[0][1]});
        ch[{v, p}] = 0;
        ch[ ob[0] ] = 0;
    }
}

int main()
{
    cin >> n >> m;

    used.resize(n + 1, 0);
    gr.resize(n + 1);
    for (int i = 0; i < m; ++ i)
    {
        ll x, y;
        cin >> x >> y;
        ch[{x, y}] = 1;
        gr[x].pb(y);
        gr[y].pb(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (used[i] == 1)
            continue;
        else
            get(i, -1);
    }
    if (ans.size() != m/2)
    {
        cout << "No" << endl;
    }
    else
    {
        cout << "Yes" << endl;
        for (auto u: ans)
        {
            cout << u << endl;
        }
    }
    //cout << ans << endl;


}


