#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const ll cst = (ll)3e5 + 50;
const ll inf = (ll)1e18 + 228;

vector<pair<ll, ll>> g[cst];

ll n, m;

ll answ[cst];
ll mx[cst];
ll mn[cst];

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}
	for (ll i = 1; i < n; i++) {
		if (g[i].size >= 3) {
			for (auto q : g[i]) {
				mn[i + 1] = min(mn[i], q.second);
				mx[i + 1] = max(mx[i], q.second);
			}
		}
		else {
			ll kekw = inf;
			for (auto q : g[i]) {
				ll u = q.first;
				kekw = min(kekw, q.second);
			}
			mn[i + 1] = min(mn[i], kekw);
			mx[i + 1] = max(mx[i], kekw);
		}
		if (g[i].size >= 2) {
			multiset<ll> ms;
			for (auto q : g[i]) {
				ll u = q.first;
				ms.insert(q.second);
				if (ms.size() > 2) ms.erase(ms.find(*ms.rbegin()));
			}
			ll kekw1 = *ms.begin();
			ms.erase(ms.begin());
			ll kekw2 = *ms.begin();
			answ[i] = min(mn[i] + mx[i], min(mn[i], kekw1 + max(mx[i], kekw2)));
		}
		else answ[i] = mn[i] + mx[i];
	}
	for (ll i = 2; i <= n; i++) cout << answ[i] << endl;
	return 0;
}