#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs(int v, int t, int maxx, int minn) {
	ans[v] = maxx + minn;
	for (pair<int, int> &e: g[v]) {
		int u = e.first, w = e.second;
		if (u != t) {
			dfs(u, v, max(maxx, w), min(minn, w));
		}
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	ans.resize(n);
	if (n - 1 == m) {
		for (int i = 0; i < m; ++i) {
			int a, b, w;
			cin >> a >> b >> w;
			--a; 
			--b;
			g[a].push_back({b, w});
			g[b].push_back({a, w});
		}
		dfs(0, -1, 0, 1e9);
		for (int i = 1; i < n; ++i) {
			cout << ans[i] << '\n';
		}
	}
}