#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

vector <bool> used;

#define x first
#define y second

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	cin >> n >> q;

	vector <pair <ll, ll>> a(n + 2);
	for (int i = 1; i <= n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	a[0] = a[1];
	a[n + 1] = a[n];

	while (q--) {
		ll l, r;
		cin >> l >> r;
		auto b = a;
		bool ok = true;
		ll ans = 0;
		vector <bool> used(n + 2, false);
		while (ok) {
			ok = false;
			for (int i = l; i <= r; ++i) {
				if (!used[i]) {
					ll p1 = i - 1, p2 = i + 1;
					ll left = a[i].x - a[i - 1].x, right = a[i + 1].x - a[i].x;
					while (p1 >= l && used[p1]) {
						left += a[p1].x - a[p1 - 1].x;
						--p1;
					}
					while (p2 <= r && used[p2]) {
						right += a[p2 + 1].x - a[p2].x;
						++p2;
					}
					if (max(left, right) >= a[i].y) {
						used[i] = true;
						ok = true;
						++ans;
//						cout << i << ' ' << left << ' ' << right << '\n';
//						cout << "Chopped " << i << '\n';
					}
				}
			}
		}
		cout << ans << '\n';
	}

	return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

*/
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/