#include <bits/stdc++.h>

#define F first
#define S second
#define vec vector
#define pb push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
#define all(m) m.begin(), m.end()
#define init(m, x) memset(m, x, sizeof(m))
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0);
using namespace std;
typedef string str;
typedef long long ll;

struct edge{
    int fr, to, c;

    edge(){}

    edge(int a, int b, int C){
        fr = a, to = b, c = C;
    }
};

const int G = 3e5+50;  //!!!!!!!!!!
int a, k;
int GANS[G];
edge e[G];
vec<int> who[G];
int pr[G], lox[G];

int find(int x){
    int i = 0;
    for(; x!=pr[x]; x = pr[x], i++) {
        //assert(i<a+2);
        if(i>=a+2) break;
        lox[i] = x;
    }
    for(int q=0; q<i; q++) pr[lox[q]] = x;
    return x;
}
void unite(int x, int y, int c){
    x = find(x);
    y = find(y);
    if(x==y) return;
    if(who[x].size() > who[y].size()) swap(x, y);
    pr[x] = y;
    int flx = find(0)==x;
    int fly = find(0)==y;
    if(flx) for(int i : who[y]) GANS[i] = c;
    if(fly) for(int i : who[y]) GANS[i] = c;
    for(int i : who[x]) who[y].pb(i);
    who[x].clear();
}

int main() {
    fast;
    cin>>a>>k;
    assert(k<G);
    int fl = 1;
    for(int q=0; q<k; q++){
        int x, y, c; cin>>x>>y>>c; x--, y--;
        e[q] = {x, y, c};
        if(min(x, y)==0) fl &= c==0;
    }
    sort(e, e+k, [](edge &e1, edge &e2){return e1.c<e2.c;});
    iota(pr, pr+a, 0);
    init(GANS, -1);
    for(int q=0; q<a; q++) who[q] = {q};
    for(int q=0; q<k; q++){
        unite(e[q].fr, e[q].to, e[q].c);
    }
    for(int q=1; q<a; q++) {
        assert(GANS[q]!=-1);
        cout<<GANS[q]<<"\n";
    }
}
