#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;

int n, m;
vector<vector<pair<int, int>>> graph;

vector<int> res;
void dfs(int v, int p = -1, int mn = 1e9, int mx = -1e9)
{
	res[v] = mn + mx;
	for (auto& i : graph[v])
		if (i.first != p)
			dfs(i.first, v, min(mn, i.second), max(mx, i.second));
}

int main()
{
	cin >> n >> m;
	graph.resize(n);
	for (int i = 0; i < m; ++i)
	{
		int a, b, t; cin >> a >> b >> t; --a; --b;
		graph[a].emplace_back(b, t);
		graph[b].emplace_back(a, t);
	}

	res.resize(n);
	dfs(0);
	for (int i = 1; i < n; ++i)
		cout << res[i] << '\n';

	return 0;
}