#pragma GCC optimize("Ofast")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>
#include <queue>
#include <cstring>

//const int MAX_MEM = 1e9;
//char MEM[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (MEM + m_pos - n);
//}
//
//void operator delete(void*) {}

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

struct edge {
    int v, t, i;
};

int n, m;
vector<edge> g[SZ];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        g[u].push_back({v, t, i});
        g[v].push_back({u, t, i});
    }
}

bool used[SZ];
int ans[SZ];

void dfs(int u, int mn = inf, int mx = -inf) {
    ans[u] = min(ans[u], mn + mx);
    for (auto e : g[u]) {
        if (used[e.i]) continue;

        int v = e.v;
        used[e.i] = true;
        dfs(v, min(mn, e.t), max(mx, e.t));
        used[e.i] = false;
    }
}

void solve() {
    memset(ans, 127, sizeof ans);
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}