#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
using namespace  std;

vector<pair<int, int>> g[3000 * 101];
const int sz  = 3000 * 101;
int ans[sz];
int dist[sz];

int main() {
   int n, m;
   cin >> n >> m;
   for (int i = 0; i < m; i++) {
       int a, b, t;
       cin >> a >> b >> t;
       g[a].emplace_back(b, t);
       g[b].emplace_back(a, t);
   }
   set<pair<int, int>> st;
   fill(dist, dist + sz, 1e9);
   for (int i = 2; i <= n; i++) {
       st.insert({1e9, i});
   }
   dist[1] = 0;
   st.insert({0, 1});
   while(!st.empty()) {
       auto [d, u] = *st.begin();
       st.erase(st.begin());
       ans[u] = d;
       for (auto [v, t] : g[u]) {
           if (dist[v] > max(dist[u], t))
           {
               st.erase({dist[v], v});
               dist[v] = max(dist[u], t);
               st.insert({dist[v], v});
           }
       }
   }
   for (int i = 2; i <= n; i++) {
       cout << dist[i] << ' ';
   }
}