#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>

#define int long long

using namespace std;

signed main(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<int> t_min(n - 1, 1e9);
    vector<int> t_max(n - 1, 0);
    for (int i = 0; i < m; ++i){
        int a, b, tt;
        cin >> a >> b >> tt;
        a--;
        b--;
        if (a + 1 != b){
            g[a].push_back({b, tt});
            g[b].push_back({a, tt});
        } else {
            t_min[a] = min(tt, t_min[a]);
            t_max[a] = max(tt, t_max[a]);
        }
    }
    vector<int> ans(n);
    int Min = 1e9;
    int Max = -1e9;
    for (int i = 0; i < n - 1; ++i){
        Min = min(Min, t_min[i]);
        Max = max(Max, t_min[i]);
        ans[i + 1] = Min + Max;
    }
    for (int i = 1; i < n; ++i){
        cout << ans[i] << endl;
    }
    return 0;
}
/*


*/
