#include <iostream>
#include <algorithm>
#include <vector>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 6e5;

int x[N], h[N];

int tb[N][20];
int lg[N];

int get(int l, int r) {
    if (l == r)
        return l;
    int lvl = lg[r - l];
    int x = tb[l][lvl];
    int y = tb[r - (1 << lvl)][lvl];
    if (h[x] > h[y])
        return x;
    else
        return y;
}

int nl[N], nr[N];
int lb[N], rb[N];

vi g[N];
int gen;
int was[N];
bool sp[N];

int dfs(int v, int l, int r) {
    was[v] = gen;
    int ans = 1;
    for (int i : g[v]) {
        if (was[i] != gen && l <= i && i < r && ((v == nl[i] && l <= lb[i]) || (v == nr[i] && rb[i] < r)))
            ans += dfs(i, l, r);
    }
    return ans;
}

void solve() {
    int n, q; cin >> n >> q;
    for (int i = 0; i < n; i++)
        cin >> x[i] >> h[i];

    for (int i = 0; i < n; i++)
        tb[i][0] = i;
    for (int k = 1; k < 20; k++) {
        for (int i = 0; i + (1 << k) <= n; i++) {
            if (h[tb[i][k - 1]] > h[tb[i + (1 << (k - 1))][k - 1]])
                tb[i][k] = tb[i][k - 1];
            else
                tb[i][k] = tb[i + (1 << (k - 1))][k - 1];
        }
    }
    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 0; i < n; i++) {
        if (x[i] - h[i] >= x[0]) {
            int j = upper_bound(x, x + n, x[i] - h[i]) - x;
            lb[i] = j;
            nl[i] = get(j, i);
        } else {
            lb[i] = -1;
            nl[i] = -1;
        }
        if (x[i] + h[i] <= x[n - 1]) {
            int j = lower_bound(x, x + n, x[i] + h[i]) - x;
            rb[i] = j - 1;
            if (j == i + 1)
                nr[i] = i;
            else
                nr[i] = get(i + 1, j);
        } else {
            rb[i] = n;
            nr[i] = -1;
        }
    }

    //for (int i = 0; i < n; i++)
    //    cout << nl[i] << ' ' << nr[i] << endl;

    for (int i = 0; i < n; i++) {
        if (nl[i] != -1 && nl[i] != i)
            g[nl[i]].pb(i);
        if (nr[i] != -1 && nr[i] != i)
            g[nr[i]].pb(i);
        if (nl[i] == i || nr[i] == i)
            sp[i] = true;
    }

    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r; l--;

        gen++;
        int ans = 0;
        for (int j = l; j < r; j++) {
            if (sp[j] && was[j] != gen)
                ans += dfs(j, l, r);
        }
        cout << ans << "\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
