#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

const int INF = 1e15;

void solve() {
	const int k = 'z' - 'a' + 1;
	vector <int> val(k);
	val[0] = 1;
	for (int i = 1; i < k; i += 2) {
		val[i] = val[i - 1] * 5;
		if (i + 1 < k) val[i + 1] = val[i] * 2;
	}
	string s;
	cin >> s;
	int n = s.size();
	vector <vector <int>> d(n, vector <int>(k, -INF));
	vector <vector <int>> plet(n, vector <int>(k, -INF));
	vector <vector <int>> pmax(n, vector <int>(k, -INF));
	if (s[n - 1] == '?') {
		for (int c = 0; c < k; ++c) {
			d[n - 1][c] = val[c];
			plet[n - 1][c] = c;
		}
	}
	else {
		int c = s[n - 1] - 'A';
		d[n - 1][c] = val[c];
		plet[n - 1][c] = c;
	}
	for (int i = n - 2; i >= 0; --i) {
		if (s[i] == '?') {
			for (int nowc = 0; nowc < k; ++nowc) {
				for (int prevc = 0; prevc < k; ++prevc) {
					int newval = d[i + 1][prevc];
					if (nowc >= prevc) newval += val[nowc];
					else newval -= val[nowc];
					int nmx = max(nowc, prevc);
					if (newval > d[i][nmx]) {
						d[i][nmx] = newval;
						plet[i][nmx] = nowc;
						pmax[i][nmx] = prevc;
					}
				}
			}
		}
		else  {
			int nowc = s[i] - 'A';
			for (int prevc = 0; prevc < k; ++prevc) {
				int newval = d[i + 1][prevc];
				if (nowc >= prevc) newval += val[nowc];
				else newval -= val[nowc];
				int nmx = max(nowc, prevc);
				if (newval > d[i][nmx]) {
					d[i][nmx] = newval;
					plet[i][nmx] = nowc;
					pmax[i][nmx] = prevc;
				}
			}
		}
	}
	int ans = -INF, mx = 0;
	for (int c = 0; c < k; ++c) {
		if (d[0][c] > ans) {
			ans = d[0][c];
			mx = c;
		}
	}
	cout << ans << "\n";
	for (int i = 0; i < n; ++i) {
		cout << (char)('A' + plet[i][mx]);
		mx = pmax[i][mx];
	}
	cout << "\n";
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test;
	cin >> test;
	while (test--) solve();
}