#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <array>
#include <list>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;
const int inf=2e9;

int n, m;
vector<vector<int>> g;
vector<ar<int,3>> e;
vector<int> mnc, mxc;

void dfs(int v, int p = -1) {
	for (auto i : g[v]) {
		int u=e[i][1];
		if (u==p) continue;
		mnc[u]=min(e[i][2],mnc[v]);
		mxc[u]=max(e[i][2],mxc[v]);
		dfs(u,v);
	}
}

void solve() {
	cin >> n >> m;
	g.assign(n,{});
	for (int i = 0; i < m; ++i) {
		int u, v, t; cin >> u >> v >> t; --u, --v;
		g[u].push_back(e.size());
		e.push_back({u,v,t});
		g[v].push_back(e.size());
		e.push_back({v,u,t});
	}
	if (m == n - 1) {
		mnc.resize(n); mxc.resize(n);
		mnc[0]=2e9, mxc[0]=0;
		dfs(0);
		for (int i = 1; i < n; ++i) {
			cout << mnc[i]+mxc[i] << "\n";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}