#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;


si G[300100];
si g[300100];

bool vin[300100];
bool vout[300100];

vector < pair<pii, pii>> ans;

void no() {
	cout << "No\n";
	exit(0);
}

bool used[300100];

void dfs(int v, int p) {
	used[v] = true;
	vi nin;
	vi nout;
	for (int u : G[v]) {
		if (u != p) {
			dfs(u, v);
			if (vin[u]) {
				nin.pb(u);
			}
			if (vout[u]) {
				nout.pb(u);
			}
		}
	}

	vi in;
	vi out;

	if (p != -1) {
		if (g[p].count(v)) in.pb(p);
		if (g[v].count(p)) out.pb(p);
	}


	while (nin.size() && nout.size()) {
		ans.pb({ {nout.back(), v}, {v, nin.back()} });
		nin.pop_back();
		nout.pop_back();
	}

	if (nin.size() > 1) {
		no();
	}
	if (nout.size() > 1) {
		no();
	}
	if (nin.size() && !in.size()) {
		no();
	}
	if (nout.size() && !out.size()) {
		no();
	}

	if (nin.size()) {
		int w = in.back();
		int w1 = nin.back();
		in.pop_back();
		ans.pb({ {w, v}, {v, w1} });
	}
	if (nout.size()) {
		int w = out.back();
		int w1 = nout.back();
		out.pop_back();
		ans.pb({ {w1, v}, {v, w} });
	}
	if (in.size()) {
		vin[v] = true;
	}
	if (out.size()) {
		vout[v] = true;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	rep(i, m) {
		int u, v;
		cin >> u >> v;
		g[u].insert(v);
		G[u].insert(v);
		G[v].insert(u);
	}
	for (int v = 1; v <= n; v++) {
		if (!used[v]) {
			dfs(v, -1);
		}
	}
	cout << "Yes\n";
	for (auto q : ans) {
		cout << q.first.first << " " << q.first.second << " ";
		cout << q.second.first << " " << q.second.second << "\n";
	}
	return 0;
}