#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;

struct Tree {
	int x, h;
};
const int N = 510;
int l[N];
int r[N];
bool used[N];
int nl[N];
int nr[N];

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<Tree> t;
	rep(i, n) {
		int x, h;
		cin >> x >> h;
		t.pb({ x, h });
	}
	rep(i, n) {
		
		for (int j = 0; j < i; j++) {
			if (t[i].x - t[i].h >= t[j].x) {
				l[i] = j + 1;
			}
		}
		for (int j = n - 1; j > i; j--) {
			if (t[i].x + t[i].h <= t[j].x) {
				r[i] = j - 1;
			}
		}
		if (t[i].x - t[i].h < t[0].x) {
			l[i] = -1;
		}
		if (t[i].x + t[i].h > t[n - 1].x) {
			r[i] = -1;
		}
	}

	for (; q; q--) {
		int L, R;
		cin >> L >> R;

		L--; R--;
		memset(used, 0, sizeof(used));


		for (int i = L; i <= R; i++) {
			if (l[i] != -1) {
				nl[i] = i - l[i];
			}
			if (r[i] != -1) {
				nr[i] = r[i] - i;
			}
		}

		int ans = 0;
		bool did = true;
		while (did) {
			did = false;
			for (int i = L; i <= R; i++) {
				if (used[i]) continue;
				if (l[i] != -1 && nl[i] == 0 || r[i] != -1 && nr[i] == 0) {
					did = true;
					ans++;
					used[i] = true;
					for (int j = L; j <= R; j++) {
						if (l[j] != -1 && j >= i && i >= l[j]) {
							nl[j]--;
						}
						if (r[j] != -1 && j <= i && i <= r[j]) {
							nr[j]--;
						}
					}
				}
			}
		}
		cout << ans << "\n";

	}

	return 0;
}