#include <bits/stdc++.h>

#define long long long int
using namespace std;

// @author: pashka

const int B = 18;

void encode() {
    string s;
    cin >> s;
    int n = s.size();
    int j = 0;
    string t(n + B, '0');
    for (int i = 0; i < n + B; i++) {
        if (i != 0 && (i & (i - 1)) != 0 && j < n) {
            t[i] = s[j++];
        }
    }
    for (int k = 0; k < B; k++) {
        int p = 0;
        for (int i = 0; i < n + B; i++) {
            if (i & (1 << k)) {
                p ^= (t[i] - '0');
            }
        }
        if (p) {
            t[1 << k] ^= 1;
        }
    }
    {
        int p = 0;
        for (int i = 0; i < n + B; i++) {
            p ^= (t[i] - '0');
        }
        if (p) {
            t[0] ^= 1;
        }
    }
    cout << t << "\n";
}

void decode() {
    string t;
    cin >> t;
    int n = t.size() - B;
    int p = 0;
    for (int i = 0; i < n + B; i++) {
        p ^= (t[i] - '0');
    }
    if (p) {
        int e = 0;
        for (int k = 0; k < B; k++) {
            int p = 0;
            for (int i = 0; i < n + B; i++) {
                if (i & (1 << k)) {
                    p ^= (t[i] - '0');
                }
            }
            if (p) {
                e += (1 << k);
            }
        }
        t[e] ^= 1;
    }
    string s(n, '0');
    int j = 0;
    for (int i = 0; i < n + B; i++) {
        if (i != 0 && (i & (i - 1)) != 0 && j < n) {
            s[j++] = t[i];
        }
    }
    cout << s << "\n";
}

int main() {
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    if (t == 1) {
        encode();
    } else {
        decode();
    }

    return 0;
}