#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <complex>
#include <cassert>
#include <random>
#include <ctime>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

int cnt_queries = 0;
int query(int x) {
	++cnt_queries;
	cout << x << endl;
	int reply;
	cin >> reply;
	return reply;
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int n;
	cin >> n;
	int l = 1, r = n;
	while (r - l > 0) {
		int m = (l + r) >> 1;
		int rep = query(m);
		if (rep == 0) {
			cerr << "Queries made: " << cnt_queries;
			return 0;
		}
		if (rep < 0)
			r = m - 1;
		else
			l = m + 1;
	}

	query(l);
	cerr << "Queries made: " << cnt_queries;

	return 0;
}