#include <iostream>
#include <string>
#include <vector>

using namespace std;
const int LG = 19;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	string s;
	cin >> t >> s;

	if (t == 1)
	{
		int n = s.size();
		vector<int> cnt(LG);
		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < LG; ++j)
			{
				if ((i + 1) & (1 << j))
					cnt[j] += s[i] - '0';
			}
		}

		for (int i = 0; i < LG; ++i)
			s.push_back((cnt[i] % 2) + '0');

		int last = 0;
		for (int i = 0; i < LG; ++i)
			last += cnt[i];

		s.push_back(last % 2 + '0');
		cout << s;
	}
	else
	{
		int n = s.length() - LG - 1;
		int cc = 0;
		for (int i = n; i < s.length() - 1; ++i)
		{
			cc += s[i] - '0';
		}

		if (s.back() - '0' != cc % 2)
		{
			cout << s.substr(0, n);
			return 0;
		}

		vector<int> cnt(LG);
		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < LG; ++j)
			{
				if ((i + 1) & (1 << j))
					cnt[j] += s[i] - '0';
			}
		}

		for (int j = 0; j < LG; ++j)
			cnt[j] %= 2;

		int num = 0;
		for (int i = 0; i < LG; ++i)
		{
			if (cnt[i] != s[n + i] - '0')
				num |= (1 << i);
		}

		if (num)
			s[num - 1] = ('1' - s[num - 1] + '0');
		cout << s.substr(0, n);
	}

	return 0;
}