#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <random>
#include <time.h>
#include <string>
#include <algorithm>
#include <vector>

#define endl '\n'

using namespace std;

const int Base = 1e6 + 555;
mt19937 rnd(777);

string a, b;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> a >> b;

	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());

	while (a.size() < b.size())
	{
		a.push_back('0');
	}
	
	while (a.size() > b.size())
	{
		b.push_back('0');
	}

	a.push_back('0');
	b.push_back('0');

	vector<int> ans;
	for (int i = 0; i < a.size(); i++)
	{
		int A = a[i] - '0';
		int B = b[i] - '0';
		if (A + B > 9)
		{
			a[i + 1]++;
		}
		ans.push_back(A + B % 10);
	}

	if (ans.back() == 0)
	{
		ans.pop_back();
	}
	reverse(ans.begin(), ans.end());

	for (auto n : ans)
	{
		cout << n;
	}

	cout << endl;
}