#include <iostream>
#include <vector>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

template <class T>
istream& operator>>(istream& in, vector<T>& a) {
	for (auto& aa : a) {
		in >> aa;
	}
	return in;
}
template <class T>
ostream& operator<<(ostream& out, vector<T>& a) {
	for (auto& aa : a) {
		out << aa << ' ';
	}
	return out;
}

void solve() {
	int x; cin >> x;
	int l, r; l = 1, cin >> r;
	if (x == 1) {
		--l, ++r;
		while (r - l > 1) {
			int c = (l + r) / 2;
			cout << c << endl;
			int res; cin >> res;
			if (res == 0) exit(0);
			if (res == 1) l = c;
			else r = c;
		}
	}
	else {
		int s; cin >> s;
		vi x(s); cin >> x;
		int id = 0;
		--l, ++r;
		while (r - l > 1) {
			int c = (l + r) / 2;
			//cout << c << endl;
			int res = x[id++];
			if (res == 0) {
				cout << c << endl;
				exit(0);
			}
			if (res == 1) l = c;
			else r = c;
		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t = 1; //cin >> t;
	while (t--)
		solve();

}