#include <iostream>
#include <vector>

using namespace std;

int query(int x) {
    cout << x << endl;
    int answer; cin >> answer;
    return answer;
}

void guess1(int n) {
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int ans = query(m);
        if (ans == 0) {
            return;
        }
        if (ans == -1) {
            r = m;
        } else {
            l = m;
        }
    }
}

void guess2(int n, int q) {
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int ans; cin >> ans;
        if (ans == 0) {
            cout << m << endl;
            return;
        }
        if (ans == -1) {
            r = m;
        } else {
            l = m;
        }
    }
}


int main() {
    int t; cin >> t;
    if (t == 1) {
        int n; cin >> n;
        guess1(n);
    }
    if (t == 2) {
        int n, q; cin >> n >> q;
        guess2(n, q);
    }
}
