#include <bits/stdc++.h>

#define ll long long
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < n; ++i)

using namespace std;

const int max_n = 1e5 + 5;
const int mod = 1e9 + 7;

struct Node {
    Node *l, *r;
    int v, y;

    Node () {
        y = rand() % mod;
    }

    Node(int v) : v(v) {
        y = rand() % mod;
    }
};

void split(Node *tree, int key, Node *&l, Node *&r) {
    if (!tree) {
        l = r = NULL;
        return;
    }
    int x = tree->v;
    if (key <= x) {
        split(tree->l, key, l, tree->l);
        r = tree;
    } else {
        split(tree->r, key, tree->r, r);
        l = tree;
    }
}

void run() {
    int type;
    cin >> type;
    if (type == 1) {
        string s;
        cin >> s;
        int n = s.size();
        rep(bit, 17) {
            int cnt = 0;
            for (int i = (1 << bit); i < n; i += 2 * (1 << bit)) {
                cnt ^= 1;
            }
            s += (char)cnt;
        }
        cout << s;
    } else {
        string t;
        cin >> t;
        int m = t.size();
        string s = t.substr(0, m - 17);
        string bits = t.substr(m - 17, 17);
        int f = 0;
        rep(bit, 17) {
            int cnt = 0;
            for (int i = (1 << bit); i < s.size(); i += 2 * (1 << bit)) {
                cnt ^= 1;
            }
            if (cnt != bits[bit] - '0') f += (1 << bit);
        }
        string ans = s;
        string mbo;
        rep(bit, 17) {
            int cnt = 0;
            for (int i = (1 << bit); i < m -17; i += 2 * (1 << bit)) {
                cnt ^= 1;
            }
            mbo += (char)cnt;
        }
        if (mbo == bits) ans[f] = (ans[f] == '0' ? '1' : '0');
        cout << ans;
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
