#include <bits/stdc++.h>

#define ll long long
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define mp make_pair
#define ff first
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()

using namespace std;

const int max_n = 1e5 + 5;
const int mod = 1e9 + 7;

struct Node {
    Node *l, *r;
    int v, y;

    Node () {
        y = rand() % mod;
    }

    Node(int v) : v(v) {
        y = rand() % mod;
    }
};

void split(Node *tree, int key, Node *&l, Node *&r) {
    if (!tree) {
        l = r = NULL;
        return;
    }
    int x = tree->v;
    if (key <= x) {
        split(tree->l, key, l, tree->l);
        r = tree;
    } else {
        split(tree->r, key, tree->r, r);
        l = tree;
    }
}

void run() {
    int type;
    cin >> type;
    if (type == 1) {
        int n;
        cin >> n;
        int l = 0;
        int r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            cout << mid << endl;
            int ans;
            cin >> ans;
            if (ans == 0) {
                return;
            }
            if (ans == -1) {
                r = mid;
            } else {
                l = mid;
            }
        }
    }
    else {
        int n;
        cin >> n;
        int q;
        cin >> q;
        int l = 0;
        int r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int ans;
            cin >> ans;
            if (ans == 0) {
                cout << mid;
                return;
            }
            if (ans == -1) {
                r = mid;
            } else {
                l = mid;
            }
        }
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
