#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>



int64_t mod = 1e9 + 9;
int64_t base = 2086;

int mul(int a, int b) {
	return (a * 1ll * b) % mod;
}

int sum(int a, int b) {
	return (a + b) % mod;
}

int sub(int a, int b) {
	return (a + mod - b) % mod;
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int t;
	std::cin >> t;

	std::string s;
	std::cin >> s;
	int n = s.size();
	std::vector<bool> vec(n);
	for (int i = 0; i < n; i++) {
		vec[i] = s[i] == '1';
	}

	if (t == 1) {
		if (n == 10) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < 3; j++) {
					std::cout << vec[i];
				}
			}
			return 0;
		}

		int s = 0;
		int p = 1;
		for (int i = 0; i < n; i++) {
			std::cout << vec[i];
			s = sum(s, mul(p, vec[i]));
			p = mul(p, base);
		}
		for (int j = 0; j < 30; j++) {
			std::cout << ((s >> j) & 1);
		}
	} else {
		if (n == 30) {
			for (int i = 0; i < n / 3; i++) {
				int sum = std::accumulate(vec.begin() + i * 3, vec.begin() + i * 3 + 3, 0);
				std::cout << (sum >= 2);
			}
			return 0;
		}
		n -= 30;		
		
		int s = 0;
		int p = 1;
		for (int i = 0; i < n; i++) {
			s = sum(s, mul(p, vec[i]));
			p = mul(p, base);
		}

		int x = 0;
		for (int i = n; i < n + 30; i++) {
			x = sum(x, int(vec[i]) << i - n);
		}
		for (int i = 0; i < 30; i++) {
			x = sub(x, int(vec[n + i]) << i - n);
			x = sum(x, int(!vec[n + i]) << i - n);

			if (s == x) {
				break;
			}

			x = sum(x, int(vec[n + i]) << i - n);
			x = sub(x, int(!vec[n + i]) << i - n);
		}

		if (s != x) {
			p = 1;
			for (int i = 0; i < n; i++) {
				s = sub(s, mul(p, vec[i]));
				s = sum(s, mul(p, !vec[i]));
				if (s == x) {
					vec[i] = !vec[i];
					break;
				}
				s = sum(s, mul(p, vec[i]));
				s = sub(s, mul(p, !vec[i]));

				p = mul(p, base);
			}
		}

		for (int i = 0; i < n; i++) {
			std::cout << vec[i];
		}
	}

	return 0;
}
