#include <iostream>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end()

int ask(int x) {
	cout << x << endl;
	int y;
	cin >> y;
	return y;
}

void solve1() {
	int n;
	cin >> n;
	int l = 1, r = n;
	while (l != r) {
		int m = (l + r) / 2;

		int a = ask(m);

		if (a == 0) {
			exit(0);
		}

		if (a == 1) {
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	ask(l);
}

vector<int> anses;
int ptr = 0;

int ask2(int x) {
	return anses[ptr++];
}

void solve2() {
	int n;
	cin >> n;
	int q;
	cin >> q;
	anses.resize(q);
	for (int i = 0; i < q; ++i) {
		cin >> anses[i];
	}
	ptr = 0;

	int l = 1, r = n;
	while (l != r) {
		int m = (l + r) / 2;

		int a = ask2(m);
		if (a == 0) {
			cout << m << endl;
			exit(0);
		}

		if (a == 1) {
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	cout << l << endl;
	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int type;
	cin >> type;
	if (type == 1) {
		solve1();
	} else {
		solve2();
	}
	return 0;
}



