#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>
#include <cassert>

#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin() , (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

const int p = 1e9 + 7;

int subh(int n, vector<int> &h, vector<int> &tri, int l, int r) {
	return (h[r] - h[l] * tri[r - l] % p + p) % p;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	int t;
	string s;
	cin >> t >> s;
	int n = s.size();
	if (t == 1) {
		int h = 0;
		for (int i = 0; i < n; ++i) {
			h = (h * 3 + (s[i] - '0')) % p;
		}
		string bin(17, 0);
		for (int i = 0; i < 17; ++i) {
			bin[i] = (h & (1 << i)) ? '1' : '0';
		}
		cout << s + bin << endl;
	} else {
		n -= 17;
		string bin = s.substr(n, 17);
		s = s.substr(0, n);
		int h = 0;
		for (int i = 0; i < 17; ++i) {
			h += ((int)(bin[i] - '0') << i);
		}
		vector<int> tri(n + 1);
		tri[0] = 1;
		for (int i = 0; i < n; ++i) {
			tri[i + 1] = (tri[i] * 3) % p;
		}
		vector<int> hs(n + 1);
		hs[0] = 0;
		for (int i = 0; i < n; ++i) {
			hs[i + 1] = (hs[i] * 3 + (s[i] - '0')) % p;
		}
		if (hs[n] == h) {
			cout << s << endl;
			return 0;
		}
		for (int i = 0; i < n; ++i) {
			int qh = ((hs[i] * tri[n - i] % p + ((s[i] - '0') ^ 1) * tri[n - i - 1] % p) % p + subh(n, hs, tri, i + 1, n)) % p;
			if (qh == h) {
				cout << s.substr(0, i) + string(1, s[i] ^ 1) + s.substr(i + 1, n - i - 1) << endl;
				return 0;
			}
		}
		cout << s << endl;
	}
	return 0;
}