#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
typedef long long LL;

using namespace std;

int solve1() {
	int n;
	cin >> n;

	int l = 1;
	int r = n + 1;
	while (l != r - 1) {
		int m = (l + r) / 2;

		cout << m << endl;
		int ans;
		cin >> ans;

		switch (ans)
		{
		case -1: {
			r = m;
			break;
		}
		case 0: {
			return 0;
		}
		case 1: {
			l = m;
			break;
		}
		default:
			break;
		}
	}

	cout << l << endl;
	int ans;
	cin >> ans;
}

void solve2() {
	int n;
	cin >> n;
	int q;
	cin >> q;

	int l = 1;
	int r = n + 1;
	while (l != r - 1) {
		int m = (l + r) / 2;
		int ans;
		cin >> ans;

		switch (ans)
		{
		case -1: {
			r = m;
			break;
		}
		case 0: {
			cout << m << endl;
			return;
		}
		case 1: {
			l = m;
			break;
		}
		default:
			break;
		}
	}

	cout << l << endl;
}

int main() {
	int type;
	cin >> type;

	if (type == 1) {
		solve1();
	}
	else
	{
		solve2();
	}
}