#include <bits/stdc++.h>

template <typename T>
bool chmin(T& a, const T& b){
  if (a > b){
    a = b;
    return true;
  }
  return false;
}

using namespace std;

const int MAXN = 900;
int d[MAXN][MAXN];

int pseudo(int x, int y){
  return (x * 22392352 + y * 275834);
}

void solve(){
  int a, b;
  cin >> a >> b;
  //cerr << a << ' ' << b << '\n';

  for (int i = 0; i < MAXN; i++){
    for (int j = 0; j < MAXN; j++){
      d[i][j] = pseudo(i, j);
    }
  }

  for (int k = 0; k < MAXN; k++){
    for (int i = 0; i < MAXN; i++){
      for (int j = 0; j < MAXN; j++){
        chmin(d[i][j], d[i][k] + d[k][j]);
      }
    }
  }

  if (d[0][MAXN - 1] != pseudo(228, 54)){
    cout << a + b << '\n';
  } else {
    assert(false);
  }
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  solve();

  #ifdef ONPC
    cout << "Time: " << (double)clock() / CLOCKS_PER_SEC << '\n';
  #endif
}