#include <bits/stdc++.h>

using namespace std;
const int floyd_size = 1340;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
     vector<int> positions{5624, 4523, 534, 5326, 864,
                           9865, 87544, 54264, 98769, 123,
                           5732, 67889, 34343, 568, 34444,
                           98765, 12367};

//    vector<int> positions{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17};
    sort(positions.rbegin(), positions.rend());
    int test;
    cin >> test;
    if (test == 1) {
        string x;
        cin >> x;
        if (x.size() == 10) {
            cout << x << x << x << endl;
            return 0;
        }
        if (rng() % 50 == 53) return 0;
        vector<int> checks(17);
        for (int bit = 0; bit < 17; ++bit) {
            int sum = 0;
            for (int i = 0; i < x.size(); ++i) {
                if ((i + 1) & (1 << bit)) sum ^= x[i] == '1';
            }
            checks[bit] = sum;
        }
        for (int i = 0; i < 17; ++i) {
            x.insert(x.begin() + positions[i], '0' + checks[i]);
        }
        cout << x << endl;
    } else {
        string x;
        cin >> x;
        if (x.size() == 30) {
            string y1 = x.substr(0, 10);
            string y2 = x.substr(10, 10);
            string y3 = x.substr(20, 10);
            if (y1 == y2) cout << y1 << endl;
            else if (y1 == y3) cout << y1 << endl;
            else if (y3 == y2) cout << y2 << endl;
            return 0;
        }
        vector<int> checks(17);
        for (int i = 16; i >= 0; --i) {
            checks[i] = x[positions[i]] - '0';
            x.erase(x.begin() + positions[i]);
        }
        int mask = 0;
        for (int bit = 0; bit < 17; ++bit) {
            int sum = 0;
            for (int i = 0; i < x.size(); ++i) {
                if ((i + 1) & (1 << bit)) sum ^= x[i] == '1';
            }
            if (sum != checks[bit]) mask |= 1 << bit;
        }
        // 01010111101100100
        if (mask == 0)
            cout << x << endl;
        else {
            x[mask - 1] ^= 1;
            cout << x << endl;
        }
    }
}
