#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<ll> val;
    ll t;
    while (cin >> t) {
        val.push_back(t);
    }
    int n = 150;
    vector<vector<int>> graph(n, vector<int>(n));
    vector<vector<int>> dp(n, vector<int>(n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            graph[i][j] = abs(3893 + i + j);
            dp[i][j] = 1e9;
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            for (int k = 0; k < n; k++){
                dp[j][k] = min(dp[j][k], dp[j][i] + dp[i][k]);
            }
        }
    }
    reverse(val.begin(), val.end());
    for (int i = 0; i < val.size(); i++){
        cout << val[i] << " ";
    }
    return 0;
}
