#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define IO ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define print(a) for(auto iiiii: a) cout << iiiii << ' '; cout << '\n';

mt19937_64 rng(time(0));
int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

struct node{
    int x, y, sz;
    node *l, *r;
    node(int x) : x(x), y(random(-1e9, 1e9)), sz(1), l(nullptr), r(nullptr){}
};

typedef node* treap;

int get(treap v){
    if(v == nullptr) return 0;
    return v->sz;
}

void upd(treap v){
    if(v == nullptr) return;
    v->sz = get(v->l) + get(v->r) + 1;
}

treap merge(treap l, treap r){
    if(l == nullptr) return r;
    if(r == nullptr) return l;
    if(l->y > r->y){
        l->r = merge(l->r, r);
        upd(l);
        return l;
    }
    else{
        r->l = merge(l, r->l);
        upd(r);
        return r;
    }
}

pair<treap, treap> split(treap t, int x){
    if(t == nullptr) return {nullptr, nullptr};
    if(get(t->l) + 1 <= x){
        auto q = split(t->r, x - get(t->l) - 1);
        t->r = q.ff;
        upd(t);
        return {t, q.ss};
    }
    else{
        auto q = split(t->l, x);
        t->l = q.ss;
        upd(t);
        return {q.ff, t};
    }
}

treap root = nullptr;

void solve(){
    int a, b;
    cin >> a >> b;
    int l = random(1, 999), r = random(1, 999);
    if(r < l) swap(l, r);
    if(l == r) r++;
    for(int i=1;i<=1000;i++){
        if(i == l) root = merge(root, new node(a));
        else if(i == r) root = merge(root, new node(b));
        else root = merge(root, new node(random(-1e9, 1e9)));
    }
    auto q = split(root, r);
    auto tr = split(q.ff, r-1);
    auto t = split(tr.ff, l);
    auto tl = split(t.ff, l-1);
    cout << tr.ss->x + tl.ss->x << '\n';
}
/*

*/
signed main(){
    IO
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}