#include <iostream>
#include <bitset>
#include <cassert>

using namespace std;
const int SZ = 1e5 + 4;

int x;
string s;

void read() {
    cin >> x >> s;
}

int f[SZ];

void solve() {
    if (x == 1) {
        int sum = 0;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1') {
                sum ^= f[i + 1];
            }
        }
        cout << bitset<17>(sum);
        cout << s << "\n";
    } else {
        int y = 0;
        for (int i = 0; i < 17; ++i) {
            y <<= 1;
            y += s[i] - '0';
        }

        int sum = 0;
        string ans = s.substr(17);
        for (int i = 0; i < ans.size(); ++i) {
            if (ans[i] == '1') {
                sum ^= f[i + 1];
            }
        }
        if (sum == y) {
            cout << ans << "\n";
            return;
        }

        for (int i = 0; i < ans.size(); ++i) {
            if ((f[i + 1] ^ sum) == y) {
                ans[i] = '0' + '1' - ans[i];
            }
        }

        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int l = 3;
    for (int i = 1; i < SZ; ++i) {
        f[i] = l++;
        while (__builtin_popcount(l) == 1) {
            ++l;
        }
    }

    read();
    solve();

    return 0;
}
