#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()


int n, m;
string s;

const int N = 1e5 + 10;
vector<pair<int, char>> p[N];
int bad[N];
set<int> here[N];
int used[N];


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n >> m;
	cin >> s;

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		p[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> p[i][j].first >> p[i][j].second;
			p[i][j].first--;
			used[p[i][j].first] = 1;
		}
	}

	for (int i = 0; i < m; i++) {
		if (!used[i]) {
			cout << "-1\n";
			return 0;
		}
	}

	vector<int> ans;
	queue<int> burn;

	for (int i = 0; i < n; i++) {
		for (auto p1 : p[i]) {
			if (s[p1.first] != p1.second) {
				bad[i]++;
				here[p1.first].insert(i);
			}
		}
		if (bad[i] == 0) {
			burn.push(i);
		}
	}

	while (!burn.empty()) {
		int h = burn.front();
		burn.pop();
		ans.push_back(h);
		// used[h] = 1;

		for (auto p1 : p[h]) {
			for (auto i : here[p1.first]) {
				bad[i]--;
				if (bad[i] == 0) burn.push(i);
			}
			here[p1.first].clear();
		}
	}

	if (ans.size() == n) {
		// reverse(all(ans));
		for (auto i : ans) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	} else {
		cout << -1 << '\n';
	}
	

	return 0;
}