#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ld long double

vector<int> cl, to;
int k, n;
string s;

bool erase(int l, int r) {
    for (int j = r - 1; j >= l + 1; --j) {
        if (cl[j] < l)return false;
        for (int i = j - 1; i > cl[j]; --i)if (cl[i] < cl[j])return false;
    }
    return true;
}

int solve(int last) {
    if (last == n - 1)return -1;
    if (erase(last, n))return -1;

    for (int c = 0; c < 26; ++c) {
        for (int i = last + 1; i < n; ++i) {
            if ((int) (s[i] - 'a') == c && erase(last, i))return i;
        }
    }
    return n - 1;
}

int bit(int x, int i) {
    return (x >> i) & 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> k >> n;
    vector<vector<int>> er(26);

    for (int i = 0; i < k; ++i) {
        string S;
        cin >> S;
        for (int j = 0; j < k; ++j) {
            if (S[j] == '1')er[j].push_back(i);
        }
    }

    cin >> s;
    cl.resize(n, -1);
    to.resize(n, -1);
    vector<int> last(26, -1);

    for (int i = 0; i < s.size(); ++i) {
        for (int j : er[s[i] - 'a']) {
            cl[i] = max(cl[i], last[j]);
        }
        last[s[i] - 'a'] = i;
    }
    string res;
    for (int m = 0; m < (1 << n); ++m) {
        if (bit(m, 0) == 0)continue;
        vector<int> b;
        for (int i = 0; i < n; ++i)if (bit(m, i))b.push_back(i);
        b.push_back(n);
        bool bad = false;
        for (int i = 1; i < b.size(); ++i)if (!erase(b[i - 1], b[i]))bad = true;
        string r2;
        for(int i = 0; i < n; ++i)if(bit(m, i))r2.push_back(s[i]);
        if(!bad && res.empty())res = r2;
        if(!bad)res = min(res, r2);
    }
    cout << res;
    return 0;
//    int l = 0;
//    string res;
//    res.push_back(s[0]);
//    while (true) {
//        l = solve(l);
//        if (l == -1)break;
//        res.push_back(s[l]);
//    }
//    cout << res;
}
