#include <bits/stdc++.h>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char> > > a(n);
    vector<vector<int> > cnt(m);
    vector<set<int> > help(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            char c;
            cin >> x >> c;
            --x;
            a[i].push_back({x, c});
            cnt[x].push_back(i);
            if (c != s[x])
                help[i].insert(x);
        }
    }
    for (int i = 0; i < m; ++i) {
        if (cnt[i].empty()) {
            cout << -1;
            return 0;
        }
    }
    queue<int> q;
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (help[i].empty())
            q.push(i);
    }
    vector<bool> used(m);
    while(!q.empty()){
        int now = q.front();
        q.pop();
        ans.push_back(now);
        for(int i = 0;i<a[now].size();++i){
            if(!used[a[now][i].first])
            {
                used[a[now][i].first] = 1;
                for(auto u : cnt[a[now][i].first]){
                    if(help[u].find(a[now][i].first) != help[u].end()) {
                        help[u].erase(a[now][i].first);
                        if(help[u].empty())
                            q.push(u);
                    }
                }
            }
        }
    }
    if(ans.size() != n) {
        cout << -1;
        return 0;
    }
    for(int i = 0;i<m;++i){
        if(!used[i])
        {
            cout << -1;
            return 0;
        }
    }
    for(int i = 0;i<n;++i)
        cout << ans[i] + 1 << " ";
}