#include <bits/stdc++.h>

using namespace std;

string findmn(string s1, string s2) {
    if (s1.size() > s2.size())
        swap(s1, s2);
    if(s1.empty())
        return s2;
    for (int i = 0; i < s1.size(); ++i) {
        if (s1[i] < s2[i])
            return s1;
        else if (s1[i] > s2[i])
            return s2;
    }
    return s1;
}

string findmn2(string s1, string s2, char c) {
    if (s1.size() > s2.size())
        swap(s1, s2);
    if(s1.empty())
        return s2;
    for (int i = 0; i < s1.size(); ++i) {
        if (s1[i] < s2[i])
            return s1;
        else if (s1[i] > s2[i])
            return s2;
    }
    if(s1.size() == s2.size())
        return s1;
    if(s2[s1.size()] < c)
        return s2;
    return s1;
}

string findmn3(string s1, string s2, char c) {
    if (s1.size() > s2.size())
        swap(s1, s2);
    if(s1.empty())
        return s2;
    for (int i = 0; i < s1.size(); ++i) {
        if (s1[i] < s2[i])
            return s1;
        else if (s1[i] > s2[i])
            return s2;
    }
    if(s1.size() == s2.size())
        return s1;
    for(int i = s1.size();i<s2.size();++i){
        if(s2[i] > c)
        {
            return s1;
        }
        if(s2[i] < c)
            return s2;
    }
    return s2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<int> > help(k, vector<int>(k));
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            help[i][j] = c - '0';
        }
    string s;
    cin >> s;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = s[i] - 'a';
    vector<vector<int> > dp(n + 2, vector<int>(n + 2, 0));
    for (int i = 1; i < n; ++i) {
        if (help[a[i - 1]][a[i]])
            dp[i][i] = 1;
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 1; l < n - len + 1; ++l) {
//            if(l == 4){
//                cout << 0;
//            }
            int r = l + len - 1;
            for (int i = l - 1; i < r; ++i) {
                if (i == l - 1) {
                    if (dp[l][r - 1] && help[a[i]][a[r]]) {
                        dp[l][r] = 1;
                        break;
                    }
                } else if (help[a[i]][a[r]] && dp[l][i] && (i == r - 1 || dp[i + 1][r - 1])) {
                    dp[l][r] = 1;
                    break;
                }
            }
        }
    }
    vector<vector<string>> ans(n, vector<string> (k + 1));
    for(int i = 0;i<=k;++i)
        ans[0][i] = s[0];
    for(int i = 1;i<n;++i){
        for(int j = 1;j<=k;++j){
            for(int p = 0;p<i;++p){
                if(p == i - 1 || dp[p + 1][i - 1]) {
                    int hel = 0;
                    if(j - 1 == a[i])
                        ans[i][j] = findmn3(ans[i][j], ans[p][a[i] + 1] + s[i], char('a' + j - 1));
                    else if (j - 1 >= a[i])
                        ans[i][j] = findmn2(ans[i][j], ans[p][a[i] + 1] + s[i], char('a' + j - 1));
                    else
                        ans[i][j] = findmn(ans[i][j], ans[p][a[i] + 1] + s[i]);
                }
            }
        }
    }
    string answer = s;
    for (int i = 0; i < n; ++i) {
        for(int j = 1;j<=k;++j) {
            if (i == n - 1 || dp[i + 1][n - 1])
                answer = findmn(ans[i][j], answer);
        }
    }
    cout << answer << endl;
}/*
 * 3 7 010001100 abacaba
 * 3 10
110
010
101
cabbcbaacc

 3 10
110
010
101
aabbccbbcc
 */