#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MX = 2e18;
vector<vector<int>> gr, dok;
vector<int> pred, help;
vector<int> docs;
vector<pair<int, int> > dp;
bool dfs(int v = 0){
    if(gr[v].empty()){
        dp[v] = {docs[v], docs[v]};
        return true;
    }
    vector<pair<int, int>> now;
    for(auto u : gr[v]){
        if(!dfs(u))
            return false;
        now.push_back(dp[u]);
    }
    sort(now.begin(), now.end());
    for(int i = 1;i<now.size();++i){
        if(now[i].first <= now[i - 1].second)
            return false;
    }
    dp[v] = {now[0].first, now.back().second};
    return true;
}

void check(){
    if(dfs()){
        cout << "Yes\n";
        exit(0);
    }
}

void gen(int p = 0){
    if(p == help.size())
    {
        check();
        return;
    }
    for(int i = 0;i<dok[help[p]].size();++i){
        docs[help[p]] = dok[help[p]][i];
        gen(p + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    dp.resize(n);
    gr.resize(n);
    pred.resize(n);
    dok.resize(n);
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            while (k--) {
                int x;
                cin >> x;
                --x;
                gr[i].push_back(x);
                pred[x] = i;
            }
        } else {
            int k;
            cin >> k;
            help.push_back(i);
            while (k--) {
                int x;
                cin >> x;
                dok[i].push_back(x);
            }
        }
    }
    docs.resize(n);
    gen();
    cout << "No\n";
}