#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <bitset>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
//#define int ll

bool check(const set<int>& need, bitset<100'000> & tek) {
	for (const int& i : need)
		if (!tek[i])
			return 0;
	return 1;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<set<int>> need(n), del(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		int in;
		char ch;
		for (int j = 0; j < k; ++j) {
			cin >> in >> ch;
			--in;
			if (s[in] == ch) {
				del[i].emplace(in);
			}
			else {
				need[i].emplace(in);
			}
		}
	}
	bitset<100'000> tek;
	vector<bool> u(n);
	vector<int> ans;
	for (int i = 0; i < n; ++i) {
		bool f = false;
		for (int j = 0; j < n; ++j) {
			if (u[j])
				continue;
			if (need[j].empty()) {
				f = true;
				for (const int& i : del[j]) {
					if (!tek[i]) {
						for (int j1 = 0; j1 < n; ++j1) {
							need[j1].erase(i);
							if (j != j1)
								del[j1].erase(i);
						}
						tek[i] = 1;
					}
				}
				ans.emplace_back(j + 1);
				u[j] = 1;
				break;
			}
		}
		if (!f) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < m; ++i)
		if (!tek[i]) {
			cout << -1;
			return 0;
		}
	for (int& i : ans)
		cout << i << " ";
	return 0;
}