#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <bitset>
#include <set>

using namespace std;

//#define int ll

bool check(const set<int>& need, bitset<100'000> & tek) {
	for (const int& i : need)
		if (!tek[i])
			return 0;
	return 1;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);	
	cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<bitset<100'000>> need(n), del(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		int in;
		char ch;
		for (int j = 0; j < k; ++j) {
			cin >> in >> ch;
			--in;
			if (s[in] == ch) {
				del[i][in] = 1;
			}
			else {
				need[i][in] = 1;
			}
		}
	}
	bitset<100'000> tek;
	set<int> ord;
	for (int i = 0; i < n; ++i)
		ord.emplace(i);
	vector<int> ans;
	for (int i = 0; i < n; ++i) {
		int de = -1;
		for (int j : ord) {
			if ((need[j] | tek) == tek) {
				tek |= del[j];
				ans.emplace_back(j + 1);
				break;
			}
		}
		if (de == -1) {
			cout << -1;
			return 0;
		}
		ord.erase(de);
	}
	for (int i = 0; i < m; ++i)
		if (!tek[i]) {
			cout << -1;
			return 0;
		}
	for (int& i : ans)
		cout << i << " ";
	return 0;
}