#include <iostream>
#include <algorithm>
#include <vector>
#include <deque>

using namespace std;

#define v vector

int n;

v<v<int>> g;
v<int> pr, tout;
v<v<int>> lst;
v<int> ch;
v<v<int>> st;
v<int> z;

int cnt = 0;

void dfs(int i) {
    for (auto j : g[i]) {
        dfs(j);
    }
    tout[i] = cnt++;
}

void init() {
    cin >> n;
    g.resize(n);
    pr.resize(n, -1);
    lst.resize(n);
    tout.resize(n);
    for (int i = 0; i < n; i++) {
        int tp; cin >> tp;
        if (tp == 1) {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int to; cin >> to; to--;
                g[i].push_back(to);
                pr[to] = i;
            }
        } else {
            int m; cin >> m;
            lst[i].resize(m);
            for (int j = 0; j < m; j++) cin >> lst[i][j];
            z.push_back(i);
        }
    }
    ch.resize(n, -1);
}

int cur;

bool cmp(int i, int j) {
    return st[g[cur][i]][0] < st[g[cur][j]][0];
}

bool cmp2(int i, int j) {
    return tout[i] < tout[j];
}

bool check(v<int> &arr) {
    for (int i = 0; i < arr.size() - 1; i++) {
        if (arr[i] > arr[i + 1]) return false;
    }
    return true;
}

v<v<int>> perm_list;
deque<int> q;

bool proccess() {
    st.clear();
    st.resize(n);
    perm_list.clear();
    perm_list.resize(n);
    for (auto j : z) {
        q.push_back(j);
    }
    for (auto i : q) {
        if (g[i].size() == 0) {
            st[i].push_back(lst[i][ch[i]]);
        } else {
            v<int> perm(g[i].size());
            for (int j = 0; j < g[i].size(); j++) perm[j] = j;
            cur = i;
            sort(perm.begin(), perm.end(), cmp);
            v<int> total;
            for (auto j : perm) {
                for (auto num : st[g[i][j]]) {
                    total.push_back(num);
                }
            }
            if (check(total)) {
                st[i] = total;
                perm_list[i] = perm;
            } else {
                return false;
            }
        }
    }
    return true;
}

bool finish = false;

void gen(int i) {
    if (finish) return;
    if (i == n) {
        if (proccess()) {
            finish = true;
        }
        return;
    }
    if (lst[i].size() == 0) {
        gen(i + 1);
        return;
    }
    for (int j = 0; j < lst[i].size(); j++) {
        ch[i] = j;
        gen(i + 1);
        if (finish) return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init();
    dfs(0);
    for (int i = 0; i < n; i++) q.push_back(i);
    sort(q.begin(), q.end(), cmp2);
    gen(0);
    if (finish) {
        cout << "Yes\n";
        for (int i = 0; i < n; i++) {
            if (lst[i].size() == 0) {
                for (auto j : perm_list[i]) {
                    cout << g[i][j] + 1 << " ";
                }
                cout << "\n";
            } else {
                cout << lst[i][ch[i]] << "\n";
            }
        }
    } else {
        cout << "No\n";
    }
    return 0;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
 */

/*
3
1 2 2 3
2 1 1
2 1 2
 */

/*
5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */
