#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
const int N = 1e5 + 10;
vector<int> a[N];
vector<int> ps[N];
int cnt[N], used[N];
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	string s;
	cin >> n >> m >> s;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		while (k--) {
			int pos;
			char c;
			cin >> pos >> c;
			--pos;
			if (c != s[pos]) ps[pos].pb(i), cnt[i]++;
			else a[i].pb(pos);
		}
	}
	set<pair<int, int>> st;
	for (int i = 0; i < n; i++)
		st.insert({ cnt[i], i });
	vector<int> ans;
	while (cap(st)) {
		auto e = *st.begin();
		if (e.first) {
			cout << "-1\n";
			return 0;
		}
		st.erase(st.begin());
		int i = e.second;
		ans.pb(i + 1);
		for (int x : a[i]) if (!used[x]) {
			used[x] = 1;
			for (int j : ps[x]) {
				st.erase({ cnt[j], j });
				--cnt[j];
				st.insert({ cnt[j], j });
			}
		}
	}
	for (int i = 0; i < m; i++) if (!used[i]) {
		cout << "-1\n";
		return 0;
	}
	for (int i : ans) cout << i << ' ';
	return 0;
}
/*
3 4  
glhf 
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/