#include <iostream>
#include <string>
#include <queue>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int k, n; cin >> k >> n;
    vector<int> len(n);
    vector t(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s; cin >> s;
        for (int j = 0; j < k; ++j) t[i][j] = s[j] == '1';
    }

    string s; cin >> s;
    vector<int> dp(n, 0);
    vector<vector<int>> go(n);
    for (int i = 1; i < n; ++i) {
        dp[i] = i;
        int j = i - 1;
        while(t[s[j]-'a'][s[i]-'a'] == 0 && j != dp[j]) {
            j = dp[j];
        }
        if (t[s[j]-'a'][s[i]-'a']) dp[i] = j;
        if (dp[i] < i) {
            int j = dp[i];
            while (true) {
                go[j].push_back(i+1);
                if (j == dp[j]) break;
                j = dp[j];
            }
        }
    }

    for (int i = 1; i <= n; ++i) go[i-1].push_back(i);

    string ans;
    vector<int> pos({0});
    while (true) {
        ans.push_back(s[pos[0]]);

        bool got = false;
        vector<int> nxt;
        char ch = 'z';
        for (int i : pos) {
            for (int j : go[i]) {
                if (j == n) {
                    got = true;
                } else {
                    ch = min(ch, s[j]);
                }
            }
        }

        if (got) break;
        for (int i : pos) {
            for (int j : go[i]) if (s[j] == ch) nxt.push_back(j);
        }
        sort(nxt.begin(), nxt.end());
        nxt.erase(unique(nxt.begin(), nxt.end()), nxt.end());
        nxt.swap(pos);
    }
    cout << ans << endl;
}