#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<int>> del(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        string inp;
        cin >> inp;
        for (int j = 0; j < k; ++j)
            del[i][j] = inp[j] - '0';
    }
    string s;
    cin >> s;
    vector<vector<bool>> can(n, vector<bool>(n, false));
    for (int i = 0; i < n; ++i)
        can[i][i] = true;
    for (int l = 2; l <= n; ++l) {
        for (int st = 0; st <= n - l; ++st) {
            int f = st + l - 1;
            for (int i = st + 1; i <= f; ++i) {
                if (can[st][i - 1] && can[i][f] && del[s[st] - 'a'][s[i] - 'a'] == 1) {
                    can[st][f] = true;
                    break;
                }
            }
        }
    }
    vector<string> suf(n + 1);
    suf[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        string best = suf[i + 1];
        for (int j = i + 2; j <= n; ++j) {
            if (!can[i][j - 1])
                break;
            if (suf[j] < best)
                best = suf[j];
        }
        suf[i] = s[i] + best;
    }
    cout << suf[0] << endl;
}
