#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "map"

using namespace std;
#define all(x) (x).begin(), (x).end()
vector<vector<int>> g;
vector<vector<int>> elems;
vector<int> choise;
bool ok = 0;
pair<int, int> dfs(int v) {
    int l = -1, ll = -1;
    if (g[v].empty())
        return {choise[v], choise[v]};
    for (auto i : g[v]) {
        pair<int, int> d = dfs(i);
        if (ll == -1)
            ll = d.first;
        if (d.first >= l)
            l = d.second;
        else {
            ok = false;
        }
    }
    return {ll, l};
}
void recslv(int v) {
    if (v == elems.size()) {
        ok = 1;
        dfs(0);
        if (ok) {
            cout << "Yes\n";
            for (int i = 0; i < g.size(); ++i) {
                if (g[i].empty())
                    cout << choise[i] << '\n';
                else {
                    for (auto j : g[i])
                        cout << j + 1 << ' ';
                    cout << '\n';
                }
            }
            exit(0);
        }
    } else {
        if (g[v].empty()) {
            for (auto i : elems[v]) {
                choise[v] = i;
                recslv(v + 1);
            }
        } else {
            sort(all(g[v]));
            do {
                recslv(v + 1);
            } while (next_permutation(all(g[v])));
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    elems.assign(n, {});
    choise.assign(n, 0);
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int q;
                cin >> q;
                q--;
                g[i].push_back(q);
            }
        } else {
            int q;
            cin >> q;
            while (q--) {
                int v;
                cin >> v;
                elems[i].push_back(v);
            }
        }
    }
    recslv(0);
    cout << "No\n";
}
