#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

//const int N = 5e5 + 100, K = 26, INF = 1e18;
const int N = 1e3 + 100, K = 26, INF = 1e18;

int bit(int a, int n) {
    return (a >> n) & 1;
}

int k, n, a[26][26];
string s, ans, dp[N][N];
bool g[N][N];

int get(int l, int r) {
    if (l > r) return true;
    return g[l][r];
}

void solve() {
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
    if (k <= 2) {
        ans = s[0];
        char l = s[0];
        for (int i = 1; i < n; i++) {
            if (s[i] == 'a' || !a[l - 'a'][s[i] - 'a']) {
                ans += s[i];
                l = s[i];
            }
        }
        int cnta = 0, cntb = 0;
        for (int i = 0; i < ans.size(); i++) {
            if (ans[i] == 'a') cnta++;
            else cntb++;
        }
        cout << ans[0];
        for (int i = 1; i < ans.size(); i++) {
            if (ans[i - 1] == 'a') cnta--;
            else cntb--;
            if ((cnta == 0 || a[s[i - 1] - 'a'][0]) && (cntb == 0 || a[s[i - 1] - 'a'][1])) {
                break;
            } else {
                cout << ans[i];
            }
        }
        return;
    }
    for (int len = 0; len < n - 1; len++) {
        for (int i = 1; i < n - len; i++) {
            int j = i + len;
            if (i == j) {
                if (a[s[i - 1] - 'a'][s[i] - 'a']) {
                    g[i][j] = true;
                }
            } else {
                for (int h = i; h <= j; h++) {
                    if (a[s[h - 1] - 'a'][s[j] - 'a'] && get(h, j - 1) && get(i, h - 1)) {
                        g[i][j] = true;
                        break;
                    }
                }
            }
        }
    }
    dp[0][0] = s[0];
    for (int i = 1; i < n; i++) {
        for (int h = 1; h < n; h++) {
            for (int j = i - 1; j >= 0; j--) {
                if (get(j + 1, i - 1) && !dp[j][h - 1].empty()) {
                    string u = dp[j][h - 1];
                    u += s[i];
                    if (dp[i][h].empty() || dp[i][h] > u) {
                        dp[i][h] = u;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int h = 0; h < n; h++) {
            if (!dp[i][h].empty() && get(i + 1, n - 1) && (ans.empty() || ans > dp[i][h])) {
                ans = dp[i][h];
            }
        }
    }
    cout << ans;
}