#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <queue>



#define ll long long
#define all(a) a.begin(), a.end()


using namespace std;


int n, m;
string s;
vector<vector<int>> gd;
vector<vector<int>> bd;
vector<vector<int>> bd_hr;
vector<bool> usd;
vector<int> bd_cnt;
vector<int> res;



int32_t main() {
	cin >> n >> m;
	cin >> s;
	gd.resize(n);
	bd.resize(n);
	bd_hr.resize(m);
	bd_cnt.resize(n);
	usd.resize(m);
	queue<int> q;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			if (s[a] == c) {
				gd[i].push_back(a);
			}
			else {
				bd[i].push_back(a);
				bd_hr[a].push_back(i);
				bd_cnt[i] += 1;
			}
		}
		if (bd_cnt[i] == 0) {
			q.push(i);
		}
	}
	while (!q.empty()) {
		int x = q.front();
		q.pop();
		res.push_back(x);
		for (auto c : gd[x]) {
			if (!usd[c]) {
				usd[c] = true;
				for (auto y : bd_hr[c]) {
					bd_cnt[y] -= 1;
					if (bd_cnt[y] == 0) {
						q.push(y);
					}
				}
			}
		}
	}
	if (res.size() < n) {
		cout << -1 << "\n";
	}
	else {
		for (auto c : res) {
			cout << c + 1 << " ";
		}
		cout << "\n";
	}
	return 0;
}

/*
1 1
a
1 1 a
*/

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/

/*
2 2
aa
2 1 a 2 b
2 1 b 2 a
*/