#include <iostream>
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;

vvi matrix;
int can_you_delete(string &a, int l, int r, vi last_sym){
    if (r - l <= 1){
        return 1;
    }
    string cur = "";
    for (int i = l + 1; i < r; i++){
        cur += a[i];
    }
    string ans;
    while (cur.length()){
        if (ans.size() && matrix[cur.back() - 'a'][ans.back() - 'a']){
            ans.pop_back();
        }else{
            ans += cur.back();
            cur.pop_back();
        }
    }
    while (ans.size() && last_sym[ans.back() - 'a']){
        ans.pop_back();
    }
    return ans.size() == 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k, n;
    cin >> k >> n;
    matrix = vvi (k, vi (k));
    for (int i = 0; i < k; i++){
        string pos;
        cin >> pos;
        for (int j = 0; j < k; j++){
            matrix[i][j] = pos[j] - '0';
        }
    }
    string main;
    cin >> main;
    vvi indexes(k);
    for (int i = 0; i < n; i++){
        indexes[main[i] - 'a'].push_back(i);
    }
    for (int i = 0; i < k; i++){
        reverse(indexes[i].begin(), indexes[i].end());
        if (indexes[i].back() == 0){
            indexes[i].pop_back();
        }
    }
    string rezult;
    int last_ind = 0;
    rezult += main[0];
    for (int i = 1; i < n; i++){
        int last = rezult[rezult.size() - 1] - 'a';
        if (can_you_delete(main, last_ind, main.size(), matrix[last])){
            break;
        }
        int gr = INT_MAX;
        for (int aim = 0; aim < k; aim++){

            for (auto item : indexes[aim])
                if (can_you_delete(main, last_ind, item, matrix[last])){
                    gr = item;
                    break;
                }

        }

        for (int j = 0; j < k; j++){
            while (indexes[j].size() && indexes[j].back() <= gr) {
                indexes[j].pop_back();
            }
        }

        rezult += main[gr];
        last_ind = gr;
    }
    cout << rezult << endl;
    return 0;
}