#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
using namespace std;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; (i) < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; (i) >= 0; i--)

const int N = 510;
vector<int> g[N];
vector<int> u[N];
int dp[N][N];

int curdp[N];
int ndp[N];
int suf[N];

void f(int v, vector<int> order) {
	memcpy(curdp, dp[g[v][order[0]]], sizeof(curdp));
	for (int i = 1; i < order.size(); i++) {
		int k = g[v][order[i]];
		for (auto& i : ndp) i = N;
		rforn(j, N) {
			suf[j] = dp[k][j];
			if (j < N - 1) suf[j] = min(suf[j], suf[j + 1]);
		}
		forn(j, N) {
			ndp[j] = N;
			if (curdp[j] < N - 1) {
				ndp[j] = suf[curdp[j] + 1];
			}
		}
		memcpy(curdp, ndp, sizeof(ndp));
	}
	memcpy(dp[v], curdp, sizeof(curdp));
}

void r(int v, vector<int> cur = vector<int>()) {
	if (cur.size() == g[v].size()) {
		f(v, cur);
		return;
	}
	vector<bool> used(g[v].size(), false);
	for (auto i : cur) used[i] = true;
	forn(i, g[v].size()) {
		if (!used[i]) {
			cur.push_back(i);
			r(v, cur);
			cur.pop_back();
		}
	}
}

void dfs(int v = 0) {
	if (!g[v].size()) {
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
	}
	r(v);
}

int main() {
	fastio;
	int n;
	cin >> n;
	vector<int> z;
	forn(i, n) {
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			g[i].resize(k);
			forn(j, k) {
				cin >> g[i][j];
				g[i][j]--;
			}
		}
		else {
			int m;
			cin >> m;
			u[i].resize(m);
			forn(j, m) {
				cin >> u[i][j];
				z.push_back(u[i][j]);
			}
		}
	}

	for (auto& i : dp) {
		for (auto& j : i) {
			j = N;
		}
	}
	sort(all(z));
	forn(i, n) {
		if (u[i].size()) {
			for (auto j : u[i]) {
				dp[i][j] = j;
			}
		}
	}
	dfs();
	for (auto i : dp[0]) {
		if (i != N) {
			cout << "Yes\n";
			return 0;
		}
	}
	cout << "No\n";
	return 0;
}