#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;
typedef vector<int> vi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = (int) 1e5 + 10;

bool used[N];
bool need[N];

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<map<int, char>> cards(n);
    for (auto &mp : cards) {
        int k;
        cin >> k;
        forn(i, k) {
            int a;
            char c;
            cin >> a >> c;
            a--;
            mp[a] = c;
        }
    }
    vi p(n);
    iota(all(p), 0);
    do {
        bool ok = true;
        vector<bool> used(m);
        for (auto& i : p) {
            for (auto& [pos, val] : cards[i]) {
                ok &= used[pos] || s[pos] == val;
                used[pos] = true;
            }
        }
        if (ok && count(all(used), false) == 0) {
            for (auto& i : p) {
                cout << i + 1 << ' ';
            }
            return ;
        }
    } while (next_permutation(all(p)));
    cout << -1 << nl;
}

signed main() {
    IO();
    Solve();
    return 0;
}