#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;

const char el = '\n';
const int inf = 1000'000'000;

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define firn(i, n) for (int i = 1; i < (int)n; i++)
#define x first
#define y second

mt19937 rnd(time(nullptr));

const int K = 27, N = 500'002;
int g[K][K], d[N][2 * K], t[N][2 * K];
vector<int> p[K];
vector<int> suffix_array(string s) {
    s += char('a' - 1);
    int n = (int)s.size();
    vector<int> p(n), c(n), cnt(256);
    forn(i, n)
        cnt[s[i]]++;
    firn(i, 256)
        cnt[i] += cnt[i - 1];
    forn(i, n)
        p[--cnt[s[i]]] = i;
    int cls = 1;
    firn(i, n) {
        if (s[p[i - 1]] != s[p[i]])
            cls++;
        c[p[i]] = cls - 1;
    }
    for (int h = 0; (1 << h) < n; h++) {
        vector<int> pn(n), cn(n);
        forn(i, n) {
            pn[i] = p[i] - (1 << h);
            if (pn[i] < 0) pn[i] += n;
        }
        cnt.assign(cls, 0);
        forn(i, n)
            cnt[c[i]]++;
        firn(i, cls)
            cnt[i] += cnt[i - 1];
        for (int i = n - 1; i >= 0; i--)
            p[--cnt[c[pn[i]]]] = pn[i];
        cn[p[0]] = 0;
        cls = 1;
        firn(i, n) {
            int mid1 = (p[i - 1] + (1 << h)) % n, mid2 = (p[i] + (1 << h)) % n;
            if (c[p[i]] != c[p[i - 1]] || c[mid1] != c[mid2])
                cls++;
            cn[p[i]] = cls - 1;
        }
        c = cn;
    }
    return p;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k, n;
    cin >> k >> n;
    forn(i, k) forn(j, k) {
            char c;
            cin >> c;
            g[i][j] = c - '0';
        }
    string s;
    cin >> s;
    auto P = suffix_array(s);
    vector<int> l(n + 1, -1);
    forn(i, n) {
        int ls = -1;
        forn(j, K) {
            if (g[j][s[i] - 'a'] && !p[j].empty())
                ls = max(ls, p[j].back());
        }
        forn(j, K) {
            while(!p[j].empty() && p[j].back() > ls)
                p[j].pop_back();
        }
        p[s[i] - 'a'].push_back(i);
        l[i] = ls;
    }
    vector<int> ans(n + 1, n);
    vector<int> stack(1, n), pos(n + 1);
    forn(i, n + 1) pos[P[i]] = i;
    for (int i = n - 1; i >= 0; i--) {
        while(l[stack.back()] >= i) stack.pop_back();
        ans[i] = i + 1;
        for (int j = i + 1; ; j++) {
            if (pos[j] < pos[ans[i]])
                ans[i] = j;
            if (l[j] < i) break;
        }
        stack.push_back(i);
    }
    for (int i = 0; i < n; i = ans[i])
        cout << s[i];
    cout << endl;
    system("pause");
    return 0;
}
