#include <bits/stdc++.h>

//#define int long long
#define ll long long
#define all(v) v.begin(), v.end()

using namespace std;

const int maxn = 5e5 + 3;
const int maxk = 50;
const int L = 19;
const int p = 29;

void make(vector<vector<bool>> &field, int x, int y) {
    int n = field.size();
    int m = field[0].size();
    for (int i = x; i < n; ++i) {
        for (int j = y; j < m; ++j) {
            field[i][j] = true;
        }
    }
}

int count_e(vector<vector<bool>> &field, int x, int y) {
    int n = field.size();
    int m = field[0].size();
    int ans = 0;
    for (int i = x; i < n; ++i) {
        for (int j = y; j < m; ++j) {
            ans += !field[i][j];
        }
    }
    return ans;
}

signed main() {
    cin.tie();
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    int n;
    cin >> n;
    int k;
    cin >> k;
    int m;
    cin >> m;
    if (t == 1) {

        string mes;
        cin >> mes;
        int b = 0;
        int g = 0;
        while (b < m) {
            vector<vector<bool>> field(m, vector<bool>(m, false));
            int part = g % 2;
            while (true) {
                if (part == 0) {
                    int x = 0, y = 0;
                    for (int i = 0; i < n && b < m; ++i) {
                        for (int j = 0; j < n; ++j) {
                            int it = i - j;
                            if (it == 0) continue;
                            bool s = it < 0;
                            if (mes[b] == '1' == s && count_e(field, i, j) < count_e(field, x, y)) {
                                x = i, y = j;
                            }
                        }
                    }
                    cout << x + 1 << " " << y + 1 << endl;
                    make(field, x, y);
                    ++b;
                } else {
                    int x = 0, y = 0;
                    cin >> x >> y;
                    --x, --y;
                    make(field, x, y);
                }
                if (count_e(field, 0, 0) == 0) {
                    break;
                }
                part++;
                part %= 2;
            }
            g++;
        }
        cout << 0 << endl;
        exit(0);
    } else {
        int q;
        cin >> q;
        int g = 0;
        string res;
        int who = 0;
        for (int i = 0; i < q; ++i) {
            int x, y;
            cin >> x >> y;
            --x, --y;
            if (x == 0 && y == 0) {
                g++;
                who = g % 2;
            } else if (who == 0) {
                bool s = x - y < 0;
                if (s) res += '1';
                else res += '0';
            }
            who++;
            who %= 2;
        }
        cout << res << endl;
    }
    return 0;
}