#include <bits/stdc++.h>

//#define int long long
#define ll long long
#define all(v) v.begin(), v.end()

using namespace std;

const int maxn = 100;


vector<int> m[maxn];
vector<int> graph[maxn];

int res[maxn];
vector<int> a[maxn];

bool dfs(int v, int l = 0, int r = 100000) {
    if (graph[v].empty()) {
        for (auto x: m[v]) {
            if (l <= x && x < r) {
                res[v] = x;
                return true;
            }
        }
        return false;
    } else {
        if (graph[v].size() == 1) {
            return dfs(graph[v][0], l, r);
        } else {
            int u0 = graph[v][0];
            int u1 = graph[v][1];
            for (int mid = l; mid <= r; ++mid) {
                if (dfs(u0, l, mid) && dfs(u1, mid, r)) {
                    a[v] = {u0, u1};
                    return true;
                }
            }
            swap(u0, u1);
            for (int mid = l; mid <= r; ++mid) {
                if (dfs(u0, l, mid) && dfs(u1, mid, r)) {
                    a[v] = {u0, u1};
                    return true;
                }
            }
            return false;
        }
    }
}


signed main() {
    cin.tie();
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int u;
                cin >> u;
                --u;
                graph[i].push_back(u);
            }
        } else {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int u;
                cin >> u;
                m[i].push_back(u);
            }
        }
    }
    if (dfs(0)) {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            if (graph[i].empty()) {
                cout << res[i] << "\n";
            } else {
                for (int u: a[i]) {
                    cout << u + 1 << " ";
                }
                cout << "\n";
            }
        }
    } else {
        cout << "No\n";
    }
    return 0;
}