#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a)
{
    for (auto& x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int smallN = 2004;
const int maxN = 500005;
const int maxA = 26;
int A, n;
char s[maxN];
bool C[maxA][maxA];
int nxt[maxN];

int last1[maxA][smallN], last2[maxA][smallN];
bool dp[maxA][smallN][smallN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> A >> n;
    for (int x = 0; x < A; ++x)
    {
        string t;
        cin >> t;
        for (int y = 0; y < A; ++y)
            C[x][y] = t[y] - '0';
    }
    cin >> s;
    for (int i = 0; i < n; ++i)
        s[i] -= 'a';
    s[n] = 0;

    for (int i = n - 1; i >= 1; --i)
    {
        for (int c = 0; c < A; ++c)
            if (C[c][s[i]])
            {
                last2[c][i] = last1[c][i + 1];
                last1[c][i] = i;
            }
            else
            {
                last2[c][i] = last2[c][i + 1];
                last1[c][i] = last1[c][i + 1];
            }
    }

    for (int i = 1; i <= n; ++i)
        for (int c = 0; c < A; ++c)
            dp[c][i][i - 1] = 1;
    for (int l = 0; l < n; ++l)
    {
        for (int c = 0; c < A; ++c)
        {
            if (C[c][s[l]])
                dp[c][l][l] = 1;
        }
    }
    for (int len = 2; len <= n - 1; ++len)
    {
        for (int l = 1, r = len; r < n; ++l, ++r)
        {
            for (int c = 0; c < A; ++c)
            {
                if (last1[c][l] != l) continue;
                int i = last2[c][l - 1];
                if (i > r)
                {
                    dp[c][l][r] = dp[s[i]][l + 1][r];
                }
                else
                {
                    dp[c][l][r] = dp[s[i]][l + 1][i - 1] && dp[c][i][r];
                }
            }
        }
    }/**/
    memset(nxt, 255, sizeof nxt);
    nxt[n] = n;
    for (int i = n - 1; i >= 0; --i)
    {
        int min_j = -1;
        for (int j = n; j > i; --j)
        {
            if (nxt[j] != -1 && dp[s[i]][i + 1][j - 1])
            {
                if (min_j == -1 || s[j] < s[min_j])
                    min_j = j;
            }
        }
        nxt[i] = min_j;
    }
//    mdebug(nxt, n + 1); exit(0);
    for (int i = 0; i < n; i = nxt[i])
        cout << (char)(s[i] + 'a');
    cout << '\n';

    return 0;
}