#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1000;

int n;
vector<int> t(MAXN);
vector<int> upd[MAXN];
vector<int> g[MAXN];
vector<int> mn(MAXN), mx(MAXN);
vector<int> ans[MAXN];

bool dfs(int v) {
    if (g[v].size() == 0) {
        ans[v].push_back(mn[v] - 1);
        return true;
    }

    if (g[v].size() == 1) {
        if (dfs(g[v][0])) {
            mn[v] = mn[g[v][0]];
            mx[v] = mx[g[v][0]];
            return true;
        } else {
            return false;
        }
    }

    if (!dfs(g[v][0]) || !dfs(g[v][1])) {
        return false;
    }

    int mn1 = mn[g[v][0]];
    int mx1 = mx[g[v][0]];
    int mn2 = mn[g[v][1]];
    int mx2 = mx[g[v][1]];

    if (mn1 < mn2 && mx1 < mn2) {
        ans[v].push_back(g[v][0]);
        ans[v].push_back(g[v][1]);
        return true;
    }

    if (mn2 < mn1 && mx2 < mn1) {
        ans[v].push_back(g[v][1]);
        ans[v].push_back(g[v][0]);
        return true;
    }

    return false;
}

void rec(int i) {
    if (i == n) {
        cerr << "there";
        if (dfs(0)) {
            cout << "Yes";
            /*for (int i = 0; i < n; i++) {
                for (int x : ans[i]) {
                    cout << (x + 1) << " ";
                }
                cout << "\n";
            }*/
            exit(0);
        }

        for (int i = 0; i < n; i++) {
            ans[i].clear();
        }
        return;
    }

    if (t[i] == 1) {
        rec(i + 1);
        return;
    }

    for (int j : upd[i]) {
        mn[i] = j;
        mx[i] = j;
        rec(i + 1);
    }
}

int32_t main() {
    cin >> n;

    for (int i = 0; i < n; i++) {
        int type;
        cin >> type;

        t[i] = type;

        int k;
        cin >> k;

        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;

            if (type == 1) {
                g[i].push_back(x - 1);
            } else {
                upd[i].push_back(x);
            }
        }
    }

    rec(0);
    cout << "No";

    return 0;
}