#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> ans;

vector<int> check(vector<vector<int>> &sons, int v, int p, vector<int> &done)
{
    vector<vector<int>> res;
    for (auto u : sons[v])
        res.push_back(check(sons, u, p, done));
    if ((int)sons[v].size() == 0)
        res.push_back({done[v]});
    sort(res.begin(), res.end());
    vector<int> fin;
    for (int i = 0; i < (int)res.size(); i++)
        for (int j = 0; j < (int)res[i].size(); j++)
            fin.push_back(res[i][j]);
    return fin;
}

bool sorted(vector<int> a)
{
    for (int i = 1; i < (int)a.size(); i++)
        if (a[i - 1] > a[i])
            return false;
    return true;
}


vector<int> make_ans(vector<vector<int>> &sons, int v, vector<int> &done)
{
    vector<pair<vector<int>, int>> res;
    for (auto u : sons[v])
        res.push_back({make_ans(sons, u, done), u});
    if ((int)sons[v].size() == 0)
    {
        ans[v].push_back(done[v]);
        return {done[v]};
    }
    sort(res.begin(), res.end());
    vector<int> fin;
    for (int i = 0; i < (int)res.size(); i++)
        for (int j = 0; j < (int)res[i].first.size(); j++)
            fin.push_back(res[i].first[j]);
    for (int i = 0; i < (int)res.size(); i++)
        ans[v].push_back(res[i].second + 1);
    return fin;
}


void gen(vector<vector<int>> &sons, vector<vector<int>> &prb, vector<int> &cons, int num, bool &fl, vector<int> &done)
{
    if (num == (int)cons.size())
    {
        if (sorted(check(sons, 0, -1, done)))
        {
            make_ans(sons, 0, done);
            fl = true;
        }
        return;
    }
    else
    {
        for (int i = 0; i < prb[cons[num]].size(); i++)
        {
            done[cons[num]] = prb[cons[num]][i];
            gen(sons, prb, cons, num + 1, fl, done);
            if (fl)
                return;
        }
    }
}



int main()
{
    int n; cin >> n;
    ans.resize(n);
    vector<vector<int>> sons(n);
    vector<vector<int>> prb(n);
    vector<int> cons;
    for (int i = 0; i < n; i++)
    {
        int t; cin >> t;
        if (t == 1)
        {
            int k; cin >> k;
            for (int j = 0; j < k; j++)
            {
                int a; cin >> a;
                sons[i].push_back(a - 1);
            }
        }
        else
        {
            cons.push_back(i);
            int m; cin >> m;
            for (int j = 0; j < m; j++)
            {
                int a; cin >> a;
                prb[i].push_back(a);
            }
        }
    }
    bool fl = false;
    vector<int> done(n);
    gen(sons, prb, cons, 0, fl, done);

    if (!fl)
    {
        cout << "No" << endl;
    }
    else
    {
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < (int)ans[i].size(); j++)
                cout << ans[i][j] << " ";
            cout << endl;
        }
    }
    return 0;
}
