#include <bits/stdc++.h>
using namespace std;
const int maxn = 2000, INF = 1e9;
int dp[maxn][maxn];
int help[(1 << 8)];
int m = 0;
int true_imp[1000000];
vector<int> adj[maxn];
vector<int> imp[maxn];

void dfs(int u) {
    for (auto elem : adj[u]) {
        dfs(elem);
    }
    int n = adj[u].size();
    if (n == 0) return;
    for (int j = 0; j < m; ++j) {
        help[0] = j;
        for (int mask = 1; mask < (1 << n); ++mask) {
            help[mask] = INF;
            for (int k = 0; k < n; ++k) {
                if ((mask >> k) & 1) {
                    int jj = help[mask ^ (1 << k)];
                    if (jj == INF) continue;
                    help[mask] = min(help[mask], dp[adj[u][k]][jj]);
                }
            }
        }
        dp[u][j] = help[(1 << n) - 1];
    }
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> imps;
    for (int i = 0; i < n; ++i) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            adj[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> adj[i][j];
                --adj[i][j];
            }
        }
        else {
            m += k;
            imp[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> imp[i][j];
                --imp[i][j];
                imps.push_back(imp[i][j]);
            }
        }
    }
    sort(imps.begin(), imps.end());
    for (int i = 0; i < (int)imps.size(); ++i) true_imp[imps[i]] = i;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) dp[i][j] = INF;
        for (int j = 0; j < (int)imp[i].size(); ++j) {
            imp[i][j] = true_imp[imp[i][j]];
            dp[i][imp[i][j]] = imp[i][j];
        }
        int last = 1e9;
        for (int j = m - 1; j >= 0; --j) {
            last = min(last, dp[i][j]);
            dp[i][j] = last;
        }
    }
    dfs(0);
    if (dp[0][0] == INF) {
        cout << "No\n";
        return 0;
    }
    else {
        cout << "Yes\n";
        return 0;
    }
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92


3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */