#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;

bool check(int n, int m, vi& s, v2i& data, vi& order) {
    for (int c = 0; c < m; ++c) {
        int i = 0;
        while (i < n) {
            if (data[c][order[i]] == s[c])
                break;
            if (data[c][order[i]] != s[c] && data[c][order[i]] != -1) {
                return false;
            }
            ++i;
        }
        if (i == n) {
            return false;
        }
    }
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string ins;
    cin >> ins;
    vi s(m);
    for (int i = 0; i < m; ++i)
        s[i] = ins[i] - 'a';
    v2i data(m, vi(n, -1));
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            data[p - 1][i] = c - 'a';
        }
    }
    vi order(n);
    iota(order.begin(), order.end(), 0);
    do {
        if (check(n, m, s, data, order)) {
            for (auto e : order)
                cout << e + 1 << ' ';
            cout << '\n';
            return 0;
        }
    } while (next_permutation(order.begin(), order.end()));
    cout << "-1\n";
}
