#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int> 
#define ti tuple <int, int, int>
#define mkp make_pair
#define mkt make_tuple
#define F first
#define S second

const int K = 26, N = 10007;

bool ed[K][K];
vector <map <char, pi> > bor;
vector <int> term;
string ans;

void go(int R, int v) {
	if (term[v] <= R)
		return;
	for (auto it : bor[v])
		if (it.S.F <= R) {
			ans.push_back(it.F);
			go(R, it.S.S);
			return;
		}
}

void add(int lay, int v, int val, int n) {
	if (lay == ans.size()) {
		term[v] = val;
		return;
	}
	if (bor[v].find(ans[lay]) == bor[v].end()) {
		bor[v][ans[lay]].S = bor.size();
		bor.push_back(map <char, pi>());
		term.push_back(n);
	}
	bor[v][ans[lay] - 'a'].F = val;
	add(lay + 1, bor[v][ans[lay] - 'a'].S, val, n);
}

void solve() {
	int k, n;
	cin >> k >> n;
	bor.push_back(map<char, pi>());
	term.push_back(n);
	loop(i, k) 
		loop(j, k) {
			char c; cin >> c;
			ed[i][j] = c - '0';
		}
	string s; cin >> s;
	for (int i = n - 1; i >= 0; --i) {
		int R = i + 1;
		string cur = ""; 
		cur.push_back(s[i]);
		for (; R < n; ++R) {
			while (cur.size() > 1 && !ed[cur.back() - 'a'][s[R] - 'a'])
				cur.pop_back();
			if (cur.size() == 1 && !ed[s[i] - 'a'][s[R] - 'a'])
				break;
			cur.push_back(s[R]);
		}
		ans.clear();
		ans.push_back(s[i]);
		go(R, 0);
		add(0, 0, i, n);
	}
	cout << ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

