#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("tune=native")

#define ios ios_base::sync_with_stdio(true);cin.tie(0);cout.tie(0);
#define ll long long
#define len(x) (int)(x.size())

const ll INF = 2e18;

int n, m;
string s;
vector<bool> positions_used;
vector<int> cnt_bad_positions, order;
vector<vector<int>> good_positions, cards_with_bad_position;
deque<int> good_cards;

void read(){
    cin >> n >> m >> s;
    positions_used.resize(m);
    cnt_bad_positions.resize(n);
    good_positions.resize(n);
    cards_with_bad_position.resize(m);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            if(s[--p] != c){
                cards_with_bad_position[p].push_back(i);
                ++cnt_bad_positions[i];
            }else{
                good_positions[i].push_back(p);
            }
        }
        if(!cnt_bad_positions[i]){
            good_cards.push_back(i);
        }
    }
}

void put_card(){
    int card = good_cards.front();
    good_cards.pop_front();
    order.push_back(card);
    for(int p: good_positions[card]){
        if(!positions_used[p]){
            positions_used[p] = true;
            for(int bp: cards_with_bad_position[p]){
                --cnt_bad_positions[bp];
                if(cnt_bad_positions[bp] == 0){
                    good_cards.push_back(bp);
                }
            }
        }
    }
}

void solve(){
    read();
    while(!good_cards.empty()){
        put_card();
    }
    bool allUsed = true;
    for (int i = 0; i < m; ++i) {
        if(!positions_used[i]){
            allUsed = false;
            break;
        }
    }
    if(!allUsed){
        cout << -1 << endl;
        return;
    }
    for (int i = 0; i < n; ++i) {
        cout << order[i] + 1 << " ";
    }
    cout << endl;
}

int main(){
    //freopen("input.txt", stdin, "r")
    //freopen("output.txt", stdout, "w")
    ios;
    solve();
    return 0;
}