#include <bits/stdc++.h>

using namespace std;

bool a[26][26];


int n;
string s;

vector<int> dp_lexmin_next;
vector< vector<int> > upgo;
vector< vector<int> > uphash;
vector<int> pows;

const int POW = 57;
const int MOD = 1000000009;

int lexmin(int i, int j) {
	int origi = i;
	int origj = j;

	int k = 0;
	while(uphash[i][k] == uphash[j][k] && i < n) {
		i = upgo[i][k];
		j = upgo[j][k];
	}
	return s[i] < s[j] ? origi : origj;
}


signed main() {
	int k;
	cin >> k >> n;

	for(int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for(int j = 0; j < k; j++) {
			a[i][j] = s[j] - '0';
		}
	}

	cin >> s;
	s.push_back('\0');

	pows.resize(n + 1);
	pows[0] = 1;
	for(int i = 1; i < pows.size(); i++) {
		pows[i] = (long long)pows[i - 1] * POW % MOD;
	}

	vector<int> dp_can_delete_r(n);
	dp_can_delete_r[n - 1] = n - 1;

	dp_lexmin_next.resize(n);
	dp_lexmin_next[n - 1] = n;

	upgo.resize(n + 1, vector<int>(30));
	uphash.resize(n + 1, vector<int>(30));
	for(int i = 0; i < 30; i++) {
		upgo[n - 1][i] = n;
		upgo[n][i] = n;
		uphash[n - 1][i] = 0;
		uphash[n][i] = 0;
	}

	for(int l = n - 2; l >= 0; l--) {
		dp_lexmin_next[l] = l + 1;
		int r = l;
		while(r + 1 < n && a[s[l] - 'a'][s[r + 1] - 'a']) {
			dp_lexmin_next[l] = lexmin(dp_lexmin_next[l], dp_lexmin_next[r + 1]);
			r = dp_can_delete_r[r + 1];
		}
		dp_can_delete_r[l] = r;

		upgo[l][0] = dp_lexmin_next[l];
		uphash[l][0] = s[dp_lexmin_next[l]];
		for(int i = 1; i < 30; i++) {
			upgo[l][i] = upgo[upgo[l][i - 1]][i - 1];
			uphash[l][i] = (uphash[l][i - 1] + ((1 << (i - 1)) > n ? 0 : (long long)pows[1 << (i - 1)] * uphash[upgo[l][i - 1]][i - 1])) % MOD;
		}
	}

	int i = 0;
	while(i < n) {
		cout << s[i];
		i = dp_lexmin_next[i];
	}
	cout << endl;

	return 0;
}