#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long

using namespace std;

signed main() {
	int n, m; cin >> n >> m;
	vector <vector <pair <int, char>>> a(n);

	string s; cin >> s;

	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int pos; char c; cin >> pos >> c; pos--;
			a[i].push_back({ pos, c });
		}
	}

	vector <int> p(n, -1);
	vector <char> used(n, false);
	for (int i = 0; i < n; i++) {
		int chosen = -1;
		for (int j = 0; j < n && chosen == -1; j++) {
			if (used[j])
				continue;
			bool ok = true;
			for (auto p : a[j]) {
				if (s[p.first] != 0 && s[p.first] != p.second) {
					ok = false;
					break;
				}
			}
			if (ok)
				chosen = j;
		}
		if (chosen == -1) {
			cout << -1;
			return 0;
		}
		used[chosen] = true;
		p[i] = chosen;
		for (auto p : a[chosen]) {
			s[p.first] = 0;
		}
	}

	for (int i = 0; i < m; i++) {
		if (s[i] != 0) {
			cout << -1;
			return 0;
		}
	}

	for (auto x : p) {
		cout << x + 1 << ' ';
	}

	return 0;
}