#include <iostream>
#include <vector>
#include <set>

int main() {
    int32_t n, m;
    std::cin >> n >> m;

    std::string str;
    std::cin >> str;

    std::vector<int32_t>* cards_bad = new  std::vector<int32_t>[n];
    std::vector<int32_t>* cards_good = new  std::vector<int32_t>[n];
    for(int32_t i = 0; i < n; i++) {
        int32_t k;
        std::cin >> k;

        for(int32_t j = 0; j < k; j++) {
            int32_t pos;
            char val;
            std::cin >> pos >> val;
            pos--;

            if(val != str[pos])
                cards_bad[i].push_back(pos);
            else
                cards_good[i].push_back(pos);
        }
    }

    std::vector<int32_t> answer;
    std::set<int32_t> remains;
    for(int32_t i = 0; i < n; i++)
        remains.insert(i);
    bool* states = new bool[m];
    for(int32_t i = 0; i < m; i++)
        states[i] = false;
    for(int32_t i = 0; i < n; i++) {
        int32_t improving = -1;
        for(auto it = remains.begin(); it != remains.end(); it++) {
            bool ok = true;
            for(int32_t j = 0; j < cards_bad[*it].size(); j++)
                if(!states[cards_bad[*it][j]]) {
                    ok = false;
                    break;
                }
            if(ok) {
                improving = *it;
                break;
            }
        }
        if(improving == -1) {
            std::cout << -1;
            return 0;
        }
        for(int32_t j = 0; j < cards_good[improving].size(); j++)
            states[cards_good[improving][j]] = true;
        remains.erase(improving);
        answer.push_back(improving);
    }

    for(int32_t i = 0; i < m; i++)
        if(!states[i]) {
            std::cout << -1;
            return 0;
        }

    for(int32_t i = 0 ;i < n; i++)
        std::cout << answer[i] + 1 << " ";
    return 0;
}
