#include <iostream>
#include <vector>
#include <string>
#define int long long

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<bool> closed(m);
    vector<int> st;
    vector<int> cns(n);
    vector<vector<int>> ns(m);
    vector<vector<int>> can_close(n);
    for (int i(0); i < n; ++i)
    {
        int k;
        cin >> k;
        for (int j(0); j < k; ++j)
        {
            int pos;
            char c;
            cin >> pos >> c;
            pos--;
            if (c != s[pos])
            {
                ns[pos].push_back(i);
                cns[i]++;
            }
            if (c == s[pos]) can_close[i].push_back(pos);
        }
    }
    vector<int> result;
    for (int i(0); i < n; ++i)
    {
        if (cns[i] == 0) st.push_back(i);
    }
    for (int z(0); z < n; ++z)
    {
        if (st.empty())
        {
            cout << -1 << endl;
            return 0;
        }
        int now = st.back();
        st.pop_back();
        result.push_back(now + 1);
        for (int j: can_close[now])
        {
            if (!closed[j])
            {
                closed[j] = true;
                for (int i: ns[j])
                {
                    cns[i]--;
                    if (cns[i] == 0) st.push_back(i);
                }
            }
        }
    }
    bool all = true;
    for (bool i: closed)
    {
        if (!i)
        {
            all = false;
            break;
        }
    }
    if (all)
    {
        for (int i: result) cout << i << ' ';
        cout << endl;
    }
    else cout << -1 << endl;
    return 0;
}
