#include <bits/stdc++.h>

using namespace std;

int cnt(vector<vector<int>> board, pair<int, int> ps) {
    int n = board.size();
    int res = 0;
    for (int i = ps.first; i < n; ++i) {
        for (int j = ps.second; j < n; ++j) {
            if (!board[i][j]) {
                ++res;
            }
        }
    }
    return res;
}

vector<pair<int, pair<int, int>>> all(vector<vector<int>> &board) {
    int n = board.size();
    vector<pair<int, pair<int, int>>> res;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (!board[i][j])
                res.push_back({cnt(board, {i, j}), {i, j}});
        }
    }
    sort(res.begin(), res.end());
    vector<pair<int, pair<int, int>>> res2;
    for (auto i : res) {
        if (res2.empty() || res2.back().first != i.first)
            res2.push_back(i);
    }
    return res2;
}

int fr;

void make_move(vector<vector<int>> &board, pair<int, int> ps) {
    int n = board.size();
    int res = 0;
    for (int i = ps.first; i < n; ++i) {
        for (int j = ps.second; j < n; ++j) {
            if (!board[i][j]) {
                board[i][j] = 1;
                --fr;
            }
        }
    }
}

void cl(vector<vector<int>> &board) {
    int n =  board.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0;  j < n; ++j)
            board[i][j] = 0;
    }
    fr = n * n;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tp, n, k, m;
    cin >> tp >> n >> k >> m;
    fr = n * n;
    if (tp == 1) {
        string s;
        cin >> s;
        vector<vector<int>> board(n, vector<int>(n));
        fr = n * n;
        int _ = 0;
        for (int i = 0; i < m; i += 2) {
            if (_ % 2) {
                int x, y;
                cin >> x >> y;
                --x, --y;
                make_move(board, {x, y});
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
            auto cur = all(board);
            string curs = s.substr(i, 2);
            int val;
            if (curs == "00")
                val = 0;
            else if (curs == "01")
                val = 1;
            else if (curs == "10")
                val = 2;
            else if (curs == "11")
                val = 3;
            if (cur.size() < 4) {
                cout << "1 1" << endl;
                _++;
                cl(board);
                continue;
            } else {
                cout << cur[val].second.first + 1 << ' ' << cur[val].second.second + 1 << endl;
                make_move(board, cur[val].second);
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
            if (_ % 2 == 0) {
                int x, y;
                cin >> x >> y;
                --x, --y;
                make_move(board, {x, y});
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
        }
        if (fr != n * n)
            cout << "1 1\n" << endl;
        cout << 0 << endl;
    } else {
//        assert(false);
        int games;
        cin >> games;
        vector<pair<int, int>> input;
        int ff, ss;
        while (cin >> ff >> ss) input.push_back({ff, ss});
        string answer;
        vector<vector<int>> board(n, vector<int>(n));
        fr = n * n;
        int _ = 0;
        int ind = 0;
        for (int i = 0; i < m; i += 2) {
            if (_ % 2) {
                int x = input[ind].first, y = input[ind].second;
                --x, --y;
                make_move(board, {x, y});
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
            auto cur = all(board);
            if (cur.size() < 4) {
                int x = input[ind].first, y = input[ind].second;
                --x, --y;
                make_move(board, {x, y});
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                } else
                    assert(false);
            } else {
                int x = input[ind].first, y = input[ind].second;
                --x, --y;
                make_move(board, {x, y});
                if (cur[0].second == make_pair(x, y)) answer += "00";
                if (cur[1].second == make_pair(x, y)) answer += "01";
                if (cur[2].second == make_pair(x, y)) answer += "10";
                if (cur[3].second == make_pair(x, y)) answer += "11";
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
            if (_ % 2) {
                int x = input[ind].first, y = input[ind].second;
                --x, --y;
                make_move(board, {x, y});
                if (fr == 0) {
                    cl(board);
                    ++_;
                    continue;
                }
            }
        }
        while (answer.size() > m)
            answer.pop_back();
        cout << answer << endl;
    }
    return 0;
}