#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <queue>
#include <string>

using namespace std;

typedef long long ll;

const ll N = 2e5;

bool used[N], vis[N];
vector <pair <ll, char>> v[N];
vector <ll> e[N];
ll sz[N];
vector <ll> ans;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	queue <ll> q;
	for (ll i = 0; i < n; i++) {
		ll k; cin >> k;
		v[i].resize(m);
		for (ll j = 0; j < k; j++) {
			cin >> v[i][j].first >> v[i][j].second;
			v[i][j].first--;
			if (s[v[i][j].first] != v[i][j].second) {
				sz[i]++;
				e[v[i][j].first].push_back(i);
			}
		}
		if (sz[i] == 0) {
			q.push(i);
		}
	}
	while (!q.empty()) {
		ll a = q.front(); q.pop();
		ans.push_back(a);
		for (ll i = 0; i < v[a].size(); i++) {
			if (used[v[a][i].first]) {
				continue;
			}
			used[v[a][i].first] = 1;
			for (ll j = 0; j < e[v[a][i].first].size(); j++) {
				sz[e[v[a][i].first][j]]--;
				if (sz[e[v[a][i].first][j]] == 0) {
					q.push(e[v[a][i].first][j]);
				}
			}
		}
	}
	if (ans.size() != n) {
		cout << -1;
		return 0;
	}
	for (ll i = 0; i < n; i++) {
		ll p = ans[i];
		for (ll j = 0; j < v[p].size(); j++) {
			if (vis[v[p][j].first]) {
				continue;
			}
			vis[v[p][j].first] = 1;
			if (s[v[p][j].first] != v[p][j].second) {
				cout << -1;
				return 0;
			}
		}
	}
	for (ll i = 0; i < n; i++) {
		cout << ans[i] + 1 << " ";
	}
}