#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <stack>

using namespace std;

typedef int ll;

const ll N = 200;
const ll inf = 1e18;

bool used[50][50];
ll D[10];

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
	D[0] = 1;
	for (ll i = 1; i < 10; i++) {
		D[i] = 2 * D[i - 1];
	}
	ll test; cin >> test;
	ll n, k, m;
	cin >> n >> k >> m;
	if (test == 2) {
		string ans;
		ll igr; cin >> igr;
		ll cur = 0;
		for (ll i = 0; i < igr; i++) {
			for (ll j = 0; j < N; j++) {
				ll a, b;
				cin >> a >> b;
				if (a == 1 && b == 1) {
					break;
				}
				a--; b--;
				if (i % 2 == 0 && j % 2 == 0) {
					for (ll h = 0; h < 5; h++) {
						ans.push_back(((a >> h) & 1) + '0');
					}
				}
				if (i % 2 == 1 && j % 2 == 1) {
					for (ll h = 0; h < 5; h++) {
						ans.push_back(((a >> h) & 1) + '0');
					}
				}
			}
		}
		cout << ans;
		return 0;
	}
	string s; cin >> s;
	while (s.length() % 5 != 0) {
		s.push_back('0');
	}
	ll cur = 0;
	ll t = 0;
	while (cur < s.length()) {
		for (ll i = 0; i < 40; i++) {
			for (ll j = 0; j < 40; j++) {
				used[i][j] = 0;
			}
		}
		if (t % 2 == 1) {
			ll a, b;
			cin >> a >> b; a--; b--;
			for (ll i = a; i < 32; i++) {
				for (ll j = b; j < 32; j++) {
					used[i][j] = 1;
				}
			}
		}
		while (1) {
			if (cur >= s.length()) {
				cout << 1 << " " << 1 << '\n';
				cout.flush();
				break;
			}
			ll k = 0;
			for (ll i = cur; i < cur + 5; i++) {
				k += D[i - cur] * (s[i] - '0');
			}
			bool g = 0;
			for (ll i = 31; i >= 0; i--) {
				if (!used[k][i]) {
					cout << k + 1 << " " << i + 1 << '\n';
					for (ll h1 = k; h1 < 32; h1++) {
						for (ll h2 = i; h2 < 32; h2++) {
							used[h1][h2] = 1;
						}
					}
					cur += 5;
					cout.flush();
					g = 1;
					break;
				}
			}
			if (!g) {
				cout << 1 << " " << 1 << '\n';
				cout.flush();
				break;
			}
			ll a, b; cin >> a >> b;
			for (ll i = a - 1; i < 32; i++) {
				for (ll j = b - 1; j < 32; j++) {
					used[i][j] = 1;
				}
			}
			if (a == 1 && b == 1) {
				break;
			}
		}
		t++;
	}
	if (t % 2 == 1){
		ll a, b; cin >> a >> b;
	}
	cout << 0;
	return 0;
}