#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <stack>

using namespace std;

typedef int ll;

const ll N = 200;
const ll inf = 1e18;

ll n;
vector <ll> e[N];
vector <ll> u[N];
vector <ll> A[N];
vector <ll> ans[N];
vector <ll> kons;
bool kon[N];

bool cmp(pair<vector <ll>, ll> a, pair<vector <ll>, ll> b) {
	return a.first[0] < b.first[0];
}

bool dfs(ll x) {
	if (e[x].size() == 0) {
		return 1;
	}
	pair<vector <ll>, ll> v[8];
	for (ll i = 0; i < e[x].size(); i++) {
		bool ok = dfs(e[x][i]);
		if (!ok) {
			return 0;
		}
		v[i].first = A[e[x][i]];
		v[i].second = e[x][i];
	}
	sort(v, v + e[x].size(), cmp);
	for (ll i = 0; i < e[x].size(); i++) {
		for (ll j = 0; j < v[i].first.size(); j++) {
			A[x].push_back(v[i].first[j]);
		}
	}
	for (ll i = 0; i < A[x].size() - 1; i++){
		if (A[x][i] > A[x][i + 1]) {
			return 0;
		}
	}
	for (ll i = 0; i < e[x].size(); i++) {
		ans[x].push_back(v[i].second);
	}
	return 1;
}

void per(ll num) {
	if (num == kons.size()) {
		for (ll i = 0; i < n; i++) {
			if (!kon[i]) {
				A[i].clear();
			}
			ans[i].clear();
		}
		if (dfs(0)) {
			cout << "Yes" << '\n';
			for (ll i = 0; i < n; i++) {
				if (kon[i]) {
					cout << A[i][0] << '\n';
				}
				else {
					for (ll j = 0; j < ans[i].size(); j++) {
						cout << ans[i][j] + 1 << " ";
					}
					cout << '\n';
				}
			}
			exit(0);
		}
		return ;
	}
	for (ll i = 0; i < u[kons[num]].size(); i++) {
		A[kons[num]].push_back(u[kons[num]][i]);
		per(num + 1);
		A[kons[num]].pop_back();
	}
	return;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	cin >> n;
	for (ll h = 0; h < n; h++) {
		ll a; cin >> a;
		if (a == 1) {
			ll k; cin >> k;
			for (ll i = 0; i < k; i++) {
				ll x; cin >> x;
				x--;
				e[h].push_back(x);
			}
		}
		else {
			ll k; cin >> k;
			kons.push_back(h);
			kon[h] = 1;
			for (ll i = 0; i < k; i++) {
				ll x; cin >> x;
				u[h].push_back(x);
			}
		}
	}
	per(0);
	cout << "No";
}