#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 100500;

vector<int> g[MAXN];
vector<int> kek[MAXN][26];

int used[MAXN];
vector<int> topsort;

void dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    topsort.push_back(v);
}

signed main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (auto &el : a[i]) {
            cin >> el.first >> el.second;
            el.first--;
            kek[el.first][el.second - 'a'].push_back(i);
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 26; j++) {
            if (j + 'a' == s[i]) {
                continue;
            }
            for (int el1 : kek[i][s[i] - 'a']) {
                for (int el2 : kek[i][j]) {
                    g[el1].push_back(el2);
                }
            }
        }
    }
    for (int v = 0; v < n; v++) {
        if (!used[v]) {
            dfs(v);
        }
    }
    reverse(all(topsort));
    string res;
    for (int i = 0; i < m; i++) {
        res += ' ';
    }
    for (int i : topsort) {
        for (auto el : a[i]) {
            if (res[el.first] == ' ') {
                res[el.first] = el.second;
            }
        }
    }
    if (res == s) {
        for (int el : topsort) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    } else {
        cout << -1 << '\n';
    }
}
