#include <bits/stdc++.h>
using namespace std;

int n, m;
string s;
vector<vector<int>> a;
vector<vector<char>> c;
vector<int> k;
vector<bool> used, taken;
vector<int> cnt;
vector<int> p;
vector<vector<int>> bad;
queue<int> q;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> s;
    k.resize(n);
    a.resize(n);
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> k[i];
        a[i].resize(k[i]);
        c[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) {
            cin >> a[i][j] >> c[i][j];
            --a[i][j];
        }
    }
    bad.resize(m);
    cnt.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k[i]; ++j) {
            if (s[a[i][j]] != c[i][j]) {
                bad[a[i][j]].push_back(i);
                ++cnt[i];
            }
        }
    }
    used.assign(m, false);
    taken.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (cnt[i] == 0) {
            taken[i] = true;
            q.push(i);
        }
    }
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        p.push_back(u);
        for (int i = 0; i < k[u]; ++i) {
            if (!used[a[u][i]]) {
                used[a[u][i]] = true;
                for (int t : bad[a[u][i]]) {
                    --cnt[t];
                    if (cnt[t] == 0 && !taken[t]) {
                        taken[t] = true;
                        q.push(t);
                    }
                }
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << p[i] + 1 << " ";
    }
    cout << endl;
    return 0;
}
