#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::pair;
using std::string;
using std::vector;


using ll = long long;
using ld = long double;


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	string s;
	cin >> s;

	vector<vector<int>> v(n);
	vector<vector<int>> v1(m);
	vector<int> bad(n);
	std::set<int> cur;
	vector<bool> used(m);

	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			if (a >= m)
				continue;
			if (s[a] != c) {
				++bad[i];
				v1[a].push_back(i);
			}
			v[i].push_back(a);
		}
		if (bad[i] == 0)
			cur.insert(i);
	}

	vector<int> ans;
	while (!cur.empty()) {
		int ind = *cur.begin();
		ans.push_back(ind);
		cur.erase(cur.begin());
		for (int j = 0; j < v[ind].size(); ++j) {
			int c = v[ind][j];
			if (!used[c]) {
				for (int k : v1[c]) {
					--bad[k];
					if (bad[k] == 0)
						cur.insert(k);
				}
			}
			used[c] = true;
		}
	}

	if (ans.size() < n) {
		cout << -1;
		return 0;
	}

	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}