#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 32;
int a[maxn][maxn];
int n;

void make(int x, int y) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i <= x && n - j - 1 <= y)a[i][j] = 1;
        }
    }
}

void ask(int x, int y) {
    if (x != -1) {
        cout << (n - x - 1) + 1 << " " << y + 1 << endl;
        make(x, y);
    }
    cin >> x;
    cin >> y;
    x--;
    y--;
    x = (n - x - 1);
    make(x, y);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    freopen("\\\\.\\pipe\\game.in", "r", stdin);
    freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int type;
    cin >> type;
    int k, m;
    cin >> n >> k >> m;

    if (type == 1) {
        string s;
        cin >> s;
        int l = 0;
        bool first = true;
        while (l < m) {
            if (!first)ask(-1, -1);
            int cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == 0) {
                        cnt++;
                    }
                }
            }
            if (cnt == 0) {
                first = !first;
                continue;
            }
            int bits = 0;
            while (cnt != 0) {
                bits++;
                cnt /= 2;
            }
            bits--;
            int to = min(l + bits - 1, (int) m - 1);
            int num = 0;
            for (int i = l; i <= to; ++i) {
                num += (s[i] - '0') * (1 << (i - l));
            }
            bool found = false;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (found)continue;
                    if (a[i][j] == 0) {
                        if (num == 0) {
                            found = true;
                            ask(i, j);
                        } else num--;
                    }
                }
            }
            first = !first;
            l = to + 1;
        }
    } else {
        int G;
        cin >> G;
        vector<pair<int, int>> d;
        vector<char> s(m);
        for (int i = 0; i < G; ++i) {
            int aa, bb;
            cin >> aa >> bb;
            aa--;
            bb--;
            aa = (n - aa - 1);
            d.push_back({aa, bb});
        }
        int l = 0;
        bool first = true;
        int it = 0;
        while (l < m) {
            if (!first) {
                it++;
                first = !first;
                continue;
            }
            int cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == 0) {
                        cnt++;
                    }
                }
            }
            if (cnt == 0) {
                first = !first;
                it++;
                continue;
            }
            int bits = 0;
            while (cnt != 0) {
                bits++;
                cnt /= 2;
            }
            int num = d[it].first * n + d[it].second;
            while (num != 0) {
                s[l] = num % 2;
                num /= 2;
                l++;
            }
            first = !first;
            it++;
        }
        for (int i = 0; i < s.size(); ++i) {
            cout << s[i];
        }
    }
}