#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 1e5 + 100;
vector <int> g[N];
vector <int> sert[N];

int m;

vector <int> dfs(int v, int p) {
    if (!g[v].empty()) {
        vector <vector <int>> now;
        for (int i : g[v]) {
            if (i == p)
                continue;

            now.push_back(dfs(i, v));
        }

        vector <int> ans(m, -1);

        vector <int> ind;
        ind.reserve(g[v].size() - 1);
        for (int i = 0; i < now.size(); i++) {
            ind.push_back(i);
        }

        do {
            for (int st = 0; st < m; st++) {
                int n = st;
                for (int i : ind) {
                    if (now[i][n] == -1) {
                        n = -1;
                        break;
                    } else {
                        n = now[i][n];
                    }
                }
                if (ans[st] == -1 || (n != -1 && ans[st] > n))
                    ans[st] = n;
            }
        } while (next_permutation(all(ind)));
        return ans;
    } else {
        sort(all(sert[v]));

        vector <int> ans(m, - 1);
        for (int i : sert[v]) {
            int j = i;
            while (j > -1 && ans[j] == -1)
                ans[j--] = i;
        }
        return ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector <int> se;
    for (int i = 0; i < n; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int x;
            cin >> x;
            while (x--) {
                int v;
                cin >> v;
                v--;
                g[i].push_back(v);
            }
        } else {
            int x;
            cin >> x;
            while (x--) {
                int v;
                cin >> v;
                sert[i].push_back(v);
                se.push_back(v);
            }
        }
    }
    sort(all(se));
    se.erase(unique(all(se)), se.end());
    m = se.size();

    for (int i = 0; i < n; i++) {
        for (int& j : sert[i]) {
            j = lower_bound(all(se), j) - se.begin();
        }
    }

    vector <int> ans = dfs(0, -1);
    if (ans[0] != -1) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
    return 0;
}
