#include <iostream>
#include "vector"
#include "map"
#include "string"
#include "algorithm"

using namespace std;

int k, n;
vector<string> mat;
map<string, string> mp;

string ans(string s) {
    if (s.size() <= 1) {
        return s;
    } else if (mp.find(s) != mp.end()) {
        return mp[s];
    }
    string best = s;
    for (int i = 0; i < s.size() - 1; ++i) {
        if (mat[s[i] - 'a'][s[i + 1] - 'a'] == '1') {
            string tr;
            if (i + 2 < s.size()) {
                tr = ans(s.substr(0, i + 1) + s.substr(i + 2, s.size() - i - 2));
            } else {
                tr = ans(s.substr(0, i + 1));
            }
            if (best > tr) {
                best = tr;
            }
        }
    }
    return mp[s] = best;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> n;
    mat.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> mat[i];
    }
    string s; cin >> s;
    cout << ans(s) << endl;
    return 0;
}