#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define fi first
#define se second
#define sz(a) (int) (a).size()
#define pb push_back
#define all(a) (a).begin(), (a).end()

void print(vector<int> a) {
    for (auto x : a) cout << x << " ";
    cout << endl;
}

const int N = 100000, M = 500;
int type[N], n;
vector<vector<int>> g, dp, tmp;
int DP[M][M][M];
int dp2[(1 << 8)][M][M];

void dfs(int v) {
    if (sz(dp[v])) {
        sort(all(dp[v]));
        for (int i = 0; i < n; i++) for (int j = i; j < n; j++) {
            auto it = lower_bound(all(dp[v]), i) - dp[v].begin();
            if (it != sz(dp[v]) && dp[v][it] <= j) {
                DP[v][i][j] = 1;
            }
            else {
                DP[v][i][j] = 0;
            }
        }
        return;
    }
    for (auto x : g[v]) {
        dfs(x);
    }
    for (int i = 0; i < n; i++) for (int j = i; j < n; j++) dp2[0][i][j] = 1;
    int d = sz(g[v]);
    for (int k = 1; k < (1 << d); k++) {
        for (int i = 0; i < n; i++) for (int j = i; j < n; j++) dp2[k][i][j] = 0;
        for (int u = 0; u < d; u++) {
            if ((k & (1 << u)) > 0) {
                for (int l = 0; l < n; l++) {
                    for (int r = l; r < n; r++) {
                        for (int p = l; p < r; p++) {
                            if (dp2[k ^ (1 << u)][p + 1][r] && DP[g[v][u]][l][p]) {
                                dp2[k][l][r] = 1;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int l = 0; l < n; l++) {
        for (int r = l; r < n; r++) {
            if (dp2[(1 << d) - 1][l][r]) DP[v][l][r] = 1;
        }
    }
}

void gen(int x) {
    if (x == n) {
        //cout << "F" << endl;
        for (int i = 0; i < n; i++) if (type[i] == 1) tmp[i].clear();
        dfs(0);
        //cout << "F" << endl;
        bool f = true;
        for (int i = 1; i < sz(tmp[0]); i++) {
            if (tmp[0][i] <= tmp[0][i - 1]) f = false;
        }
        //print(tmp[0]);
        //print(tmp[1]);
        ////print(tmp[2]);
        //cout << "f = " << f << endl;
        if (f) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                if (type[i] == 2) {
                    cout << tmp[i][0] << '\n';
                }
                else {
                    vector<pii> d;
                    for (auto x : g[i]) {
                        d.pb({tmp[x][0], x});
                    }
                    sort(all(d));
                    for (auto x : d) {
                        cout << x.se + 1 << " ";
                    } cout << '\n';
                }
            }
            exit(0);
        }
        //cout << "F" << endl;
        return;
    }
    for (auto y : dp[x]) {
        tmp[x].pb(y);
        gen(x + 1);
        tmp[x].pop_back();
    }
    if (sz(dp[x]) == 0) gen(x + 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    dp.resize(n);
    tmp.resize(n);
    vector<int> z;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        type[i] = t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int x; cin >> x; x--;
                g[i].pb(x);
            }
        }
        else {
            int k;
            cin >> k;
            while (k--) {
                int x; cin >> x;
                z.pb(x);
                dp[i].pb(x);
            }
        }
    }
    sort(all(z));
    z.resize(unique(all(z)) - z.begin());
    for (int i = 0; i < n; i++) {
        for (auto& x : dp[i]) x = lower_bound(all(z), x) - z.begin();
        //print(dp[i]);
    }
    dfs(0);
    for (int v = 0; v < n; v++) {
        for (int l = 0; l < n; l++) {
            for (int r = l; r < n; r++) {
                //cout << v << " " << l << " " << r << " " << DP[v][l][r] << endl;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (DP[0][i][j]) {
                cout << "Yes";
                return 0;
            }
        }
    }
    cout << "No";
}
