#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <random>

using namespace std;

bool operator>(string& a, string& b) {
	for (int i = 0; i < (int)min((int)a.length(), (int)b.length()); i++) {
		if (a[i] > b[i]) return true;
		else if (a[i] < b[i]) return false;
	}
	return (int)a.length() > (int)b.length();
}

int main() {
	int k, n;
	cin >> k >> n;
	vector<vector<int>> can_del(k, vector<int>(k));
	for (auto& line : can_del) {
		string s;
		cin >> s;
		for (int i = 0; i < k; i++) line[i] = s[i] - '0';
	}
	string s;
	cin >> s;
	
	if (k != 2) {
		string best = s;
		mt19937 rnd(33);
		for (int i = 0; i < 400000; i++) {
			string copy = s;
			int to_del = 0;
			for (int i = 0; i + 1 < n; i++) {
				if (can_del[s[i] - 'a'][s[i + 1] - 'a']) to_del++;
			}
			int cnt_del = (int)(rnd() % ((int)s.size() + 1));
			for (int j = 0; j < cnt_del; j++) {
				if (to_del == 0) break;
				while (true) {
					int targ = (int)(rnd() % ((int)copy.size() - 1));
					if (can_del[copy[targ] - 'a'][copy[targ + 1] - 'a']) {
						to_del--;
						if (targ != (int)copy.size() - 2) {
							if (can_del[copy[targ] - 'a'][copy[targ + 2] - 'a']) to_del++;
							if (can_del[copy[targ + 1] - 'a'][copy[targ + 2] - 'a']) to_del--;
						}
						copy.erase(copy.begin() + targ + 1);
						break;
					}
				}
			}
			if (best > copy) best = copy;
		}
		cout << best << endl;
	}
	else {
		vector<int> groups;
		int now = 1;
		for (int i = 1; i < n; i++) {
			if (s[i] == s[i - 1]) now++;
			else {
				groups.push_back(now);
				now = 1;
			}
		}
		groups.push_back(now);

		
		if (can_del[1][1]) {
			if (s[0] == 'a') for (int i = 1; i < groups.size(); i += 2)groups[i] = 1;
			else for (int i = 0; i < groups.size(); i += 2) groups[i] = 1;
		}
		if (s[0] == 'a') {
			if (can_del[0][1]) {
				int cnt_a = 0;
				if (can_del[0][0]) {
					cout << "a\n";
					return 0;
				}
				if (can_del[1][0]) {
					cnt_a = groups[0];
				}
				else {
					for (int i = 0; i < groups.size(); i += 2) cnt_a += groups[i];
				}
				string answ = "";
				for (int i = 0; i < cnt_a; i++) answ += "a";
				cout << answ << endl;
				return 0;
			}
			else {
					
				if (can_del[1][0] && can_del[1][1]) {
					string answ = "";
					for (int i = 0; i < groups[0]; i++) answ += 'a';
					answ += 'b';
					cout << answ;
					return 0;
				}
				else {
					string answ = "";
					char ch = 'a';
					for (int i = 0; i < groups.size(); i++) {
						for (int j = 0; j < groups[i]; j++) answ += ch;
						if (ch == 'a') ch = 'b';
						else ch = 'a';
					}
				}
			}
		}
		else {
			string answ = "";
			for (int i = 0; i < groups[0]; i++) answ += 'b';
			if (can_del[0][1]) {
				int cnt_a = 0;
				if (can_del[0][0]) {
					answ += "a";
					return 0;
				}
				if (can_del[1][0]) {
					cnt_a = groups[0];
				}
				else {
					for (int i = 0; i < groups.size(); i += 2) cnt_a += groups[i];
				}
				string answ2 = "";
				for (int i = 0; i < cnt_a; i++) answ2 += "a";
				answ += answ2;
			}
			else {
				if (can_del[1][0] && can_del[1][1]) {
					cout << "b";
					return 0;
				}
				else if (can_del[1][0]) {
					for (int i = 0; i < groups[0]; i++) cout << "b";
					return 0;
				}
				else {
					string answ2 = "";
					char ch = 'a';
					for (int i = 0; i < groups.size(); i++) {
						for (int j = 0; j < groups[i]; j++) answ2 += ch;
						if (ch == 'a') ch = 'b';
						else ch = 'a';
					}
					answ += answ2;
				}
			}
			cout << answ;
			return 0;
		}


		
	}
}