#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <random>

using namespace std;

int to_int(string& secret, int from, int cnt) {
	int answ = 0;
	for (int j = min(from + cnt - 1, (int)secret.length() - 1); j >= from; j--) {
		answ *= 2;
		answ += secret[j] - '0';
	}
	return answ;
}
string to_bit(int x, int cnt) {
	string answ = "";
	while (x > 0) {
		answ += (x % 2 + '0');
		x /= 2;
	}
	while ((int)answ.length() < cnt) answ += '0';
	return answ;
}

void start_1() {
	int n, k, m;
	cin >> n >> k >> m;
	string secret;
	int secret_j = 0;
	cin >> secret;
	vector<vector<int>> map(n, vector<int>(n, 0));
	int cnt_bit = 1;
	int must_free = 2;
	int free = n * n;
	while (must_free * 2 < free) {
		must_free *= 2;
		cnt_bit++;
	}

	bool turn = true;
	bool first_turn = true;
	while (true) {
		//cout << "D: " << must_free << " " << cnt_bit << endl;
		if (turn) {
			if (first_turn) {
				first_turn = false;
				if (secret_j >= (int)secret.length()) {
					cout << 0 << endl;
					return;
				}
			}

			if (free == 1) {
				cout << "1 1" << endl;
				int cnt_bit = 1;
				int must_free = 2;
				int free = n * n;
				while (must_free * 2 < free) {
					must_free *= 2;
					cnt_bit++;
				}
				first_turn = true;
				turn = !turn;
				continue;
				
			}
			else if (free == 2) {
				if (map[0][1] == 0) {
					cout << "2 1" << endl;
				}
				else cout << "1 2" << endl;
				turn = !turn;
				continue;
			}
			int pos = to_int(secret, secret_j, cnt_bit) + 1;
			secret_j += cnt_bit;
			for (int y = n - 1; y >= 0 && pos > 0; y--) {
				for (int x = n - 1; x >= 0 && pos > 0; x--) {
					if (map[y][x] == 0) pos--;
					if (pos == 0) {
						for (int i = n - 1; i >= y; i--) {
							for (int j = n - 1; j >= x; j--) {
								if (map[i][j] == 0) {
									map[i][j] = 1;
									free--;
								}
							}
						}
						while (must_free >= free) {
							must_free /= 2;
							cnt_bit--;
						}
						cout << x + 1 << " " << y + 1 << endl;
					}
				}
			}
		}
		else {
			int i, j;
			cin >> j >> i;
			if (i == 1 && j == 1) {
				if (secret_j >= (int)secret.length()) {
					cout << 0 << endl;
					return;
				}
				else {
					int cnt_bit = 1;
					int must_free = 2;
					int free = n * n;
					while (must_free * 2 < free) {
						must_free *= 2;
						cnt_bit++;
					}
					first_turn = true;
					turn = !turn;
					continue;
				}
			}
			i--;
			j--;
			for (int y = n - 1; y >= i; y--) {
				for (int x = n - 1; x >= j; x--) {
					if (map[y][x] == 0) {
						free--;
						map[y][x] = 1;
					}
				}
			}
			while (must_free >= free) {
				must_free /= 2;
				cnt_bit--;
			}
		}
		turn = !turn;
	}

}
void start_2() {
	int n, k, m;
	cin >> n >> k >> m;
	string secret = "";
	int q;
	cin >> q;
	bool turn = true;
	for (int i = 0; i < q; i++) {
		vector<vector<int>> map(n, vector<int>(n, 0));
		int cnt_bit = 1;
		int must_free = 2;
		int free = n * n;
		while (must_free * 2 < free) {
			must_free *= 2;
			cnt_bit++;
		}
		while (true) {
			if (turn) {
				int x, y;
				cin >> x;
				if (x == 0) break;
				cin >> y;
				x--; y--;
				if ((int)secret.length() >= m) {
					turn = !turn;
					continue;
				}
				int pos = 0;
				bool found = false;
				for (int i = n - 1; i >= 0 && !found; i--) {
					for (int j = n - 1; j >= 0 && !found; j--) {
						if (map[i][j] == 0) pos++;
						if (i == y && j == x) found = true;
					}
				}
				pos--;
				secret += to_bit(pos, cnt_bit);
				for (int i = n - 1; i >= y; i--) {
					for (int j = n - 1; j >= x; j--) {
						if (map[i][j] == 0) {
							map[i][j] = 1;
							free--;
						}
					}
				}
				while (must_free >= free) {
					must_free /= 2;
					cnt_bit--;
				}
			}
			else {
				int x, y;
				cin >> x >> y;
				if ((int)secret.length() >= m) {
					turn = !turn;
					continue;
				}
				x--;
				y--;
				for (int i = n - 1; i >= y; i--) {
					for (int j = n - 1; j >= x; j--) {
						if (map[i][j] == 0) {
							map[i][j] = 1;
							free--;
						}
					}
				}
				while (must_free >= free) {
					must_free /= 2;
					cnt_bit--;
				}
			}
			turn = !turn;
		}
	}
	for (int i = 0; i < m; i++) cout << secret[i];
	cout << endl;
}

int main() {
	int t;
	cin >> t;
	if (t == 1) start_1();
	else start_2();
}