#include <iostream>
#include <vector>
#include <map>

using namespace std;

int n, m;
string s;
inline bool check(vector <pair <int, char>> &c, vector <bool> &used) {
    for (auto &[i, ch]: c) {
        if (used[i])
            continue;
        if (s[i] != ch)
            return false;
        used[i] = true;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n >> m;
    cin >> s;
    vector <vector <pair <int, char>>> a(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (auto &[pos, ch]: a[i]) {
            cin >> pos >> ch;
            pos--;
        }
    }
    vector <bool> used(n);
    vector <bool> good(m);
    vector <int> ans;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            if (!good[j] && check(a[j], used)) {
                good[j] = true;
                ans.push_back(j + 1);
                break;
            }
        }
    }

    return 0;
}
