#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

int k, n;
vector<vector<int>> can;

bool cmp2(vector<int> a1, vector<int> a2) {
    for (int i = 0; i < (int) a1.size() && i < (int) a2.size(); i++) {
        if (a1[i] < a2[i])
            return true;
        if (a1[i] > a2[i])
            return false;
    }
    return a1.size() > a2.size();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> n;
    can.resize(k + 1, vector<int> (k + 1));
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= k; j++) {
            char c;
            cin >> c;
            if (c == '1') {
                can[i][j] = 1;
            }
        }
    }
    for (int i = 0; i <= k; i++) {
        can[i][0] = 1;
    }
    vector<int> arr;
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        arr.push_back(c - 'a' + 1);
    }
    n++;
    arr.push_back(0);
    vector<vector<int>> dp(n);
    dp[0].push_back(arr[0]);
    vector<int> cur = {0};
    for (int i = 1; i < n; i++) {
        vector<vector<int>> can2;
        can2.push_back(dp[i - 1]);
        can2.back().push_back(arr[i]);
        for (int el : cur) {
            can2.push_back(dp[el]);
            can2.back().push_back(arr[i]);
        }
        while (!cur.empty() && !can[arr[cur.back()]][arr[i]]) {
            cur.pop_back(); 
        }
        cur.push_back(i);
        dp[i] = *min_element(can2.begin(), can2.end(), cmp2);
    }
    assert(dp.back().back() == 0);
    dp.back().pop_back();
    for (int el : dp.back()) {
        cout << (char) (el + 'a' - 1);
    }
    cout << endl;
}
