#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
using namespace std;

vector<vector<int>> g;
map<int, vector<int>> d;
vector<vector<pair<int, int>>> can;

void dfs(int v, int p) {
    if (d.count(v)) {
        for (int x : d[v]) {
            can[v].push_back({ x, x });
        }
    }
    for(int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    for (int u : g[v]) {
        for (int u1 : g[v]) {
            if (u != p && u1 != p && u != u1 && u < u1) {
                for (pair<int, int> p1 : can[u]) {
                    for (pair<int, int> p2 : can[u1]) {
                        if (p1.first > p2.second || p2.first > p1.second) {
                            can[v].push_back({ min(p1.first, p2.first), max(p1.second, p2.second) });
                        }
                    }
                }
            }
        }
    }
    if (g[v].size() == 2) {
        for (int u : g[v]) {
            if (u != p) {
                for (pair<int, int> p1 : can[u]) {
                    can[v].push_back(p1);
                }
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int m;
            cin >> m;
            assert(m != 0);
            while (m--) {
                int x;
                cin >> x;
                d[i].push_back(x);
            }
        } else {
            int k;
            cin >> k;
            while (k--) {
                int u;
                cin >> u;
                --u;
                g[i].push_back(u);
            }
        }
    }
    can.resize(n);
    dfs(0, -1);
    if (can[0].size()) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}
/*
3 7
010
001
100
abacaba

 3 5
010
001
100
bcacb

 6
 1 3 5 4 6
 2 3 10 61 60
 2 2 80 20
 2 2 40 70
 1 2 3 2
 2 4 30 90 91 92
 */