#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int K = 27;
constexpr int MAXN = 2005;

bool may[K][K];
bool dp[MAXN][MAXN];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int k, n;
	std::cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char ch;
			std::cin >> ch;
			may[i + 1][j + 1] = ch == '1';
		}
	}
	std::string s;
	std::cin >> s;
	n = s.size();
	for (int i = 0; i < n; i++) {
		s[i] -= 'a';
		s[i]++;
	}
	s += char(0);
	n++;

	for (int len = 1; len < n; len++) {
		for (int l = 0; l < n - len + 1; l++) {
			int r = l + len - 1;
			if (l == r) {
				dp[l][r] = true;
			} else {
				for (int i = l; i < r; i++) {
					if (dp[l][i] && dp[i][r - 1] && may[s[i]][s[r]]) {
						dp[l][r] = true;
						break;
					}
				}
			}
		}
	}

	std::string ans = s.substr(0, 1);
	std::vector<int> vec = { 0 };
	while (ans.back() != 0) {
		char mn = 30;
		for (int i : vec) {
			for (int j = i + 1; j < n; j++) {
				if (dp[i][j - 1]) {
					mn = std::min(mn, s[j]);
				}
			}
		}
		std::vector<int> vec2;
		for (int i : vec) {
			for (int j = i + 1; j < n; j++) {
				if (dp[i][j - 1] && mn == s[j]) {
					vec2.push_back(j);
				}
			}
		}
		ans += mn;
		vec.swap(vec2);
		std::sort(vec.begin(), vec.end());
		vec.erase(std::unique(vec.begin(), vec.end()), vec.end());
	}

	for (int i = 0; i < ans.size() - 1; i++) {
		std::cout << char(ans[i] + 'a' - 1);
	}


	return 0;
}

/*
3 5
010
001
100
abacaba


*/