#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define int ll
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < int(n); ++i)
#define x first
#define y second
#define pb push_back
typedef pair<int, int> pi;

// dp[i][26] - min len ends with c
// dp[i][c1] = if can delete c1:
				// dp[i][c0]
// dp[i][c1] = dp[i - 1][c0] + 1

const int N = 500 + 10;
const int A = 26 + 3;
int f[A][A];
int  k, n;
bool dp[A][N][N];
string s;
string s_min[N];	

string t_s(string r) {
	string ans;
	for (char c : r) {
		if (c) {
			ans.push_back(c + 'a' - 1);
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> k >> n;
	rep(i, k) {
		string t;
		cin >> t;
		rep(j, k) {
			f[i + 1][j + 1] = int(t[j]) - int('0');
		}
	}

	cin >> s;
	rep(i, s.size()) {
		s[i] -= int('a') - 1;
	}
	s.push_back(0);
	n++;

	for (int len = 0; len <= n; ++len) {
		for (int l = 0; l + len <= n; ++l) {
			int r = l + len - 1;
			for (int c = 0; c <= k; ++c) {
				if (len == 0) {
					dp[c][l][r] = 1;
					continue;
				}
				if (len == 1) {
					dp[c][l][r] = f[c][s[l]];
					continue;
				}
				for (int m = l; m <= r; ++m) {
					if (!f[c][s[m]]) {
						continue;
					}
					bool fs1 = (m - 1 < l ? 1 : dp[c][l][m - 1]);
					bool sc1 = (r < m + 1 ? 1 : dp[c][m + 1][r]);
					bool sc2 = (r < m + 1 ? 1 : dp[s[m]][m + 1][r]);
					if (fs1 && (sc1 || sc2)) {
						dp[c][l][r] = 1;
					}
				}
				if (dp[c][l][r]) {
					for (int k = r - 1; k >= l; --k) {
						assert(dp[c][l][k]);
					}
				}

				// if (c > 0) {
				// 	cerr << "dp " << char(c - 1 + 'a') << ' ' << l << ' ' << r << " = " << dp[c][l][r] << endl;
				// }
			}
		}
	}
	string ans;
	s_min[n - 1].push_back(0);
	for (int i = n - 2; i >= 0; --i) {
		s_min[i].push_back(30);
		int r0 = -1;
		for (int r = i + 1; r < n; ++r) {
			if (r != i + 1 && !dp[s[i]][i + 1][r - 1])
				continue;
			s_min[i] = min(s_min[i], string(1, s[i]) + s_min[r]);
			if (s_min[i] == string(1, s[i]) + s_min[r]) {
				r0 = r;
			}
		}
		// cerr << i << ": s_min=" << t_s(s_min[i]) << ", r0=" << r0<< endl;
	}
	cout << t_s(s_min[0]);

	return 0;
}