#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

void fail() {
    cout << -1;
    exit(0);
}

string s;
ll n,m;

vector<lvec> card_with;

struct card {
    bool taken = false;
    set<ll> good, bad;
    card(ll i_card) {
        ll k;
        cin >> k;
        while (k--) {
            ll pos;
            char a;
            cin >> pos >> a;
            pos--;
            card_with[pos].push_back(i_card);
            if (a == s[pos]) good.insert(pos);
            else bad.insert(pos);
        }
    }
    void erase(ll i) {
        if (taken) return;
        bad.erase(i);
        good.erase(i);
    }
};

vector<card> v;

int main() {
    freopen("A.in", "r", stdin);
    cin >> n >> m;
    card_with.resize(m);
    cin >> s;
    for (ll i = 0; i < n; i ++)
        v.emplace_back(i);
    lvec ready;
    for (ll i = 0; i < n ; i++) {
        if (v[i].bad.empty()) {
            v[i].taken = true;
            ready.push_back(i);
        }
    }
    lvec ans;
    lvec bits_set(m, false);
    while (!ready.empty()) {
        ll i = ready.back();
        ready.pop_back();
        ans.push_back(i + 1);
        lvec add;
        for (auto &el : v[i].good) {
            if(!bits_set[el]) {
                add.push_back(el);
                bits_set[el] = true;
            }
        }
        for (auto &el : add)
            for (auto i : card_with[el]) {
                v[i].erase(el);
                if (!v[i].taken && v[i].bad.empty()) {
                    v[i].taken = true;
                    ready.push_back(i);
                }
            }
    }
    if (ans.size() < n) fail();
    for (auto &el : ans) cout << el << " ";
    return 0;
}
