#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 10;
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
 */
vector<int> g[N];
int n;
vector<int> ups[N];

bool ans = true;
int x;
int choosen[N];
bool check(int v) {
    if (g[v].empty()) {
        if (upper_bound(ups[v].begin(), ups[v].end(), x) == ups[v].end()) {
            return false;
        }
        x = *upper_bound(ups[v].begin(), ups[v].end(), x);
        choosen[v] = x;
        return true;
    }
    for (auto to : g[v]) {
        if (!check(to)) {
            return false;
        }
    }
    return true;
}

void f(int v) {
    if (g[v].empty()) {
        x = 0;
        if (check(1)) {
            cout << "Yes\n";
            for (int i = 1; i <= n; i++) {
                if (g[i].empty()) {
                    cout << choosen[i];
                } else
                for (auto to : g[i]) {
                    cout << to << " ";
                }
                cout << "\n";
            }
            exit(0);
        }
    }
    sort(g[v].begin(), g[v].end());
    do {
        for (auto to : g[v]) {
            f(to);
        }
    } while (next_permutation(g[v].begin(), g[v].end()));
}


int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            g[i].resize(k);
            for (auto &to : g[i]) {
                cin >> to;
            }
        } else {
            int m;
            cin >> m;
            ups[i].resize(m);
            for (auto &up : ups[i]) {
                cin >> up;
            }
            sort(ups[i].begin(), ups[i].end());
        }
    }

    f(1);

    cout << "No";


    return 0;
}
