#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    int n, m;
    cin >> n >> m;
    string s; cin >> s;
    vector <vector <pair <int, char> > > a(n);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a[i].resize(x);
        for (int j = 0; j < x; j++) {
            int pos; char c;
            cin >> pos >> c;
            a[i][j] = {pos - 1, c};
        }
    }
    vector <char> cur(m, '#');
    vector <int> ans, cnt(n);
    vector <vector <int> > warning(m);
    queue <int> q;
    for (int i = 0; i < n; i++) {
        for (auto &p : a[i]) {
            if (p.second == '#') continue;
            if (p.second == s[p.first]) continue;
            warning[p.first].push_back(i);
            cnt[i]++;
        }
        if (!cnt[i])
            q.push(i);
    }
    while (!q.empty()) {
        int i = q.front();
        q.pop();
        vector <int> was;
        for (auto &p : a[i]) {
            if (cur[p.first] != '#') continue;
            cur[p.first] = p.second;
            was.push_back(p.first);
        }
        ans.push_back(i);
        for (int j = 0; j < was.size(); j++) {
            for (auto &el : warning[was[j]]) {
                cnt[el]--;
                if (!cnt[el])
                    q.push(el);
            }
        }
    }
    if (ans.size() < n) {
        cout << -1;
        return 0;
    }
    for (int i = 0; i < m; i++)
        if (s[i] != cur[i]) {
            cout << -1;
            return 0;
        }
    for (auto &el : ans)
        cout << el + 1 << " ";
    return 0;
}
