#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> a(n);
    set<pair<int, int>> best;
    vector<vector<pair<char, int>>> b(m);
    vector<int> count(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        int cnt = 0;
        for (int j = 0; j < k; ++j) {
            int ind;
            char c;
            cin >> ind >> c;
            --ind;
            a[i][j] = {ind, c};
            if (s[ind] != c){
                cnt += 1;
            }
            b[ind].push_back({c, i});
        }
        best.insert({cnt, i});
        count[i] = cnt;
    }
    vector<bool> pos(m);
    vector<int> ans;
    while (best.size() > 0){
        auto q = *best.begin();
        best.erase(best.begin());
        if (q.first != 0){
            cout << -1;
            return 0;
        }
        ans.push_back(q.second + 1);
        for (auto i : a[q.second]){
            if (!pos[i.first]){
                pos[i.first] = true;
                for (auto j : b[i.first]){
                    if (j.first != s[i.first]){
                        best.erase({count[j.second], j.second});
                        count[j.second]--;
                        best.insert({count[j.second], j.second});
                    }
                }
            }
        }
    }
    if (find(pos.begin(), pos.end(), false) != pos.end()){
        cout << -1;
        return 0;
    }
    for (auto i : ans){
        cout << i << " ";
    }
}
