#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int k, n;
    cin >> k >> n;
    vector<vector<int>> a(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    string s;
    cin >> s;
    vector<string> dp(n + 1);
    vector<int> cnt(n + 1);
    for (int i = n - 1; i > -1; --i) {
        dp[i] = s[i] + dp[i + 1];
        int mx = 0;
        for (int j = 1; j + i < n; ++j) {
            if (a[s[i] - 'a'][s[j + i] - 'a'] == 0 && mx <= 0) {
                break;
            }
            mx--;
            mx = max(mx, cnt[i + j]);
            if (dp[i] > dp[j + i + 1]) {
                dp[i] = dp[j + i + 1];
            }
            cnt[i] += 1;
        }
    }
    cout << dp[0];
}