#include <bits/stdc++.h>
using namespace std;

const int N = 2e5 + 5;


vector<vector<pair<int, char>>> v;
int good[N], bad[N];


struct kek {
  int id;
  bool operator< (const kek &a) const {
    return bad[id] < bad[a.id] || bad[id] == bad[a.id] && id < a.id;
  }
};


bool used[N];
vector<pair<int, int>> ids[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  string s;
  cin >> s;
  v.resize(n);
  set<kek> st;
  for (int i = 0; i < n; ++i) {
    int k, g = 0, b = 0;
    cin >> k;
    for (int j = 0; j < k; ++j) {
      int a;
      char ch;
      cin >> a >> ch;
      a--;
      if (s[a] == ch) g++;
      else b++;
      v[i].emplace_back(a, ch);
      ids[a].emplace_back(i, j);
    }
    good[i] = g, bad[i] = b;
    st.insert({i});
  }
  set<int> added;
  vector<int> res;
  while (!st.empty()) {
    auto it = st.begin();
    if (bad[it->id]) {
      cout << -1;
      return 0;
    }
    int i = it->id;
    res.push_back(i);
    added.insert(i);
    st.erase(it);
    for (auto &x : v[i]) {
      if (used[x.first])
        continue;
      used[x.first] = true;
      for (auto &j : ids[x.first]) {
        if (added.find(j.first) != added.end()) continue;
        st.erase({j.first});
        if (v[j.first][j.second].second == s[x.first]) {
          good[j.first]--;
        } else {
          bad[j.first]--;
        }
        st.insert({j.first});
      }
    }
  }

  for (int i = 0; i < m; ++i) {
    if (!used[i]) {
      cout << -1;
      return 0;
    }
  }
  for (int i : res)
    cout << i + 1 << ' ';

}