#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 1e5 + 5;
int M, F;

int n;

bool dop = false;

vector<int> g[N], lv[N];
int isl[N];

vector<vector<int>> dp;
vector<vector<vector<pair<int, int>>>> save;
ll fact[10];

int go(int v, int l) {
  if (dp[v][l] != -1)
    return dp[v][l];
  if (isl[v]) {
    int id = lower_bound(lv[v].begin(), lv[v].end(), l) - lv[v].begin();
    if (id == lv[v].size())
      return dp[v][l] = -2;
    return dp[v][l] = lv[v][id];
  }
  vector<int> perm(g[v].size());
  iota(perm.begin(), perm.end(), 0);
  do {
    int cur = l;
    vector<int> curs = {cur};
    for (int j = 0; j < perm.size() && cur != -2; ++j) {
      cur = go(g[v][perm[j]], cur);
      curs.push_back(cur);
    }
    if (cur != -2 && dop) {
      if (dp[v][l] == -1 || dp[v][l] > cur) {
        dp[v][l] = cur;
        save[v][l].resize(perm.size());
        for (int j = 0; j < perm.size(); ++j)
          save[v][l][j] = {perm[j], curs[j]};
      }
    }
  } while (next_permutation(perm.begin(), perm.end()));
  if (dp[v][l] == -1)
    dp[v][l] = -2;
  return dp[v][l];
}

int ans[N];

vector<int> ans2[N];

void get_ans(int v, int l) {
  if (isl[v]) {
    ans[v] = lower_bound(lv[v].begin(), lv[v].end(), dp[v][l]) - lv[v].begin();
    return;
  }
  for (int j = 0; j < g[v].size(); ++j) {
    ans2[v].push_back(g[v][save[v][l][j].first] + 1);
    get_ans(g[v][save[v][l][j].first], save[v][l][j].second);
  }
}
int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  fact[0] = 1;
  for (int i = 1; i < 10; ++i) fact[i] = fact[i - 1] * i;

  vector<int> all;
  cin >> n;
  for (int i = 0; i < n; ++i) {
    int x;
    cin >> x;
    if (x == 1) {
      int k;
      cin >> k;
//      g[i].resize(k);
      for (int j = 0; j < k; ++j) {
        int u;
        cin >> u;
        u--;
        g[i].push_back(u);
      }
    } else {
      isl[i] = 1;
      int m;
      cin >> m;
      lv[i].resize(m);
      for (int j = 0; j < m; ++j) {
        cin >> lv[i][j];
        lv[i][j]--;
        all.push_back(lv[i][j]);
      }
      sort(lv[i].begin(), lv[i].end());
    }
  }

  sort(all.begin(), all.end());
  for (int i = 0; i < n; ++i) {
    if (isl[i]) {
      for (int &j : lv[i])
        j = lower_bound(all.begin(), all.end(), j) - all.begin();
    }
  }

  M = 2002;
//  if (n > 100){
//    M = 505, F = 5 * 4 * 3 * 2 + 1;
//  } else if (n <= 100) {
//    M = 105, F = 8 * 7 * 6 * 5 * 4 * 3 * 2;
//  } else {
//    M = 2005;
//  }
  dp.resize(M, vector<int>(M, -1));
  save.resize(M, vector<vector<pair<int, int>>>(M));

  for (int i = 0; i < n; ++i)
    if (g[i].size() > 5)
      dop = true;
  if (n <= 500)
    dop = true;
  if (go(0, 0) == -2)
    cout << "No";
  else {
    cout << "Yes\n";
    if (!dop)
      return 0;
    get_ans(0, 0);
    for (int i = 0; i < n; ++i) {
      if (isl[i]) {
        cout << all[lv[i][ans[i]]] + 1 << '\n';
      } else {
        for (int j : ans2[i])
          cout << j << ' ';
        cout << '\n';
      }
    }
  }
}