#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

int n;
vector < vector <int> > g;
vector <set <int> > a;

void cnt_a(int v) {
    for (auto to : g[v]) {
        cnt_a(to);
        for (auto x : a[to])
            a[v].insert(x);
    }
}

bool try_dfs(int v, int x) {
    if (g[v].empty()) {
        return a[v].count(x);
    }
    vector <bool> was(g[v].size(), false);
    for (int _ = 0; _ < g[v].size(); _++) {
        for (int i = 0; i < g[v].size(); i++) {
            if (was[i])
                continue;
            if (a[g[v][i]].count(x)) {
                bool t = try_dfs(g[v][i], x);
                if (!t)
                    return false;
                x++;
                was[i] = true;
            }
        }
    }
    return true;
}

void solve() {
    cin >> n;
    g.resize(n);
    a.resize(n);
    vector <int> lst;
    for (int i = 0; i < n; i++) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            while (k --> 0) {
                int v; cin >> v;
                g[i].push_back(v - 1);
            }
        } else {
            int k; cin >> k;
            while (k --> 0) {
                int v; cin >> v;
                a[i].insert(v);
                lst.push_back(v);
            }
        }
    }
    cnt_a(0);
    sort(all(lst));
    for (auto x : lst) {
        if (try_dfs(0, x)) {
            cout << "Yes\n";
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}