#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define all(x) x.begin(), x.end()

typedef pair <int, int> pii;

const int N = 1e5 + 5;

set <pii> alive_perf;
int bad_amount[N];
vector <int> with_this_pos_wrong[N];
vector <int> kills[N];
bool have[N];

int32_t main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i)
    {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j)
        {
            int a;
            char c;
            cin >> a >> c;
            --a;
            if (s[a] != c)
            {
                ++bad_amount[i];
                with_this_pos_wrong[a].push_back(i);
            }
            else
                kills[i].push_back(a);
        }
    }
    for (int i = 0; i < n; ++i)
        alive_perf.insert({bad_amount[i], i});
    vector <int> ans(n);
    for (int i = 0; i < n; ++i)
    {
        if (alive_perf.begin() -> x > 0)
        {
            cout << -1 << endl;
            exit(0);
        }
        int pnum = ans[i] = alive_perf.begin() -> y;
        alive_perf.erase(alive_perf.begin());
        for (int kill : kills[pnum])
        {
            have[kill] = true;
            for (int free : with_this_pos_wrong[kill])
            {
                alive_perf.erase({bad_amount[free], free});
                alive_perf.insert({--bad_amount[free], free});
            }
            with_this_pos_wrong[kill].clear();
        }
    }
    for (int i = 0; i < m; ++i)
        if (!have[i])
        {
            cout << -1 << endl;
            exit(0);
        }
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << endl;
}