#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 2e3 + 10;

int n;
int wback[N];
map<int, int> widx;
int t[N], k[N];
vector<int> g[N];
int dp[N][N], pr[N][N];
vector<int> ans[N];

void dfs(int u) {
	if (t[u] == 2) {
		for (int v : g[u])
			for (int j = 0; j <= v; ++j)
				dp[u][j] = min(dp[u][j], v + 1);
		return;
	}
	for (int v : g[u])
		dfs(v);
	vector<int> order = g[u];
	int cnt = 0;
	do {
		for (int i = 0; i < N; ++i) {
			int curr = i;
			for (int v : order) {
				if (curr == N)
					break;
				curr = dp[v][curr];
			}
			if (dp[u][i] > curr) {
				dp[u][i] = curr;
				pr[u][i] = cnt;
			}
		}
		++cnt;
	} while (next_permutation(all(order)));
}


void dfs_back(int u, int i) {
	if (t[u] == 2) {
		ans[u].push_back(wback[*lower_bound(all(g[u]), i)]);
		return;
	}
	for (int iter = 0; iter < pr[u][i]; ++iter)
		next_permutation(all(g[u]));
	ans[u] = g[u];
	for (int &e : ans[u])
		++e;
	for (int v : g[u]) {
		dfs_back(v, i);
		i = dp[v][i];
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> t[i] >> k[i];
		g[i].resize(k[i]);
		for (int j = 0; j < k[i]; ++j) {
			cin >> g[i][j];
			if (t[i] == 1)
				--g[i][j];
			else
				widx[g[i][j]] = 0;
		}
		sort(all(g[i]));
	}
	int cnt = 0;
	for (auto &e : widx) {
		wback[cnt] = e.x;
		e.y = cnt++;
	}
	for (int i = 0; i < n; ++i) {
		if (t[i] == 1)
			continue;
		for (auto &u : g[i])
			u = widx[u];
	}
	fill(dp[0], dp[N], N);
	dfs(0);
	if (dp[0][0] == N) {
		cout << "No";
	} else {
		cout << "Yes\n";
		dfs_back(0, 0);
		for (int i = 0; i < n; ++i) {
			for (int v : ans[i])
				cout << v << " ";
			cout << "\n";
		}
	}
	// cout << (dp[0][0] == N ? "No" : "Yes");
	return 0;
}