#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <string>
using namespace std;
#pragma GCC optimize("O3")
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
vector <string> a;
set <string> was;
string ans = "", s;
void dfs(string cur) {
	if (was.find(cur) != was.end()) return;
	was.insert(cur);
	ans = min(ans, cur);
	int n = cur.size();
	for (int i = 1; i < n; ++i) {
		if (a[cur[i - 1] - 'a'][cur[i] - 'a'] == '1') {
			dfs(cur.substr(0, i) + cur.substr(i + 1, n - 1 - i));
		}
	}
}
const int mod = 1e9 + 7;
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int k, n; cin >> k >> n;
	a.resize(k);
	for (auto& x : a) cin >> x;
	cin >> s;
	vector <int> pr(n, -1);
	ans += s[0];
	for (int i = 1; i < n; ++i) {
		int j = i, id = i;
		char mn = s[i];
		while (true) {
			if (j == n) break;
			int l = mod;
			pr[j] = -1;
			for (int r = j - 1; r >= i - 1; --r) {
				if (r != j - 1) l = min(l, pr[r + 1]);
				if (a[s[r] - 'a'][s[j] - 'a'] != '1') continue;
				if (r > l) continue;
				pr[j] = r;
				break;
			}
			if (s[j] < mn) id = j, mn = s[j];
			if (pr[j] == -1) break;
			j++;
		}
		if (j == n) break;
		ans += mn;
		i = id;
	}
	cout << ans << '\n';
}
/*
3 7
010
001
100
abacaba

3 10
100
111
010
abcbcaccab
*/