#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <string>
using namespace std;
#pragma GCC optimize("O3")
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double

const int mod = 1e9 + 7;
vector <vector <int>> g, ok, ans;
vector <int> a, need;
bool c = false;
vector <int> dfs(int v) {
	if (g[v].size() == 0) {
		return { a[v], a[v], v };
	}
	vector <vector <int>> all;
	for (auto u : g[v]) {
		vector <int> get = dfs(u);
		if (get[0] == -1 and get[1] == -1) return get;
		all.push_back(get);
	}
	sort(all.begin(), all.end());
	ans[v] = { all[0][2] };
	for (int i = 1; i < all.size(); ++i) {
		if (all[i][0] < all[i - 1][1]) return { -1, -1 };
		ans[v].push_back(all[i][2]);
	}
	return { all[0][0], all.back()[1], v };
}
void gen(int cur) {
	if (c) return;
	if (cur == need.size()) {
		vector <int> get = dfs(1);
		if (get[0] == -1 and get[1] == -1) return;
		c = true;
		return;
	}
	for (auto x : ok[need[cur]]) {
		a[need[cur]] = x;
		ans[need[cur]] = { x };
		gen(cur + 1);
		if (c) return;
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n; cin >> n;
	g.resize(n + 1);
	a.resize(n + 1);
	ok.resize(n + 1);
	ans.resize(n + 1);
	for (int i = 1; i <= n; ++i) {
		int t; cin >> t;
		if (t == 1) {
			int k; cin >> k;
			while (k--) {
				int x; cin >> x;
				g[i].push_back(x);
			}
		}
		else {
			int k; cin >> k;
			while (k--) {
				int x; cin >> x;
				ok[i].push_back(x);
			}
			need.push_back(i);
		}
	}
	gen(0);
	if (c) {
		cout << "Yes";
		for (auto x : ans) {
			for (auto y : x) cout << y << ' ';
			cout << '\n';
		}
	}
	else cout << "No\n";
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/