#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int k, n;
string s;
vector<vector<bool>> can_delete;


int solve() {
    if (!(cin >> k >> n))
        return 1;
    can_delete.clear();
    can_delete.resize(k, vector<bool>(k, false));
    for (int i = 0; i < k; ++i) {
        string e;
        cin >> e;
        for (int j = 0; j < k; ++j) {
            if (e[j] == '1') {
                can_delete[i][j] = true;
            }
        }
    }

    cin >> s;
    string min_ans = s;

    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<bool> deleted(n, false);
        bool changed = true;
        while (changed) {
            changed = false;
            for (int j = n - 1; j >= 0; --j) {
                if (deleted[j]) continue;
                int p = n;
                for (int jj = j + 1; jj < n; ++jj) {
                    if (!deleted[jj]) {
                        p = jj;
                        break;
                    }
                }
                if (mask & (1 << p)) {
                    if (can_delete[s[j] - 'a'][s[p] - 'a']) {
                        deleted[p] = true;
                        changed = true;
                        break;
                    }
                }
            }
        }
        string cur_ans;
        for (int i = 0; i < n; ++i) {
            if ((mask & (1 << i)) && (!(deleted[i]))) {
                cur_ans = "-";
                break;
            } else {
                if (!deleted[i]) {
                    cur_ans += s[i];
                }
            }
        }
        if (cur_ans != "-") {
            min_ans = min(min_ans, cur_ans);
        }
    }
    cout << min_ans << '\n';

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
