#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()

const int N = 1e5 + 7;

int n, m;
char s[N];
vector<pair<int, char>> p[N];
vector<int> pc[N];
vector<int> ind[N];
bool ok[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    cin >> s[i];
  }
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    for (int j = 0; j < k; ++j) {
      int indd;
      char c;
      cin >> indd >> c;
      --indd;
      p[i].push_back({indd, c});
      if (s[indd] != c) {
        pc[i].push_back(indd);
        ind[indd].push_back(i);
      }
    }
  }
  set<pair<int, int>> r;
  for (int i = 0; i < n; ++i) {
    r.insert({SZ(pc[i]), i});
  }
  vector<int> ans;
  while (!r.empty()) {
    int i = r.begin()->second;
    r.erase(r.begin());
    ans.push_back(i);
    if (!pc[i].empty()) {
      cout << "-1\n";
      exit(0);
    }
    for (auto e : p[i]) {
      ok[e.first] = true;
      for (int j : ind[e.first]) {
        pc[j].pop_back();
      }
      ind[e.first].clear();
    }
  }
  if (count(ok, ok + m, true) != m) {
    cout << "-1\n";
  } else {
    for (int i : ans) {
      cout << i + 1 << ' ';
    }
    cout << '\n';
  }
  return 0;
}
