#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unrol-loops")

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

#define pb push_back
#define _ << " " <<
#define ff first
#define ss second

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

const int N = 1e5 + 10;

vector<int> g[N];
vector<int> gt[N];

vector<vector<pair<int, char> > > arr(N, vector<pair<int, char> >());

int ind = 0;
vector<int> ans(N);
vector<int> used(N);
vector<int> a(N);
string s;

void update(int num) {
    for (auto p : arr[num]) {
        a[p.ff] = 1;
    }
}

bool check(int num) {
    for (auto to : arr[num]) {
        if (s[to.ff] != to.ss && a[to.ff] == 0) return false;
    }
    return true;
}

void dfs(vector<int> &v) {
    set<int> tmp;
    for (auto u : v) {
        for (auto to : g[u]) {
            if (check(to)) {
                tmp.insert(to);
            }
        }
    }

    if (tmp.size() == 0) return;

    vector<int> to;
    for (auto x : tmp) {
        to.pb(x);
        update(x);
        ans[ind] = x + 1;
        ++ind;
    }
    dfs(to);
}

void solve() {
    int n, m;
    cin >> n >> m;
    cin >> s;

    int k, c;
    char a1;
    vector<vector<int> > v(m + 10, vector<int>());
    for (int i = 0; i < n; ++i) {
        cin >> k;
        for (int j = 0; j < k; ++j) {
            cin >> c >> a1;
            arr[i].pb({c - 1, a1});

            if (s[c - 1] == a1) {
                v[c - 1].pb(i);
            }
        }
    }

    for (auto to : v) {
        if (to.size() == 0) {
            cout << -1;
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto p : arr[i]) {
            if (s[p.ff] != p.ss) {
                for (auto to : v[p.ff]) {
                    g[to].pb(i);
                    gt[i].pb(to);
                }
            }
        }
    }

    vector<int> s;
    for (int i = 0; i < n; ++i) {
        if (gt[i].size() == 0) {
            s.pb(i);
            update(i);
            used[i] = 1;
            ans[ind] = i + 1;
            ++ind;
        }
    }

    if (s.size() == 0) {
        cout << -1;
        return;
    }
    dfs(s);

    for (int i = 0; i < m; ++i) {
        if (a[i] == 0) {
            cout << -1;
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (ind == n) break;
        if (used[i] == 0) {
            ans[ind] = i;
            used[i] = 1;
            ++ind;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    //freopen("output.txt", "w", stdout);
    //freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}




