#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <iomanip>
#include <random>
#include <array>

#define int long long

using namespace std;

random_device rd;
mt19937_64 get_rand(rd());

vector <int> g[100010];
vector <array <int, 3>> a[100010];
vector <int> pr[100010];

void dfs(int v) {
	for (int u : g[v])
		if (a[u].empty())
			dfs(u);
	if (g[v].size() == 1)
		a[v] = a[g[v][0]];
	if (g[v].size() == 2) {
		for (auto& [l, r, ul] : a[g[v][0]])
			for (auto& [l1, r1, ul1] : a[g[v][1]])
				if (l1 >= r) {
					a[v].push_back({ min(l, l1), max(r, r1), 0ll });
				}
		for (auto& [l, r, ul] : a[g[v][1]])
			for (auto& [l1, r1, ul1] : a[g[v][0]])
				if (l1 >= r) {
					a[v].push_back({ min(l, l1), max(r, r1), 1ll });

				}
	}
}

vector <int> ans[100010];
int t[100010];

void dfs1(int v, int k, int k1) {
	if (g[v].size() == 2) {
		ans[v] = { g[v][k] + 1, g[v][1 - k] + 1 };

		int it = 0, it1 = 0;
		int sz = a[g[v][1 - k]].size();
		for (auto& [l, r, ul] : a[g[v][k]]) {
			it1 = 0;
			for (auto& [l1, r1, ul1] : a[g[v][1 - k]]) {
				if (l1 >= r && min(l, l1) == a[v][k1][0] && max(r, r1) == a[v][k1][1]) {
					
					if (t[g[v][k]] == 1)
						dfs1(g[v][k], ul, it);
					else
						ans[g[v][k]] = { l };

					if (t[g[v][1 - k]] == 1)
						dfs1(g[v][1 - k], ul1, it1);
					else
						ans[g[v][1 - k]] = { l1 };

					break;
				}
				it1++;
			}
			it++;
		}
	}
	if (g[v].size() == 1) {
		ans[v] = { g[v][0] + 1 };
		if (t[g[v][0]] == 1)
			dfs1(g[v][0], k, k1);
		else
			ans[g[v][0]] = { a[v][0][0] };

	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> t[i] >> k;
		if (t[i] == 1)
			for (int ii = 0; ii < k; ii++) {
				int j;
				cin >> j;
				j--;
				g[i].emplace_back(j);
			}
		else
			for (int ii = 0; ii < k; ii++) {
				int j;
				cin >> j;
				a[i].push_back({ j, j, -1 });
			}
	}

	dfs(0);

	if (a[0].empty())
		cout << "No\n";
	else {
		cout << "Yes\n";
		dfs1(0, a[0][0][2], 0);
		for (int i = 0; i < n; i++, cout << '\n')
			for (auto i : ans[i])
				cout << i << ' ';
	}
	return 0;
}
