#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define IO ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define print(a) {for(auto iiii: a) cout << iiii << ' '; cout << '\n';}
#define printp(a) {for(auto iiii: a) cout << "{" << iiii.ff << ", " << iiii.ss << "} "; cout << '\n';}
mt19937_64 rng(2281337);
int random(int l, int r) { return uniform_int_distribution<int> (l, r)(rng); }

vector<vector<int>> graf;
vector<vector<pii>> a, pref;

void dfs(int v){
    if(graf[v].empty()) return;
    if(graf[v].size() == 1){
        dfs(graf[v][0]);
        a[v] = a[graf[v][0]];
        return;
    }
    dfs(graf[v][0]);
    dfs(graf[v][1]);
    vector<pii> tmp1, tmp2;
    int c1 = graf[v][0], c2 = graf[v][1];
    for(int k=0;k<a[c1].size();k++){
        pii i = a[c1][k];
        int j = 0;
        int mn = 1e9, ps;
        for(;j<a[c2].size();j++){
            if(a[c2][j].ff > i.ss){
                if(a[c2][j].ff > i.ss && a[c2][j].ss < mn) mn = a[c2][j].ss, ps = j;
            }
        }
        if(mn == 1e9) continue;
        a[v].pb({i.ff, mn});
        pref[v].pb({k, ps});
    }
    for(int k=0;k<a[c2].size();k++){
        pii i = a[c2][k];
        int j = 0;
        int mn = 1e9, ps;
        for(;j<a[c1].size();j++){
            if(a[c1][j].ff > i.ss && a[c1][j].ss < mn) mn = a[c1][j].ss, ps = j;
        }
        if(mn == 1e9) continue;
        a[v].pb({i.ff, mn});
        pref[v].pb({ps, k});
    }
}

vector<int> tans;

void sfd(int v, int i){
    if(graf[v].empty()){
        tans[v] = i;
        return;
    }
    if(graf[v].size() == 1){
        sfd(graf[v][0], i);
        return;
    }
    int c1 = graf[v][0], c2 = graf[v][1];
    int pc1 = pref[v][i].ff, pc2 = pref[v][i].ss;
    //cout << v << ' ' << c1 << ' ' << c2 << " | " << pc1 << ' ' << pc2 << '\n';
    if(a[c1][pc1].ss > a[c2][pc2].ff){
        swap(graf[v][0], graf[v][1]);
        //cout << "ok\n";
    }
    sfd(c1, pc1);
    sfd(c2, pc2);
}

void solve(){
    int n;
    cin >> n;
    graf.resize(n);
    a.resize(n);
    pref.resize(n);
    tans.resize(n);
    for(int i=0;i<n;i++){
        int type;
        cin >> type;
        if(type == 1){
            int k;
            cin >> k;
            while(k--){
                int x;
                cin >> x;
                x--;
                graf[i].pb(x);
            }
        }
        else{
            int k;
            cin >> k;
            while(k--){
                int x;
                cin >> x;
                a[i].pb({x, x});
            }
        }
    }
    dfs(0);
    if(a[0].empty()) cout << "No\n";
    else{
        cout << "Yes\n";
        sfd(0, 0);
        for(int i=0;i<n;i++){
            if(graf[i].empty()) cout << a[i][tans[i]].ff << '\n';
            else{
                for(auto j: graf[i]) cout << j+1 << ' ';
                cout << '\n';
            }
        }
    }
}

/*
5
1 2 5 4
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/
signed main() {
    IO
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}
