#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

bool can[27][27];
int k, n;

int to[500009];
string dp[500009];
vector<ll> pref[500009];

const ll mod = (1e9) + 9;
const int p = 27;
ll powp[500009];

string s;

inline void build(int x) {
    pref[x].resize(dp[x].size() + 1);
    for (int i = 0; i < dp[x].size(); i++) {
        pref[x][i + 1] = (pref[x][i] * p + dp[x][i] - 'a');
    }
}

inline bool check(char c, int pos, int x) {
    c -= 'a';
    int mxlef = pos;
    for (int i = pos - 1; i >= x; i--) {
        if (can[s[i] - 'a'][c]) {
            if (mxlef >= i) {
                to[pos] = i;
                return 1;
            }
        }

        mxlef = min(mxlef, to[i]);
    }

    return 0;
}

const ll mod_2 = (mod * mod);


inline int les(int i, int j) {
    if (i == -1) return j;
    if (j == -1) return i;
    int l = 0, r = min(dp[i].size(), dp[j].size()) + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (pref[i][m] == pref[j][m]) l = m;
        else r = m;
    }

    //cout << "\t" << l << ' ' << min(dp[i].size(), dp[j].size()) << endl;

    if (l == min(dp[i].size(), dp[j].size())) {
        if (dp[i].size() < dp[j].size()) return i;
        return j;
    }

    if (dp[i][l] < dp[j][l]) return i;
    return j;
}

int lenfor[500009];
int spar[20][500009];

inline void add(int j) {
    for (int i = 0; j + (1 << i) <= n + 1; i++) {
        if (i == 0) {
            spar[i][j] = j;
        }

        else {
            spar[i][j] = les(spar[i - 1][j], spar[i - 1][j + (1 << (i - 1))]);
        }
    }
}

void fill_sp() {
    for (int i = 0; i < 20; i++) {
        for (int j = 0; j + (1 << i) <= n + 1; j++) {
            spar[i][j] = -1;
           // cout << "FILL " << i << ' ' << j << endl;
        }
    }

    for (int i = 2; i <= n + 1; i++) lenfor[i] = lenfor[i >> 1] + 1;
}

inline int getmn(int l, int r) {
    int len = lenfor[r - l + 1];
    //cout << len << ' ' << spar[len][l] << ' ' << spar[len][r - (1 << len) + 1] << ' ' << r - (1 << len) + 1 << endl;
    return les(spar[len][l], spar[len][r - (1 << len) + 1]);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
       // freopen("wa.txt", "w", stdout);
    #endif // localfile

    cin >> k >> n;

    powp[0] = 1;
    for (int i = 0; i < n; i++) {
        powp[i + 1] = (powp[i] * p);
    }

    fill_sp();

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k ; j++) {
            char c;
            cin >> c;
            can[i][j] = c - '0';
        }
    }

    cin >> s;
    s += '\n';
    dp[n] = "";
    build(n);
    add(n);

    for (int i = 0; i < n; i++) to[i] = -1;

    for (int i = n - 1; i > -1; i--) {
        int j = i + 1;
        dp[i] = "-";

        while (j < n && (to[j] != -1 || check(s[j], j, i))) {
            j++;
        }
        //cout << i << endl;

        int wh = -1;
        /*for (int t = i + 1; t <= j; t++) {
            //cout << "GO: " << i << ' '<< t << ' ' << wh << endl;// << ' ' << les(t, wh)<< endl;
            if (wh == -1 || les(t, wh)) {
                wh = t;
            }
        }*/

       // cout << i << ' ' << j << endl;
        wh = getmn(i + 1, j);
       // cout << i << ' ' << wh << endl;

        dp[i] = s[i] + dp[wh];
        build(i);
        add(i);
    }

    cout << dp[0];

    return 0;
}
