#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define mp make_pair
#define pii pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
const ll MAXN = 5e5 + 10;

using namespace std;

bool can_delete[27][27];
int sz[MAXN];
int p[MAXN];
int ind[MAXN];
int r[MAXN];
int l[MAXN];
int n, k;

void del(int i) {
    if (l[i] != -1) r[l[i]] = r[i];
    if (r[i] != n) l[r[i]] = l[i];
}

int answer = 0;

void solve() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c; cin >> c;
            can_delete[i][j] = c - '0';
        }
    }
    string s; cin >> s;
    for (int i = n - 1; i > -1; --i) {
        if (i == n - 1) continue;
        while (i + sz[i] + 1 < n && can_delete[s[i] - 'a'][s[i + sz[i] + 1] - 'a']) {
            sz[i] += sz[i + sz[i] + 1] + 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        p[i] = -1;
        r[i] = i + 1;
        l[i] = i - 1;
    }
    deque<int> q1;
    vector<tuple<int, int, int>> q2;
    q1.push_back(0);
    while (q1.size()) {
        int x = q1.front();
        q1.pop_front();
        for (int i = r[x]; i <= x + sz[x] + 1; i = r[i]) {
            p[i] = x;
            q2.push_back(make_tuple(ind[p[i]], s[i] - 'a', i));
            del(i);
        }
        sort(all(q2));
        int cnt = 0;
        for (int i = 0; i < q2.size(); ++i) {
            int index = get<2>(q2[i]);
            if (i > 0) {
                if (get<0>(q2[i - 1]) != get<0>(q2[i]) ||
                    get<1>(q2[i - 1]) != get<1>(q2[i])) ++cnt;
            }
            if (index + sz[index] == n - 1) {
                answer = index;
                while (q1.size() && p[q1.back()] == cnt) q1.pop_back();
                break;
            }
            ind[index] = cnt;
            q1.push_back(get<2>(q2[i]));
        }
        q2.clear();
    }
    string ans;
    for (; answer > -1; answer = p[answer]) ans.push_back(s[answer]);
    reverse(all(ans));
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
