#include <bits/stdc++.h>

using namespace std;

struct card {
	int place, x, ind;
	card(){};
	card(int place, int x, int ind): place(place), x(x), ind(ind) {};
};

bool operator <(card a, card b) {
	if (a.place * a.x != b.place * b.x) return (a.place * a.x < b.place * b.x);
	return (a.ind < b.ind);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<set<pair<int, int>>> vec(n);
	vector<vector<pair<int, int>>> orvec(n, vector<pair<int, int>>());
	set<card> cards;
	vector<set<card>> chosen(m); 
	vector<bool> done(m, 0);
	vector<int> ans;
	for (int t = 0; t < n; ++t) {
		int k;
		cin >> k;
		if (k == 0) {
			ans.push_back(t);
			continue;
		}
		for (int i = 0; i < k; ++i) {
			int x;
			char c;
			cin >> x >> c;
			--x;
			int now = (c == s[x] ? 1 : -1);
			vec[t].insert({x, now});
			if (now == 1) orvec[t].push_back({x, now});
		}
		int newplace = (*(vec[t].begin())).first;
		int newx = (*(vec[t].begin())).second;
		cards.insert(card(newplace, newx, t));
		chosen[newplace].insert(card(newplace, newx, t));
	}
	while (!cards.empty()) {
		card now = *(--(cards.end()));
		if (!done[now.place] && now.x == -1) {
			cout << -1 << '\n';
			return 0;
		}
		//delete this, add next
		vec[now.ind].erase(vec[now.ind].begin());
		cards.erase(now);
		chosen[now.place].erase(now);
		if (vec[now.ind].empty()) {
			//if no next add to the ans and remake done
			ans.push_back(now.ind);
			for (int i = 0; i < orvec[now.ind].size(); ++i) {
				//if (orvec[now.ind][i].second == 1) {
				int ind = orvec[now.ind][i].first; 
				if (done[ind]) continue;
				done[ind] = 1;
				vector<card> nowv;
				for (card c: chosen[ind]) {
					nowv.push_back(c);
				}
				for (card c: nowv) {
					card newnow = c;
					newnow.x = 1;
					chosen[ind].erase(c);
					chosen[ind].insert(newnow);
					cards.erase(c);
					cards.insert(newnow);
				}
				//}
			}
		}
		else {
			int newplace = (*(vec[now.ind].begin())).first;
			int newx = (done[newplace] ? 1 : (*(vec[now.ind].begin())).second);
			cards.insert(card(newplace, newx, now.ind));
			chosen[newplace].insert(card(newplace, newx, now.ind));
		}		
	}
	for (int i = 0; i < m; ++i) {
		if (!done[i]) {
			cout << -1 << '\n';
			return 0;
		}
	}
	for (int x: ans) {
		cout << x + 1 << ' ';
	}
	cout << '\n';
}