#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

// #define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#pragma GCC optimize("Ofast,no-stack-protector")

const int A = 26;

int g[A][A];

string ans;

set<string> used;

void f(string s) {
	if (used.count(s)) return;
	used.insert(s);
	// dbg(s);
	chkmin(ans, s);
	int n = s.size();
	for (int i = 1; i < n; i++) {
		if (g[s[i - 1] - 'a'][s[i] - 'a']) {
			string nw;
			for (int j = 0; j < n; j++) {
				if (j != i) nw.pb(s[j]);
			}
			f(nw);
		}
	}
}



signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int k, n;
	string s;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			g[i][j] = c - '0';
		}
	}
	cin >> s;
	ans = s;
	// dbg(s);
	f(s);
	cout << ans << "\n";
}
/*
3 7
010
001
100
abacaba
-> aac

3 5
010
001
100
bcacb
-> bacb
*/