#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;

int main()
{
	int n, m; cin >> n >> m;

	string s; cin >> s;

	vector<int> cnt(n);
	vector<vector<int>> make(n), need(m);

	for (int i = 0; i < n; ++i)
	{
		int k; cin >> k;
		while (k--)
		{
			int p; char h; cin >> p >> h; --p;
			if (s[p] == h)
			{
				make[i].push_back(p);
			}
			else
			{
				++cnt[i];
				need[p].push_back(i);
			}
		}
	}

	set<pair<int, int>> ord;
	for (int i = 0; i < n; ++i)
		ord.emplace(cnt[i], i);

	vector<int> res, used(m);
	while (ord.size())
	{
		int v = ord.begin()->second; ord.erase(ord.begin());
		if (cnt[v] != 0) break;

		res.push_back(v);
		for (auto&i: make[v])
			if (!used[i])
			{
				used[i] = true;
				for (auto& j : need[i])
				{
					ord.erase({ cnt[j], j });
					--cnt[j];
					ord.insert({ cnt[j], j });
				}
			}
	}

	bool good = true;
	for (auto& i : used)
		good &= i;

	if (res.size() < n || ! good)
	{
		cout << -1 << '\n';
	}
	else
	{
		for (auto& i : res)
			cout << i + 1 << ' ';
		cout << '\n';
	}

	return 0;
}