/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm,avx,avx2,popcnt")
*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <utility>
#include <functional>
#include <numeric>
#include <chrono>
#include <random>


#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define left left1337
#define right right1337


#ifdef LOCAL 
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;

template<typename T1, typename T2> inline void mine(T1 & x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 & x, const T2 &y) {if (x < y) x = y;}


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef string str;
typedef vector<str> vs;
typedef vector<vch> vvch;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


const int N = 200100;
vector<pair<int, char>> ss[N];
bool have[N];
int bad[N];
vi in[N];

void no() {
	cout << "-1\n";
	exit(0);
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, m;
	str s;
	cin >> n >> m >> s;
	memset(have, 1, sizeof(have));
	vi can;
	fi(0, n) {
		int k;
		cin >> k;
		ss[i].resize(k);
		fx(x, ss[i]) {
			cin >> x.first >> x.second;
			--x.first;
			if (s[x.first] != x.second) {
				++bad[i];
				in[x.first].pb(i);
			}
		}
		if (bad[i] == 0) can.pb(i);
	}

	int cnt = n;
	vi p;
	while (cnt--) {
		if (can.empty()) no();
		int best = can.back();
		can.ppb;
		p.pb(best);
		for (auto[a, b] : ss[best]) {
			have[a] = false;
			fx(id, in[a]) {
				--bad[id];
				if (bad[id] == 0) 
					can.pb(id);
			}
			in[a].clear();
		}
	}
	fi(0, m) {
		if (have[i]) {
			no();
		}
	}
	fx(x, p) cout << x + 1 << ' ';
	cout << '\n';
}