#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> A(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            A[i][j] = s[j] == '1';
        }
    }
    string s;
    cin >> s;
    if (k == 1) {
        if (A[0][0]) {
            cout << "a\n";
        } else {
            cout << s << "\n";
        }
        return 0;
    }
    //
    string t;
    for (char ch : s) {
        if (t.empty() || ch != 'b' || !A[t.back() - 'a'][1]) {
            t.push_back(ch);
        }
    }
    s = t;
    //
    for (int i = (int)s.size() - 1; i >= 1; --i) {
        if (s[i] == 'b') {
            break;
        }
        //
        if (A[s[i - 1] - 'a'][0]) {
            s.pop_back();
        }
    }
    cout << s << "\n";
    return 0;
}