#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define out(x); { for (auto i : x) cout << i << ' '; cout << endl; }

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int N = 6e5;

int lg[N];
int f[33][33];
string s;
int it;
int n, m, k;

int get(int it, int len) {
    int x = 0;
    for (int i = it; i < s.size() && i < it + len; i++) {
        if (s[i] == '1')
            x += (1 << (i - it));
    }
    return x;
}

bool turn() {
    vi fd;
    for (int i = 1; i <= n; i++) {
        bool ok = false;
        for (int i2 = i, j = n; i2 > 0; j--, i2--) {
            if (f[i2][j] == 0)
                ok = true;
        }
        if (ok)
            fd.pb(i);
    }
    for (int j = n - 1; j > 0; j--) {
        bool ok = false;
        for (int j2 = j, i = n; j2 > 0; i--, j2--) {
            if (f[i][j2] == 0)
                ok = true;
        }
        if (ok)
            fd.pb(n + j);
    }
    //cout << "here" << endl;
    //cout << fd.size() << endl;
    //out(fd);

    int x = fd[get(it, lg[fd.size()])];
    //cout << x << endl;

    if (x <= n) {
        for (int i2 = x, j = n; i2 > 0; i2--, j--) {
            if (f[i2][j] == 0) {
                for (int i3 = i2; i3 <= n; i3++) {
                    for (int j3 = j; j3 <= n; j3++)
                        f[i3][j3] = 1;
                }
                cout << i2 << " " << j << endl;
                it += lg[fd.size()];
                return (i2 != 1 || j != 1);
            }
        }
    } else {
        for (int j2 = x - n, i = n; j2 > 0; i--, j2--) {
            if (f[i][j2] == 0) {
                for (int i3 = i; i3 <= n; i3++) {
                    for (int j3 = j2; j3 <= n; j3++)
                        f[i3][j3] = 1;
                }
                cout << i << " " << j2 << endl;
                it += lg[fd.size()];
                return (i != 1 || j2 != 1);
            }
        }
    }
}

bool upd() {
    int i, j; cin >> i >> j;
    if (i == 1 && j == 1)
        return false;
    for (int i2 = i; i2 <= n; i2++) {
        for (int j2 = j; j2 <= n; j2++)
            f[i2][j2] = 1;
    }
    /*for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++)
            cerr << f[i][j] << " ";
        cerr << endl;
    }
    cerr << endl;*/
    return true;
}

void solve1() {
    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;
    cin >> n >> k >> m;
    cin >> s;

    int gn = 0;
    while (it < s.size()) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                f[i][j] = 0;
        }
        if (gn % 2 == 0) {
            while (true) {
                if (!turn())
                    break;
                if (!upd())
                    break;
            }
        } else {
            while (true) {
                if (!upd())
                    break;
                if (turn())
                    break;
            }
        }
        gn++;
    }
    cout << 0 << endl;
}

void add(int x, int len) {
    for (int i = 0; i < len; i++) {
        if (x & (1 << i))
            s += "1";
        else
            s += "0";
    }
}

bool tspy() {
    vi fd;
    for (int i = 1; i <= n; i++) {
        bool ok = false;
        for (int i2 = i, j = n; i2 > 0; j--, i2--) {
            if (f[i2][j] == 0)
                ok = true;
        }
        if (ok)
            fd.pb(i);
    }
    for (int j = n - 1; j > 0; j--) {
        bool ok = false;
        for (int j2 = j, i = n; j2 > 0; i--, j2--) {
            if (f[i][j2] == 0)
                ok = true;
        }
        if (ok)
            fd.pb(n + j);
    }

    int ti, tj; cin >> ti >> tj;
    int num;
    if (ti == tj)
        num = 1;
    if (ti < tj)
        num = 1 + tj - ti;
    if (ti > tj)
        num = n + ti - tj;

    for (int i3 = ti; i3 <= n; i3++) {
        for (int j3 = tj; j3 <= n; j3++)
            f[i3][j3] = 1;
    }

    for (int i = 0; i < fd.size(); i++) {
        if (fd[i] == num)
            add(i, lg[fd.size()]);
    }
}

void solve2() {
    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;
    cin >> n >> k >> m;
    int g; cin >> g;

    for (int i = 0; i < g; i++) {
        if (i % 2) {
            while (true) {
                if (!tspy())
                    break;
                if (!upd())
                    break;
            }
        } else {
            while (true) {
                if (!upd())
                    break;
                if (!tspy())
                    break;
            }
        }
    }

    s.resize(m);
    cout << s << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);

    int t; cin >> t;
    if (t == 1) {
        solve1();
    } else {
        solve2();
    }
}
