#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long

void solve() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector <int> cnt(n);
	vector <int> used(n);
	vector <int> isPlacedPos(m);
	vector <vector <int>> fbd(m);
	vector <vector <int>> w(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int pos;
			char val;
			cin >> pos >> val;
			--pos;
			w[i].push_back(pos);
			if (s[pos] != val) {
				fbd[pos].push_back(i);
				++cnt[i];
			}
		}
	}
	vector <int> path;
	deque <int> st;
	for (int i = 0; i < n; ++i) {
		if (cnt[i] == 0) {
			st.push_back(i);
			used[i] = true;
		}
	}
	while (!st.empty()) {
		int u = st.front();
		st.pop_front();
		path.push_back(u);
		for (int pos : w[u]) {
			if (isPlacedPos[pos] == false) {
				isPlacedPos[pos] = true;
				for (int v : fbd[pos]) {
					--cnt[v];
					if (cnt[v] == 0 && used[v] == false) {
						used[v] = true;
						st.push_back(v);
					}
				}
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (isPlacedPos[i] == false) {
			cout << "-1\n";
			return;
		}
	}
	if (path.size() != n) {
		cout << "-1\n";
		return;
	}
	for (int i = 0; i < n; ++i) {
		cout << path[i] + 1 << " ";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	while (test--) {
		solve();
	}
}