#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
#include <cassert>
using namespace std;
//#define int long long

void topsort(int u, vector <vector <int>>& w, vector <int>& type, vector <int>& path) {
	if (type[u] == 1) {
		for (int v : w[u]) {
			topsort(v, w, type, path);
		}
	}
	path.push_back(u);
}

void solve() {
	int n;
	cin >> n;
	vector <vector <int>> w(n);
	vector <int> type(n);
	int to = 1;
	for (int i = 0; i < n; ++i) {
		cin >> type[i];
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			--x;
			w[i].push_back(x);
		}
		if (type[i] == 2) {
			to *= w[i].size();
		}
	}
	vector <int> path;
	topsort(0, w, type, path);
	//reverse(path.begin(), path.end());
	for (int mask = 0; mask < to; ++mask) {
		int nmask = mask;
		bool ok = true;
		vector <int> mn(n), mx(n);
		for (int u : path) {
			if (type[u] == 2) {
				mn[u] = w[u][nmask % w[u].size()];
				mx[u] = mn[u];
				nmask /= w[u].size();
			}
			else {
				sort(w[u].begin(), w[u].end(), [&mn, &mx](int lhs, int rhs) {
					return mn[lhs] < mn[rhs];
					});
				for (int i = 1; i < w[u].size(); ++i) {
					if (mn[w[u][i]] < mx[w[u][i - 1]]) {
						ok = false;
						break;
					}
				}
				mn[u] = mn[w[u][0]];
				mx[u] = mx[w[u].back()];
			}
		}
		if (ok) {
			cout << "Yes\n";
			
			for (int u = 0; u < n; ++u) {
				if (type[u] == 2) {
					cout << mn[u] + 1 << "\n";
				}
				else {
					for (int v : w[u]) {
						cout << v + 1 << " ";
					}
					cout << "\n";
				}
			}
			exit(0);
		}
	}
	cout << "No\n";
	return;
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);

	
#endif
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	int test = 1;
	while (test--) {
		solve();
	}
}