#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
//#include <random>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

//mt19937 rng(104);

typedef bitset<26> bs;

void solve(){
    int k, n; cin >> k >> n;
    vector<bs> a(k);
    FOR(i, 0, k) {
        string s;
        cin >> s;
        FOR(j, 0, k){
            a[j][i] = s[j] - '0';
        }
    }
    string s; cin >> s;
    vi b(n);
    FOR(i, 0, n){
        b[i] = s[i] - 'a';
    }
    vector<vi> rem(n);
    vector<vector<vi>> g(n+1, vector<vi>(27));
    vi used(n+1);
    FOR(i, 1, n){
        used.assign(n+1, 0);
        used[i-1] = 1;
        vi q{i-1};
        while(!q.empty()){
            int j = q.back(); q.pop_back();
            if(a[b[i]][b[j]]){
                rem[i].push_back(j);
            }
            g[j][b[i]+1].push_back(i);
            for(int l : rem[j]){
                if(used[l]) continue;
                used[l] = 1;
                q.push_back(l);
            }
        }
    }
    used.assign(n+1, 0);
    used[n-1] = 1;
    vi q{n-1};
    while(!q.empty()) {
        int j = q.back();
        q.pop_back();
        g[j][0].push_back(n);
        for (int l : rem[j]) {
            if (used[l]) continue;
            used[l] = 1;
            q.push_back(l);
        }
    }
    vi cur{0};
    used.assign(n+1, 0);
    used[0] = 1;
    vi prev(n+1);
    prev[0] = -1;
    while(!cur.empty()){
        int i = cur.back(); cur.pop_back();
        if(used[i] == 2) continue;
        used[i] = 2;
        if(i == n) continue;
        int mn = 27;
        FOR(j, 0, 27){
            if(!g[i][j].empty()){
                mn = j;
                break;
            }
        }
        for(int j = sz(g[i][mn])-1; j >= 0; --j){
            if(used[g[i][mn][j]]) continue;
            cur.push_back(g[i][mn][j]);
            used[g[i][mn][j]] = 1;
            prev[g[i][mn][j]] = i;
        }
    }
    int i = n;
    vector<char> ans;
    while(prev[i] != -1){
        ans.push_back(s[prev[i]]);
        i = prev[i];
    }
    reverse(all(ans));
    for(char c : ans) cout << c;
    cout << '\n';
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}