#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

int a[26][26];
string s;
int k, n;

bool can_delete(string &s, int i) {
    if (i == 0) {
        return 0;
    }
    return a[s[i - 1] - 'a'][s[i] - 'a'];
}

bool check(int l, int r) {
    if (l >= r) {
        return 1;
    }
    string t = s;
    for (int i = r - 1; i >= l; i--) {
        if (i < r && can_delete(t, i)) {
            t.erase(t.begin() + i);
            r--;
            i++;
        }
    }
    return l >= r;
}

void del(int l, int r) {
    if (l >= r) {
        return;
    }
    for (int i = r - 1; i >= l; i--) {
        if (i < r && can_delete(s, i)) {
            s.erase(s.begin() + i);
            r--;
            n--;
            i++;
        }
    }
}

signed main() {
    fastream;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    cin >> s;
    vector<int> prv = {0};
    vector<int> nxt;
    string res;
    while (1) {
        nxt.clear();
        char c = 'z';
        bool fl = 0;
        for (int i : prv) {
            if (check(i, n)) {
                fl = 1;
                break;
            }
            for (int j = i; j < n; j++) {
                if (check(i, j)) {
                    c = min(c, s[j]);
                }
            }
        }
        if (fl) {
            break;
        }
        res += c;
        for (int i : prv) {
            for (int j = i; j < n; j++) {
                if (s[j] == c && check(i, j)) {
                    nxt.push_back(j + 1);
                }
            }
        }
        swap(nxt, prv);
    }

    cout << res << endl;
}