#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete(void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);

const int maxn = 2e5 + 10;

int deg[maxn];
vi g[maxn];

vi a[maxn];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

//    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    set<pi> q;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int pos;
            string sym;
            cin >> pos >> sym;
            pos--;
            a[i].push_back(pos);
            if (sym[0] == s[pos]) continue;
            else {
                deg[i]++;
                g[pos].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        q.insert({deg[i], i});
    }
    vi ans;
    while (!q.empty()) {
        auto it = *q.begin();
        q.erase(q.begin());
        if (it.x != 0) {
            cout << -1 << '\n';
            return 0;
        }
        int id = it.y;
        ans.push_back(id);
        for (auto &pos : a[id]) {
            for (auto &el : g[pos]) {
                auto it2 = q.find({deg[el], el});
                if (q.end() != it2) {
                    q.erase(it2);
                }
                deg[el]--;
                q.insert({deg[el], el});
            }
            g[pos].clear();
        }
    }
    for (auto &el : ans) cout << el + 1 << " ";
    cout << '\n';


    return 0;
}
