#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete(void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);

const int maxk = 26;
const int maxn = 20;

int a[maxk][maxk];
int b[maxn];
int dp[1<<maxn];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

//    freopen("input.txt", "r", stdin);
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        b[i] = s[i] - 'a';
    }
    dp[0] = 1;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (dp[mask] == 0) continue;
        vpi c;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                continue;
            }
            c.push_back({b[i], i});
        }
        for (int i = 0; i + 1 < sz(c); i++) {
            int sym1 = c[i].x;
            int sym2 = c[i + 1].x;
            if (a[sym1][sym2]) {
                dp[mask | (1 << c[i + 1].y)] = 1;
            }
        }
    }
    string best = s;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (dp[mask] == 0) continue;
        string c;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) continue;
            c += s[i];
        }
        amin(best, c);
    }
    cout << best << '\n';


    return 0;
}