#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete(void *) noexcept {}

//#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);
const int maxn = 2048;
const int maxk = 26;
int ans[maxn];
int a[maxk][maxk];
int b[maxn];
int tmr[maxn];
bitset<maxn> can[maxn];

vi g[maxn];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

//    freopen("input.txt", "r", stdin);
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    for (int i = 0; i <= n; i++) ans[i] = maxn;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        b[i] = s[i] - 'a';
    }
    b[n] = -1;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int sym1 = b[i], sym2 = b[j];
            if (a[sym1][sym2]) can[i][j] = true;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            can[i] |= can[j];
        }
        int ft_zero = -1;
        for (int j = i + 1; j < n; j++) {
            if (can[i][j] == 0) ft_zero = (ft_zero == -1 ? j : ft_zero);
            else {
                if (ft_zero != -1) can[i][j] = false;
            }
        }
        int mn = maxn;
        for (int j = i + 1; j <= n; j++) {
            if (b[j] < mn) mn = b[j];
            if (can[i][j] == 0) break;
        }
        for (int j = i + 1; j <= n; j++) {
            if (b[j] == mn) g[i].push_back(j);
            if (can[i][j] == 0) break;
        }
//        cout << i << ": ";
//        for (int j = 0; j < n; j++) {
//            if (can[i][j]) cout << j << ' ';
//        }
//        cout << "\n";
    }
    vi q;
    q.push_back(0);
    ans[0] = b[0];
    for (int i = 1; i < n && !q.empty(); i++) {
        int best = maxn;
        vi tmp;
        for (auto &v : q) {
            if (v == n) break;
            for (auto j : g[v]) {
                if (tmr[j] == i) {
                    continue;
                }
                tmr[j] = i;
                if (best > b[j]) {
                    best = b[j];
                    tmp.clear();
                }
                if (b[j] == best) {
                    tmp.push_back(j);
                }
            }
        }
        ans[i] = best;
        swap(q, tmp);
    }
    for (int i = 0; i < n; i++) {
        if (ans[i] == -1) break;
        cout << char('a' + ans[i]);
    }


    return 0;
}