#include <bits/stdc++.h>

#define next my_next

using namespace std;

const int MAXN = 10000, MAXLOG = 14, MAXK = 26;

unsigned long long H[MAXN][MAXLOG];
int next[MAXN][MAXLOG], lg[MAXN], len[MAXN];
string s;

int get_min_str(int i, int j) {
    if (len[i] > len[j]) {
        swap(i, j);
    }
    int mi = i, mj = j;
    for (int k = lg[i]; k >= 0; k--) {
        if ((1 << k) <= len[i] && H[i][k] == H[j][k]) {
            i = next[i][k], j = next[j][k];
        }
    }
    if (i == s.size() || s[i] < s[j]) {
        return mi;
    } else {
        return mj;
    }
}

int last[MAXK], matrix[MAXK][MAXK];

string ans[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (int i = 2; i < MAXN; i++) {
        lg[i] = lg[i / 2] + 1;
    }
    int k, n;
    cin >> k >> n;
    char c;
    for (int i = 0; i < k; i++) {
        last[i] = n;
        for (int j = 0; j < k; j++) {
            cin >> c;
            matrix[i][j] = c - '0';
        }
    }
    ans[n] = "";
    cin >> s;
    for (int i = n - 1; i >= 0; i--) {
        int right = n;
        vector<int> mask(k);
        for (int j = 0; j < k; j++) {
            if (!matrix[s[i] - 'a'][j]) {
                right = min(right, last[j]);
            }
            mask[j] = matrix[s[i] - 'a'][j];
        }
        vector<bool> used(k);
        used[s[i] - 'a'] = true;
        bool run = true;
        while (run) {
            run = false;
            for (int j = 0; j < k; j++) {
                if (mask[j] && !used[j] && last[j] < right) {
                    used[j] = true;
                    for (int d = 0; d < k; d++) {
                        if (matrix[j][d] && !mask[d]) {
                            mask[d] = 1;
                            run = true;
                        }
                    }
                }
            }
            right = n;
            for (int j = 0; j < k; j++) {
                if (!mask[j]) {
                    right = min(right, last[j]);
                }
            }
        }
        last[s[i] - 'a'] = i;
        ans[i] = s[i];
        ans[i] += *min_element(ans + i + 1, ans + right + 1);
    }
    cout << ans[0] << '\n';
    return 0;
}
