import java.io.*;
import java.util.*;

public class task1 {
    public static void main(String[] args) throws IOException {
        int t = nextInt();
        while (t > 0) {
            t--;
            String s = nextToken();
            out.println(s);
            out.println(get_value(s));
        }
        out.close();
    }

    public static long get_value(String s) {
        long ans = 0;
        char max = 0;
        for (int i = s.length() - 1; i >= 0; i--) {
            char c = s.charAt(i);
            if (c >= max) {
                ans += get_letter(c);
                max = c;
            }
            else {
                ans -= get_letter(c);
            }
        }
        return ans;
    }

    public static long get_letter(char c) {
        long n = 1;
        int q = c - 'A';
        while (q >= 2) {
            q-=2;
            n *= 10;
        }
        if (q > 0) {
            n *= 5;
        }
        return n;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException{
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
