import java.io.*;
import java.util.*;

public class task4 {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[]lens = new int[n - 1];
        int[] pref = new int[n - 1];
        int[] ans = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            lens[i] = 1000000009;
        }
        for (int i = 0; i < m; i++) {
            int v = Math.min(nextInt(), nextInt()) - 1;
            lens[v] = Math.min(lens[v], nextInt());
        }
        int min = lens[0];
        int max = lens[0];
        for (int i = 0; i < n - 1; i++) {
            min = Math.min(min, lens[i]);
            max = Math.max(max, lens[i]);
            pref[i] = min + max;
        }
        for (int i = n - 3; i >= 0; i--) {
            pref[i] = Math.min(pref[i], pref[i + 1]);
        }
        min = pref[n - 2];
        for (int i = n - 2; i >= 0; i--) {
            ans[i] = min;
            if (i > 0) {
                min = Math.min(min, pref[i - 1]);
            }
        }
        for (int i = 0; i < n - 1; i++) {
            out.println(ans[i]);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException{
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}