#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define all(x) x.begin(), x.end()

const int inf = 2e9 + 10;

vector<int> w;
vector<vector<pair<int, int>>> g;
vector<int> res;

void dfs(int v, int mask, int mn, int mx) {
    if(mn != inf)res[v] = min(res[v], mn + mx);

   for(auto z : g[v]){
       if(((mask >> z.second) & 1) == 0)dfs(z.first, mask + (1 << z.second), min(mn, w[z.second]), max(mx, w[z.second]));
   }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    w.resize(m);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        w[i] = t;
        g[v].push_back({u, i});
        g[u].push_back({v, i});
    }
    if (n <= 20 && m <= 20) {
        res.resize(n, inf);
        dfs(0, 0, inf, -inf);
        for (int i = 1; i < n; ++i) cout << res[i] << '\n';
    }
}