#include <bits/stdc++.h>

using namespace std;
//#define int long long
const int MX = 2e9;
vector<vector<pair<int, int> > > gr;
vector<vector<int> > used;
vector<int> ans;

void gen(int v, int mn = MX, int mx = -MX){
    ans[v] = min(ans[v], mn + mx);
    for(auto u : gr[v]){
        if(!used[v][u.first]){
            used[v][u.first] = 1;
            used[u.first][v] = 1;
            gen(u.first, min(mn, u.second), max(mx, u.second));
            used[v][u.first] = 0;
            used[u.first][v] = 0;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(n, vector<int> (n));
    gr.resize(n);
    ans.resize(n, MX);
    for(int i = 0;i<m;++i){
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        int t;
        cin >> t;
        gr[x].push_back({y, t});
        gr[y].push_back({x, t});
    }
    gen(0);
    for(int i = 1;i<n;++i)
        cout << ans[i] << "\n";
}