#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MX = 2e18;
vector<vector<pair<int, int> > > gr;
vector<int> used;
vector<int> ans;
void dfs(int v, int mn, int mx){
    ans[v] = mn + mx;
    used[v] = 1;
    for(auto u: gr[v]){
        if(!used[u.first]){
            dfs(u.first, min(mn, u.second), max(mx, u.second));
        }
        break;
    }
}
bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(n);
    gr.resize(n);
    ans.resize(n);
    for(int i = 0;i<m;++i){
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        int t;
        cin >> t;
        if(x > y)
            swap(x, y);
        gr[x].push_back({y, t});
    }
    for(int i = 0;i<n;++i)
        sort(gr[i].begin(), gr[i].end(), cmp);
    dfs(0, MX, -MX);
    for(int i = 1;i<n;++i)
        cout << ans[i] << "\n";
}