#include <bits/stdc++.h>

#define ld double
#define pb push_back
#define ft first
#define sd second

using namespace std;

const int inf = (int)1e18;

int dp[5000][5000];
int pref[5000], suff[5000];
int x[5000], h[5000];
int n, q;

bool get(int l, int r) {
    if (l > r)
        return 1;
    if (dp[l][r] != -1)
        return dp[l][r];
    int lg = x[0];
    int rg = x[n - 1];
    if (l != 0) lg = x[l - 1];
    if (r + 1 != n) rg = x[r + 1];
    dp[l][r] = 0;
    for (int i = l; i <= r; ++i) {
        if ((lg <= x[i] - h[i] || x[i] + h[i] <= rg) && get(l, i - 1) && get(i + 1, r)) {
            dp[l][r] = 1;
            break;
        }
    }   
    return dp[l][r];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    for (int i = 0; i < n; ++i) {
        fill(dp[i], dp[i] + n, -1);
    }

    while (q--) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        int cur[n];
        int ans = 0;
        if (get(l, r)) ans = r - l + 1;
        for (int i = l; i <= r; ++i) {
            cur[i] = 0;
            if (get(l, i - 1))
                cur[i] = i - l;
            for (int j = l; j < i; ++j) {
                if (get(j + 1, i - 1)) {
                    cur[i] = max(cur[j] + i - j - 1, cur[i]);
                }
            }
            if (get(i + 1, r))
                ans = max(ans, r - i + cur[i]);
        }
        cout << ans << '\n';
    }
    return 0;
}