#include <bits/stdc++.h>

#define ll long long
#define ld double
#define pb push_back
#define ft first
#define sd second

using namespace std;

const ll inf = (ll)1e18;
vector <pair<ll, ll>> g[300000];
ll ans[300000];
bool u[300000];

void dfs(ll v, ll mx = -inf, ll mn = inf) {
    u[v] = 1;
    ans[v] = mx + mn;
    for (auto &to: g[v]) {
        if (!u[to.ft]) {
            dfs(to.ft, max(mx, to.sd), min(mn, to.sd));
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, m;
    cin >> n >> m;
    fill(ans, ans + n, inf);

    for (ll i = 0; i < m; ++i) {
        ll x, y, t;
        cin >> x >> y >> t;
        --x;
        --y;
        g[x].pb({y, t});
        g[y].pb({x, t});
    }
    if (m == n - 1) {
        dfs(0);
    }
    for (ll i = 1; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    return 0;
}
