#include <bits/stdc++.h>
using namespace std;

#define int long long

struct edge{
    int x, y;
};

int n, m, timer = 0;
vector < vector <int> > a, g;
vector <edge> e;
vector <int> used, col, mt;

void dfs(int v, int c){
    used[v] = 1;
    col[v] = c;
    for(auto to : g[v]){
        if(!used[to]){
            dfs(to, (c + 1) % 2);
        }
    }
}

bool khun(int v){
    if(used[v] == timer){
        return false;
    }
    used[v] = timer;
    for(auto to : g[v]){
        if(mt[to] == -1){
            mt[to] = v;
            return true;
        }
    }
    for(auto to : g[v]){
        if(khun(mt[to])){
            mt[to] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    a.resize(n);
    used.resize(m);
    col.resize(m);
    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        --x; --y;
        a[x].push_back(y);
        //a[y].push_back(x);
        e.push_back({x, y});
    }

    g.resize(m);
    for(int i = 0; i < m; ++i){
        for(int j = i + 1; j < m; ++j){
            if(e[i].x == e[j].y || e[i].y == e[j].x){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for(int i = 0; i < m; ++i) {
        if(!used[i]) {
            dfs(i, 0);
        }
    }

    mt.resize(m, -1);
    used.assign(n, 0);
    for(int i = 0; i < m; ++i){
        if(col[i] == 0){
            timer++;
            khun(i);
        }
    }

    int kol = 0;
    for(int i = 0; i < m; ++i){
        if(col[i] == 1 && mt[i] != -1){
            kol++;
        }
    }
    if(kol != m / 2){
        cout << "No";
        return 0;
    }

    cout << "Yes" << '\n';
    for(int i = 0; i < m; ++i){
        if(col[i] == 1){
            cout << e[i].x + 1 << " " << e[i].y + 1 << " " << e[mt[i]].x + 1 << " " << e[mt[i]].y + 1 << '\n';
        }
    }
}
