#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr ll INF = (ll)4e18L;
constexpr int MAXN = (int)3e5 + 1;
constexpr int ALPHABET = 26;
ll sym_val[26] = { 1, 5, 10, 50, 100, 500, (ll)1e3, (ll)5e3, (ll)1e4, (ll)5e4, (ll)1e5,
(ll)5e5, (ll)1e6, (ll)5e6, (ll)1e7, (ll)5e7, (ll)1e8, (ll)5e8, (ll)1e9L, (ll)5e9L, (ll)1e10L,
(ll)5e10L, (ll)1e11L, (ll)5e11L, (ll)1e12L, (ll)5e12L };
ll dp[MAXN][ALPHABET];
int p[MAXN][ALPHABET];

void solve() {
	string s;
	cin >> s;
	int n = s.length();

	for (int i = 0; i < ALPHABET; ++i) {
		dp[n][i] = 0;
		p[n][i] = 0;
	}
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] == '?') {
			int maxind = -1;
			for (int j = 0; j < ALPHABET; ++j) {
				if (p[i + 1][j] != -1 && (maxind == -1 || dp[i + 1][j] > dp[i + 1][maxind]))
					maxind = j;
				p[i][j] = maxind;
				if (maxind == -1)
					dp[i][j] = -INF;
				else
					dp[i][j] = dp[i + 1][maxind] + sym_val[j];
			}
		} else {
			int sym = s[i] - 'A';
			for (int j = 0; j < sym; ++j) {
				dp[i][j] = -INF;
				p[i][j] = -1;
			}
			int maxind = -1;
			for (int j = 0; j < sym; ++j) {
				if (p[i + 1][j] == -1)
					continue;
				if (maxind == -1 || dp[i + 1][j] > dp[i + 1][maxind])
					maxind = j;
			}
			for (int j = sym; j < ALPHABET; ++j) {
				if (p[i + 1][j] != -1 && (maxind == -1 || dp[i + 1][j] > dp[i + 1][maxind]))
					maxind = j;
				p[i][j] = maxind;
				if (maxind == -1)
					dp[i][j] = -INF;
				else if (sym < j)
					dp[i][j] = dp[i + 1][maxind] - sym_val[sym];
				else
					dp[i][j] = dp[i + 1][maxind] + sym_val[sym];
			}
		}
	}

	int maxind = -1;
	for (int i = 0; i < ALPHABET; ++i)
		if (p[0][i] != -1 && (maxind == -1 || dp[0][i] > dp[0][maxind]))
			maxind = i;
	cout << dp[0][maxind] << '\n';
	string ans;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '?')
			ans.push_back('A' + maxind);
		else
			ans.push_back(s[i]);
		maxind = p[i][maxind];
	}
	cout << ans << '\n';
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}