#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cassert>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
using ll = long long;
const int N = 3e5 + 10;
vector<pair<int, int>> g[N];
int used[N];
int ans[N];
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 2; i <= n; i++) ans[i] = 1e9 + 10;
	while (m--) {
		int x, y, t;
		cin >> x >> y >> t;
		g[x].pb({ y, t });
		g[y].pb({ x, t });
	}
	priority_queue<pair<int, int>> q;
	q.push({ 0, 1 });
	while (cap(q)) {
		int v = q.top().second;
		int w = q.top().first;
		w *= -1;
		q.pop();
		if (used[v]) continue;
		used[v] = 1;
		for (auto e : g[v]) {
			int to = e.first, W = e.second;
			if (ans[to] > min(w, W)) {
				ans[to] = min(w, W);
				q.push({ -ans[to], to });
			}
		}
	}
	for (int i = 2; i <= n; i++) cout << ans[i] + (int)1e9 << '\n';
	return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
*/