#include <bits/stdc++.h> 

#define int long long

#define pb push_back

#define data data228

#define pii pair<int, int>

#define ff first 
#define ss second

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 150000 + 7; 
const ll inf = 8e18; 
int n, m; 
vector<int> gr[maxn]; 
int used[maxn]; 
map<pii, int> Edge;
int dp[maxn][3]; 

struct match {
    int u, v; 
    int u1, v1; 
}; 

vector<int> to[maxn]; 

bool get(vector<vector<int> > add, int want) {
    int sumL = 0; 
    int sz = add.size();
    for (int i = 0; i < sz; ++i) {
        sumL += add[i][0]; 
    }    
    if (sumL > want) return false;
    int cntOne = 0; 
    int cntTwo = 0; 
    for (int i = 0; i < sz; ++i) {
        for (int j = 1; j < (int)add[i].size(); ++j) {
            add[i][j] -= add[i][0]; 
        }                    
        if ((int)add[i].size() == 3) {
            cntOne += 2; 
        } else if ((int)add[i].size() == 2) {
            if (add[i][1] == 1) {
                ++cntOne; 
            } else {
                ++cntTwo; 
            }
        }
    }
    if (sumL + cntOne >= want) return true; 
    sumL += cntOne;  
    sumL += cntTwo * 2; 
    if (sumL < want) return false; 
    sumL -= cntTwo * 2;
    if (sumL % 2 != want % 2) {
        --sumL; 
        if (cntOne == 0) return false; 
    }
    int need = (want - sumL) / 2; 
    if (need <= cntTwo) return true; 
    return false; 
}

vector<vector<int> > data[maxn];
 
void dfs(int u, int pr) {
//    cout << u << '\n'; 
    used[u] = 1; 
    int up1 = 0; 
    int down1 = 0; 
    if (Edge.find({u, pr}) != Edge.end()) {
        ++up1; 
    }
    if (Edge.find({pr, u}) != Edge.end()) {
        ++down1; 
    }               
    vector<int> vertex;
    for (auto v : gr[u]) {
        if (!used[v]) {
            to[u].pb(v); 
            vertex.pb(v);
            dfs(v, u); 
        }
    }
    vector<vector<int> > add; 
    for (auto v : vertex) {
        vector<int> pt;
        if (dp[v][2]) {
            pt.pb(-1); 
        } 
        for (int i = 0; i < 2; ++i) {
            if (dp[v][i]) {
                pt.pb(i); 
            } 
        }
        if (pt.empty()) {
            cout << "No\n"; 
            exit(0); 
        }
        add.pb(pt);         
    }
    data[u] = add; 
    if (get(add, up1 - down1)) {
        dp[u][0] = 1; 
    }

    if (up1 && get(add, -down1)) {
        dp[u][1] = 1; 
    }

    if (down1 && get(add, up1)) {
        dp[u][2] = 1; 
    } 
}
 
vector<match> res;

vector<int> trans(vector<int> xx) {
    vector<int> p; 
    for (int i = 0; i < (int)xx.size(); ++i) {
        if (xx[i] == 0) p.pb(0); 
        else if (xx[i] == 1) p.pb(1); 
        else p.pb(2); 
    }
    return p; 
}

vector<int> get1(vector<vector<int> > add, int want) {
    int sumL = 0; 
    int sz = add.size();
    for (int i = 0; i < sz; ++i) {
        sumL += add[i][0]; 
    }    
    vector<int> xx; 
    for (int i = 0; i < sz; ++i) {
        xx.pb(add[i][0]); 
    }
    int cntOne = 0; 
    int cntTwo = 0; 
    for (int i = 0; i < sz; ++i) {
        for (int j = 1; j < (int)add[i].size(); ++j) {
            add[i][j] -= add[i][0]; 
        }                    
        if ((int)add[i].size() == 3) {
            cntOne += 2; 
        } else if ((int)add[i].size() == 2) {
            if (add[i][1] == 1) {
                ++cntOne; 
            } else {
                ++cntTwo; 
            }
        }
    }
    if (sumL + cntOne >= want) {
        for (int i = 0; i < sz && sumL < want; ++i) {
            if ((int)add[i].size() >= 2 && add[i][1] == 1) {
                xx[i]++; 
                ++sumL;                                 
            }
            if (sumL < want && (int)add[i].size() >= 3) {
                ++xx[i]; 
                ++sumL; 
            }
        }
        return trans(xx); 
    }
    sumL += cntOne;  
    if (sumL % 2 != want % 2) {
        sumL -= cntOne; 
        --cntOne; 
    }
    int need = (want - (sumL + cntOne)) / 2; 
    for (int i = 0; i < sz && cntOne > 0; ++i) {
        if ((int)add[i].size() >= 2 && add[i][1] == 1) {
            xx[i]++; 
            --cntOne; 
        }
        if (cntOne && (int)add[i].size() >= 3) {
            ++xx[i]; 
            --cntOne; 
        }
    }
    for (int i = 0; i < sz && need > 0; ++i) {
        if ((int)add[i].size() == 2 && add[i][1] == 2) {
            xx[i] += 2; 
            --need; 
        }
    }
    return trans(xx); 
}



void calc(int u, int pr, int want) {
//    cout << u << " " << want << endl; 
    used[u] = 1; 
    int up1 = 0; 
    int down1 = 0; 
    if (Edge.find({u, pr}) != Edge.end()) {
        ++up1; 
    }
    if (Edge.find({pr, u}) != Edge.end()) {
        ++down1; 
    }               
    vector<int> vertex = to[u];
    int sz = vertex.size(); 
    if (want == 0) {
        vector<int> p = get1(data[u], up1 - down1);
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (up1) {
            R.pb(pr);
        }
        if (down1) {
            L.pb(pr); 
        }
        for (int i = 0; i < (int)L.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }        
    if (want == 1) {
        vector<int> p = get1(data[u], -down1); 
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (down1) {
            L.pb(pr); 
        }
        for (int i = 0; i < (int)R.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }
    if (want == 2) {
        vector<int> p = get1(data[u], up1); 
        vector<int> L; 
        vector<int> R; 
        for (int i = 0; i < sz; ++i) {
            if (p[i] == 1) {
                L.pb(vertex[i]); 
            }                
            if (p[i] == 2) {
                R.pb(vertex[i]); 
            }
        }
        if (up1) {
            R.pb(pr); 
        }
        for (int i = 0; i < (int)R.size(); ++i) {
            res.pb({L[i], u, u, R[i]}); 
        }
        for (int i = 0; i < sz; ++i) {
            calc(vertex[i], u, p[i]); 
        }
    }
}

void solve() {
    cin >> n >> m; 
    vector<pii> e;  
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v, --u, --v;        
        Edge[{u, v}] = 1; 
        gr[u].pb(v); 
        gr[v].pb(u); 
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, i); 
            if (!dp[i][0]) {
                cout << "No\n"; 
                return; 
            }
        }
    }
    cout << "Yes\n"; 
    for (int i = 0; i < n; ++i) {
        used[i] = 0; 
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            calc(i, i, 0); 
        }        
    }
    for (auto v : res) {
        cout << v.u + 1 << " " << v.v + 1 << " " << v.u1 + 1 << " " << v.v1 + 1 << '\n'; 
    }
    cout << '\n'; 
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}