#include <bits/stdc++.h>

using namespace std;
#define int long long
int pw[15];

void pre() {
    pw[0] = 1;
    for (int i = 1; i < 15; ++i) {
        pw[i] = pw[i - 1] * 10;
    }
}

int get_val(char c) {
    int pos = c - 'A';
    if (pos % 2 == 0) {
        return pw[pos / 2];
    }
    return 5 * pw[pos / 2];
}

int solve(string s) {
    int res = 0;
    char mx = 'A';
    for (int i = s.size() - 1; i >= 0; --i) {
        if (mx > s[i]) {
            res -= get_val(s[i]);
        } else {
            res += get_val(s[i]);
        }
        mx = max(mx, s[i]);
    }
    return res;
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<string> vecs;
    string cur = "";
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            vecs.push_back(cur);
            cur = "";
        } else {
            cur += s[i];
        }
    }
    vecs.push_back(cur);
    n = vecs.size();
    pair<int, char> dp[n][26];
    memset(dp, 0, sizeof(dp));
    {
        int c = solve(vecs.back());
        for (int i = 0; i < 26; ++i) {
            dp[n - 1][i] = {c, 'A'};
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < 26; ++j) {
            string t = vecs[i];
            for (int k = 0; k <= j; ++k) {
                t.push_back('A' + k);
                int v = solve(t);
                dp[i][j] = max(dp[i][j], {dp[i + 1][k].first + v, k + 'A'});
                t.pop_back();
            }
            //cout << dp[i][j] << " ";
        }
        //cout << "\n";
    }
    string res = "";
    int t = 25;
    int o = 0;
    for (int i = 0; i < n; ++i) {
        res += vecs[i];
        res += (dp[i][t].second);
        o += solve(vecs[i] + dp[i][t].second);
        t = dp[i][t].second - 'A';
    }
    res.pop_back();
    int x = solve(res);
    if (x != o - 1) {
        cout << 1 / 0;
    }
    cout << dp[0][25].first << "\n" << res << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    pre();
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
