#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>

using namespace std;
#define int long long
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define firn(i, n) for(int i = 1; i < (int)n; i++)
vector<vector<pair<int, int>>>g;
vector<int>ma, mi, used;
vector<vector<int>>ex(10, vector<int>(10, -1));
void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u.first]) {
			ma[u.first] = max(ma[v], u.second);
			mi[u.first] = min(mi[v], u.second);
			dfs(u.first);
		}
	}
}

signed main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	mi.resize(n,1e9);
	ma.resize(n,-1e9);
	used.resize(n);
	forn(i, m) {
		int u, v, t;
		cin >> u >> v >> t;
		u--;
		v--;
		g[v].push_back({ u, t });
		g[u].push_back({ v, t });
		ex[u][v] = t;
		ex[v][u] = t;

	}
	vector<int>a(n);
	forn(i, n) {
		a[i] = i;
	}
	vector<int>ans(n, 2e9);
	int t = 0;
	while (t < 1e6) {
		t++;
		int min1 = 1e9, max1 = 0;
		forn(i, n - 1) {
			if (ex[a[i]][a[i + 1]] != -1) {
				min1 = min(ex[a[i]][a[i + 1]], min1);
				max1 = max(ex[a[i]][a[i + 1]], max1);
				ans[a[i + 1]] = min(ans[a[i + 1]], min1 + max1);
			}
			else {
				break;
			}
		}

		next_permutation(all(a));
	}
	firn(i, n) {
		cout << ans[i] << '\n';
	}
	return 0;
	//dfs(0);
	vector<int>dist(n, 1e9 + 1);
	dist[0] = 1e9;
	set<pair<int, int>>s;
	s.insert({ 1e9, 0 });
	while (!s.empty()) {
		auto x = *s.begin();
		int v = x.second;
		s.erase(x);
		used[v] = 1;
		for (auto u : g[v]) {
			if (dist[u.first] > u.second || dist[u.first] > dist[v]) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = min(u.second, dist[v]);
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	firn(i, n) {
		cout << dist[i] + 1000000000 << '\n';
	}
	return 0;
}