#include <bits/stdc++.h>

using namespace std;

const int max_n = 2001;
int n;
int x[max_n], h[max_n];
int l[max_n], r[max_n];

int get_mx(int v, bool left) {
	int l = -1, r = n + 2;
	while(r - l > 1) {
		int mid = (l + r) / 2;
		if (left) {
			if (x[v] - h[v] < x[mid]) r = mid;
			else l = mid;
		}else {
			if (x[v] + h[v] > x[mid]) l = mid;
			else r = mid;
		}
	}
	return (left ? r : l);
}

void f2(int st) {
	int mx = get_mx(st, 0), v = st + 1;

	while(v <= n + 1) {
		if (v > mx) break;
		if (get_mx(v, true) < st) {
			v = r[v] + 1;
		}else ++v;
	}
	r[st] = v - 1;
}

void f1(int st) {
	int mx = get_mx(st, 1), v = st - 1;
	//cout << "mx " << mx << endl;
	while(v >= 0) {
		if (v < mx) break;
		if (get_mx(v, false) > st) {
			v = l[v] - 1;
		}else --v;
	}
	l[st] = v + 1;
}

void solve() {
	int q;
	cin >> n >> q;
	for(int i = 1;i <= n;i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1], x[n + 1] = x[n];
	
	for(int i = 0;i <= n + 1;i++)
		r[i] = n + 1;

	for(int i = 1;i <= n;i++)
		f1(i);

	for(int i = n;i >= 1;i--)
		f2(i);

	/*for(int i = 1;i <= n;i++) {
		cout << l[i] << ' ' << r[i] << endl;
	}*/

	for(int it = 0;it < q;it++) {
		int v_l, v_r;
		cin >> v_l >> v_r;
		int res = 0;
		for(int i = v_l;i <= v_r;i++) {
			if (l[i] >= v_l || r[i] <= v_r) res++;
		}
		cout << res << endl;
	}
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	solve();
}