#include <bits/stdc++.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair


const int max_n = 5e5 + 3;
int n;
int x[max_n], h[max_n];
int l[max_n], r[max_n];
 
int get_mx(int v, bool left) {
    int l = -1, r = n + 2;
    while(r - l > 1) {
        int mid = (l + r) / 2;
        if (left) {
            if (x[v] - h[v] < x[mid]) r = mid;
            else l = mid;
        }else {
            if (x[v] + h[v] > x[mid]) l = mid;
            else r = mid;
        }
    }
    return (left ? r : l);
}
 
void f2(int st) {
    int mx = get_mx(st, 0), v = st + 1;
 
    while(v <= n + 1) {
        if (v > mx) break;
        if (get_mx(v, true) <= st) {
            v = r[v] + 1;
        }else ++v;
    }
    r[st] = v - 1;
}
 
void f1(int st) {
    int mx = get_mx(st, 1), v = st - 1;
    //cout << "mx " << mx << endl;
    while(v >= 0) {
        if (v < mx) break;
        if (get_mx(v, false) >= st) {
            v = l[v] - 1;
        }else --v;
    }
    l[st] = v + 1;
}


int sum[max_n];

void fset(int x) {
	for(;x <= n;x |= (x + 1)) {
		sum[x]++;
	}
}

int fget(int x) {
	int res = 0;
	for(;x >= 0;x = (x & (x + 1)) - 1) {
		res += sum[x];
	}
	return res;
}

struct req {
	int l, r, id;
	req() {}
};

void solve() {
    int q;
    cin >> n >> q;
    for(int i = 1;i <= n;i++) {
        cin >> x[i] >> h[i];
    }
    x[0] = x[1], x[n + 1] = x[n];
     
    for(int i = 0;i <= n + 1;i++)
        r[i] = n + 1;
 
    for(int i = 1;i <= n;i++)
        f1(i);
 
    for(int i = n;i >= 1;i--)
        f2(i);
 
    vector<req> a(q);
 	for(int i = 0;i < q;i++) {
 		cin >> a[i].l >> a[i].r;
 		a[i].id = i;
 	}

 	sort(all(a), [](req v1, req v2) { return v1.l < v2.l; });

 	vector<int> res(q);

 	multiset<pii> so;
 	for(int i = 0;i < n;i++) {
 		so.emplace(mp(l[i], r[i]));
 		cout << "l r " << l[i] << " " << r[i] << endl;
 	}
 	cout << endl;

    for(req v : a) {
    	while(so.begin()->fi < v.l) {
    		cout << v.id << " " << so.begin()->se << endl;
    		fset(so.begin()->se);
    		so.erase(so.begin());
    	}
    	res[v.id] = size(so) + fget(v.r);
    }

   	for(int i : res)
   		cout << i << endl;
   	cout << endl;
}
 
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
 
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
 
    solve();
}