#include <bits/stdc++.h>
  
using namespace std;
  
#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair
 
 
const int max_n = 5e5 + 3;
int n;
int x[max_n], h[max_n];
int l[max_n], r[max_n];
  
int get_mx(int v, bool left) {
    int l = -1, r = n + 2;
    while(r - l > 1) {
        int mid = (l + r) / 2;
        if (left) {
            if (x[v] - h[v] < x[mid]) r = mid;
            else l = mid;
        }else {
            if (x[v] + h[v] > x[mid]) l = mid;
            else r = mid;
        }
    }
    return (left ? r : l);
}
  
void f2(int st) {
    int mx = get_mx(st, 0), v = st + 1;
  
    while(v <= n + 1) {
        if (v > mx) break;
        if (get_mx(v, true) <= st) {
            v = r[v] + 1;
        }else ++v;
    }
    r[st] = v - 1;
}
  
void f1(int st) {
    int mx = get_mx(st, 1), v = st - 1;
    //cout << "mx " << mx << endl;
    while(v >= 0) {
        if (v < mx) break;
        if (get_mx(v, false) >= st) {
            v = l[v] - 1;
        }else --v;
    }
    l[st] = v + 1;
}

int sum[max_n];

void fset(int x, int add) {
    for(;x <= n;x |= (x + 1)) {
        sum[x] += add;
    }
}
 
int fget(int x) {
    int res = 0;
    for(;x >= 0;x = (x & (x + 1)) - 1) {
        res += sum[x];
    }
    return res;
}
 
struct req {
    int l, r, id;
    req() {}
};

struct bi {
	int l, i, r;
	bi() {}
	bi(int l, int i, int r) : l(l), i(i), r(r) {}
};

void solve() {
    int q;
    cin >> n >> q;
    for(int i = 1;i <= n;i++) {
        cin >> x[i] >> h[i];
    }
    x[0] = x[1], x[n + 1] = x[n];
      
    for(int i = 0;i <= n + 1;i++)
        r[i] = n + 1;
  
    for(int i = 1;i <= n;i++)
        f1(i);
  
    for(int i = n;i >= 1;i--)
        f2(i);
  
    vector<req> a(q);
    for(int i = 0;i < q;i++) {
        cin >> a[i].l >> a[i].r;
        a[i].id = i;
    }
 
    sort(all(a), [](req v1, req v2) { return v1.l < v2.l; });
 
 		
 	auto cmp1 = [](bi v1, bi v2) { return v1.l < v2.l; };
 	auto cmp2 = [](bi v1, bi v2) { return v1.i < v2.i; };

    multiset<bi, decltype(cmp1)> so(cmp1);
    multiset<bi, decltype(cmp2)> in(cmp2);

    for(int i = 1;i <= n;i++) {
        so.emplace(bi(l[i], i, r[i]));
        in.emplace(bi(l[i], i, r[i]));
        fset(i, 1);
    }
 
    vector<int> res(q);

    for(req v : a) {
        while(size(so) && so.begin()->l < v.l) {
            //cout << v.id << " " << so.begin()->r << endl;
            fset(so.begin()->r, 1);
            fset(so.begin()->i, -1);
            so.erase(so.begin());
        }
        while(size(in) && in.begin()->i < v.l) {
        	if (so.find(*in.begin()) == so.end())
        		fset(in.begin()->r, -1);
        	else {
        		so.erase(so.find(*in.begin()));
        		fset(in.begin()->i, -1);
        	}
        	in.erase(in.begin());
        }

        res[v.id] = fget(v.r);
    }
 
    for(int i : res)
        cout << i << endl;
    cout << endl;
}
  
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
  
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
  
    solve();
}