#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 3e5 + 100, K = 26, INF = 2e18;

int n, m, ans[N], st, ee, timer;
vector<pair<int, int>> a[N];
vector<int> d;
bool used[N], used2[N];
int cc[N];

void dfs2(int v, int p, int mn, int mx) {

    for (auto to : a[v]) {
        if (to.first == p) continue;
        if (to.first == st) {
            ee = min(ee, min(mn, cc[to.second]) + max(mx, cc[to.second]));
        }
        if (used2[to.first] || used[to.first]) continue;
        used2[to.first] = true;
        dfs2(to.first, v, min(mn, cc[to.second]), max(mx, cc[to.second]));
        used2[to.first] = false;
    }
}

void dfs(int v, int mn, int mx) {
    d.push_back(v);
    for (int x : d) {
        timer++;
        st = x;
        ee = INF;
        fill(used2, used2 + n, false);
        dfs2(x, x, mn, mx);
        ans[v] = min(ans[v], ee);
    }

    ans[v] = min(ans[v], mn + mx);
    for (auto to : a[v]) {
        if (used[to.first]) continue;
        used[to.first] = true;
        dfs(to.first, min(mn, cc[to.second]), max(mx, cc[to.second]));
        used[to.first] = false;
    }
    d.pop_back();
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s, c;
        cin >> f >> s >> c;
        f--, s--;
        a[f].push_back({s, i});
        a[s].push_back({f, i});
        cc[i] = c;
    }
    fill(ans, ans + n, INF);
    used[0] = true;
    dfs(0, INF, -INF);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}