#include<bits/stdc++.h>

//#define int long long

using namespace std;

const int INF = 1e9+7;

int n, m;
vector<vector<vector<int>>> paths;
vector<vector<int>> g;

vector<int> ans;

vector<int> path = {0};

void dfs(int v, int need, int prev) {
    //if (prev == v) return;
    if (path.size()) {
        if (path[path.size() - 1] == need) {
            //paths[need].push_back(path);

            int cnt = 0;
            for (int i = 0; i < path.size() - 1; i++)
                cnt = max(cnt, g[i][i + 1]);
            ans[need] = min(ans[need], cnt);

            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (g[v][i] != INF && i != prev) {
            //cout << "lol " << v + 1 << " " << i + 1 << " " << need + 1 << "!\n";
            path.push_back(i);
            dfs(i, need, v);
            path.pop_back();
        }

    }
}


int32_t main() {

    cin >> n >> m;
    g.assign(n, vector<int>(n, INF));
    paths.resize(n);
    ans.assign(n, INF);

    for (int i = 0; i < m; i++) {
        int u, v, w; cin >> u >> v >> w;
        g[u-1][v-1] = min(g[u-1][v-1], w);
        g[v-1][u-1] = min(g[v-1][u-1], w);
    }

    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            cout << g[i][j] << " ";
        cout << "\n";
    }*/

    for (int i = 1; i < n; i++) {
        dfs(0, i, -1);
    }

    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";

    return 0;
}
