#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

int n, m;
vector<vector<pii>> g;
vector<int> ans;
multiset<int> q;

void dfs(int v, int p) {
	if (q.size() > 0) {
		auto it = q.end();
		it--;
		ans[v] = *(q.begin()) + *(it);
	}
	for (auto e : g[v]) {
		if (e.first == p) continue;
		q.insert(e.second);
		dfs(e.first, v);
		q.erase(q.find(e.second));
	}
}

void solve() {
	cin >> n >> m;
	if (n != m + 1) return;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b, x;
		cin >> a >> b >> x;
		a--; b--;
		g[a].pb({b, x});
		g[b].pb({a, x});
	}
	ans.resize(n);
	dfs(0, 0);
	for (int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();

	return 0;
}
