#include <bits/stdc++.h>

#define int long long

using namespace std;

// const int MAXN = 1 << 19; 

// array<int, MAXN * 2> sect;

// void upd(int i) {
//     i += MAXN
//     sect[i]++;
//     i /= 2;
//     while (i > 0) {
//         sect[i] = sect[i * 2] + sect[i * 2 + 1];
//         i /= 2;
//     }
// }

// int get(int i, int l, int r, int lq, int rq) {
//     if (lq <= l && r <= rq) {
//         return sect[i];
//     }
//     if (r <= lq || rq <= l) {
//         return 0;
//     }
//     int m = (r + l) / 2;
//     return get(i * 2, l, m, lq, rq) + get(i * 2 + 1, m, r, lq, rq);
// }

const int INF = 1e18 + 10;

array<int, 30> cnt;

int fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x;
    } else {
        return fastpow(a, n - 1) * a;
    }
}

int getval(int num) {
    if (num % 2 == 0) {
        return fastpow(10, num / 2);
    } else {
        return 5 * fastpow(10, num / 2);
    }
}

signed solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<int> quest;
    vector<int> ans(3, 0);
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            quest.push_back(i);
        }
    }
    int best = -INF;
    if (quest.size() == 0) {
        int sumplus = 0;
        int summinus = 0;
        for (int i = 0; i < n; ++i) {
            int num = s[i] - 'A';
            for (int j = 0; j < num; ++j) {
                sumplus -= getval(j) * cnt[j];
                summinus += getval(j) * cnt[j];
                cnt[j] = 0;
            }
            cnt[num]++;
            sumplus += getval(num);
        }
        for (int i = 0; i < 26; ++i) {
            cnt[i] = 0;
        }
        best = sumplus - summinus;
    } else if (quest.size() == 1) {
        for (int a = 0; a < 26; ++a) {
            s[quest[0]] = a + 'A';
            int sumplus = 0;
            int summinus = 0;
            for (int i = 0; i < n; ++i) {
                int num = s[i] - 'A';
                for (int j = 0; j < num; ++j) {
                    sumplus -= getval(j) * cnt[j];
                    summinus += getval(j) * cnt[j];
                    cnt[j] = 0;
                }
                cnt[num]++;
                sumplus += getval(num);
            }
            if (best < sumplus - summinus) {
                best = sumplus - summinus;
                ans[0] = a;
            }
            for (int i = 0; i < 26; ++i) {
                cnt[i] = 0;
            }
        }
    } else if (quest.size() == 2) {
        for (int b = 0; b < 26; ++b) {
            s[quest[1]] = b + 'A';
            for (int a = 0; a < 26; ++a) {
                int sumplus = 0;
                int summinus = 0;
                s[quest[0]] = a + 'A';
                for (int i = 0; i < n; ++i) {
                    int num = s[i] - 'A';
                    for (int j = 0; j < num; ++j) {
                        sumplus -= getval(j) * cnt[j];
                        summinus += getval(j) * cnt[j];
                        cnt[j] = 0;
                    }
                    cnt[num]++;
                    sumplus += getval(num);
                }
                if (best < sumplus - summinus) {
                    best = sumplus - summinus;
                    ans[0] = a;
                    ans[1] = b;
                }
                for (int i = 0; i < 26; ++i) {
                    cnt[i] = 0;
                }
            }
        }
    } else {
        for (int c = 0; c < 26; ++c) {
            s[quest[2]] = c + 'A';
            for (int b = 0; b < 26; ++b) {
                s[quest[1]] = b + 'A';
                for (int a = 0; a < 26; ++a) { 
                    s[quest[0]] = a + 'A';
                    int sumplus = 0;
                    int summinus = 0;
                    for (int i = 0; i < n; ++i) {
                        int num = s[i] - 'A';
                        for (int j = 0; j < num; ++j) {
                            sumplus -= getval(j) * cnt[j];
                            summinus += getval(j) * cnt[j];
                            cnt[j] = 0;
                        }
                        cnt[num]++;
                        sumplus += getval(num);
                    }
                    if (best < sumplus - summinus) {
                        best = sumplus - summinus;
                        ans[0] = a;
                        ans[1] = b;
                        ans[2] = c;
                    }
                    for (int i = 0; i < 26; ++i) {
                        cnt[i] = 0;
                    }
                }
                
            }
        }
    }
    for (int i = 0; i < quest.size(); ++i) {
        s[quest[i]] = ans[i] + 'A';
    }
    cout << best << '\n';
    cout << s << '\n';
    return 0;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}