#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

#define int ll

void Solve() {
    int cost[26];
    cost[0] = 1;
    cost[1] = 5;
    for (int i = 2; i < 26; ++i) {
        cost[i] = cost[i - 2] * 10ll;
    }
    //dp[i][mx] - max on suffix = mx
    string s;
    cin >> s;
    int n = sz(s);
    vector <vi> dp(n, vi(26, nINFL));
    vector <vpi> p(n, vpi(26, {-1, -1}));
    forn(me, 26) {
        if (s.back() != '?' && s.back() != char(me + 'A')) {continue;}
        dp[n - 1][me] = cost[me];
        p[n - 1][me] = {me, -1};
    }
    for (int i = n - 2; i >= 0; --i) {
        forn(me, 26) {
            if (s[i] != '?' && s[i] != char(me + 'A')) {continue;}
            forn(prev, 26) {
                if (dp[i + 1][prev] == nINFL) {continue;}
                if (me >= prev) {
                    if (dp[i][me] < dp[i + 1][prev] + cost[me]) {
                        dp[i][me] = dp[i + 1][prev] + cost[me];
                        p[i][me] = {me, prev};
                    }
                } else {
                    if (dp[i][prev] < dp[i + 1][prev] - cost[me]) {
                        dp[i][prev] = dp[i + 1][prev] - cost[me];
                        p[i][prev] = {me, prev};
                    }
                }
            }
        }
    }
    cout << *max_element(all(dp[0])) << '\n';
    int i = 0, me = max_element(all(dp[0])) - dp[0].begin();
    while(i < n) {
        cout << char('A' + p[i][me].first);
        me = p[i][me].second;
        ++i;
    }
    cout << '\n';
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
