#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

//#define int ll

vector <vi> ans;
vpi edges;
int ost;
bool used[22];

void Try() {
    if (ost == 0) {
        cout << "Yes\n";
        for (auto &u : ans) {
            for (auto v : u) {
                cout << v << ' ';
            }
            cout << '\n';
        }
        exit(0);
    }
    forn(i, sz(edges)) {
        if (used[i]) {continue;}
        auto [a1, b1] = edges[i];
        forn(j, sz(edges)) {
            if (used[j]) {continue;}
            auto [a2, b2] = edges[j];
            if (b1 != a2 && b2 != a1) {continue;}
            ans.eb(vi{a1, b1, a2, b2});
            used[i] = used[j] = 1;
            ost -= 2;
            Try();
            ost += 2;
            ans.pop_back();
            used[i] = used[j] = 0;
        }
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    edges.resize(m);
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        edges[i] = {a, b};
    }
    ost = m;
    Try();
    cout << "No";
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
