#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vi = vector<ll>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
ll inf = 1e12;
vi anses(3e5 + 100, inf);
vvi gr;
vector<pair<pi, ll>> ways;

void stupid_solution(int cur_ver, set<int> my_way, ll cur_min, ll cur_max){
    anses[cur_ver] = min(anses[cur_ver], cur_min + cur_max);
    for (auto i : gr[cur_ver]){
        if (!my_way.count(i)){
            my_way.insert(i);
            if (ways[i].first.first != cur_ver){
                stupid_solution(ways[i].first.first, my_way, min(cur_min, ways[i].second), max(cur_max, ways[i].second));
            }else{
                stupid_solution(ways[i].first.second, my_way, min(cur_min, ways[i].second), max(cur_max, ways[i].second));
            }
            my_way.erase(i);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    gr = vvi(n);
    ways = vector<pair<pi, ll>>(m);
    for (int i = 0; i < m; i++){
        int first, second, cost;
        cin >> first >> second >> cost;
        first--, second--;
        ways[i]= {{first, second}, cost};
        gr[first].push_back(i);
        gr[second].push_back(i);
    }
    stupid_solution(0, {}, inf, 0);
    for (int i = 1; i < n; i++){
        cout << anses[i] << endl;
    }
    return 0;
}
