#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int n;
vector<vector<pair<int, int>>> a;


int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int m;
	cin >> n >> m;
	a.resize(n);
	int x, y, w;
	vector < pair<int, pair<int, int>>> e;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		e.push_back({ w, {x, y} });
	}

	sort(rall(e));

	vector<int> dp(n, inf);
	vector<int> ans(n, inf + inf + 1);
	set<pair<int, int>> st;
	dp[0] = 0;

	for (auto i : e) {

		while (!st.empty()) {
			auto v = st.begin()->y;
			st.erase(st.begin());
			for (auto i : a[v]) {
				int t = dp[v];
				if (i.y > t) t = i.y;
				if (t < dp[i.x]) {
					st.erase({ dp[i.x], i.x });
					dp[i.x] = t;
					st.insert({ dp[i.x], i.x });
				}
			}
		}
	}

	for (auto i : ans) {
		cout << i << '\n';
	}
	return 0;
}