#include <bits/stdc++.h>
using namespace std;

#define s second
#define f first

vector <pair <int,int> > rlist;
vector <int> g[150001];
vector <int> tt[150001];
int n;
vector <int> dp;
vector <pair <int,int> > bad;
vector <int> used;

vector <int> h;
vector <int> par;

void build(int v, int p)
{
    used[v]=1;
    par[v]=p;
    h[v]=h[p]+1;
    for (int u:g[v]){
        if (used[u])continue;
        build(u,v);
    }
}
vector <vector <int> > ans;
vector <pair <int,int> > down;
vector <pair <int,int> > up;


void dfs(int v)
{
    int i,j;
    used[v]=1;
    for (int u:g[v]){
        if (used[u])continue;
        dfs(u);
    }

    int p=par[v];
    int u;
    int t0;

    for (i=0; i<g[v].size(); ++i){
        u=g[v][i];
        t0=tt[v][i];
        if (u==p)continue;
        if (dp[u]==1){
            if (t0==1){
                down.push_back({v,u});
            }
            if (t0==2){
                up.push_back({u,v});
            }
            if (t0==3){
                ans.push_back({v,u,u,v});
            }
            continue;
        }
        int t1=0;
        int u1=bad[u].f,u2=bad[u].s;
        if (h[u1]<h[u2])t1=1;
        else t1=2;

        if (t0+t1==3){
            cout << "No";
            exit(0);
        }
        if (t0==1){
            ans.push_back({v,u,u1,u2});
            continue;
        }
        if (t0==2){
            ans.push_back({u,v,u1,u2});
            continue;
        }

        ///t0==3
        if (t1==1){
            ans.push_back({v,u,u1,u2});
            up.push_back({u,v});
        }
        if (t1==2){
            ans.push_back({u,v,u1,u2});
            down.push_back({v,u});
        }
    }

    int ds=down.size();
    int us=up.size();

    if (abs((int)ds-(int)us)>=2){
        cout << "No";
        exit(0);
    }

    while (ds>0 && us>0){
        ds--;
        us--;
        ans.push_back({up.back().f,up.back().s,down.back().f,down.back().s});
        down.pop_back();
        up.pop_back();
    }
    if (ds>0)bad[v]=down[0];
    if (us>0)bad[v]=up[0];
    down.resize(0);
    up.resize(0);

    if (bad[v].f==-1)dp[v]=1;
    else dp[v]=0;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m;
    cin >> n >> m;
    rlist.resize(m);
    par.resize(n,-1);
    map <pair <int,int>, int> was;
    int i,j;
    for (i=0; i<m; ++i){
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        rlist[i]={v,u};
        if (was[{v,u}]==0){
            g[v].push_back(u);
            g[u].push_back(v);
        }
        was[{v,u}]=1;
        was[{u,v}]=1;
    }

    dp.assign(n,0);
    bad.assign(n,{-1,-1});
    used.assign(n,0);
    h.assign(n,-1);
    for (i=0; i<n; ++i){
        if (used[i])continue;
        build(i,i);
    }
    map <pair <int,int>, int> t;
    for (i=0; i<m; ++i){
        int v=rlist[i].f;
        int u=rlist[i].s;
        if (h[v]<h[u]){
            t[{v,u}]+=1;
            t[{u,v}]+=1;
        }
        else {
            t[{v,u}]+=2;
            t[{u,v}]+=2;
        }
    }
    int v;
    for (v=0; v<n; v++){
        for (int u:g[v]){
            tt[v].push_back(t[{v,u}]);
        }
    }
    ans.reserve(m/2);
    used.assign(n,0);
    for (i=0; i<n; i++){
        if (used[i])continue;
        dfs(i);
        if (dp[i]==0){
            cout << "No";
            return 0;
        }
    }
    cout << "Yes" << '\n';
    for (i=0; i<m/2; i++){
        for (j=0; j<4; j++){
            cout << ans[i][j]+1 << " ";
        }
        cout << '\n';
    }
    return 0;
}
/**
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
