#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N1 = 300100;
vector<pair<int, int>> g[N1];

int d0[N1];
void dfs0(int v, int p = -1, int mn = 1e9, int mx = 0) {
	d0[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs0(u.first, v, min(mn, u.second), max(mx, u.second));
	}
}

int d1[N1];

const int N = 2010;

int dp[N][N];

int getid(const vector<int>& z, int x) {
	return lower_bound(all(z), x) - z.begin();
}

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	forn(i, m) {
		int a, b, t;
		cin >> a >> b >> t;
		a--, b--;
		g[a].push_back(make_pair(b, t));
		g[b].push_back(make_pair(a, t));
	}

	if (m == n - 1) {
		dfs0(0);
		for (int i = 1; i < n; i++) {
			cout << d0[i] << '\n';
		}
		return 0;
	}

	bool flag1 = true, flag2 = true;
	for (auto i : g[0]) {
		if (i.second != 0) flag1 = false;
		if (i.second != 1e9) flag2 = false;
	}

	if (flag1) {
		set<pair<int, int>> q;
		q.insert(make_pair(0, 0));
		forn(i, n) d1[i] = 1e9 + 1;
		d1[0] = 0;

		while (q.size()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v]) {
				if (d1[u.first] > max(d1[v], u.second)) {
					q.erase(make_pair(d1[u.first], u.first));
					d1[u.first] = max(d1[v], u.second);
					q.insert(make_pair(d1[u.first], u.first));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << d1[i] << '\n';
		}
		return 0;
	}

	if (n <= 2000 && m <= 2000) {
		vector<int> z;
		for (auto i : g) {
			for (auto j : i) {
				z.push_back(j.second);
			}
		}
		sort(all(z));
		z.erase(unique(all(z)), z.end());
		for (auto& i : dp) {
			for (auto& j : i) {
				j = 2e9 + 1;
			}
		}
		set<pair<int, pair<int, int>>> q;
		q.insert(make_pair(0, make_pair(0, 0)));
		dp[0][0] = 0;
		while (q.size()) {
			auto v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v.first]) {
				int mn = v.second;
				int id = -1;
				if (u.second < z[mn]) {
					id = getid(z, u.second);
					mn = id;
				}
				int mx = dp[v.first][v.second] - z[v.second];
				mx = max(mx, u.second);
				if (dp[u.first][mn] > z[mn] + mx) {
					q.erase(make_pair(dp[u.first][mn], make_pair(u.first, mn)));
					dp[u.first][mn] = z[mn] + mx;
					q.insert(make_pair(dp[u.first][mn], make_pair(u.first, mn)));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			int ans = 2e9 + 1;
			forn(j, z.size()) {
				ans = min(ans, dp[i][j]);
			}
			cout << ans << '\n';
		}
		return 0;
	}
	return 0;
}