#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int maxn = 510;


int x[maxn], h[maxn];


int n;

bool erased[maxn];

int calc(int l, int r) {
    int sz = r - l;
    fill(erased, erased + n, false);
    int cnt =0 ;
    for (int k = 0; k < sz; ++k) {
        bool deleted = false;
        for (int i = l; i < r; ++i) {
            if(erased[i]) continue;
            int next_left = i - 1;
            for (; next_left >= 0 && erased[next_left]; --next_left);
            bool can_left = i != 0 && (next_left == -1 || x[next_left] + h[i] < x[i]);
            if (can_left) {
                ++cnt;
                deleted = true;
                erased[i] = true;
                continue;
            }
            int next_right = i + 1;
            for (; next_right < n && erased[next_right]; ++next_right);
            bool can_right = i != n -1 && (next_right == n || x[next_right] - h[i] > x[i]);
            if (can_right) {
                ++cnt;
                deleted = true;
                erased[i] = true;
            }
        }
        if (!deleted) break;
    }
    return cnt;
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        cout << calc(l, r) << "\n";
    }
    return 0;
}
