#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define vi vector <int>
#define vll vector <ll>
#define vvi vector <vi>
#define vvll vector <vll>
#define vpii vector <pii>
#define vvpii vector <vpii>
#define vb vector <bool>
#define vvb vector <vb>
#define fi first
#define se second

const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1 = 1e9 + 7;
const int mod2 = 1e9 + 9;
const int MAXN = 3e5 + 100;
int ans[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i=1;i<n;i++)
        ans[i]=2*INF+100;
    vector<vector<int>> total(n - 1);
    vector<int> fir(n - 1, INF + 100);
    vector<int> sec(n - 1, INF + 100);
    while (m--) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        if (u > v)
            swap(u, v);
        total[u].pb(c);
    }
    for (int i = 0; i < n - 1; i++) {
        sort(all(total[i]));
        if (total[i].size() >= 1)
            fir[i] = total[i][0];
        if (total[i].size() >= 2)
            sec[i] = total[i][1];
    }
    vector<vector<pii>> f(n - 1, vpii(n - 1)), s(n - 1, vpii(n - 1));
    for (int i = 0; i < n - 1; i++) {
        int mnx = fir[i];
        int mxx = fir[i];
        for (int j = i; j < n - 1; j++) {
            mnx = min(mnx, fir[j]);
            mxx = max(mxx, fir[j]);
            f[i][j] = {mnx, mxx};
        }
    }
    for (int i = 0; i < n - 1; i++) {
        int mnx = sec[i];
        int mxx = sec[i];
        for (int j = i; j < n - 1; j++) {
            mnx = min(mnx, sec[j]);
            mxx = max(mxx, sec[j]);
            s[i][j] = {mnx, mxx};
        }
    }
    for (int i = 0; i < n - 1; i++) {
        for (int j = i; j < n - 1; j++) {
            ans[j+1]=min(ans[j+1],f[0][j].fi+f[0][j].se);
        }
        for (int j=i;j>0;j--)
        {
            if (s[j][i].se==INF+100)
                break;
            ans[j]=min(ans[j],min(f[0][i].fi,s[j][i].fi)+max(f[0][i].se,s[j][i].se));
        }
    }
    for (int i = 1; i < n; i++)
        cout << ans[i] << '\n';
}

int main() {
#ifdef Mip182
    freopen("a.in", "r", stdin);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif
    int _t = 1;
    while (_t--)
        solve();
}