#include <iostream>

#include <algorithm>

#include <string>

using namespace std;

typedef long long ll;

ll val[26];

ll get(string& s, int i) {
	char max_c = s.back();
	ll res = 0;
	for (int j = s.size() - 1; j >= i; j--) {
		if (s[j] >= max_c) {
			res += val[s[j] - 'A'];
		}
		else {
			res -= val[s[j] - 'A'];
		}

		max_c = max(max_c, s[j]);
	}

	return res;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	ll cur = 1;
	for (int i = 0; i < 26; i++) {
		val[i] = cur;
		if (i % 2 == 0)
			cur *= 5l;
		else
			cur *= 2l;
	}

	int t; cin >> t;
	while (t--) {
		string s; cin >> s;
		int n = s.size();
		int cnt[26] = { 0 };

		for (int i = n - 1; i >= 0; i--) {
			if (s[i] != '?') {
				cnt[s[i] - 'A']++;
			}
			else {
				ll max_sum = 0, best_c = 'A';
				for (char c = 'A'; c <= 'Z'; c++) {
					s[i] = c;
					if (get(s, i) > max_sum) {
						max_sum = get(s, i);
						best_c = c;
					}
				}
				s[i] = best_c;
			}
		}

		cout << get(s, 0) << '\n' << s << '\n';
	}
	return 0;
}