#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 200;

int n, m;
set<int> g[MAXN];
int used[MAXN][MAXN];

struct Three {
    int a, b, c;

    Three(int a, int b, int c) : a(a), b(b), c(c) {}
};

vector<Three> ans;

bool rec(int ind) {
    if (ind == m / 2) {
        return true;
    }

    for (int v = 0; v < n; v++) {
        for (int u : g[v]) {
            if (used[v][u]) {
                continue;
            }

            used[v][u] = true;
            for (int t : g[u]) {
                if (used[u][t]) {
                    continue;
                }

                used[u][t] = true;

                //cerr << v << " " << u << " " << t << " " << ind << "\n";
                if (rec(ind + 1)) {
                    ans.emplace_back(v, u, t);
                    return true;
                }

                used[u][t] = false;
            }

            used[v][u] = false;
        }
    }

    return false;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].insert(v);
    }

    if (rec(0)) {
        cout << "Yes\n";
        for (auto &i : ans) {
            cout << (i.a + 1) << " " << (i.b + 1) << " " << (i.b + 1) << " " << (i.c + 1) << "\n";
        }
        exit(0);
    }


    cout << "No\n";
    return 0;
}
