#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 200;

vector<int> p, h;



int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int n, q;
    cin >> n >> q;


    h.resize(n + 2);
    p.resize(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> p[i] >> h[i];
    }

    p[0] = p[1];
    p[n + 1] = p[n];

    while (q--) {
        int l, r;
        cin >> l >> r;

        int cnt = 0;
        vector<bool> used(n + 2);
        for (int iter = 0; iter < n; iter++) {
            for (int i = l; i <= r; i++) {
                if (used[i]) {
                    continue;
                }

                int lb = p[i], rb = p[i];
                for (int j = i - 1; j >= max(0, l - 1); j--) {
                    lb = p[j];
                    if (!used[j]) {
                        break;
                    }
                }

                for (int j = i + 1; j <= min(n + 1, r + 1); j++) {
                    rb = p[j];
                    if (!used[j]) {
                        break;
                    }
                }

                if (lb <= p[i] - h[i]) {
                    used[i] = true;
                    cnt++;
                    break;
                } else if (rb >= p[i] + h[i]) {
                    used[i] = true;
                    cnt++;
                    break;
                }
            }
        }

        cout << cnt << "\n";
    }

    return 0;
}
