#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
void initial()
{
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
#define all(x) (x).begin(), (x).end()
#define sz(x) ((long long)(x).size())
#define pb push_back
#define f first
#define s second
typedef long long ll;
const ll maxn = 5e5 + 10;
vector <ll> g[maxn];
bool used[maxn];
vector <pair <pair <ll, ll>, pair <ll, ll> > > ans;
pair <ll, ll> dfs(ll v, ll p = -1)
{
    vector <ll> in, out;
    used[v] = true;
    bool ok = false;
    for (auto to: g[v])
    {
        if (to == p) {
            ok = true;
            continue;
        }
        auto [w1, w2] = dfs(to, v);
        if (w1) in.pb(to);
        if (w2) out.pb(to);
    }
    if (sz(in) - sz(out) > 1)
    {
        cout << "NO";
        exit(0);
    }
    pair <bool, bool> ret = {ok, 1};
    if (sz(in) != sz(out))
    {
        if (sz(in) > sz(out))
        {
            if (!ok)
            {
                cout << "NO";
                exit(0);
            }
            ret = {0, 1};
        }
        else
        {
            ret = {ok, 0};
            ans.pb({{p, v}, {v, out.back()}});
        }
    }
    for (int i = 0; i < min(sz(in), sz(out)); i++)
    {
        ans.pb({{in[i], v}, {v, out[i]}});
    }
    return ret;
}
int main() {
    initial();
    ll n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        ll f, t;
        cin >> f >> t;
        g[f].pb(t);
    }
    for (int i = 1; i <= n; i++)
        if (!used[i])
        {
            auto it = dfs(i);
            if (it.f || it.s)
            {
                cout << "NO";
                return 0;
            }
        }
    cout << "YES\n";
    for (auto [a, b] : ans)
        cout << a.f << " " << a.s << " " << b.f << " " << b.s << endl;
    return 0;
}
