#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

#define pll pair<ll, ll>
#define ff first
#define ss second

ll n, m;

const ll MAXN = 3e5 + 10;
const ll INF = 1e12;

vector<pll> g[MAXN];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll u, v, c;
        cin >> u >> v >> c;
        g[u].emplace_back(v, c);
        g[v].emplace_back(u, c);
    }
    if(m == n - 1){
        vector<ll> mn(n + 1, INF);
        vector<ll> mx(n + 1, -INF);

        queue<pll> q;
        q.push({1, -1});
        while(!q.empty()){
            ll v = q.front().ff;
            ll p = q.front().ss;
            for(pll e: g[v]){
                if(e.ff == p) continue;

                mn[e.ff] = min(mn[v], e.ss);
                mx[e.ff] = max(mx[v], e.ss);
                q.push({e.ff, v});
            }
        }
        for(int i = 2; i <= n; ++i) cout << mn[i] + mx[i] << '\n';

        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}
