#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e9 + 10;
const int MOD = (int)1e9 + 7;

int input() {
	int x = 0;
	char c = ' ';
	while (!isdigit(c))
		c = _getchar_nolock();
	while (isdigit(c)) {
		x = x * 10 + (c - '0');
		c = _getchar_nolock();
	}
	return x;
}

void print(int x) {
	for (char c : to_string(x))
		_putchar_nolock(c);
	_putchar_nolock(endl);
	return;
}

void dfs(int v, vector<vii>& g, vi& ans, int p = -1, int mn = INF, int mx = -INF) {
	ans[v] = mn + mx;
	for (int i = 0; i < g[v].size(); ++i) {
		int u = g[v][i].first, t = g[v][i].second;
		if (u == p)
			continue;
		dfs(u, g, ans, v, min(mn, t), max(mn, t));
	}
	return;
}

void solve() {
	int n = input(), m = input();
	vector<vii> g(m);
	for (int i = 0; i < m; ++i) {
		int u = input(), v = input(), t = input();
		--u; --v;
		g[u].pb({ v, t });
		g[v].pb({ u, t });
	}
	vi ans(n);
	dfs(0, g, ans);
	for (int i = 1; i < n; ++i)
		print(ans[i]);

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}