#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

const int N = 4e5;
vector<pair<int, int>> g[N];
int s[N];
int used[N];
int cnte = 0;
vector<vector<int>> ans;

pair<int, int> dfs(int v, int p) {
    used[v] = 1;
    pair<int, int> ret = {0, 0};
    int in = 0, out = 0;
    vector<int> ins, outs;
    for(auto e : g[v]) {
        int to = e.first;
        int real = e.second;
        if (to == p) {
            if (real) {
                s[v] = 1;
            }
            continue;
        }
        auto res = dfs(to, v);
        if (real) {
            if (res.first) {
                if (res.second) {
                    ins.push_back(to);
                }
            }
            else if (!res.second) {
                outs.push_back(to);
            }
        } else {
            if (res.first) {
                cout << "No";
                exit(0);
            }
            ins.push_back(to);
        }
    }
   // cout << v << ' ' << size(ins) << ' ' << size(outs) << ' ' << s[v] << endl;
    while (!ins.empty() && !outs.empty()) {
        int x = ins.back();
        int y = outs.back();
        ins.pop_back();
        outs.pop_back();
        ans.push_back({});
        ans.back() = {x + 1, v + 1, v + 1, y + 1};
    }
    if (!ins.empty()) {
        if (!s[v]) {
            cout << "No\n";
            exit(0);
        }
        s[v] = 0;
        ans.push_back({});
        int x = ins.back();
        ins.pop_back();
        ans.back() = {x + 1, v + 1, v + 1, p + 1};
    }
    if (size(outs) > 1 || !ins.empty()) {
        cout << "No\n";
        exit(0);
    }
    if (!outs.empty()) {
        int x = outs.back();
        ans.push_back({});
        ans.back() = {p + 1, v + 1, v + 1, x + 1};
    }
    return {!outs.empty(), s[v]};
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    map<pair<int, int>, bool> ex;
    for(int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        ex[{x, y}] = 1;
        g[x].emplace_back(y, 1);
    }
    for(int i = 0; i < n; i++) {
        for(auto to : g[i]) {
            if (to.second) {
                if (ex.find({to.first, i}) == ex.end()) {
                    g[to.first].emplace_back(i, 0);
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if (!used[i]) {
            auto res = dfs(i, -1);
            if (res.first || res.second) {
                cout << "No";
                exit(0);
            }
        }
    }
    cout << "Yes\n";
    for(auto v : ans) {
        for(int y : v) cout << y << ' '; cout << '\n';
    }
}