#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long
using namespace std;

const int INF = 1e18;
vector <int> val(26, 1);

void solve() {
	string s; cin >> s;
	int n = s.size();
	vector <vector <int>> dp(n + 1, vector <int>(26));
	vector <vector <int>> pref(n + 1, vector <int>(26));
	for (int i = n - 1; i >= 0; i--) {
		for (int j = 0; j < 26; j++) {
			if (s[i] == '?' || (s[i] - 'A') == j)
				dp[i][j] = val[j] + dp[i + 1][pref[i + 1][j]];
			else {
				if ((s[i] - 'A') < j)
					dp[i][j] = -val[s[i] - 'A'] + dp[i + 1][j];
				else
					dp[i][j] = -INF;
			}
		}
		pref[i][0] = 0;
		for (int j = 1; j < 26; j++) {
			pref[i][j] = pref[i][j - 1];
			if (dp[i][j] > dp[i][pref[i][j]])
				pref[i][j] = j;
		}
	}

	int I = 0, J = 0;
	for (int j = 0; j < 26; j++) {
		if (dp[I][j] > dp[I][J])
			J = j;
	}
	cout << dp[I][J] << endl;

	while (I < n) {
		if (s[I] == '?')
			cout << char(J + 'A');
		else
			cout << s[I];
		J = pref[I + 1][J];
		I++;
	}
	cout << endl;
}

signed main() {
	//ios::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	for (int i = 1; i < 26; i++) {
		if (i % 2 == 0)
			val[i] = val[i - 1] * 2;
		else
			val[i] = val[i - 1] * 5;
	}

	int t = 1; cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}