#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#define _CRT_SECURE_NO_WARNINGS
#define endl '\n'

using namespace std;
using ll = long long;

const int N = 3e5 + 9;

pair<ll, ll> cor0[N];
set<ll> cor;
int n;

ll mindist (int i)
{
	if (cor.size() == 2)return 0;
	int l = *prev(cor.lower_bound(i));
	int r = *cor.upper_bound(i);
	return min(cor0[i].first - cor0[l].first, cor0[r].first - cor0[i].first) - cor0[i].second;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else 
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int  q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++)
	{
		cin >> cor0[i].first;
		cin >> cor0[i].second;
	}
	cor0[0].first = cor0[1].first;
	cor0[0].second = -1;
	
	cor0[n + 1].first = cor0[n].first;
	cor0[n + 1].second = 1e18;
	n += 2;
	
	for (int d = 0; d < q; d++)
	{
		int l0, r0;
		cin >> l0 >> r0;
		

		set<pair<ll, ll>> s;
		cor.clear();
		map<int, ll> m;
		for (int i = 0; i < n; i++)
			cor.insert(i);
		for (int i = l0; i <= r0; i++)
		{
			
	s.insert({ min(cor0[i].first - cor0[i - 1].first, cor0[i + 1].first - cor0[i].first) - cor0[i].second, i });
			m[i] = min(cor0[i].first - cor0[i - 1].first, cor0[i + 1].first - cor0[i].first) - cor0[i].second;
		}
		int ans = 0;
		while (!s.empty() && (*s.begin()).first >= 0)
		{
			int i = (*s.begin()).second;
			int l = *prev(cor.lower_bound(i));
			int r = *cor.upper_bound(i);

			s.erase(s.begin());
			m[i] = 0;
			cor.erase(i);

			s.erase({ m[l], l });
			s.erase({ m[r], r });
			m[l] = mindist(l);
			m[r] = mindist(r);
			if(l >= l0 && l <= r0)
				s.insert({ m[l], l });
			if (r >= l0 && r <= r0)
				s.insert({ m[r], r });
			ans++;
		}

		cout << ans << endl;
	}
}