#include <iostream>
#include <string>
#include <cmath>
#include <vector>


using namespace std;

#define int long long

long long ten_pow[] = {1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 10000000000, 100000000000, 1000000000000};
long long five_pow[] = {5, 50, 500, 5000, 50000, 500000, 5000000, 50000000, 500000000, 5000000000, 50000000000, 500000000000, 5000000000000};

long long per_char(char ch){
    if ((ch - 'A') % 2 == 0)
        return ten_pow[(ch - 'A') / 2];
    else
        return five_pow[(ch - 'A') / 2];
}

long long per_string(string &s){
    char mx = 'A';
    long long rez = 0;
    for (int i = s.size() - 1; i >= 0; i--){
        if (s[i] < mx){
            rez -= per_char(s[i]);
        }
        else{
            rez += per_char(s[i]);
            if (s[i] > mx){
                mx = s[i];
            }
        }
    }
    return rez;
}

void f(string &s){
    for (int i = 0; i < s.size(); i++){
        if (s[i] == '?'){
            s[i] = 'Z';
        }
    }
}

void y(string &s, int num){
    int p = 0;
    for (int i = 0; i < s.size(); i++){
        if (s[i] == '?'){
            s[i] = 'A' + (long long) (num / pow(26, p)) % 26;
            p++;
        }
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--){
        string s;
        cin >> s;
        vector <char> mo;
        char tmp_mx = 'A' - 1;
        for (int i = 0; i < s.size(); i++){
            if (s[i] != '?' && s[i] >= tmp_mx){
                mo.push_back(s[i]);
            }
        }
        string rez;
        if (mo.empty()){
            for (int i = 0; i < s.size(); i++){
                rez += "Z";
            }
            long long n = per_string(rez);
            cout << n << "\n" << rez << "\n";
        }
        else {
            vector<int> count(26);
            int index = mo.size() - 1;
            for (int i = 0; i < s.size(); i++) {
                if (s[i] == '?') {
                    if ((long long) (count[24] * ten_pow[12] + count[23] * five_pow[11] +
                             count[22] * ten_pow[11] + count[21] * five_pow[10] + count[20] * ten_pow[10] +
                             count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                             count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                             count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                             count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                             count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                             count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                    count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('Z')){
                        s[i] = 'Z';
                    }
                    else if ((long long) (count[23] * five_pow[11] +
                                     count[22] * ten_pow[11] + count[21] * five_pow[10] + count[20] * ten_pow[10] +
                                     count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                                     count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                     count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                     count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                     count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                     count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                     count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('Y')){
                        s[i] = 'Y';
                    }
                    else if ((long long) (
                                     count[22] * ten_pow[11] + count[21] * five_pow[10] + count[20] * ten_pow[10] +
                                     count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                                     count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                     count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                     count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                     count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                     count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                     count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('X')){
                        s[i] = 'X';
                    }
                    else if ((long long) (
                                     count[21] * five_pow[10] + count[20] * ten_pow[10] +
                                     count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                                     count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                     count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                     count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                     count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                     count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                     count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('W')){
                        s[i] = 'W';
                    }
                    else if ((long long) (count[20] * ten_pow[10] +
                            count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                            count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                            count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                            count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                            count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                            count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                            count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('V')){
                        s[i] = 'V';
                    }
                    else if ((long long) (count[19] * five_pow[9] + count[18] * ten_pow[9] + count[17] * five_pow[8] +
                                          count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('U')){
                        s[i] = 'U';
                    }
                    else if ((long long) (count[18] * ten_pow[9] + count[17] * five_pow[8] +
                                          count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('T')){
                        s[i] = 'T';
                    }
                    else if ((long long) ( count[17] * five_pow[8] +
                                          count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('S')){
                        s[i] = 'S';
                    }
                    else if ((long long) (
                                          count[16] * ten_pow[8] + count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('R')){
                        s[i] = 'R';
                    }
                    else if ((long long) (count[15] * five_pow[7] + count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('Q')){
                        s[i] = 'Q';
                    }
                    else if ((long long) (count[14] * ten_pow[7] +
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('P')){
                        s[i] = 'P';
                    }
                    else if ((long long) (
                                          count[13] * five_pow[6] + count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('O')){
                        s[i] = 'O';
                    }
                    else if ((long long) (count[12] * ten_pow[6] + count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('N')){
                        s[i] = 'N';
                    }
                    else if ((long long) (count[11] * five_pow[5] +
                                          count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('M')){
                        s[i] = 'M';
                    }
                    else if ((long long) (count[10] * ten_pow[5] + count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('L')){
                        s[i] = 'L';
                    }
                    else if ((long long) (count[9] * five_pow[4] + count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('K')){
                        s[i] = 'K';
                    }
                    else if ((long long) (count[8] * ten_pow[4] +
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('J')){
                        s[i] = 'J';
                    }
                    else if ((long long) (
                                          count[7] * five_pow[3] + count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('I')){
                        s[i] = 'I';
                    }
                    else if ((long long) (count[6] * ten_pow[3] + count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('H')){
                        s[i] = 'H';
                    }
                    else if ((long long) (count[5] * five_pow[2] +
                                          count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('G')){
                        s[i] = 'G';
                    }
                    else if ((long long) (count[4] * ten_pow[2] + count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('F')){
                        s[i] = 'F';
                    }
                    else if ((long long) (count[3] * five_pow[1] + count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('E')){
                        s[i] = 'E';
                    }
                    else if ((long long) (count[2] * ten_pow[1] +
                                          count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('D')){
                        s[i] = 'D';
                    }
                    else if ((long long) (count[1] * five_pow[0] +count[0] * ten_pow[0]) < per_char('C')){
                        s[i] = 'C';
                    }
                    else if ((long long) (count[0] * ten_pow[0]) < per_char('B')){
                        s[i] = 'B';
                    }
                    else{
                        s[i] = 'A';
                    }
                }
                if (s[i] >= mo[index]) {
                    count[s[i] - 'A']++;
                }
                if (s[i] == mo[index]) {
                    index--;
                }
            }
            long long n = per_string(s);
            cout << n << "\n" << s << "\n";
        }
    }
    return 0;
}