import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class C {
    public static ArrayList<pair>[] g;
    public static class pair{
        int f;
        int s;
        public pair(int f, int s){
            this.f = f;
            this.s = s;
        }
    }
    public static void dfs(int v, int min, int max){
        used[v] = true;
        ans[v] = min + max;
        for(pair p : g[v]){
            dfs(p.f, Math.min(min, p.s), Math.max(max, p.s));
        }
    }
    public static int[] ans;
    public static boolean[] used;
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        int m = Integer.parseInt(st.nextToken());
        g = new ArrayList[n];
        for(int i = 0; i < n; ++i){
            g[i] = new ArrayList<>();
        }
        for(int i = 0; i < m; ++i){
            st = new StringTokenizer(reader.readLine());
            int a = Integer.parseInt(st.nextToken()) - 1;
            int b = Integer.parseInt(st.nextToken()) - 1;
            int w = Integer.parseInt(st.nextToken());
            g[a].add(new pair(b, w));
            g[b].add(new pair(a, w));
        }
        ans = new int[n];
        for(int i = 1; i < n; ++i){
            writer.println(ans[i]);
        }
        writer.close();
    }
}
