#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e18) + 123;
const ll maxn = ll(5e5) + 5;

ll n, q;
vector<ll> a, hs;

ll can_fall[maxn]; /// (immediately)

set<ll> good;
set<ll> ps;

void check(ll pos, ll l, ll r) {
    if(pos == *ps.begin()) {
        if(l == 0) {
            if(a[0] <= a[pos] - hs[pos]) {
                good.insert(pos);
            }
        } else {
            if(a[l - 1] <= a[pos] - hs[pos] && a[0] <= a[pos] - hs[pos]) {
                good.insert(pos);
            }
        }
    } else {
        ll prev = *--ps.lower_bound(pos);
        if(a[prev] <= a[pos] - hs[pos] && a[0] <= a[pos] - hs[pos]) {
            good.insert(pos);
        }
    }

    if(pos == *--ps.end()) {
        if(r == n - 1) {
            if(a[pos] + hs[pos] <= a[n - 1]) {
                good.insert(pos);
            }
        } else {
            if(a[pos] + hs[pos] <= a[r + 1]) {
                good.insert(pos);
            }
        }
    } else {
        ll nxt = *ps.upper_bound(pos);
        if(a[pos] + hs[pos] <= a[nxt]) {
            good.insert(pos);
        }
    }
}

void solve() {
    cin >> n >> q;
    for(ll i = 0; i < n; i++) {
        ll x, h;
        cin >> x >> h;
        a.pb(x);
        hs.pb(h);
    }

    for(ll i = 0; i < n; i++) {
        bool cur = false;

        if(i > 0 && a[i - 1] <= a[i] - hs[i]) {
            cur = true;
        }
        if(i < n - 1 && a[i] + hs[i] <= a[i + 1]) {
            cur = true;
        }

        can_fall[i] = cur;
    }

    map<pll, ll> anses;

    for(ll tt = 0; tt < q; tt++) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;

        if(anses.find({l, r}) != anses.end()) {
            cout << anses[{l, r}] << "\n";
            continue;
        }

        ps.clear();
        for(ll i = l; i <= r; i++) {
            ps.insert(i);
        }

        ll ans = 0;

        good.clear();

        for(ll i = l; i <= r; i++) {
            check(i, l, r);
        }

        for(ll s = 0; s < (r - l + 1); s++) {
            if(good.size() == 0) {
                break;
            }

            ll cur = *good.begin();

            ps.erase(cur);
            good.erase(cur);

            if(ps.upper_bound(cur) != ps.end()) {
                check(*ps.upper_bound(cur), l, r);
            }
            if(ps.lower_bound(cur) != ps.begin()) {
                check(*--ps.lower_bound(cur), l, r);
            }
            ans++;
        }

        cout << ans << "\n";

        anses[{l, r}] = ans;
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
