//#include <iostream>
//#include <vector>
//#include <set>
//#include <map>
//#include <cassert>
#include <bits/stdc++.h>
using namespace std;

vector<set<int>> g;
vector<set<int>> g2;
set<pair<int, int>> used;

vector<pair<pair<int, int>, pair<int, int>>> answer;

void no() {
    cout << "No\n";
    exit(0);
}

void del(pair<int, int> dd) {
    int u = dd.first, v = dd.second;
    g2[u].erase(v);
    used.erase(dd);
    if (used.find({v, u}) == used.end()) {
        g[u].erase(v);
        g[v].erase(u);
    }
}

void dfs(int v, int pr = -1) {
    if (g[v].empty())
        return;
    for (int to : g[v]) {
        if (to != pr) {
            dfs(to, v);
//            assert(g[to].size() <= 1);
        }
    }
    vector<pair<int, int>> tov, fromv;
    for (int to : g2[v]) {
        if (to != pr) {
            fromv.emplace_back(v, to);
        }
    }
    for (int to : g[v]) {
        if (to != pr) {
            if (g2[v].find(to) == g2[v].end() || (g2[v].find(to) != g2[v].end() && g2[to].find(v) != g2[to].end())) {
//                assert(g2[to].size() == 1 && *g2[to].begin() == v);
                tov.emplace_back(to, v);
            }
        }
    }
    int fsz = fromv.size();
    int tsz = tov.size();
    if (abs(fsz - tsz) > 1) no();
    while (!fromv.empty() && !tov.empty()) {
        answer.emplace_back(tov.back(), fromv.back());
        del(fromv.back());
        del(tov.back());
        fromv.pop_back();
        tov.pop_back();
    }

//    if (g[v].size() == 1 && pr != -1) {
//        assert(*g[v].begin() == pr);
//        if (used.find({pr, v}) != used.end() && used.find({v, pr}) != used.end()) {
//            del({pr, v});
//            del({v, pr});
//            answer.push_back({{pr, v}, {v, pr}});
//        }
//    }
    if (fromv.empty() && tov.empty()) return;
    if (pr == -1) no();

    if (!fromv.empty()) {
        auto it = used.find({pr, v});
        if (it == used.end()) no();
        answer.push_back({{pr, v}, *fromv.begin()});
        del({pr, v});
        del(*fromv.begin());
    }
    if (!tov.empty()) {
        auto it = used.find({v, pr});
        if (it == used.end()) no();
        answer.push_back({*tov.begin(), {v, pr}});
        del({v, pr});
        del(*fromv.begin());
    }
}

int main() {
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    g2.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        if (used.find({u, v}) == used.end() && used.find({v, u}) == used.end()) {
            g[v].insert(u);
            g[u].insert(v);
        }
        g2[u].insert(v);
        used.insert({u, v});
    }
    for (int i = 0; i < n; ++i)
        dfs(i);
    cout << "Yes\n";
    for (auto now : answer)
        cout << now.first.first + 1 << ' ' << now.first.second + 1 << ' ' << now.second.first + 1 << ' ' << now.second.second + 1 << '\n';
    return 0;
}
