#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 10;
const ll inf = 1e18;

vector <pair <ll, ll>> e[N];
ll ans[N];
bool used[N];
ll d[N];
ll n, m;
set <pair <ll, ll>> s;

void deix() {
	for (ll i = 1; i < n; i++) {
		d[i] = inf;
		s.insert(make_pair(d[i], i));
	}
	d[0] = 0;
	s.insert(make_pair(0, 0));
	for (ll i = 0; i < n; i++) {
		auto it = s.begin();
		ll a = (*it).second;
		s.erase(it);
		used[a] = 1;
		for (ll i = 0; i < e[a].size(); i++) {
			ll v = e[a][i].first;
			if (used[v]) {
				continue;
			}
			s.erase(make_pair(d[v], v));
			d[v] = min(d[v], max(d[a], e[a][i].second));
			s.insert(make_pair(d[v], v));
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--; b--;
		e[a].push_back(make_pair(b, c));
		e[b].push_back(make_pair(a, c));
	}
	deix();
	for (ll i = 1; i < n; i++) {
		cout << d[i] << '\n';
	}
}