#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()

vector<vector<pair<int, ll> > > g;
vector<vector<pair<int, ll> > > t;
vector<ll> dist;

const ll MX = 1000000000;

bool check3()
{
    for(auto &[u, w] : g[0])
        if(w != MX)
            return 0;
    /*for(int i = 0; i < g.size(); ++i)
    {
        for(auto &[v, w] : g[i])
        {
            w *= -1;
        }
    }*/
    return 1;
}

vector<int> dsu;

void ini(int n)
{
    dsu.assign(n, 0);
    for(int v = 0; v < n; ++v)
        dsu[v] = v;
}

int get(int v)
{
    return v == dsu[v] ? v : dsu[v] = get(dsu[v]);
}

void Merge(int u, int v)
{
    u = get(u);
    v = get(v);
    if(u == v)
        return;
    if(rand() & 1)
        swap(u, v);
    dsu[u] = v;
}

void MIN_OSTOV()
{
    int n = g.size();
    t.clear();
    t.resize(n);
    vector<pair<ll, pair<int, int> > > e;
    for(int v = 0; v < n; ++v)
    {
        for(auto &[u, w] : g[v])
        {
            e.emplace_back(w, make_pair(u, v));
        }
    }
    sort(all(e));
    ini(n);
    for(auto &[w, c] : e)
    {
        int v = c.first;
        int u = c.second;
        if(get(v) != get(u))
        {
            Merge(u, v);
            t[v].emplace_back(u, w);
            t[u].emplace_back(v, w);
        }
    }
}

void dfs(int v, int p, ll mx, ll mn)
{
    dist[v] = mx + mn;
    for(auto &[u, w] : t[v])
    {
        if(u == p)
            continue;
        dfs(u, v, max(mx, w), min(mn, w));
    }
}

void solve(bool flag3)
{
    MIN_OSTOV();
    ///cout << "done" << endl;
    int n = g.size();
    dist.assign(n, -2 * MX);
    dist[0] = 0;
    dfs(0, -1, - 2 * MX, 2 * MX);
    ///ll len = g[0][0].second;
    for(int i = 1; i < n; ++i)
    {
        ///dist[i] += len;
        if(flag3)
            dist[i] *= -1;
        cout << dist[i] << '\n';
    }
}

bool check2()
{
    for(auto &[u, w] : g[0])
        if(w)
            return 0;
    return 1;
}

signed main()
{
    ios;
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        ll w;
        cin >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    bool flag3 = 0;
    if(check3())
    {
        flag3 = 1;
    }
    if(m == n - 1 || check2() || flag3)
    {
        ///cout << "go" << endl;
        solve(0);
        return 0;
    }
    /*vector<
    for(int i = 0; i < n; ++i)
    {

    }*/
    return 0;
}
