#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>

using namespace std;

const int MAXN = 10007;

int x[MAXN];
int h[MAXN];
bool used[MAXN];
int n;

bool check(int pos) {
	if (used[pos]) return false;
	if (x[pos] - h[pos] >= x[0]) {
		bool flag = true;
		for (int i = 0; i < pos; ++i) {
			if (used[i]) continue;
			if (x[pos] - h[pos] <= x[i]) {
				flag = false;
				break;
			}
		}
		if (flag) return true;
	}
	if (x[pos] + h[pos] <= x[n - 1]) {
		bool flag = true;
		for (int i = n - 1; i > pos; --i) {
			if (used[i]) continue;
			if (x[pos] + h[pos] >= x[i]) {
				flag = false;
				break;
			}
		}
		if (flag) return true;
	}
	return false;
}

int ask(int l, int r) {
	memset(used, 0, sizeof used);
	int cnt = 0;
	bool flag = true;
	while (cnt < r - l + 1) {
		flag = false;
		for (int i = l; i <= r; ++i) {
			if (check(i)) {
				++cnt;
				flag = true;
			}
		}
		if (!flag) break;
	}
	return cnt;
}

int main() {
	int q;
	cin >> n >> q;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		cout << ask(l, r) << "\n";
	}
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/