#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <set>

using namespace std;

const int MAXN = 10007;

int x[MAXN];
int h[MAXN];
bool used[MAXN];
set<int, less<int>> leftX;
set<int, greater<int>> leftX2;
int n;

bool check(int pos) {
	if (used[pos]) return false;
	if (x[pos] - h[pos] >= x[0]) {
		auto xl = leftX2.upper_bound(x[pos]);
		if (xl == leftX2.end() || x[pos] - h[pos] >= (*xl)) return true;
	}
	if (x[pos] + h[pos] <= x[n - 1]) {
		auto xr = leftX.upper_bound(x[pos]);
		if (xr == leftX.end() || x[pos] + h[pos] <= (*xr)) return true;
	}
	return false;
}

int ask(int l, int r) {
	memset(used, 0, sizeof used);
	leftX.clear();
	leftX2.clear();
	for (int i = max(0, l - 1); i <= min(n - 1, r + 1); ++i) {
		leftX.insert(x[i]);
		leftX2.insert(x[i]);
	}
	int cnt = 0;
	bool flag = true;
	while (cnt < r - l + 1) {
		flag = false;
		for (int i = l; i <= r; ++i) {
			if (check(i)) {
				++cnt;
				flag = true;
				used[i] = true;
				leftX.erase(x[i]);
				leftX2.erase(x[i]);
			}
		}
		if (!flag) break;
	}
	return cnt;
}

int main() {
	int q;
	cin >> n >> q;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}
	/*for (int l = 0; l < n; ++l) {
		for (int r = l; r < n; ++r) {

		}
	}*/
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		cout << ask(l, r) << "\n";
	}
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/

/*
5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
*/