#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
//#define int long long
using namespace std;

const int maxn = 3e5 + 228;
vector<pair<int, int> > g[maxn];
int ans[maxn];
int link[maxn];
int sizex[maxn];

int find(int a){
    return (link[a] == a ? a : link[a] = find(link[a]));
}

void unite(int a, int b){
    a = find(a);
    b = find(b);
    if(sizex[a] > sizex[b])
        swap(a, b);
    link[a] = b;
    sizex[b] += a;
}

bool same(int a, int b){
    return find(a) == find(b);
}

bool cmp(pair<int, pair<int, int> > a, pair<int, pair<int, int> > b){
    return a.second.second < b.second.second;
}

void dfs(int v, int p = -1, int mn = 1e9, int mx = 0){
    ans[v] = mn + mx;
//    cout << v << " " << mn << " " << mx << endl;
    for(pair<int, int> i:g[v]){
        if(i.first == p)
            continue;
        dfs(i.first, v, min(mn, i.second), max(mx, i.second));
    }
}

pair<int, int> dp[1<<20][20];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, int> > >  edges;
    for(int i=0; i<maxn; i++){
        link[i] = i;
        sizex[i] = 1;
        ans[i] = 2e9;
    }
    for(auto &i:dp)
        for(pair<int, int> &j:i)
            j = make_pair(-1, -1);
    for(int i=0; i<m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        if(a > b)
            swap(a, b);
        if(a == 0){
            dp[1<<edges.size()][edges.size()] = make_pair(c, c);
            ans[b] = c*2;
        }
        edges.push_back(make_pair(a, make_pair(b, c)));
        edges.push_back(make_pair(b, make_pair(a, c)));
//        g[a].push_back(make_pair(b, c));
//        g[b].push_back(make_pair(a, c));
    }
    for(int &i:ans)
        i = 2e9;
    for(int i=1; i<(1<<(m*2)); i++){
        for(int j=0; j<m*2; j++){
            if((i & (1<<j)) == 0)
                continue;
            for(int l=0; l<m*2; l++){
                if(j == l)
                    continue;
                if(dp[i ^ (1<<j)][l] != make_pair(-1ll, -1ll)){
                    if(edges[j].first == edges[l].second.first){
                        dp[i][j] = make_pair(min(dp[i ^ (1<<j)][l].first, edges[l].second.second), max(dp[i ^ (1<<j)][l].second, edges[l].second.second));
//                        cout << edges[j].second.first << " " << dp[i][j].first << " " << dp[i][j].second << endl;
                        ans[edges[j].second.first] = min(ans[edges[j].second.first], dp[i][j].first + dp[i][j].second);
                    }
                }
            }
        }
    }
    for(int i=1; i<n; i++)
        cout << ans[i] << endl;
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
==========
4 4
1 2 2
3 2 0
2 4 3
4 3 1
 */