#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

vector < pair < int, int > > g[N];

int res[N];

void dfs(int v, int p, int minc, int maxc) {
	res[v] = minc + maxc;
	for (auto t : g[v]) {
		int to = t.first;
		int c = t.second;
		if (to == p)
			continue;
		dfs(to, v, min(minc, c), max(maxc, c));
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int n, m;

	cin >> n >> m;

	for (int i = 1; i <= m; ++i) {
		int v, to, c;
		cin >> v >> to >> c;
		g[v].push_back({ to, c });
		g[to].push_back({ v, c });
	}

	dfs(1, 1, 1e9 + 10, -1e9 - 10);

	for (int i = 2; i <= n; ++i) {
		cout << res[i] << '\n';
	}

}