#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

const int A = 26;
const ll INF = 2 * 1e18;
vector<ll> values;

ll count(string &s){
    int n = s.size();
    ll ans = 0; char mx = 'A';
    for (int i = n - 1; i >= 0; i--){
        if (s[i] < mx)
            ans -= values[s[i] - 'A'];
        else
            ans += values[s[i] - 'A'];
        mx = max(mx, s[i]);
    }
    return ans;
}

void gen(vector<int> &lst, vector<int> &gaps, string &s, string &ans, ll &best, ll done){
    if (done == lst.size()){
        for (int i = 0; i < gaps.size(); i++)
            s[gaps[i]] = (char)(lst[i] + 'A');
        ll curr = count(s);
        if (curr > best){
            best = curr;
            ans = s;
        }
        return;
    }
    for (int letter = 0; letter < A; letter++){
        lst[done] = letter;
        gen(lst, gaps, s, ans, best, done + 1);
    }
}

void solution(){
    string s;
    cin >> s;
    int n = s.size();

    values.resize(A);
    values[0] = 1;
    for (int i = 1; i < A; i++){
        if (i % 2 == 0)
            values[i] = values[i - 1] * 2;
        else
            values[i] = values[i - 1] * 5;
    }

    vector<int> gaps;
    for (int i = 0; i < n; i++)
        if (s[i] == '?')
            gaps.pb(i);

    if (gaps.empty()){
        cout << count(s) << "\n" << s << endl;
        return;
    }

    vector<int> lst(gaps.size());
    string ans = s; ll best = -INF;
    gen(lst, gaps, s, ans, best, 0);
    cout << best << "\n" << ans << endl;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; test++) {
        solution();
        //cout << "test " << test << " completed" << endl;
    }
    return 0;
}