#include <iostream>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>

typedef long long ll;


const int N = 2e6;
const int alp = 26;
const ll inf = 1e18;

using namespace std;

ll val[alp];
int cnt[alp];

int n;
string s;
string news;
string a;

ll gen(int last, int q)
{
	if (q == n)
	{
		char mx = 'A';
		ll ans = 0;
		for (int qq = n - 1; qq > -1; qq--)
		{
			if (mx > news[qq])
			{
				ans -= val[news[qq] - 'A'];
			}
			else
			{
				ans += val[news[qq] - 'A'];
				mx = news[qq];
			}
		}
		return ans;
	}
	else
	{
		ll an = -inf;
		if (s[q] == '?')
		{
			for (int w = last; w < alp; w++)
			{
				news[q] = char(w + 'A');
				auto x = gen(w, q + 1);
				if (an < x)
				{
					an = x;
					a = news;
				}
			}
			return an;
		}
		else
		{
			news[q] = s[q];
			return gen(last, q + 1);
		}
	}
}

int main()
{
	int test = 1;
	cin >> test;
	val[0] = 1;
	for (int q = 1; q < alp; q++)
	{
		val[q] = val[q - 1] * (q % 2 ? 5 : 2);
	}
	while (test--)
	{
		cin >> s;
		n = s.size();
		news.resize(n);
		a = s;
		ll ans = 0;
		char mx = 'A';
		int kolvo = 0;
		for (int q = n - 1; q > -1; q--)
		{
			if (s[q] == '?')
			{
				kolvo++;
				mx = 'Z';
				ans += val['Z' - 'A'];
			}
			else
			{
				if (mx > s[q])
				{
					ans -= val[s[q] - 'A'];
				}
				else
				{
					ans += val[s[q] - 'A'];
					mx = s[q];
				}
			}
		}
		cout << gen(0, 0) << '\n';
		cout << a << '\n';
	}
}