#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int> > data;
vector<bool> del;
int n;

int get_max_del(int l, int r) {
    if (l == r) {
        int lef = l - 1;
        int rig = l + 1;
        while (lef >= 0 && del[lef]) {
            lef--;
        }
        while (rig < n && del[rig]) {
            rig++;
        }
        if (rig == n) {
            rig--;
        }
        if (lef == -1) {
            lef++;
        }
        if (data[rig].first - data[l].first >= data[l].second) {
            del[l] = true;
            return 1;
        }
        else if (data[l].first - data[lef].first >= data[l].second) {
            del[l] = true;
            return 1;
        }
        return 0;
    }
    int lef = l - 1;
    int rig = l + 1;
    while (lef >= 0 && del[lef]) {
        lef--;
    }
    if (lef == -1) {
        lef++;
    }
    if (data[l].first - data[lef].first >= data[l].second) {
        del[l] = true;
        return 1 + get_max_del(l + 1, r);
    }
    int max_del = get_max_del(l + 1, r);
    while (rig < n && del[rig]) {
        rig++;
    }
    if (data[rig].first - data[l].first >= data[l].second) {
        del[l] = true;
        return 1 + max_del;
    }
    return max_del;
}

int main()
{
    int q;
    cin >> n;
    cin >> q;
    del.resize(n);
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x;
        cin >> h;
        data.push_back({x, h});
    }
    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l;
        cin >> r;
        l--;
        r--;
        for (int i = 0; i < n; ++i) {
            del[i] = false;
        }
        cout << get_max_del(l, r) << '\n';
    }
    return 0;
}
