#include <bits/stdc++.h>

using namespace std;
const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <vector <pair <int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w; --x; --y;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
    }
    if (m == n - 1) {
        vector <int> ans(n);
        function<void(int,int,int,int)> dfs = [&](int v, int minn, int maxx, int p) {
            ans[v] = minn + maxx;
            for (auto i : g[v]) {
                if (i.first == p) continue;
                dfs(i.first, min(minn, i.second), max(maxx, i.second), v);
            }
        };
        for (int i = 1; i < n; ++i) cout << ans[i] << "\n";
        return 0;
    }
    vector <int> d(n, INF);
    d[0] = 0;
    set <pair <int, int>> s;
    s.insert(make_pair(0, 0));
    vector <bool> used(n);
    while (!s.empty()) {
        auto now = *s.begin();
        used[now.second] = true;
        s.erase(s.begin());
        for (auto i : g[now.second]) {
            if (d[i.first] > max(i.second, now.first) && !used[i.first]) {
                s.erase(make_pair(d[i.first], i.first));
                d[i.first] = max(i.second, now.first);
                s.insert(make_pair(d[i.first], i.first));
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << d[i] << "\n";
}

