#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>;
using namespace std;

const int M = 400005;
vector<pair<int, int>>kon[M];
vector<pair<int, int>>nac[M];
//map<pair<int, int>, int>ord;
vector<pair<int, int>>e;
vector<int>all[M];
int mt[2 * M];
int used[2 * M];
int step = 1;
int col[2 * M];

void dfs(int v, int t) {
	col[v] = t;
	int k = 1;
	if (t == 1)
		k++;
	for (auto e : all[v]) {
		if (col[e] == 0)
			dfs(e, k);
	}
}
bool kun(int v) {
	if (used[v] == step)
		return false;
	used[v] = step;
	for (auto to : all[v]) {
		if (mt[to] == -1) {
			mt[to] = v;
			return true;
		}
	}
	for (auto to : all[v]) {
		if (kun(mt[to])) {
			mt[to] = v;
			return true;
		}
	}
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		kon[b].push_back({ a,i });
		nac[a].push_back({ b,i });
		//ord[{a, b}] = i;
		e.push_back({ a,b });
	}
	for (int i = 0; i < n; i++) {
		for (auto c : kon[i]) {
			int x = c.first;
			for (auto g : nac[i]) {
				if (g.first == x && i < x)
					continue;
				all[c.second].push_back(g.second);
				all[g.second].push_back(c.second);
			}
		}
	}
	int M1 = 0;

	for (int i = 0; i < 2 * M; i++)
		mt[i] = -1;
	for (int i = 0; i < m; i++) {
		if (col[i] == 0)
			dfs(i, 1);
	}
	for (int i = m-1; i>=0; i--) {
		if (col[i] == 2)
			continue;
		if (kun(i)) {
			step++;
			M1++;
			if (M1 == m / 2)
				break;
		}
	}
	if (M1 < m / 2) {
		cout << "No";
		return;
	}
	cout << "Yes" << '\n';
	for (int i = 0; i < 2 * M; i++) {
		if (mt[i] == -1)
			continue;
		int pos = i;
		int x = e[pos].first;
		int y = e[pos].second;
		cout << x + 1 << ' ' << y + 1 << ' ';
		pos = mt[i];
		x = e[pos].first;
		y = e[pos].second;
		cout << x + 1 << ' ' << y + 1 << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	int t;
	//cin >> t;
	t = 1;
	while (t) {

		t--;
		solve();
	}
}