#include <bits/stdc++.h>

using namespace std;

vector <int> used;
vector <set <int> > gr, in, out;
vector <vector <int> > ans;

pair <int, pair <int, int> > dfs(int v, int p) {
    used[v] = 1;
    for (int to : gr[v]) {
        if (to == p)
            continue;
        auto kek = dfs(to, v);
        if (!kek.first) {
            if (out[v].find(to) == out[v].end()) {
                cout << "No\n";
                exit(0);
            }
            ans.push_back({v, to, to, kek.second.second});
            out[v].erase(to);
        }
        else if (kek.first == 1) {
            if (out[to].find(v) == out[to].end()) {
                cout << "No\n";
                exit(0);
            }
            ans.push_back({kek.second.first, to, to, v});
            out[to].erase(v);
            in[v].erase(to);
        }
    }
    while (true) {
        bool fl = false;
        int del1 = -1, del2 = -1;
        for (auto st : in[v]) {
            if (st == p)
                continue;
            if (fl)
                break;
            for (auto fn : out[v]) {
                if (fn == p)
                    continue;
                /*cout << st << fn << endl;
                for (auto el : in[v])
                    cout << el << " ";
                cout << " in\n";
                for (auto el : out[v])
                    cout << el << " ";
                cout << " out\n";*/
                ans.push_back({st, v, v, fn});
                fl = true;
                del1 = st;
                del2 = fn;
                //if ()
                //in[v].erase(st);
                //out[v].erase(fn);
                break;
            }
        }
        if (!fl)
            break;
        in[v].erase(del1);
        out[v].erase(del2);
    }
    int kek1 = 0, kek2 = 0, bad_vert;
    for (auto el : in[v]) {
        if (el != p) {
            kek1++;
            bad_vert = el;
        }
    }
    for (auto el : out[v]) {
        if (el != p) {
            kek2++;
            bad_vert = el;
        }
    }
    if (kek1 > 1 || kek2 > 1) {
        cout << "No\n";
        exit(0);
    }
    if (!kek1 && !kek2) {
        return {-1, {-1, -1}};
    }
    if (kek1 == 1) {
        return {1, {bad_vert, v}};
    }
    return {0, {v, bad_vert}};
    //return {-1, {-1, -1}};
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    used.resize(n);
    gr.resize(n);
    in.resize(n);
    out.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].insert(b);
        gr[b].insert(a);
        out[a].insert(b);
        in[b].insert(a);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            auto res = dfs(i, -1);
            if (res.first != -1) {
                cout << "No\n";
                exit(0);
            }
        }
    }
    cout << "Yes\n";
    for (auto elem : ans) {
        for (int v : elem)
            cout << v + 1 << " ";
        cout << "\n";
    }
    return 0;
}
