#include <iostream>
#include "vector"

using namespace std;

vector<bool> used;
vector<pair<int, int>> res, ans, g;
vector<vector<int>> good;
int m, us = 0;
bool found = false;

void solve() {
    if (found) {
        return;
    }
    if (us == m) {
        found = true;
        ans = res;
        return;
    }
    for (int i = 0; i < m; ++i) {
        if (not used[i]) {
            for (auto j : good[i]) {
                if (not used[j]) {
                    used[i] = true;
                    used[j] = true;
                    us += 2;
                    res.push_back({i, j});
                    if (found) {
                        return;
                    }
                    solve();
                    used[i] = false;
                    used[j] = false;
                    us -= 2;
                    res.pop_back();
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b;
        a--; b--;
        g.push_back({a, b});
    }
    used.resize(m, false);
    good.resize(m);
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            if (g[i].first == g[j].second or g[i].second == g[j].first) {
                good[i].push_back(j);
                good[j].push_back(i);
            }
        }
    }
    solve();
    if (found) {
        cout << "Yes" << endl;
        for (auto el : ans) {
            cout << g[el.second].first + 1 << " " << g[el.second].second + 1 << " " << g[el.first].first + 1 << " " << g[el.first].second + 1 << endl;
        }
    } else {
        cout << "No" << endl;
    }
}