#include <iostream>
#include "vector"
#include "algorithm"

using namespace std;

vector<vector<int>> lft, rght;

bool comp(int a, int b) {
    return min(lft[a].size(), rght[a].size()) < min(lft[b].size(), rght[b].size());
}

signed main() {
    int n, q; cin >> n >> q;
    vector<pair<int, int>> tr;
    for (int i = 0; i < n; ++i) {
        int x, h; cin >> x >> h;
        tr.push_back({x, h});
    }
    lft.resize(n);
    rght.resize(n);
    for (int i = 0; i < n; ++i) {
        if (tr[i].first - tr[i].second < tr[0].first) {
            lft[i] = {-1};
        } else {
            int j = i - 1;
            while (j >= 0 and tr[i].first - tr[i].second < tr[j].first) {
                lft[i].push_back(j);
                j--;
            }
        }
        if (tr[i].first + tr[i].second > tr[n - 1].first) {
            rght[i] = {-1};
        } else {
            int j = i + 1;
            while (j < n and tr[i].first + tr[i].second > tr[j].first) {
                rght[i].push_back(j);
                j++;
            }
        }
    }
    /*for (auto el : lft) {
        for (auto el1 : el) {
            cout << el1 << " ";
        }
        cout << endl;
    }*/
    vector<int> z = {-1};
    for (int i = 0; i < q; ++i) {
        int l, r; cin >> l >> r;
        l--; r--;
        vector<bool> del(n, false);
        vector<int> sbtr;
        for (int j = l; j <= r; ++j) {
            sbtr.push_back(j);
        }
        sort(sbtr.begin(), sbtr.end(), comp);
        int ans = 0;
        while (true) {
            bool deld = false;
            for (auto j : sbtr) {
                if (not del[j]) {
                    bool psbl = false;
                    if (lft[j] != z) {
                        psbl = true;
                        for (auto el : lft[j]) {
                            if (not del[el]) {
                                psbl = false;
                                break;
                            }
                        }
                    }
                    if ((not psbl) and rght[j] != z) {
                        psbl = true;
                        for (auto el : rght[j]) {
                            if (not del[el]) {
                                psbl = false;
                                break;
                            }
                        }
                    }
                    if (psbl) {
                        ans++;
                        del[j] = true;
                        deld = true;
                    }
                }
            }
            if (not deld) {
                break;
            }
        }
        cout << ans << endl;
    }
}