#include<bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define fi first
#define se second
#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define pb push_back

const int N = 300000;
vector<pii> g[N];
int used[N];
set<pii> usd;
vector<pair<pii, pii>> ans;

void dfs(int v, int pr) {
    used[v] = 1;
    for (auto x : g[v]) {
        int y = v ^ x.fi ^ x.se;
        if (!used[y]) dfs(y, v);
    }
    vector<pii> A, B;
    for (auto x : g[v]) {
        if (usd.find(x) == usd.end()) {
            int y = v ^ x.fi ^ x.se;
            if (y == pr) continue;
            if (x.fi == v) B.pb(x);
            else A.pb(x);
        }
    }
    while (sz(A) && sz(B)) {
        auto x = A.back(); A.pop_back();
        auto y = B.back(); B.pop_back();
        ans.pb({x, y});
        usd.insert(x);
        usd.insert(y);
    }
    for (auto x : g[v]) {
        if (usd.find(x) == usd.end()) {
            int y = v ^ x.fi ^ x.se;
            if (y != pr) continue;
            if (x.fi == v) {
                if (sz(A)) {
                    auto z = A.back(); A.pop_back();
                    ans.pb({z, x});
                    usd.insert(z);
                    usd.insert(x);
                }
            }
            else {
                if (sz(B)) {
                    auto z = B.back(); B.pop_back();
                    ans.pb({z, x});
                    usd.insert(z);
                    usd.insert(x);
                }
            }
        }
    }
    if (sz(A) || sz(B)) {
        cout << "No";
        exit(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb({x, y});
        g[y].pb({x, y});
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }
    cout << "Yes\n";
    for (auto [x, y] : ans) {
        cout << x.fi + 1 << " " << x.se + 1 << " " << y.fi + 1 << " " << y.se + 1 << '\n';
    }
}
