#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 3e5, inff = 1e18;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define vec vector

vec<pll> ans(mx1, { 1e9, 0 });
vec<vec<pll>> g(mx1);
vi t(mx1);
ll timer = 0;
vi up(mx1, 0);
vi tm(mx1, 0);
vi used(mx1, 0);
vi mst(mx1, 0);

void dfs_m(ll v, ll p) {
	tm[v] = timer++;
	up[v] = tm[v];
	used[v] = 1;
	for (auto u : g[v]) {
		if (u.ff == p)
			continue;
		if (!used[u.ff]) {
			dfs_m(u.ff, v);
			if (tm[v] < up[u.ff]) {
				mst[u.ss] = 1;
			}
			up[v] = min(up[v], up[u.ff]);
		}
		else {
			up[v] = min(up[v], tm[u.ff]);
		}
	}
}

vvi compn;
vi color(mx1, 0);
vi val_comp;
vec<vec<pll>> g_comp(mx1);

void dfs0(ll v, ll &mn) {
	color[v] = compn.size();
	used[v] = 1;
	compn.back().pb(v);
	for (auto u : g[v]) {
		if (!mst[u.ss] && !used[u.ff]) {
			mn = min(mn, t[u.ss]);
			dfs0(u.ss, mn);
		}
	}
}

vi usd_comp(mx1, 0);

void dfs1(ll v, ll p, ll val) {
	usd_comp[v] = 1;
	for (auto u : compn[v]) {
		ans[u].ss = val;
	}
	for (auto u : g_comp[v]) {
		if (!used[u.ff]) {
			dfs1(u.ff, v, min(val, t[u.ss]));
		}
	}
}

void run() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0, v, u; i < m; ++i) {
		cin >> v >> u >> t[i];
		v--, u--;
		g[v].pb({ u, i });
		g[u].pb({ v, i });
	}
	dfs_m(0, -1);
	used.assign(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (!used[i]) {
			compn.pb({});
			ll mn = inff;
			dfs0(i, mn);
			val_comp.pb(mn);
		}
	}
	for (ll i = 0; i < compn.size(); ++i) {
		for (auto v : compn[i]) {
			for (auto u : g[v]) 
				if (mst[u.ss]) {
					g_comp[color[v]].pb({ color[u.ff], u.ss });
				}
		}
	}
	dfs1(0, -1, val_comp[0]);
	for (ll i = 1; i < n; ++i)
		cout << ans[i].ff + ans[i].ss << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	//cin >> tkk;
	while (kk++ < tkk) {
		run();
		//cout << '\n';
	}
	return 0;
}

/*
5 5
1 2 0
1 3 0
1 4 0
2 5 0
3 5 3

3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1

3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/