#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

int sum(char x) {
    int g = x - 'A';
    int j = pow(10, g/2);
    if (g&1) j *= 5;
    return j;
}

void solut() {
    string s;
    cin >> s;
    int v = 0;
    vector<int> cnt('Z' + 1);
    for (char i : s) {
        if (i == '?') continue;
        cnt[i]++;
    }
    int n = s.size();

    vector<vector<int>> dp(n, vector<int>('Z' + 1, -1e18));
    vector<vector<vector<int>>> pred(n, vector<vector<int>>('Z'+1, vector<int>(3)));

    if (s[n-1] == '?') {
        for (int i = 'A'; i <= 'Z'; ++i) {
            dp[n-1][i] = sum(i);
            pred[n-1][i] = {-1, -1, i};
        }
    } else {
        dp[n-1][s[n-1]] = sum(s[n-1]);
    }

    for (int i = n-2; i >= 0; --i) {
        if (s[i] == '?') {
            for (int c = 'A'; c <= 'Z'; ++c) {
                for (int j = 'A'; j <= c; ++j) {
                    if (dp[i][c] <  dp[i+1][j] + sum(c)) {
                        dp[i][c] =  dp[i+1][j] + sum(c);
                        pred[i][c] = {i+1, j, c};
                    }
                }
                for (int j = c+1; j <= 'Z'; ++j) {
                    if (dp[i][j] < dp[i+1][j] - sum(c)) {
                        dp[i][j] = dp[i+1][j] - sum(c);
                        pred[i][j] = {i+1, j, c};
                    }
                }
            }
        } else {
            for (int j = 'A'; j <= s[i]; ++j) {
                if (dp[i][s[i]] < dp[i+1][j] + sum(s[i])) {
                    dp[i][s[i]] = dp[i+1][j] + sum(s[i]);
                    pred[i][s[i]] = {i+1, j, s[i]};
                }
            }
            for (int j = s[i]+1; j <= 'Z'; ++j) {
                if (dp[i][j] < dp[i+1][j] - sum(s[i])) {
                    dp[i][j] = dp[i+1][j] - sum(s[i]);
                    pred[i][j] = {i+1, j, s[i]};
                }
            }
        }
    }

    int C = max_element(all(dp[0])) - dp[0].begin();
    cout << dp[0][C] << "\n";
    string ans;
    vector<int> cur = pred[0][C];
    for (int i = 0; i < n; ++i) {
        ans += char(cur[2]);
        if (i == n-1) break;
        cur = pred[cur[0]][cur[1]];
    }


    cout << ans << "\n";
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) solut();
}
