#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

vector<vector<int>> gr;
vector<int> ans;


int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    int inf = 1e15;
    gr.resize(n, vector<int>(n, inf));
    ans.resize(n, inf);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u][v] = c;
        gr[v][u] = c;
    }

    int p = (1<<n);
    vector<vector<pair<int,int>>> dp(p+1, vector<pair<int,int>>(n, {1e15, 0}));
    dp[1][1] = {1e15, 0};

    for (int mask = 2; mask <= p; ++mask) {
        for (int l = 0; l < n; ++l) {
            if (((1<<l) & mask) == 0) continue;
            for (int from = 0; from < n; ++from) {
                int c = (1<<l);
                if (((1<<from) & mask) > 0) {
                    auto a = dp[mask][l];
                    auto b = dp[mask & (~c)][from];

                    //cout << mask << ' ' << from << ' ' << l << endl;
                    if (a.fi + a.se > min(b.fi, gr[from][l]) + max(b.se, gr[from][l])) {
                        dp[mask][l] = {min(b.fi, gr[from][l]), max(b.se, gr[from][l])};
                        ans[l] = min(ans[l], dp[mask][l].fi + dp[mask][l].se);
                    }
                }
            }
        }
    }

    for (int i = 1; i < n; ++i) {
        cout << ans[i] << ' ';
    }
}