#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs(int v, int mn, int mx, int p = -1) {
    ans[v] = mn + mx;
    for (auto pp : g[v]) {
        if (pp.first != p) {
            dfs(pp.first, min(mn, pp.second), max(mx, pp.second), v);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >>  b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dfs(0, 1e9, 0);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}
