#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 1e18;
int pows[18];

void pows_build() {
    rep(i, 18) {
        if (i == 0) pows[i] = 1;
        else pows[i] = pows[i - 1] * 10;
    }
}

int f(int n) {
    if (n % 2 == 0) return pows[n / 2];
    return 5 * pows[n / 2];
}

vector<pii> pref_build(vector<int> &a) {
    int n = a.size();
    vector<pii> res(n);
    rep(i, n) {
        if (i == 0) res[0] = {a[0], 0};
        else {
            if (res[i - 1].ff > a[i]) {
                res[i] = res[i - 1];
            } else {
                res[i] = {a[i], i};
            }
        }
    }
    return res;
}

void run() {
    pows_build();
    string s;
    cin >> s;
    reverse(all(s));
    int n = s.size();
    vector<vector<int>> dp(n, vector<int> (26, -inf));
    vector<vector<pii>> pr(n, vector<pii> (26, mp(-1, -1)));
    vector<pii> pref;
    rep(j, 26) {
        if (s[0] != '?' && s[0] - 'A' != j) continue;
        dp[0][j] = f(j);
        pr[0][j].ss = j;
    }
    pref = pref_build(dp[0]);
    rep(i, n) {
        if (i == 0) continue;
        rep(mx, 26) {
            if (s[i] != '?') {
                int num = s[i] - 'A';
                if (num > mx) continue;
                if (num == mx) {
                    int res = pref[mx].ff + f(mx);
                    if (res > dp[i][mx]) {
                        dp[i][mx] = res;
                        pr[i][mx] = {pref[mx].ss, num};
                    }
                } else {
                    int res = dp[i - 1][mx] - f(num);
                    if (res > dp[i][mx]) {
                        dp[i][mx] = res;
                        pr[i][mx] = {mx, num};
                    }
                }
            } else {
                rep(num, 26) {
                    if (num > mx) continue;
                    if (num == mx) {
                        int res = pref[mx].ff + f(mx);
                        if (res > dp[i][mx]) {
                            dp[i][mx] = res;
                            pr[i][mx] = {pref[mx].ss, num};
                        }
                    } else {
                        int res = dp[i - 1][mx] - 1;
                        if (res > dp[i][mx]) {
                            dp[i][mx] = res;
                            pr[i][mx] = {mx, 0};
                        }
                    }
                }
            }
        }
        pref = pref_build(dp[i]);
    }
    int ans = -inf;
    int opt = -1;
    rep(j, 26) {
        if (dp[n - 1][j] > ans) {
            ans = dp[n - 1][j];
            opt = j;
        }
    }
    pii it = mp(n - 1, opt);
    string res = "";
    while (it.ff >= 0) {
        res += (char)('A' + pr[it.ff][it.ss].ss);
        it.ss = pr[it.ff][it.ss].ff;
        it.ff--;
    }
    cout << ans << '\n' << res << '\n';
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        run();
    return 0;
}
