#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 3e5, lg = 19;

vector<vector<pair<int, int> > > g;
vector<int> ans, used;
void dfs(int v, int p = 0, int cmn = 2e9, int cmx = -1){
    //cout << v << ' ' << cmn << ' ' << cmx << endl;
    ans[v] = min(ans[v], cmn + cmx);
    used[v] = 1;
    for(auto to: g[v]){
        if(to.first == p) continue;
        ans[to.first] = min(ans[to.first], min(cmn, to.second) + max(cmx, to.second));
        //cout << "? " << to.first << ' ' << min(cmn, to.second) << ' ' << max(cmx, to.second) << endl;
        if(used[to.first]) continue;
        dfs(to.first, v, min(cmn, to.second), max(cmx, to.second));
    }
    used[v] = 0;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    for(int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    ans.resize(n, 2e9);
    dfs(0);
    for(int i = 1; i < n; i++){
        cout << ans[i] << '\n';
    }
}