#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
#include <random>
#include <cassert>
#include <bitset>
#include <queue>
#include <deque>

//#pragma GCC target("avx2")

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<set<int> > in, out;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int> > e(m);
    in.resize(n), out.resize(n);
    set<pair<int, int> > exists;
    for (int i = 0; i < m; ++i) {
        cin >> e[i].first >> e[i].second;
        e[i].first--;
        e[i].second--;
        out[e[i].first].insert(i);
        in[e[i].second].insert(i);
        exists.insert(e[i]);
    }
    set<pair<int, int> > cnt;
    for (int i = 0; i < n; ++i) {
        cnt.insert(make_pair(in[i].size() + out[i].size(), i));
    }
    vector<vector<int> > ans;
    while (cnt.size() > 0) {
        auto it = cnt.begin();
        int ind = (*it).second;
        if (it->first > 1) break;
        if (it->first == 0) {
            cnt.erase(it);
            continue;
        }
        if (in[ind].size() == 1) {
            int u = e[*in[ind].begin()].first;
            if (in[u].size() == 0) {
                cout << "No\n";
                return;
            }
            int numE = *in[u].begin();
            ans.push_back({numE, *in[ind].begin()});
            exists.erase(e[numE]);
            exists.erase(e[*in[ind].begin()]);
            cnt.erase(make_pair(in[u].size() + out[u].size(), u));
            in[u].erase(in[u].begin());
            if (in[u].size() + out[u].size() > 0) cnt.insert(make_pair(in[u].size() + out[u].size(), u));
            cnt.erase({1, ind});
            cnt.erase({0, ind});
        } else {
            int u = e[*out[ind].begin()].second;
            if (out[u].size() == 0) {
                cout << "No\n";
                return;
            }
            int numE = *out[u].begin();
            ans.push_back({*out[ind].begin(), numE});
            exists.erase(e[numE]);
            exists.erase(e[*out[ind].begin()]);
            cnt.erase(make_pair(in[u].size() + out[u].size(), u));
            out[u].erase(out[u].begin());
            if (in[u].size() + out[u].size() > 0) cnt.insert(make_pair(in[u].size() + out[u].size(), u));
            cnt.erase({1, ind});
            cnt.erase({0, ind});
        }
    }

    vector<pair<int, int> > need;
    for (auto i : exists) {
        need.push_back(i);
    }
    vector<pair<int, int> > ttt;

    for (auto i : need) {
        if (exists.count(i) == 0) continue;
        auto j = i;
        swap(j.first, j.second);
        if (exists.count(j) == 0) {
            cout << "No\n";
            return;
        } else {
            ttt.push_back(i);
            exists.erase(j);
        }
    }

    cout << "Yes\n";
    for (auto j : ans) {
        for (auto i : j) {
            cout << e[i].first + 1 << ' ' << e[i].second + 1 << ' ';
        }
        cout << '\n';
    }
    for (auto i : ttt) {
        cout << i.first + 1 << ' ' << i.second + 1 << ' ' << i.second + 1 << ' ' << i.first + 1 << '\n';
    }
}


signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}