#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 25;
const int INF = 1e18 + 118;

vector<vector<pair<pair<int, int>, int>>> g(MAXN);
vector<vector<pair<int, int>>> h(MAXN);

int dist[MAXN];

const int K = 1e9;

int timer = 0;

int used[MAXN];
int tin[MAXN];
int fup[MAXN];

map<pair<int, int>, int> block;

void dfs(int u, int p)
{
    used[u] = true;
    tin[u] = fup[u] = timer++;
    for (auto el : g[u])
    {
        int v = el.first.first;
        int w = el.first.second;
        int num = el.second;
        if (num == p)
        {
            continue;
        }
        if (!used[v])
        {
            dfs(v, num);
            if (fup[v] > tin[u])
            {
                block[{u, v}] = true;
                block[{v, u}] = true;
            }
            fup[u] = min(fup[u], fup[v]);
        }
        else
        {
            fup[u] = min(fup[u], tin[v]);
        }
    }
}

int num[MAXN];

int cnt = 0;

void dfs2(int u)
{
    num[u] = cnt;
    used[u] = true;
    for (auto el : g[u])
    {
        int v = el.first.first;
        int w = el.first.second;
        if (!used[v] && !block[{u, v}])
        {
            dfs2(v);
        }
    }
}

int dp[MAXN];

void calc(int u)
{
    used[u] = true;
    for (auto el : h[u])
    {
        int v = el.first;
        int w = el.second;
        if (!used[v])
        {
            calc(v);
            dp[v] = min(dp[v], w);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, int>> edges;
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({{v, w}, i});
        g[v].push_back({{u, w}, i});
    }
    dfs(0, -1);
    for (int i = 0; i < n; ++i)
    {
        used[i] = false;
    }
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            dfs2(i);
            ++cnt;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        dp[i] = INF;
    }
    for (int u = 0; u < n; ++u)
    {
        for (auto el : g[u])
        {
            int v = el.first.first;
            int w = el.first.second;
            if (num[u] == num[v])
            {
                dp[num[u]] = min(dp[num[u]], w);
            }
            else
            {
                h[num[u]].push_back({num[v], w});
                h[num[v]].push_back({num[u], w});
            }
        }
    }
    for (int i = 0; i < n; ++i)
    {
        used[i] = false;
    }
    calc(0);
    for (int i = 1; i < n; ++i)
    {
        cout << dp[num[i]] + K << endl;
    }
    return 0;
}

