#include<bits/stdc++.h>
#define fi first
#define se second
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb emplace_back
#define mpa make_pair
using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<vector<int>> g2(n);
    vector<pair<int, int>> e(m);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        g[x].pb(y);
        g[y].pb(x);
        g2[x].pb(i);
        e[i] = mpa(x, y);
    }
    vector<int> used(m);
    vector<vector<int>> indown(n), outdown(n), inup(n), outup(n);
    vector<int> d(n, -1);
    function<void(int, int, int)> dfs = [&](int v, int p, int dep) {
        d[v] = dep;
        for (auto &to : g[v]) {
            if (to != p) {
                dfs(to, v, dep + 1);
            }
        }
        for (auto &idx : g2[v]) {
            int to = (v ^ e[idx].fi ^ e[idx].se);
            if (to == p) {
                indown[to].pb(idx);
                outup[v].pb(idx);
            } else {
                outdown[v].pb(idx);
                inup[to].pb(idx);
            }
        }
    };
    vector<pair<int, int>> ans;
    function<void(int, int)> dfs2 = [&](int v, int p) {
        for (auto &to : g[v]) {
            if (to != p) {
                dfs2(to, v);
            }
        }
        for (auto &to : g[v]) {
            if (to != p) {
                while (true) {
                    while (indown[to].size() && used[indown[to].back()]) indown[to].pop_back();
                    while (outup[to].size() && used[outup[to].back()]) outup[to].pop_back();
                    if (indown[to].size() && outup[to].size()) {
                        ans.pb(indown[to].back(), outup[to].back());
                        used[indown[to].back()] = used[outup[to].back()] = 1;
                    } else {
                        break;
                    }
                }
                while (true) {
                    while (outdown[to].size() && used[outdown[to].back()]) outdown[to].pop_back();
                    while (inup[to].size() && used[inup[to].back()]) inup[to].pop_back();
                    if (outdown[to].size() && inup[to].size()) {
                        ans.pb(inup[to].back(), outdown[to].back());
                        used[outdown[to].back()] = used[inup[to].back()] = 1;
                    } else {
                        break;
                    }
                }
            }
        }
        while (true) {
            while (indown[v].size() && used[indown[v].back()]) indown[v].pop_back();
            while (outdown[v].size() && used[outdown[v].back()]) outdown[v].pop_back();
            if (indown[v].size() && outdown[v].size()) {
                ans.pb(indown[v].back(), outdown[v].back());
                used[indown[v].back()] = used[outdown[v].back()] = 1;
            } else {
                break;
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (d[i] == -1) {
            dfs(i, -1, 0);
            dfs2(i, -1);
        }
    }
    if ((int)(ans.size()) * 2 != m) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (auto &elem : ans) {
            cout << e[elem.fi].fi + 1 << " " << e[elem.fi].se + 1 << " ";
            cout << e[elem.se].fi + 1 << " " << e[elem.se].se + 1 << " ";
            cout << endl;
        }
    }

}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
