#include<bits/stdc++.h>
#define fi first
#define se second
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb emplace_back
#define mpa make_pair
using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> x(m), y(m), c(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        cin >> x[i] >> y[i] >> c[i];
        --x[i]; --y[i];
        g[x[i]].pb(i);
        g[y[i]].pb(i);
    }
    /*
    vector<int> used(n);
    vector<int> ans(n);
    function<void(int, int, int)> dfs = [&](int v, int l, int r) {
        used[v] = 1;
        ans[v] = l + r;
        for (auto &i : g[v]) {
            int to = (v ^ x[i] ^ y[i]);
            if (!used[to]) {
                dfs(to, min(l, c[i]), max(r, c[i]));
            }
        }
    };
    dfs(0, 1e9, -1e9);
    for (int i = 1; i < n; ++i) cout << ans[i] << " ";
    */

    vector<int> p(n);
    vector<vector<int>> elems(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        elems[i].pb(i);
    }
    function<int(int)> gp = [&](int v) {
        if (p[v] == v) return v;
        return p[v] = gp(p[v]);
    };
    function<void(int, int)> unite = [&](int v, int u) {
        v = gp(v);
        u = gp(u);
        if (v == u) return;
        if (elems[v].size() < elems[u].size()) swap(v, u);
        for (auto &elem : elems[u]) elems[v].pb(elem);
        p[u] = v;
    };

    vector<int> order(m);
    vector<int> ans(n);
    for (int i = 0; i < m; ++i) order[i] = i;
    sort(all(order), [&](int i, int j){return c[i] < c[j];});
    for (auto &i : order) {
        int a = gp(x[i]);
        int b = gp(y[i]);
        if (a == b) continue;
        if (b == gp(0)) swap(a, b);
        if (a == gp(0)) {
            for (auto &elem : elems[gp(b)]) {
                ans[elem] = c[i];
            }
        }
        unite(a, b);
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << " ";
    }
}
/*

*/
