#include <bits/stdc++.h>

using namespace std;

void dfs(int x, vector<vector<pair<int, int> > > &a, vector<int> &d, int minn, int maxx)
{
    d[x] = minn + maxx;
    for (int i = 0; i < a[x].size(); ++i)
    {
        int y = a[x][i].first;
        if (d[y] == -1)
        {
            dfs(y, a, d, min(minn, a[x][i].second), max(maxx, a[x][i].second));
        }
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int> > > a(n, vector<pair<int, int> > (0));
    for (int i = 0; i < m; ++i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u -= 1;
        v -= 1;
        a[u].push_back({v, t});
        a[v].push_back({u, t});
    }
    vector<int> d(n, -1);
    dfs(0, a, d, 1e9 + 1, -1);
    for (int i = 1; i < n; ++i)
    {
        cout << d[i] << "\n";
    }
}
