//
// Created by roi on 09.04.2021.
//

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

#define int ll

void run() {
  int n, q;
  cin >> n >> q;
  vec<pair<int, int>> a(n + 2);
  for (int i = 1; i <= n; i++) {
    cin >> a[i].first >> a[i].second;
  }
  a[0] = a[1];
  a[n + 1] = a[n];
  vec<int> h(n + 2), x(n + 2);
  for (int i = 0; i < n + 2; i++) {
    h[i] = a[i].second;
    x[i] = a[i].first;
  }
  while (q--) {
    int l, r;
    cin >> l >> r;
    vec<int> st {l - 1};
    int cnt = 0;
    for (int i = l; i <= r; i++) {
      st.push_back(i);
      while (st.size() >= 2 &&
          (x[i + 1] - x[st.back()] >= h[st.back()] ||
          x[st.back()] - x[st[st.size() - 2]] >= h[st.back()])) {
        st.pop_back();
        cnt++;
      }
    }
    cout << cnt << '\n';
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}