#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int MAXN = 3e5 + 5;
constexpr int INF = 1.1e9;

struct Edge {
	int t, w;
	int id;
};
int n, m;
std::vector<Edge> gr[MAXN];
int ans[MAXN];
bool dp[20][1 << 20];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);


	std::cin >> n >> m;

	if (n <= 20 && m <= 20) {
		int fuck[20][20];
		int w[20];
		int u[20], v[20];
		for (int i = 0; i < n; i++) {
			std::fill(fuck[i], fuck[i] + 20, -1);
		}
		for (int i = 0; i < m; i++) {
			std::cin >> u[i] >> v[i] >> w[i];
		}
		dp[0][0] = true;
		std::fill(ans, ans + n, 2.1e9);
		for (int mask = 0; mask < (1 << m); mask++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (((mask >> j) & 1)) {
						if (u[j] == i || v[j] == i) {
							if (u[j] != i) {
								std::swap(u[j], v[j]);
							}
							if (dp[v[j]][mask ^ (1 << j)]) {
								dp[i][mask] = true;
							}
						}
					}
				}
				if (dp[i][mask]) {
					int min = INF, max = 0;
					for (int j = 0; j < m; j++) {
						if ((mask >> j) & 1) {
							min = std::min(min, w[j]);
							max = std::max(max, w[j]);
						}
					}
					ans[i] = std::min(ans[i], min + max);
				}
			}
		}
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
		return 0;
	}
	for (int i = 0; i < m; i++) {
		int u, v, t;
		std::cin >> u >> v >> t;
		u--; v--;
		gr[u].push_back({ v, t, i });
		gr[v].push_back({ u, t, i });
	}
	if (n == m + 1) {
		std::function<void(int, int, int, int)> dfs = [&](int v, int f, int min, int max) {
			ans[v] = min + max;
			for (auto [t, w, id] : gr[v]) {
				if (id != f) {
					dfs(t, id, std::min(min, w), std::max(max, w));
				}
			}
		};
		dfs(0, -1, INF, 0);
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
	} else {

	}


	return 0;
}