#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int MAXN = 3e5 + 5;
constexpr int INF = 1.1e9;

struct Edge {
	int t, w;
	int id;
};
struct Edge2 {
	int u, v, w;
};
int n, m;
std::vector<Edge> gr[MAXN];
int ans[MAXN];
bool dp[20][1 << 20];
bool used[MAXN];

int ub;

void dfs(int v) {
	if (used[v]) {
		return;
	}
	used[v] = true;
	ans[v] = ub;
	for (auto [t, w, id] : gr[v]) {
		if (w <= ub) {
			dfs(t);
		}
	}
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);


	std::cin >> n >> m;

	if (n <= 20 && m <= 20) {
		int fuck[20][20];
		int w[20];
		int u[20], v[20];
		for (int i = 0; i < n; i++) {
			std::fill(fuck[i], fuck[i] + 20, -1);
		}
		for (int i = 0; i < m; i++) {
			std::cin >> u[i] >> v[i] >> w[i];
			u[i]--;
			v[i]--;
		}
		dp[0][0] = true;
		std::fill(ans, ans + n, 2.1e9);
		for (int mask = 0; mask < (1 << m); mask++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (((mask >> j) & 1)) {
						if (u[j] == i || v[j] == i) {
							if (u[j] != i) {
								std::swap(u[j], v[j]);
							}
							if (dp[v[j]][mask ^ (1 << j)]) {
								dp[i][mask] = true;
							}
						}
					}
				}
				if (dp[i][mask]) {
					int min = INF, max = 0;
					for (int j = 0; j < m; j++) {
						if ((mask >> j) & 1) {
							min = std::min(min, w[j]);
							max = std::max(max, w[j]);
						}
					}
					ans[i] = std::min(ans[i], min + max);
				}
			}
		}
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
		return 0;
	}

	std::vector<int> fuck(m);
	std::vector<Edge2> ed;
	for (int i = 0; i < m; i++) {
		int u, v, t;
		std::cin >> u >> v >> t;
		fuck.push_back(t);
		u--; v--;
		gr[u].push_back({ v, t, i });
		gr[v].push_back({ u, t, i });
		ed.push_back({ u, v, t });
	}
	std::sort(ed.begin(), ed.end(), [](Edge2 a, Edge2 b) {return a.w < b.w; });
	std::sort(fuck.begin(), fuck.end());
	fuck.erase(std::unique(fuck.begin(), fuck.end()), fuck.end());

	if (n == m + 1) {
		std::function<void(int, int, int, int)> dfs = [&](int v, int f, int min, int max) {
			ans[v] = min + max;
			for (auto [t, w, id] : gr[v]) {
				if (id != f) {
					dfs(t, id, std::min(min, w), std::max(max, w));
				}
			}
		};
		dfs(0, -1, INF, 0);
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
		return 0;
	} else if (std::all_of(gr[0].begin(), gr[0].end(), [](Edge e) {return e.w == 0; })) {
		ub = 0;
		dfs(0);
		for (int i = 0; i < m; i++) {
			ub = ed[i].w;
			dfs(ed[i].v);
			dfs(ed[i].u);
		}	
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
		return 0;

	} else if (std::all_of(gr[0].begin(), gr[0].end(), [](Edge e) {return e.w == (int(1e9)); })) {

	}
	exit(324);

	return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

*/