#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

typedef long long ll;

#define int ll

int kek[27];

int f(string &s){
	int n = s.size();

	int mx = 0;
	int res = 0;

	for(int i = n - 1; i >= 0; i--){
		res += (s[i] >= mx ? kek[s[i] - 'A'] : -kek[s[i] - 'A']);
		mx = max(mx, int(s[i]));
	}

	return res;
}

void Solve(){
	string s; cin >> s;

	for(char &c : s)
		if(c != '?')
			c -= 'A';

	int n = s.size();

	vector<vector<int>> pref_big(n, vector<int>(26));
	vector<vector<int>> pref_small(n, vector<int>(26));
	vector<int> suf(n);

	for(int i = 0; i < n; i++){
		for(int j = 0; j < 26; j++){
			pref_big[i][j] = (i ? pref_big[i - 1][j] : 0) + (s[i] == '?' ? 0 : kek[s[i]] * (s[i] >= j));
			pref_small[i][j] = (i ? pref_small[i - 1][j] : 0) + (s[i] == '?' ? 0 : kek[s[i]] * (s[i] < j));
		}
	}

	for(int i = n - 1; i >= 0; ){
		if(s[i] == '?'){
			int r = i + 1;
			int l = i;

			while(l - 1 >= 0 && s[l - 1] == '?')
				l--;

			int r1 = l;
			int l1 = max(0ll, l - 1);

			while(l1 - 1 >= 0 && s[l1 - 1] != '?')
				l1--;

			if(r1 - l1 == 0){
				for(int j = l; j < r; j++)
					s[j] = 'Z' - 'A';
			}else{
				pair<int, int> ans = {0, 0};

				for(int c = 0; c < 26; c++){
					int mx = max((i + 1 == n ? 0 : suf[i + 1]), c);
					int res = (r - l) * kek[c];

					for(int j = r1 - 1; j >= l1; j--){
						res += (s[j] >= mx ? kek[s[j]] : -kek[s[j]]);
						mx = max(mx, int(s[j]));
					}

					ans = max(ans, make_pair(res, c));
				}

				for(int j = l; j < r; j++)
					s[j] = ans.se;
			}

			for(int j = r - 1; j >= l; j--)
				suf[j] = max((j + 1 == n ? 0 : suf[j + 1]), int(s[j]));

			i = l - 1;
		}else{
			suf[i] = max((i + 1 == n ? 0 : suf[i + 1]), int(s[i]));
			i--;
		}
	}

	for(char &c : s)
		c += 'A';

	cout << f(s) << '\n';
	cout << s << '\n';
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);

	kek[0] = 1;

	for(int i = 1; i < 26; i++)
		kek[i] = kek[i - 1] * (i & 1 ? 5 : 2);

	int test = 1;
	cin >> test;

	for(int i = 1; i <= test; i++)
		Solve();
}