#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
const int MAX = 400000;
const int INF = 1'000'000'000;
int n, m;
int a, b, vol;
int used[MAX], dep[MAX], down[MAX], mst[MAX], elem[MAX];
int used2[MAX], mi[MAX], co[MAX], ans[MAX];
vector<pair<int, int>> all_edges;
vector<pair<int, int>> edges[MAX], edges2[MAX];
void dfs(int v, int pred, int de) {
	used[v] = 1;
	dep[v] = de;
	down[v] = de;
	for (auto i : edges[v]) {
		if (!used[i.first]) {
			dfs(i.first, i.second, de + 1);
			down[v] = min(down[v], down[i.first]);
		}
		else if(i.second != pred){
			down[v] = min(down[v], dep[i.first]);
		}
	}
	if (pred != -1) {
		if (down[v] == de) {
			mst[pred] = 1;
		}
	}
	return;
}
void dfs2(int v, int col) {
	used2[v] = 1;
	co[v] = col;
	for (auto i : edges[v]) {
		if (mst[i.second]) {
			continue;
		}
		mi[col] = min(mi[col], elem[i.second]);
		if (!used2[i.first]) {
			dfs2(i.first, col);
		}
	}
	return;
}
void dfs3(int v, int pred, int mini) {
	mini = min(mini, mi[v]);
	ans[v] = mini;
	for (auto i : edges2[v]) {
		if (i.first != pred) {
			dfs3(i.first, v, min(mini, i.second));
		}
	}
}
signed main() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> vol;
		a--;
		b--;
		all_edges.push_back({ a, b });
		elem[i] = vol;
		edges[a].push_back({ b, i });
		edges[b].push_back({ a, i });
	}
	dfs(0, -1, 0);
	int col = 1;
	for (int i = 0; i < n; i++) {
		if (!used2[i]) {
			mi[col] = INF;
			dfs2(i, col);
			col++;
		}
	}
	for (int i = 0; i < m; i++) {
		if (mst[i]) {
			edges2[co[all_edges[i].first]].push_back({ co[all_edges[i].second], elem[i] });
			edges2[co[all_edges[i].second]].push_back({ co[all_edges[i].first], elem[i] });
		}
	}
	dfs3(1, -1, INF);
	for (int i = 1; i < n; i++) {
		cout << INF + ans[co[i]] << endl;
	}
	return 0;
}