#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int n;
	cin >> n;
	vector<string> s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < s[i].size(); ++j) {
			s[i][j] -= 'A';
		}
	}
	vector<int> mos(26);
	mos[0] = 1;
	mos[1] = 5;
	for (int i = 0; i + 2 < 26; ++i) {
		mos[i + 2] = mos[i] * 10;
	}
	for (int i = 0; i < n; ++i) {
		int ans = 0;
		for (int j = 0; j < s[i].size(); ++j) {
			int big = 0;
			for (int k = j + 1; k < s[i].size(); ++k) {
				if (s[i][j] < s[i][k]) {
					big = 1;
					break;
				}
			}
			if (big) {
				ans -= mos[s[i][j]];
			} else {
				ans += mos[s[i][j]];
			}
		}
		cout << ans << endl;
		string t = s[i];
		for (int j = 0; j < t.size(); ++j) {
			t[j] += 'A';
		}
		cout << t << endl;
	}
	return 0;
}