#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

struct edge {
	ll v = 0, t = 0, i = 0;
};

void rec(vector<vector<edge>> &gr, vector<bool> &used, vector<ll> &ans,
		 ll v, ll mn, ll mx) {
	if (mn + mx < ans[v]) {
		ans[v] = mn + mx;
	}
	else {
		return;
	}
	for (int i = 0; i < gr[v].size(); i++) {
		if (!used[gr[v][i].i]) {
			used[gr[v][i].i] = 1;
			rec(gr, used, ans, gr[v][i].v, min(gr[v][i].t, mn), max(gr[v][i].t, mx));
			used[gr[v][i].i] = 0;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, m;
	cin >> n >> m;
	vector<vector<edge>> gr(n);
	vector<bool> used(m, 0);
	for (int i = 0; i < m; i++) {
		ll l, r, t;
		cin >> l >> r >> t;
		l--; r--;
		gr[l].push_back({ r, t, i });
		gr[r].push_back({ l, t, i });
	}
	vector<ll> ans(n, 1e12);
	rec(gr, used, ans, 0, 1e12, 0);
	for (int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}
}

/*
8 10
1 2
2 3
3 4
4 3
5 2
5 6
6 5
1 7
7 1
7 8
*/