#include <iostream>
#include<vector>
#include<algorithm>;
#define fori(n) for(int i=0;i<n;i++)
#define forj(n) for(int j=0;j<n;j++)
#define INF 2000000000
using namespace std;
int number = 0;
struct tree {
	int x, h;
	tree(int x_, int h_) {
		x = x_; h = h_;
	}
};
vector<int> d;
int change(int n, int l, int r, int ask) {
	if (r-l == 1) {
		d[n] = 0;
		return d[n] = 0;
	}

	int m = (l + r) / 2;
	if (ask >= m)d[n] = d[2 * n + 1] + change(2 * n + 2, m, r, ask);
	else d[n] = change(2 * n + 1, l, m, ask);
	return d[n];

}
int getl(int n, int l, int r, int ask) {
	if (l == 0 && r == number && d[n] == 1)return 0;
	if (ask == 0)return 0;
	if (r - l == 1)return l;
	int m = (l + r) / 2;
	int ans = 0;
	if (ask >= m && d[2 * n + 2] != 0)
	{
		ans = getl(2 * n + 2, m, r, ask);
		if (ans == ask && (d[2*n+1]!=0 || l==0)) {
			ans= getl(2 * n + 1, l, m, ask);
		}
		return ans;
	}
	else ans= getl(2 * n + 1, l, m, ask);
	return ans;
}
int getr(int n, int l, int r, int ask) {
	if (l == 0 && r == number && d[n] == 1)return number-1;
	if (ask == number - 1)return ask;
	if (r - l == 1)return l;
	int m = (l + r) / 2;
	int ans = 0;
	if (ask < m && d[2*n+1]!=0 )
	{
		ans= getr(2 * n + 1, l, m, ask);
		if (ans == ask && (d[2 * n + 2] != 0 || r==number-1)) {
			ans = getr(2 * n + 2, m, r, ask);
		}
		return ans;
	}
	else return getr(2 * n + 2, m, r, ask);
}
void reset(int n, int l, int r) {
	d[n] = r - l;
	if (r - l == 1)return;
	reset(2 * n + 1, l, (l + r) / 2);
	reset(2 * n + 2, (l + r) / 2, r);
}

vector<tree*> road;


int main() {
	int n, q, x, h, l, r; 
	cin >> n >> q;
	number = n;
	vector<int>xs;
	fori(n) {
		cin >> x >> h;
		road.push_back(new tree(x, h));
		xs.push_back(x);
	}
	vector<int>del;
	vector<bool>used(n);
	d.resize(4 * n, 1);
	fori(q) {
		d.clear();
		d.resize(4 * n, 0);
		reset(0, 0, n);
		del.clear();
		used.clear();
		used.resize(n, 0);
		cin >> l >> r;
		int cnt = 0;
		int il = l-1;
		int ir = r;
		for (int j = il; j < ir; j++) {
			if (used[j])continue;
			
			l = getl(0, 0, n, j);
			r = getr(0, 0, n, j);
			if (road[l]->x + road[j]->h <= road[j]->x ||
				road[j]->x+road[j]->h<=road[r]->x) {
				cnt++;
				used[j] = 1;
				change(0, 0, n, j);
				if(l>=il)del.push_back(l);
				if(r<ir)del.push_back(r);
			}
		}
		int st = 0;
		int j;
		
		while (st != del.size()) {
			j = del[st];
			st++;
			if (used[j])continue;
			
			
			l = getl(0, 0, n, j);
			r = getr(0, 0, n, j);
			if (road[l]->x + road[j]->h <= road[j]->x ||
				road[j]->x + road[j]->h <= road[r]->x) {
				cnt++;
				used[j] = 1;
				change(0, 0, n, j);
				if (l >= il)del.push_back(l);
				if (r<il)del.push_back(r);
			}
		}
		cout << cnt << '\n';

	}



}