#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) (x).begin(), (x).end()
#define fr(i, a, b) for(int i = a; i < b; i++)
#define sz(x) (int)(x).size()

const int N = 3e5;
vector<pair<int, int>> gr[N];
int tmin[N], tmax[N];

void dfs(int u, int p = -1){
	for(auto [v, t] : gr[u]){
		if(v == p) continue;
		tmin[v] = min(t, tmin[u]);
		tmax[v] = max(t, tmax[u]);
		dfs(v, u);
	}
}

void solve(){
	int n, m;
	cin >> n >> m;
	fr(i, 0, m){
		int u, v, t;
		cin >> u >> v >> t;
		u--, v--;
		gr[u].push_back({v, t});
		gr[v].push_back({u, t});
	}
	tmin[0] = 1e9, tmax[0] = 0;
	dfs(0);
	fr(i, 1, n) cout << tmin[i] + tmax[i] << endl;

}

signed main(){

	// freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t = 1;
	// cin >> t;
	while(t--) solve();
}