#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> used;
vector<pair<int, int>> a;

void dfs(int v, vector<vector<pair<int, int>>> &gr, int mn, int mx) {
    a[v] = {mn, mx};
    used[v] = 1;
    for (auto u : gr[v]){
        if (used[u.first] == 0){
            dfs(u.first, gr, min(mn, u.second), max(mx, u.second));
        }
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v;
        --u;
        gr[v].push_back({u, t});
        gr[u].push_back({v, t});
    }
    if (m == n - 1) {
        used.resize(n);
        a.resize(n);
        dfs(0, gr, 1000000000, 0);
        for (int i = 1; i < n; ++i){
            cout << a[i].first + a[i].second << "\n";   
        }
    }
}
