#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <cmath>

using namespace std;

int cnt21;
int cnt12;

void check(vector <set <int>> &graph, int am, int n, vector<pair<pair<int, int>, pair<int, int>>> &ans) {
    if (am == 0) {
        cout << "Yes\n";
        for (auto now : ans) {
            cout << now.first.first + 1 << " " << now.first.second + 1 << " " << now.second.first + 1 << " " << now.second.second + 1 << "\n";
        }
        exit(0);
    }
    else {
        for (int i = 0; i < n; i++) {
            if (graph[i].size() != 0) {
                set <int> fi = graph[i];
                for (auto now : fi) {
                    set <int> fnow = graph[now];
                    for (auto nww : fnow) {
                        graph[i].erase(now);
                        graph[now].erase(nww);
                        ans.push_back({{i, now}, {now, nww}});
                        check(graph, am - 2, n, ans);
                        ans.pop_back();
                        graph[i].insert(now);
                        graph[now].insert(nww);
                    }
                }
            }
        }
        return;
    }
}


void dfs(int v, vector <set<int>> &graph, vector <int> &col) {
    for (auto nw : graph[v]) {
        if (col[nw] == 0) {
            if (col[v] == 2) {
                col[nw] = 1;
            }
            else {
                col[nw] = 2;
            }
            dfs(v, graph, col);
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector <set <int>> graph(n);
    vector <set <int>> rg(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        graph[v].insert(u);
        rg[v].insert(u);
        rg[u].insert(v);
    }
    vector <int> col(n);
    col[0] = 1;
    dfs(0, rg, col);
    for (int v = 0; v < n; v++) {
        for (auto nw : graph[v]) {
            if (col[v] == 2 and col[nw] == 1) {
                cnt21++;
            }
            else {
                cnt12++;
            }
        }
    }
    if (cnt12 != cnt21) {
        cout << "NO\n";
    }
    else {
        int am = m;
        vector<pair<pair<int, int>, pair<int, int>>> ans;
        check(graph, am, n, ans);
        cout << "No\n";
    }
}