#include <bits/stdc++.h>

#define int long long

using namespace std;

int MAP(char c)
{
    int x = c - 'A';
    int res = 1;
    for (int i = 0; i < x / 2; ++i)
        res *= 10;
    if (x % 2 == 0)
        return res;
    else
        return res * 5;
}

signed main()
{
    int Q; cin >> Q;
    while (Q--) {
        string s; cin >> s;
        int n = s.size();
        vector <int> arr(n);
        for (int i = 0; i < n; ++i)
            arr[i] = MAP(s[i]);
        vector <int> codes_arr(n);
        for (int i = 0; i < n; ++i)
            codes_arr[i] = s[i] - 63;

        vector <int> quests;
        int cur_max = 2;
        for (int i = n - 1; i > -1; --i) {
            if (codes_arr[i] == 0)
                codes_arr[i] = cur_max;
            else
                cur_max = max(cur_max, codes_arr[i]);
        }

        vector <vector <int>> counts;
        vector <int> count(28, 0);
        counts.push_back(count);
        vector <int> lasts(28, -1);
        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                int start = codes_arr[i];
                int delta = 0;
                int max_delta = delta, res = start;
                for (int code = start + 1; code < 28; ++code) {
                    delta += MAP(code + 63) - MAP(code - 1 + 63);

                    int t = 0;
                    for (int j = code; j < 28; ++j)
                        t = max(t, lasts[j]);
                    auto last_count = counts[t];

                    int bright = upper_bound(quests.begin(), quests.end(), t) - quests.begin();
                    int quests_cnt = quests.size() - bright;

                    delta -= MAP(code - 1 + 63) * (count[code - 1] - last_count[code - 1]) * 2;
                    delta += (MAP(code + 63) - MAP(code - 1 + 63)) * quests_cnt;

                    if (delta > max_delta) {
                        max_delta = delta;
                        res = code;
                    }
                }

                codes_arr[i] = res;
                lasts[res] = i;
                count[0] += 1;
                quests.push_back(i);
            }
            else {
                count[codes_arr[i]] += 1;
                lasts[codes_arr[i]] = i;
            }
            counts.push_back(count);
        }

        for (int i = quests.size() - 2; i > -1; --i) {
            if (codes_arr[quests[i]] < codes_arr[quests[i + 1]]) {
                codes_arr[quests[i]] = codes_arr[quests[i + 1]];
            }
        }

        s = "";
        for (auto i: codes_arr)
            s += (char)(i + 63);
        arr.assign(n, 0);
        for (int i = 0; i < n; ++i)
            arr[i] = MAP(s[i]);

        vector <int> st;
        int ans = 0;
        for (auto i: arr) {
            while (!st.empty() && i > st.back()) {
                ans -= st.back();
                st.pop_back();
            }
            st.push_back(i);
        }

        for (auto i: st)
            ans += i;

        cout << ans << "\n";
        cout << s << "\n";
    }
}
