#include <bits/stdc++.h>
using namespace std;

typedef long long ll;


const ll inf = 1e18;

ll cost[30];

void solve() {
  string ss;
  cin >> ss;
  string s;
  int n = ss.size();
  ll smst = 0, mx = 0;
  bool have = false;
  for (int i = n - 1; i >= 0; --i) {
    if (ss[i] == '?') {
      s += ss[i];
      have = true;
      continue;
    }
    ll x = ss[i] - 'A';
    if (mx > x) {
      smst -= cost[x];
    } else {
      mx = x;
      s += ss[i];
    }
  }
  reverse(s.begin(), s.end());
  n = s.size();

  if (!have) {
    for (int i = 0; i < n; ++i) {
      smst += cost[s[i] - 'A'];
    }
    cout << smst << '\n' << ss << '\n';
    return;
  }

  vector<int> mnpref(n);
  int mn = 25;
  for (int i = 0; i < n; ++i) {
    if (s[i] != '?')
      mn = min(mn, s[i] - 'A');
    mnpref[i] = mn;
  }
  vector<vector<ll>> dp(n, vector<ll>(26, -inf));
  vector<vector<ll>> par(n, vector<ll>(26, -1));

  bool was = false;
  for (int i = 0; i < n; ++i) {
    if (s[i] != '?')
      continue;
    int j = i - 1;
    vector<ll> cur_sum(26);
    while (j >= 0 && s[j] != '?') {
      cur_sum[s[j] - 'A'] += cost[s[j] - 'A'];
      j--;
    }
    ll all_sum = 0;
    for (int cr = 0; cr < 26; ++cr)
      all_sum += cur_sum[cr];
    if (j < 0) {
      for (int cr = mnpref[i]; cr < 26; ++cr) {
        dp[i][cr] = all_sum + cost[cr];
        all_sum -= 2 * cur_sum[cr];
      }
      continue;
    }

    ll max_pr = -inf, pr = 25;
    all_sum = -all_sum;
    for (int cr = 25; cr >= mnpref[i]; --cr) {
      all_sum += 2 * cur_sum[cr];
      if (dp[j][cr] > max_pr) {
        pr = cr;
        max_pr = dp[j][cr];
      }
      par[i][cr] = pr;
      dp[i][cr] = max_pr + all_sum + cost[cr];
    }
  }

  ll res = -inf;
  int lst = n - 1;
  while (lst >= 0 && s[lst] != '?')
    lst--;
  for (int i = 0; i < 26; ++i)
    res = max(res, dp[lst][i]);
  for (int i = lst + 1; i < n; ++i)
    res += cost[s[i] - 'A'];
  res += smst;
  cout << res << '\n';

  string ans;
  int id = 25;
  ll mx_cr = -inf;
  for (int i = 0; i < 26; ++i) {
    if (dp[lst][i] > mx_cr) {
      mx_cr = dp[lst][i];
      id = i;
    }
  }
  while (lst != -1) {
    ans += 'A' + id;
    id = par[lst][id];
    lst--;
    while (lst >= 0 && s[lst] != '?')
      lst--;
  }
  reverse(ans.begin(), ans.end());
  int j = 0;
  for (int i = 0; i < ss.size(); ++i) {
    if (ss[i] == '?') {
      ss[i] = ans[j];
      j++;
    }
  }
  cout << ss << '\n';
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  cost[0] = 1;
  for (int i = 1; i < 27; ++i) {
    if (i & 1)
      cost[i] = cost[i - 1] * 5;
    else
      cost[i] = cost[i - 1] * 2;
  }

  int t;
  cin >> t;
  while (t--)
    solve();
}