#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 21, inf = 1e9;


int n, m;

struct edge {
  int u, v, t;
};

vector<edge> e;
vector<int> g[N];


bool dp[1 << N][N];

int res[N];

void go(int mask, int v) {
  for (int u : g[v]) {
    if (!(mask >> u & 1)) {
      int to = (e[u].v ^ e[u].u ^ v);
      if (!dp[mask | (1 << u)][to]) {
        dp[mask | (1 << u)][to] = true;
        go(mask | (1 << u), to);
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n >> m;


  e.resize(m);
  for (int i = 0; i < m; ++i) {
    int u, v, t;
    cin >> u >> v >> t;
    u--, v--;
    e[i] = {u, v, t};
    g[v].push_back(i);
    g[u].push_back(i);
  }

  go(0, 0);

  fill(res, res + n, 2 * inf);

  for (int v = 1; v < n; ++v) {
    for (int mask = 0; mask < (1 << m); ++mask) {
      if (dp[mask][v]) {
        int mx = 0, mn = inf;
        for (int ne = 0; ne < m; ++ne) {
          if (mask >> ne & 1) {
            mx = max(mx, e[ne].t);
            mn = min(mn, e[ne].t);
          }
        }
        res[v] = min(res[v], mx + mn);
      }
    }
    cout << res[v] << '\n';
  }

}
