#include <bits/stdc++.h>
#define int long long
#define inf 4000000000000001
using namespace std;

void solve1(string s)
{
    vector<int> mos(26);
    mos[0] = 1;
    for(int i = 1; i < 26; i++)
    {
        if(i & 1) mos[i] = mos[i - 1] * 5;
        else mos[i] = mos[i - 1] * 2;
    }

    vector<vector<int>> dp(s.size() + 1, vector<int>(26, -inf));
    vector<vector<int>> pc(s.size() + 1, vector<int>(26, -1));
    vector<vector<int>> pd(s.size() + 1, vector<int>(26, -1));
    dp[0][0] = 0;
    for(int sz = 1; sz <= s.size(); sz++)
    {
        for(int mxc = 0; mxc < 26; mxc++)
        {
            //dynamic:
            for(int mxcc = 0; mxcc <= mxc; mxcc++)
            {
                if(s[s.size() - sz] - 'A' != mxcc && s[s.size() - sz] != '?') continue;
                for(int mxcd = mxc; mxcd >= 0; mxcd--)
                {
                    int cur = mos[mxcc] + dp[sz - 1][mxcd];
                    if(mxcc < mxcd) cur = -mos[mxcc] + dp[sz - 1][mxcd];
                    if(cur > dp[sz][mxc])
                    {
                        dp[sz][mxc] = cur;
                        pc[sz][mxc] = mxcc;
                        pd[sz][mxc] = mxcd;
                    }

                    if(mxcc < mxc) break;
                }
            }
        }
    }
    int ans = -inf, ind = -1;
    for(int i = 0; i < 26; i++)
    {
        if(dp[s.size()][i] > ans)
        {
            ans = dp[s.size()][i];
            ind = i;
        }
    }
    cout << ans << "\n";
    string sans = "";
    for(int sz = s.size(); sz > 0; sz--)
    {
        sans += (char)(pc[sz][ind] + 'A');
        ind = pd[sz][ind];
    }
    cout << sans << "\n";
}

void solve2(string s)
{
    vector<int> mos(26);
    mos[0] = 1;
    for(int i = 1; i < 26; i++)
    {
        if(i & 1) mos[i] = mos[i - 1] * 5;
        else mos[i] = mos[i - 1] * 2;
    }

    int ans = -2000000000000000001;
    string sans = "#";
    bool nenf = true;
    for(int q3 = 0; q3 < 26 && nenf; q3++)
    {
        for(int q2 = 0; q2 < 26 && nenf; q2++)
        {
            for(int q1 = 0; q1 < 26; q1++)
            {
                int q = 0, mx = 0, cur = 0;
                vector<int> qs;
                qs.push_back(q1);
                qs.push_back(q2);
                qs.push_back(q3);
                string scur = "";
                for(int i = s.size() - 1; i >= 0; i--)
                {
                    if(s[i] != '?')
                    {
                        int c = s[i] - 'A';
                        if(mos[c] < mx) cur -= mos[c];
                        else cur += mos[c];
                        mx = max(mx, mos[c]);
                        scur += s[i];
                    }
                    else
                    {
                        int c = qs[q];
                        if(mos[c] < mx) cur -= mos[c];
                        else cur += mos[c];
                        mx = max(mx, mos[c]);
                        q++;
                        scur += (char)(c + 'A');
                    }
                }
                if(cur > ans)
                {
                    ans = cur;
                    sans = scur;
                }
                if(q <= 1) nenf = false;
            }
        }
    }
    cout << ans << "\n";
    for(int i = sans.size() - 1; i >= 0; i--) cout << sans[i];
    cout << "\n";
}

signed main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
    {
        string s;
        cin >> s;
        int qcnt = 0;
        for(int j = 0; j < s.size(); j++)
        {
            if(s[j] == '?') qcnt++;
        }
        if(qcnt > 3) solve1(s);
        else solve2(s);
    }
}
