#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
using namespace std;
typedef long long ll;
#define int long long

int n, m;
set <int> g[300010];
set <int> gn[300010];

set <int> gall[300010];

vector <pair <pair <int, int>, pair <int, int>>> ans;

bool used[300010];

int dfs(int u, int p, bool in, bool up)
{
	used[u] = true;
	vector <int> son;

	vector <pair <int, int>> into, out;
	if (in)
	{
		into.push_back({ p, u });
	}
	if (up)
	{
		out.push_back({ u, p });
	}
	for (auto v : gall[u]) if (v != p)
	{
		son.push_back(v);
		auto got = dfs(v, u, g[u].count(v), gn[u].count(v));

		if (got == -1) return -1;
		if (got == 0) continue;
		if (got == 1) out.push_back({ u, v });
		if (got == 2) into.push_back({ v, u });
	}

	while (into.size() && out.size())
	{
		ans.push_back({ into.back(), out.back() });
		into.pop_back();
		out.pop_back();
	}

	if (into.size() >= 2 || out.size() >= 2) return -1;

	if (into.size())
	{
		auto got = into.back();
		if (got.first != p) return -1;
		return 1;
	}
	if (out.size())
	{
		auto got = out.back();
		if (got.second != p) return -1;
		return 2;
	}
	return 0;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i < m; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].insert(v);
		gn[v].insert(u);
		gall[u].insert(v);
		gall[v].insert(u);
	}


	for (int i = 1; i <= n; ++i)
	{
		if (used[i]) continue;
		auto got = dfs(i, i, 0, 0);

		if (got == -1)
		{
			cout << "No\n";
			return 0;
		}
	}

	assert(ans.size() == m / 2);
	cout << "Yes\n";
	for (auto i : ans)
	{
		cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
	}
	return 0;
}