//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("avx,avx2")

#include <bits/extc++.h>

using namespace std;

#define vc vector
typedef long long ll;
typedef vc<ll> vll;

ll d[300005];

bool used[25][(1 << 22)];
vc<pair<ll, pair<ll, ll>>> g[300005];

void dfs(ll v, ll mn, ll mx, ll msk) {
    used[v][msk] = true;
    d[v] = min(d[v], mx + mn);
    for (auto &to1 : g[v]) {
        pair<ll, ll> to = to1.second;
        if (((msk >> to1.first) & 1) == 0 && !used[to.first][msk | (1 << to1.first)]) {
            dfs(to.first, min(mn, to.second), max(mx, to.second), msk | (1 << to1.first));
        }
    }
}

int main() {
    ll n, m;
    cin >> n >> m;
    for (ll v = 1; v <= n; ++v) {
        d[v] = INT_MAX;
    }
    while (m--) {
        ll v, to, w;
        cin >> v >> to >> w;
        g[v].push_back({m + 1, {to, w}});
        g[to].push_back({m + 1, {v, w}});
    }
    dfs(1, LLONG_MAX, -LLONG_MAX, 0);
    for (ll to = 2; to <= n; ++to) {
        cout << d[to] << '\n';
    }
}