#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back
#define vpi vector<pair<int, int>>
#define minq(mi, a) mi = min(mi, a)
#define maxq(ma, a) ma = max(ma, a)
#define pi pair<int, int>

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 2e5 + 10;

// #define int ll

vi g[MAXN], g1[MAXN];
vector<tuple<int, int, int>> ans;
bool taken[30][30];
int n, m, par[MAXN];

void rec(int dep) {
    if (dep * 2 == m) {
        cout << "Yes" << nl;
        for (auto[a, b, c] : ans) {
            cout << a + 1 << ' ' << b + 1 << ' ' << b + 1 << ' ' << c + 1 << nl;
        }
        exit(0);
    }
    forn (i, n) {
        for (auto to : g[i]) {
            if (!taken[i][to]) {
                for (auto to1 : g[to]) {
                    if (!taken[to][to1]) {
                        taken[i][to] = 1;
                        taken[to][to1] = 1;
                        ans.pb({i, to, to1});
                        rec(dep + 1);
                        ans.pop_back();
                        taken[i][to] = 0;
                        taken[to][to1] = 0;
                    }
                }
            }
        }
    }
}

void dfs(int v, int p) {
    for (auto to : g1[v]) {
        if (to != p) {
            par[to] = v;
            dfs(to, v);
        }
    }
}

vi GetPath(int a, int b) {
    par[a] = -1;
    dfs(a, -1);
    vi ans;
    while (b != a) {
        ans.pb(b);
        b = par[b];
    }
    ans.pb(a);
    reverse(all(ans));
    return ans;
}

void TryPath(vi path, set<pi > s2) {
    if (sz(path) % 2 == 0) {
        return;
    }
    vector<tuple<int, int, int>> ans;
    for (int i = 1; i + 1 < sz(path); i += 2) {
        if (s2.count({path[i - 1], path[i]}) == 0) {
            return;
        }
        if (s2.count({path[i], path[i + 1]}) == 0) {
            return;
        }
        s2.erase({path[i - 1], path[i]});
        s2.erase({path[i], path[i + 1]});
        ans.pb({path[i - 1], path[i], path[i + 1]});
    }
    path.pop_back();
    reverse(all(path));
    path.pop_back();
    for (int i = 1; i < sz(path); i += 2) {
        if (s2.count({path[i - 1], path[i]}) == 0) {
            return;
        }
        if (s2.count({path[i], path[i + 1]}) == 0) {
            return;
        }
        s2.erase({path[i - 1], path[i]});
        s2.erase({path[i], path[i + 1]});
        ans.pb({path[i - 1], path[i], path[i + 1]});
    }
    set<pi > s1;
    for (auto[a, b] : s2) {
        if (s1.count({min(a, b), max(a, b)})) {
            continue;
        }
        s1.insert({min(a, b), max(a, b)});
        ans.pb({a, b, a});
    }
    cout << "Yes" << nl;
    for (auto[a, b, c] : ans) {
        cout << a + 1 << ' ' << b + 1 << ' ' << b + 1 << ' ' << c + 1 << nl;
    }
    exit(0);
}

void Solve() {
    cin >> n >> m;
    if (m & 1) {
        cout << "No";
        exit(0);
    }
    set<pair<int, int>> s1, s2;
    forn (i, m) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        s1.insert({min(a, b), max(a, b)});
        s2.insert({a, b});
        g[a].pb(b);
    }
    if (n <= 20 && m <= 20) {
        rec(0);
        cout << "No";
        exit(0);
    }
    if (m == 2 * n - 4) {
        vpi gg;
        for (auto[a, b] : s1) {
            int cnt = s2.count({a, b}) + s2.count({b, a});
            if (cnt == 1) {
                if (s2.count({a, b})) {
                    gg.pb({a, b});
                } else {
                    gg.pb({b, a});
                }
            }
        }
        if (sz(gg) == 0) {
            cout << "Yes" << nl;
            for (auto[a, b] : s1) {
                cout << a + 1 << ' ' << b + 1 << ' ' << b + 1 << ' ' << a + 1 << nl;
            }
            exit(0);
        }
        if (sz(gg) != 2) {
            cout << "No";
            exit(0);
        }
        for (auto[a, b] : s1) {
            g1[a].pb(b);
            g1[b].pb(a);
        }
        auto path = GetPath(gg[0].first, gg[1].first), p1 = GetPath(gg[0].first, gg[1].second);
        if (sz(p1) > sz(path)) {
            path = p1;
        }
        p1 = GetPath(gg[0].second, gg[1].first);
        if (sz(p1) > sz(path)) {
            path = p1;
        }
        p1 = GetPath(gg[0].second, gg[1].second);
        if (sz(p1) > sz(path)) {
            path = p1;
        }
        TryPath(path, s2);
        reverse(all(path));
        TryPath(path, s2);
        cout << "No";
        exit(0);
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
}