#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
const int mod = 1e9 + 7;
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n, m; cin >> n >> m;
	map <pair <int, int>, int> mp;
	for (int i = 0; i < m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		mp[{u, v}] = w;
		mp[{v, u}] = w;
	}
	vector <int> ok;
	for (int i = 1; i <= n; ++i)
		ok.push_back(i);
	vector <int> ans(n + 1, mod * mod);
	do {
		if (ok[0] != 1) continue;
		int mn = mod, mx = -mod;
		for (int i = 1; i < ok.size(); ++i) {
			if (mp.find({ ok[i], ok[i - 1] }) == mp.end()) break;
			mn = min(mn, mp[{ok[i], ok[i - 1]}]);
			mx = max(mx, mp[{ok[i], ok[i - 1]}]);
			ans[ok[i]] = min(ans[ok[i]], mx + mn);
		}
	} while (next_permutation(ok.begin(), ok.end()));
	for (int i = 2; i <= n; ++i)
		cout << ans[i] << '\n';
}