#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;
typedef long long ll;

vector <int> g[150010];

bool used[150010];
int kk[150010];

bool dp[150010][3];

set <pair <int, int>> s;

struct node {
    pair <int, int> v1, v2;
};

set <pair <pair <int, int>, pair <int, int>>> ans;

void dfs(int v, int pr = -1) {
    bool f = false;
    used[v] = 1;
    for (auto u : g[v]) {
        if (u != pr) {
            dfs(u, v);
            f = true;
        }
    }
    if (!f) {
        dp[v][0] = 1;
        return;
    }
    set <pair <int, int>> p1, p2;
    for (auto u : g[v]) {
        if (u != pr) {
            if (dp[u][0]) {
                if (s.count({u, v})) {
                    ans.insert({{u + 1, v + 1}, {v + 1, u + 1}});
                } else {
                    p1.insert({v + 1, u + 1});
                }
            } else if (dp[u][1]) {
                ans.insert({{v + 1, u + 1}, {u + 1, kk[u] + 1}});
                if (s.count({u, v})) {
                    p2.insert({u + 1, v + 1});
                }
            } else if (dp[u][2]) {
                if (s.count({u, v})) {
                    p1.insert({v + 1, u + 1});
                    ans.insert({{kk[u] + 1, u + 1}, {u + 1, v + 1}});
                } else {
                    cout << "No";
                    exit(0);
                }
            } else {
                cout << "No";
                exit(0);
            }
        }
    }
    if (abs(sz(p1) - sz(p2)) > 1) {
        cout << "No";
        exit(0);
    }
    for (auto i : p1) {
        if (sz(p2) == 0)
            break;
        ans.insert({*p2.begin(), i});
        p2.erase(p2.begin());
    }
    if (sz(p1) == 0 && sz(p2) == 0) {
        dp[v][0] = true;
        return;
    }
    if (sz(p1) == 1) {
        dp[v][1] = true;
        kk[v] = p1.begin()->Y - 1;
        return;
    }
    dp[v][2] = true;
    kk[v] = p2.begin()->X - 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, x, y;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        g[x - 1].pb(y - 1);
        s.insert({x - 1, y - 1});
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    cout << "Yes\n";
    for (auto i : ans) {
        cout << i.X.X << " " << i.X.Y << " " << i.Y.X << " " << i.Y.Y << '\n';
    }
    return 0;
}

/*/
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
/*/
