#include<bits\stdc++.h>
using namespace std;

const int MAXN = 15e4 + 1;
set<int> g[MAXN];
set<pair<int, int>> edg;
vector<pair<pair<int, int>, pair<int, int>>> ans;
bool used[MAXN];

pair<int, int> inout[MAXN]; //{in, out}

void dfs1(int v, int p) {
    used[v] = true;
    for (auto u : g[v]) {
        if (u != p) {
            //cout << u << " " << v << endl;
            if (edg.count({u, v})) inout[u].first++;
            if (edg.count({v, u})) inout[u].second++;
            dfs1(u, v);
        }
    }
}

pair<bool, bool> dfs2(int v, int p) {
    pair<int, int> now;
    vector<pair<int, int>> tmp1, tmp2;
    for (auto u : g[v]) {
        if (u != p) {
            pair<bool, bool> t = dfs2(u, v);
            //cout << v << " " << u << " " << t.first << " " << t.second << " | ";
            if (t.first) tmp1.push_back({u, v});
            if (t.second) tmp2.push_back({v, u});
            now.second += t.first;
            now.first += t.second;
        }
    }
    //cout << "\n";
    //cout << v << " " << p << ":\n";
    int t = min(now.first, now.second);
    now.first -= t;
    now.second -= t;
    //cout << t << "\n";
    for (int i = 0; i < t; ++i) {
        ans.push_back({tmp1[i], tmp2[i]});
    }
    if (now.first > inout[v].second || now.second > inout[v].first) {
        cout << "No\n";
        exit(0);
    } else {
        if (now.first) ans.push_back({{p, v}, tmp2.back()});
        if (now.second) ans.push_back({{v, p}, tmp1.back()});
        return {inout[v].first - now.second, inout[v].second - now.first};
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        edg.insert({u - 1, v - 1});
        g[u - 1].insert(v - 1);
        g[v - 1].insert(u - 1);
    }
    //cout << endl;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i, -1);
            dfs2(i, -1);
        }
    }
    /*cout << endl;
    for (int i = 0; i < n; ++i) {
        cout << inout[i].first << " " << inout[i].second << "\n";
    }*/
    cout << "Yes\n";
    for (auto it : ans) {
        cout << it.first.first + 1 << " " << it.first.second + 1 << " " << it.second.first + 1 << " " << it.second.second + 1 << "\n";
    }
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2


4 4
2 1
2 3
2 4
4 2


4 4
1 2
2 1
3 4
4 3
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}


