#include <bits/stdc++.h>
using ll = long long;
using namespace std;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()

const int MAXN = 5e5 + 7;
int arr[MAXN];
int h[MAXN];
int p[MAXN];
int sz[MAXN];
int mx[MAXN];
int mn[MAXN];
bool used[MAXN];

int find(int a){
    if (p[a] == a)
        return a;
    return p[a] = find(p[a]);
}

void un(int a, int b){
    a = find(p[a]);
    b = find(p[b]);
    if (a == b)
        return;
    if (sz[a] > sz[b])
        swap(a, b);
    sz[b] += sz[a];
    p[a] = b;
    mx[b] = max(mx[b], mx[a]);
    mn[b] = min(mn[b], mn[a]);
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> arr[i] >> h[i];
    arr[0] = arr[1];
    arr[n + 1] = arr[n];
    while (q--){
        for (int i = 0; i <= n + 1; i++){
            p[i] = i;
            sz[i] = 1;
            mn[i] = mx[i] = i, used[i] = false;
        }
        int l, r;
        cin >> l >> r;
        deque<int> can;
        for (int i = l; i <= r; i++){
            if (arr[i] - arr[i - 1] >= h[i] || arr[i + 1] - arr[i] >= h[i]) {
                can.push_back(i);
                used[i] = true;
            }
        }
        int cnt = 0;
        while (SZ(can)){
            int x = can.front();
            can.pop_front();
            cnt++;
            if (used[x + 1])
                un(x, x + 1);
            if (used[x - 1])
                un(x - 1, x);
            x = find(x);
            int l1 = mn[x] - 1;
            int r1 = mx[x] + 1;
            if (l <= l1 && arr[r1] - arr[l1] >= h[l1] && !used[l1]) {
                can.push_back(l1);
                used[l1] = true;
            }
            if (r1 <= r && arr[r1] - arr[l1] >= h[r1] && !used[r1]) {
                can.push_back(r1);
                used[r1] = true;
            }
        }
        cout << cnt << '\n';
    }
    return 0;
}
