#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define int long long
#define X first
#define Y second

using namespace std;

void solve(){
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> arr(n);
    for (auto & e : arr)
        cin >> e.X >> e.Y;

    int left = arr[0].X, right = arr.back().X;

    while (q--){
        vector<bool> o(n);
        int ans = 0, l, r;

        cin >> l >> r;
        --l, --r;

        while (true){
            int t = -1;

            for (int i = l; i <= r; ++i){
                if (o[i])
                    continue;

                if (arr[i].X + arr[i].Y <= right){
                    bool can = true;
                    int k = l + 1;
                    while (k < n && arr[k].X < arr[i].X + arr[i].Y){
                        if (!o[k]){
                            can = false;
                            break;
                        }
                        ++k;
                    }
                    if (can)
                        t = i;

                }

                if (arr[i].X - arr[i].Y >= left){
                    bool can = true;
                    int k = l - 1;
                    while (k >= 0 && arr[k].X > arr[i].X - arr[i].Y){
                        if (!o[k]){
                            can = false;
                            break;
                        }
                        --k;
                    }
                    if (can)
                        t = i;
                }
            }

            if (t == -1)
                break;
            ++ans;
            o[t] = true;
        }

        cout << ans << endl;
    }
}

signed main() {
    solve();
    return 0;
}
