#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll power(ll base, int exp) {
    if (exp == 0) return 1;
    return base * power(base, exp - 1);
}

ll value(char c) {
    int ord = c - 'A';
    if (ord % 2 == 0) return power(10, ord / 2);
    return 5 * power(10, ord / 2);
}

void solve();

signed main() {
    int t;
    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

const int k = 26;

void solve() {
    string p;
    cin >> p;
    vector<vector<ll>> dp(p.size() + 1, vector<ll>(26, -1e18));
    dp[p.size()][0] = 0;
    for (int i = (int) p.size() - 1; i >= 0; --i) {
        if (p[i] != '?') {
            ll lower = -1e18;
            for (char c = 'A'; c <= 'Z'; ++c) {
                if (c <= p[i]) lower = max(lower, dp[i + 1][c - 'A']);
                if (c > p[i]) dp[i][c - 'A'] = dp[i + 1][c - 'A'] - value(p[i]);
            }
            dp[i][p[i] - 'A'] = lower + value(p[i]);
        } else {
            ll lower = -1e18;
            for (char c = 'A'; c <= 'Z'; ++c) {
                lower = max(lower, dp[i + 1][c - 'A']);
                dp[i][c - 'A'] = lower + value(c);
            }
        }
    }
    cout << *max_element(dp[0].begin(), dp[0].end()) << '\n';
    function<void(int, int)> restore = [&](int i, char max) {
        if (i == p.size()) return;
        if (p[i] != '?') {
            cout << p[i];
            if (max == p[i]) {
                ll lower = dp[i][p[i] - 'A'] - value(p[i]);
                for (char c = 'A'; c <= p[i]; ++c) {
                    if (c <= p[i] && lower == dp[i + 1][c - 'A']) return restore(i + 1, c);
                }
            } else if (max > p[i]){
                if (dp[i][max - 'A'] == dp[i + 1][max - 'A'] - value(p[i])) return restore(i + 1, max);
            }
        } else {
            cout << max;
            ll lower = dp[i][max - 'A'] - value(max);
            for (char c = 'A'; c <= max; ++c) {
                if (lower == dp[i + 1][c - 'A']) return restore(i + 1, c);
            }
        }
    };
    restore(0, 'A' + (max_element(dp[0].begin(), dp[0].end()) - dp[0].begin()));
    cout << '\n';
}
