#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

//#define GLIBCXX_DEBUG

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    int t;
//    cin >> t;
//    while(t--)
    solve();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pii>> graph(n);
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        graph[a - 1].emplace_back(b - 1, t);
        graph[b - 1].emplace_back(a - 1, t);
    }

    vector<ll> dist1(n, 1e18);
    dist1[0] = 0;
    set<pii> queue1 = {{0, 0}};
    while (!queue1.empty()) {
        auto [d, u] = *queue1.begin();
        queue1.erase(queue1.begin());
        for (auto [e, t] : graph[u]) {
            if (t < dist1[e]) {
                queue1.erase({dist1[e], e});
                dist1[e] = t;
                queue1.insert({dist1[e], e});
            }
        }
    }
    vector<ll> dist2(n, -1e18);
    dist1[0] = 0;
    set<pii> queue2 = {{0, 0}};
    while (!queue2.empty()) {
        auto [d, u] = *queue2.begin();
        queue2.erase(queue2.begin());
        for (auto [e, t] : graph[u]) {
            if (t > dist1[e]) {
                queue2.erase({dist1[e], e});
                dist1[e] = t;
                queue2.insert({dist1[e], e});
            }
        }
    }
    for (int i = 1; i < n; i++)
        cout << dist1[i] + dist2[i] << '\n';
}