#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const ll INFL = 2e18;
const int INF = 2e9;
const int MAXN = 3e5 + 1;
struct edge {
    int t, w;
};

int ans[MAXN];

void dfs(vector<vector<edge>> &g, int v, int p, int mn, int mx) {
    ans[v] = mn + mx;
    for (auto &i : g[v])
        if (i.t != p)
            dfs(g, i.t, v, min(mn, i.w), max(mx, i.w));
}

int main() {
    input();
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        g[u].push_back({v, t});
        g[v].push_back({u, t});
    }
    if (m == n - 1) {
        vector<int> mn(n), mx(n);
        dfs(g, 0, -1, INF, 0);
        for (int i = 1; i < n; i++)
            cout << ans[i] << "\n";
    } else {

    }
    return 0;
}