#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<int>> edges;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> x(n);
	vector<int> h(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> h[i];	
	}
	vector<vector<int>> mat(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) {
				continue;
			}
			if (h[i] > abs(x[i] - x[j])) {
				mat[i][j] = 1;
			}
		}
	}
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		vector<int> del(n);
		int cnt = 0;
		bool fl = true;
		vector<int> pos;
		for (int j = l; j <= r; j++) {
			bool bad = false;
			for (int k = 0; k < n; k++) {
				if (k < l && k > r) {
					if (mat[j][k]) {
						bad = true;
					}
				}
			}
			if (!bad) {
				pos.push_back(j);
			}
		}
		while (fl) {
			fl = false;
			for (auto j : pos) {
				if (del[j]) {
					continue;
				}
				bool left = true, right = true;
				if (x[0] > x[j] - h[j]) {
					left = false;
				}
				if (j != 0) {
					for (int k = 0; k < j; k++) {
						if (!del[k] && mat[j][k]) {
							left = false;
						}
					}
				} else {
					left = false;
				}

				if (x[n - 1] < x[j] + h[j]) {
					right = false;
				}
				if (j != n - 1) {
					for (int k = j + 1; k < n; k++) {
						if (!del[k] && mat[j][k]) {
							right = false;
						}
					}
				}
				else {
					right = false;
				}
				if (left || right) {
					cnt++;
					del[j] = true;
					fl = true;
					break;
				}
			}
		}
		cout << cnt << endl;
	}
	cin >> n;
	return  0;
}