#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2");
//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("unrol-loops");

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
oredered_set;
*/

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

const ll INF = 1e10;
const int N = 3e5 + 10;

vector<pair<int, ll> > g[N];

vector<ll> mn(N, 1e10), mx(N);

void bfs(int s, int n) {
    vector<ll> mn(n + 1, INF);
    vector<ll> mx(n + 1, -1);
    vector<ll> ans(n + 1, INF);
    map<vector<ll>, int> used;

    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        err << "!" _ v _ mx[v] _ mn[v] << endl;

        for (auto e : g[v]) {
            int to = e.ff;
            ll w = e.ss;

            vector<ll> t = {to, max(mx[v], w), min(w, mn[v])};
            if (used[t] == 1) continue;

            ll tmp = w;
            if (mx[v] != -1) tmp = max(w, mx[v]);

            if (mx[to] > tmp || mn[to] > min(w, mn[v])) {
                mx[to] = max(mx[v], w);
                mn[to] = min(w, mn[v]);
                used[t] = 1;

                ans[to] = min(ans[to], mx[to] + mn[to]);
                q.push(to);
            }
        }
    }

    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << "\n";
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    int u, v;
    ll t;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v >> t;
        g[u].pb({v, t});
        g[v].pb({u, t});
    }

    bfs(1, n);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}


