#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>
#include <array>
#include <ctime>
#include <chrono>
#include <tuple>

#define int long long

using namespace std;

random_device rd;
mt19937_64 get_rand(rd());

vector <pair <int, int>> g[300010];
int ans[300010];

void dfs(int v, int mn = 1e9 + 7, int mx = -1e9 - 7, int p = -1) {
	ans[v] = mn + mx;
	for (auto [u, w] : g[v])
		if (u != p)
			dfs(u, min(w, mn), max(w, mx), v);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	srand(time(NULL));

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		g[u].emplace_back(v, w);
		g[v].emplace_back(u, w);
	}
	dfs(0);
	for (int i = 1; i < n; i++)
		cout << ans[i] << '\n';
	return 0;
}