#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> values = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000,
                      50000000, 100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000,
                      500000000000, 1000000000000, 5000000000000};

int compute(const vector<int> &a) {
    int mx = -1;
    int res = 0;
    int n = a.size();
    for (int i = n - 1; i >= 0; --i) {
        mx = max(mx, a[i]);
        if (mx > a[i]) {
            res -= values[a[i]];
        } else {
            res += values[a[i]];
        }
    }

    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    assert(values.size() == (int) ('Z' - 'A' + 1));


    int tests;
    cin >> tests;


    for (int test = 0; test < tests; ++test) {
        string s;
        cin >> s;
        vector<int> a;
        int lst_q = -1;
        int frst_q = -1;
        vector<int> qs;
        int n = s.size();

        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                a.push_back(-1);
                if (frst_q == -1) {
                    frst_q = i;
                }
                qs.push_back(i);
                lst_q = i;
            } else {
                a.push_back(s[i] - 'A');
            }
        }
        vector<int> res;
        int res_value = INT64_MIN;
        if (lst_q == -1) {
            res = a;
            res_value = compute(res);
        } else {
            for (int num1 = 0; num1 < values.size(); ++num1) {
                for (int num2 = 0; num2 < values.size(); ++num2) {
                    for (int num3 = 0; num3 < values.size(); ++num3) {
                        vector<int> b = a;
                        b[qs[0]] = num1;
                        if (qs.size() >= 2) {
                            b[qs[1]] = num2;
                        }
                        if (qs.size() >= 3) {
                            b[qs[2]] = num3;
                        }
                        int res_b = compute(b);
                        if (res_b > res_value) {
                            res = b;
                            res_value = res_b;
                        }
                    }
                }
            }
        }

        if (qs.size() >= 2) {
            vector<int> nums;
            for (auto ind :qs) {
                nums.push_back(res[ind]);
            }
            for (int i = 0; i < qs.size() - 1; ++i) {
                assert(nums[i] >= nums[i + 1]);
            }
        }

        cout << res_value << '\n';
        for (auto e : res) {
            assert(e >= 0);
            assert(e + 'A' <= 'Z');
            cout << (char) ('A' + e);
        }
        cout << '\n';

    }
}
