#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <numeric>
#include <random>
#include <list>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll LINF = 1e18;
const int INF = 1e9 + 7;
//const int N = 20;
//vector <int> tin, tout;
//vector <bool> colors;
//vector <vector <int>> ps;
//
//void Dfs(int v, int p, bool color, vector <set <int>>& g, int& tm) {
// colors[v] = color;
// tin[v] = tm++;
// for (auto i : g[v]) {
// if (i != p)
// Dfs(i, v, !color, g, tm);
// }
// ps[v][0] = p;
// for (int i = 1; i < N; i++)
// ps[v][i] = ps[ps[v][i - 1]][i - 1];
// tout[v] = tm++;
//}
//
//bool is_lower(int a, int b) {
// return tin[b] <= tin[a] && tout[a] <= tout[b];
//}
//
//void Solve() {
// int n, m;
// cin >> n >> m;
// vector <set <int>> g(n);
// vector <set <int>> h(n);
// vector <set <int>> t(n);
// tin.resize(n); tout.resize(n); colors.resize(n);
// ps.resize(n, vector <int>(N, 0));
// for (int i = 0; i < m; i++) {
// int a, b;
// cin >> a >> b;
// g[a - 1].insert(b - 1);
// h[b - 1].insert(a - 1);
// t[a - 1].insert(b - 1);
// t[b - 1].insert(a - 1);
// }
// int _time = 0;
// Dfs(0, -1, 0, t, _time);
//
// // hypot -- we will destroy by MIN LCA
//
// 
//}

const int N = 20;
void Solve() {
	int n, q;
	cin >> n >> q;
	vector <pair <int, int>> v(n);

	for (auto& i : v) cin >> i.first >> i.second;
	v.push_back(v.back());
	v.insert(v.begin(), v.front());

	mt19937 rnd(337);

	vector <pair <int, int>> erasable;
	for (int i = 0; i < N; i++) {
		int ln = min(rnd() % n, rnd() % n);
		int a = rnd() % (n - ln) + 1;
		int b = a + ln;

		list <int> lst;
		for (int j = a; j <= b; j++) {
			lst.push_back(j);
		}
		int it = 0;
		while (!lst.empty()) {
			bool ok = false;
			vector <list<int>::iterator> todel;
			for (auto i = lst.begin(); i != lst.end(); i++) {
				for (auto i : todel)
					lst.erase(i);
				todel.clear();
				if (v[*i].first - (i == lst.begin() ? v[a - 1].first : v[*prev(i)].first) >= v[*i].second ||
					(next(i) == lst.end() ? v[b + 1].first : v[*next(i)].first) - v[*i].first >= v[*i].second)
					todel.push_back(i), ok = true;
			}
			if (!ok) break;
			for (auto i : todel)
				lst.erase(i);
		}

		if (lst.empty()) {
			erasable.push_back({ a, b });
		}
	}
	sort(erasable.begin(), erasable.end());

	
	
	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		list <int> lst;
		int ndx = 0;
		for (int j = a; j <= b; j++) {
			if (ndx < erasable.size() && j >= erasable[ndx].first && erasable[ndx].second < b) {
				j = max(j, erasable[ndx].second);
				ndx++;
			} else
				lst.push_back(j);
		}
		
		int it = 0;
		while (!lst.empty()) {
			bool ok = false;
			vector <list<int>::iterator> todel;
			for (auto i = lst.begin(); i != lst.end(); i++) {
				for (auto i : todel)
					lst.erase(i);
				todel.clear();
				if (v[*i].first - (i == lst.begin() ? v[a - 1].first : v[*prev(i)].first) >= v[*i].second ||
					(next(i) == lst.end() ? v[b + 1].first : v[*next(i)].first) - v[*i].first >= v[*i].second)
					todel.push_back(i), ok = true;
			}
			if (!ok) break;
			for (auto i : todel)
				lst.erase(i);
		}
		cout << b - a + 1 - lst.size() << '\n';
	}

}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}