#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 10000000000;

int n;
vector <vector <pair <int, int> > > g;

ostream& operator<<(ostream& os, vector <int> a)
{
    for (auto x : a)
    {
        os << x << " ";
    }
    return os;
}

ostream& operator<<(ostream& os, pair <int, int> a)
{
    os << a.first << " " << a.second;
    return os;
}

vector <int> mx, mn;
vector <bool> used;

void dfs(int v, int mini, int maxi)
{
    used[v] = true;
    mx[v] = maxi;
    mn[v] = mini;
    for (auto rib : g[v])
    {
        int u = rib.first, w = rib.second;
        if (!used[u])
        {
            dfs(u, min(mini, w), max(maxi, w));
        }
    }
}

void solve1()
{
    mx.assign(n, -inf);
    mn.assign(n, inf);
    used.assign(n, false);
    dfs(0, inf, -inf);
    for (int i = 1; i < n; i++)
    {
        cout << mx[i] + mn[i] << endl;
    }
}

int32_t main()
{
    int m;
    cin >> n >> m;
    vector <pair <int, int> > temp;
    g.assign(n, temp);
    for (int i = 0; i < m; i++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].push_back(make_pair(u, w));
        g[u].push_back(make_pair(v, w));
    }
    solve1();
    return 0;
}
