#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef double db;
typedef pair < int, int > pii;

struct Edge {
    int v, u, t;
    Edge (int v = 0, int u = 0, int t = 0) : v(v), u(u), t(t) {}
};

const int N = 3e5 + 5;
const int inf = 1e9 + 7;
vector < pii > gr[N];
Edge edge[N];
int ans[N];
int used[N];
int C = 1;
int lev[N], up[N];
int mn[N], mx[N];
int br[N];
int par[N];
pii kek[N];
pii srt[N];

void dfst(int v, int a = inf, int b = 0, int prv = -1) {
    if (v) {
        a = min(a, mn[v]);
        b = max(b, mn[v]);
    }
    ans[v] = a + b;
//    bool fl = 0;
    for (auto p : gr[v]) {
        int u = p.F, t = edge[p.S].t;
        if (u == prv) {
            continue;
        }
        mn[u] = min(mn[u], t);
        dfst(u, a, b, v);
    }
}

void dij(int n) {
    fill(ans + 1, ans + n, inf);
    set < pii > cur;
    for (auto p : gr[0]) {
        cur.insert(mp(edge[p.S].t, p.S));
    }
    used[0] = 1;
    while (sz(cur)) {
        pii p = *(cur.begin());
        cur.erase(cur.begin());
        int i = p.S, t = p.F;
        int v = edge[i].v, u = edge[i].u;
        ans[u] = min(ans[u], max(ans[v], t));
        ans[v] = min(ans[v], max(ans[u], t));
        if (used[v]) {
            swap(v, u);
        }
        if (!used[v]) {
            used[v] = 1;
            for (auto p : gr[v]) {
                if (!used[p.F]) {
                    int i = p.S;
                    cur.insert({edge[i].t, i});
                }
            }
        }
    }
}

int ver(int i, int v) {
    return edge[i].v ^ edge[i].u ^ v;
}

void dfs(int v) {
    for (auto p : gr[v]) {
        int u = p.F, i = p.S;
        if (v + 1 != u) {
            continue;
        }
        int t = edge[i].t;
        if (kek[v].F >= t) {
            kek[v].S = kek[v].F;
            kek[v].F = t;
        } else if (kek[v].S > t) {
            kek[v].S = t;
        }
    }
}
void upd(int v, int t) {
    mn[v] = min(mn[v], t);
    used[v] = C;
    for (auto q : gr[v]) {
        int u = q.F, i = q.S;
//        used[u] = 1;
        if (used[u] == C || (lev[v] > lev[u] && br[i])) {
            continue;
        }
        upd(u, t);
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--, u--;
        gr[v].pb({u, i});
        gr[u].pb({v, i});
        edge[i] = {v, u, t};
//        cnt[{v, u}]++;
//        cnt[{u, v}]++;
    }
    for (int i = 0; i < n; i++) {
        kek[i] = {inf, inf};
    }
    dfs(0);
//    dij(n);
//    dfs(0);
//    fill(mn, mn + n, inf);
//    for (int i = 0; i < m; i++) {
//        int v = edge[i].v, u = edge[i].u, t = edge[i].t;
//        if (lev[v] > lev[u]) {
//            swap(v, u);
//        }
//        C++;
//        upd(u, t);
//    }
    kek[0] = {0, 0};
    for (int i = 0; i < n; i++) {
        ans[i] = inf;
        int a = inf, b = 0;
        for (int j = 0; j < n; j++) {
            a = min(a, kek[j].F);
            b = max(b, kek[j].S);
            ans[i] = min(ans[i], a + b);
        }

    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << endl;
    }
    return 0;
}
