#include<iostream>
#include<vector>
#include<cmath>
#include<string>
#include<algorithm>

using namespace std;

typedef long long int ll;

struct rebro {
	ll a, b, t;
};

struct nm {
	ll a, i;
};

struct resmin {
	ll sum, tmin, tmax;
};

ll min(ll a, ll b) {
	if (a > b) return b;
	return a;
}

ll max(ll a, ll b) {
	if (a > b) return a;
	return b;
}

void dfs(ll n, ll m, vector<rebro>& a, vector<vector<nm>>& b, vector<ll>& min_l, vector<ll>& max_l, ll x, vector<bool>& usd) {
	usd[x] = true;
	for (auto i : b[x]) {
		if (!usd[i.a]) {
			min_l[i.a] = min(min_l[x], a[i.i].t);
			max_l[i.a] = max(max_l[x], a[i.i].t);
			dfs(n, m, a, b, min_l, max_l, i.a, usd);
		}
	}
}

int main() {
	ll n, m;
	cin >> n >> m;
	vector<resmin> res(n);
	vector<ll> min_l(n - 1, 1e9+1);
	vector<ll> max_l(n - 1, -1);
	vector<ll> max_res(n - 1, -1);
	vector<ll> min_res(n - 1, 2 * 1e9 + 1);
	ll a, b, t;
	for (ll i = 0; i < m; i++) {
		cin >> a >> b >> t;
		a--;
		b--;
		if (a == b + 1) {
			min_l[b] = min(min_l[b], t);
			max_l[b] = max(max_l[b], t);
		}
		else {
			min_l[a] = min(min_l[a], t);
			max_l[a] = max(max_l[a], t);
		}
	}
	max_res[0] = max_l[0];
	min_res[0] = min_l[0];
	for (ll i = 1; i < n - 1; i++) {
		max_res[i] = max(max_res[i - 1], max_l[i]);
		min_res[i] = min(min_res[i - 1], min_l[i]);
	}
	for (ll i = 0; i < n - 1; i++) cout << max_res[i] + min_res[i] << endl;
	/*cout << endl;
	for (ll i = 0; i < n - 1; i++) cout << max_l[i] << endl;
	cout << endl;
	for (ll i = 0; i < n - 1; i++) cout << min_l[i] << endl;*/
}

/*
5 8
3 4 3
1 2 8
4 5 9
2 3 7
3 4 0
1 2 1
4 5 6
3 4 15

*/