#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


vector<ll> values;

const int ALPHA = 26;


ll try_char(const string &s) {
    char max_char = 0;
    ll total = 0;
    for (char q : s) {
        if (q < max_char) {
            total -= values[q - 'A'];
        } else {
            total += values[q - 'A'];
            max_char = q;
        }
    }
    return total;
}


void solve() {
    values.resize(ALPHA);
    for (int i = 0; i < ALPHA; i++) {
        values[i] = (i % 2 == 0 ? 1 : 5) * pow(10, i / 2);
    }

    string s; cin >> s;
    int n = s.size();
    vector<vector<ll>> dp(n, vector<ll>(ALPHA, INT64_MIN));
    vector<string> strings(26, s);
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            for (char k = 0; k < ALPHA; ++k) {
                for (int j = 0; j <= k; ++j) {
                    ll v = (i > 0 ? dp[i - 1][k] : 0) + values[k];
                    if (dp[i][j] < v) {
                        dp[i][j] = v;
                        strings[j][i] = 'A' + k;
                    }
                }
            }
        } else {
            int k = s[i] - 'A';
            for (int j = 0; j < ALPHA; ++j) {
                if (k >= j) {
                    dp[i][j] = (i > 0 ? *max_element(dp[i - 1].begin() + k, dp[i - 1].end()) : 0) + values[k];
                } else {
                    dp[i][j] = (i > 0 ? dp[i - 1][j] : 0) - values[k];
                }
            }
        }
    }

    cout << *max_element(all(dp[n - 1])) << "\n";
    ll best = INT64_MIN;
    int best_i = 0;
    for (int i = 0; i < ALPHA; ++i) {
        reverse(all(strings[i]));
        ll res = try_char(strings[i]);
        if (best < res) {
            best = res;
            best_i = i;
        }
    }
    reverse(all(strings[best_i]));
    cout << strings[best_i] << "\n";
}


int main() {
#if ELT
    freopen("../A.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q; cin >> q;
    while(q--) {
        solve();
    }
#endif
    return 0;
}
