#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const ll cst = 5e5 + 5;
const ll inf = (ll)1e18 + 228;

ll x[cst];
ll h[cst];

ll badl[cst];
ll badr[cst];

vector<ll> bad[cst];

ll ld[cst];
ll rd[cst];
bool used[cst];

ll n, q;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> q;
	for (ll i = 1; i <= n; i++) cin >> x[i] >> h[i];
	x[0] = x[1] - 1;
	h[0] = h[n + 1] = inf;
	x[n + 1] = x[n] + 1;
	for (ll i = 1; i <= n; i++) {
		for (ll j = 0; j < i; j++) {
			if (x[i] - x[j] < h[i]) {
				badl[i]++;
				bad[j].push_back(i);
			}
		}
		for (ll j = i + 1; j <= n + 1; j++) {
			if (x[j] - x[i] < h[i]) {
				badr[i]++;
				bad[j].push_back(i);
			}
		}
	}
	badl[1] = inf;
	badr[n] = inf;
	while (q--) {
		ll l, r;
		cin >> l >> r;
		for (ll i = l; i <= r; i++) used[i] = ld[i] = rd[i] = 0;

		ll answ = 0;
		vector<ll> good;
		
		for (ll i = l; i <= r; i++) {
			if (!badl[i] || !badr[i]) {
				good.push_back(i);
				used[i] = 1;
			}
		}
		while (!good.empty()) {
			ll v = good.back();
			good.pop_back();
			answ++;
			for (ll i : bad[v]) {
				if (x[i] < x[v]) {
					rd[i]++;
					if (rd[i] == badr[i] && !used[i] && (i >= l && i <= r)) {
						good.push_back(i);
						used[i] = 1;
					}
				}
				if (x[i] > x[v]) {
					ld[i]++;
					if (!used[i] && ld[i] == badl[i] && (i >= l && i <= r)) {
						good.push_back(i);
						used[i] = 1;
					}
				}
			}
		}
		cout << answ << endl;
	}
	return 0;
}