#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

ll values[26];

ll func(string s) {
  ll res = 0;
  int mx = -1;
  int n = s.size();
  for (int i = n - 1; i >= 0; i--) {
    int dig = s[i] - 'A';
    if (dig < mx) {
      res -= values[dig];
    } else {
      res += values[dig];
    }
    mx = max(mx, dig);
  }
  return res;
}

int main() {
  values[0] = 1;
  values[1] = 5;
  for (int i = 2; i <= 25; i++) {
    values[i] = values[i - 2] * 10;
  }
  int q;
  cin >> q;
  while (q--) {
    string s;
    cin >> s;
    cout << func(s) << '\n';
    cout << s << '\n';
  }
  return 0;
}