#pragma GCC optimize("O3")

#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

typedef vector <int> vi;
typedef vector <vi> vvi;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, q;
  cin >> n >> q;
  vector <int> x(n), h(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> h[i];
  }
  vvi ans(n, vi(n));
  for (int i = 0; i < n; i++) {
    int L = x[max(i - 1, 0)];
    vector <int> st;
    for (int j = i; j < n; j++) {
      st.push_back(j);
      while (!st.empty()) {
        int l;
        if (st.size() >= 2) {
          l = x[st[st.size() - 2]];
        } else {
          l = L;
        }
        if (x[st.back()] - h[st.back()] >= l) {
          st.pop_back();
          continue;
        }
        int r = x[min(j + 1, n - 1)];
        if (x[st.back()] + h[st.back()] <= r) {
          st.pop_back();
          continue;
        }
        break;
      }
      ans[i][j] = (j - i + 1) - st.size();
    }
  }
  while (q--) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    cout << ans[l][r] << '\n';
  }
  return 0;
}

/*
3 3
 1 3
 3 1
 4 2
 1 1
 2 3
 1 3
 */


/*
 5 3
 1 5
 3 1
 4 2
 5 3
 6 1
 1 5
 5 5
 1 1
 */