#include <iostream>
#include <string>
#include <vector>
using namespace std;
using ll = long long;

ll pw(ll a, ll m){
	if(!m)
		return 1;
	if(m % 2)
		return pw(a, m - 1) * a;
	return pw(a * a, m / 2);
}

ll to_10(int x){
	return pw(10, x / 2) * pw(5, x % 2);
}

void btck(vector<vector<pair<int, int>>>& vl, int i, int j){
	if(i >= vl.size())
		return;
	cout << char('A' + vl[i][j].first);
	btck(vl, i + 1, vl[i][j].second);
}

const ll INF = 1e18;
const int AL = 'z' - 'a' + 1;
ll gto[AL];

signed main(){
	for(int i = 0; i < AL; ++i)
		gto[i] = to_10(i);
	int t;
	cin >> t;
	while(t--){
		string s;
		cin >> s;
		int n = s.size();
		vector<int> a(n);
		for(int i = 0; i < n; ++i){
			if(s[i] == '?')
				a[i] = -1;
			else
				a[i] = s[i] - 'A';
		}
		char mxch = s[n - 1];
		vector<vector<ll>> dp(n, vector<ll>(AL, -INF));
		vector<vector<pair<int, int>>> bt(n, vector<pair<int, int>>(AL));
		if(a[n - 1] == -1){
			for(int j = 0; j < AL; ++j){
				dp[n - 1][j] = gto[j];
				bt[n - 1][j] = {j, 0};
			}
		} else {
			dp[n - 1][a[n - 1]] = gto[a[n - 1]];
			bt[n - 1][a[n - 1]] = {a[n - 1], 0};
		}
		for(int i = n - 2; i >= 0; --i){
			if(a[i] == -1){
				for(int j = 0; j < AL; ++j){
					for(int j_ = 0; j_ <= j; ++j_){
						if(dp[i][j] < gto[j] + dp[i + 1][j_]){
							dp[i][j] = gto[j] + dp[i + 1][j_];
							bt[i][j] = {j, j_};
						}
					}
				}
			} else {
				for(int j = 0; j < AL; ++j){
					if(j <= a[i]){
						if(dp[i][a[i]] < gto[a[i]] + dp[i + 1][j]){
							dp[i][a[i]] = gto[a[i]] + dp[i + 1][j];
							bt[i][a[i]] = {a[i], j};
						}
					} else {
						if(dp[i][j] < -gto[a[i]] + dp[i + 1][j]){
							dp[i][j] = -gto[a[i]] + dp[i + 1][j];	
							bt[i][j] = {a[i], j};
						}
					}
				}
			}
		}
		ll ans = 0;
		for(int i = 1; i < AL; ++i)
			if(dp[0][i] > dp[0][ans])
				ans = i;
		cout << dp[0][ans] << endl;
		btck(bt, 0, ans);
		cout << endl;
	}
}
