#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

int main() {
	ll n, q;
	cin >> n >> q;
	v<pa<ll, ll>> trees(n);
	for (ll i = 0; i < n; ++i) {
		ll xi, hi;
		cin >> xi >> hi;
		trees[i] = { xi, hi };
	}
	for (ll req = 0; req < q; ++req) {
		ll li, ri;
		cin >> li >> ri;
		--li;
		v<pa<ll, ll>> subarr(trees.begin() + li, trees.begin() + ri);
		ll cnt = 0;
		while (true) {
			ll ti = 0;
			bool found = false;
			for (ll i = 0; i < subarr.size(); ++i) {
				bool canLeft = i == 0 || subarr[i - 1].first <= subarr[i].first - subarr[i].second;
				canLeft &= li == 0 || trees[li - 1].first <= subarr[i].first - subarr[i].second;
				canLeft &= trees.front().first <= subarr[i].first - subarr[i].second;
				bool canRight = i == subarr.size() - 1 || subarr[i + 1].first >= subarr[i].first + subarr[i].second;
				canRight &= ri == n || trees[ri].first >= subarr[i].first + subarr[i].second;
				canRight &= trees.back().first >= subarr[i].first + subarr[i].second;
				if (canLeft || canRight) {
					found = true;
					ti = i;
					break;
				}
			}
			if (found) {
				++cnt;
				subarr.erase(subarr.begin() + ti);
			}
			else {
				break;
			}
		}
		cout << cnt << '\n';
	}
}