#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;

const ll inf = 1e18;

vector<ll> val(26, 1);

ll valofstr(string s)
{
	ll n = s.size();
	ll ans = 0;
	ll k = 0;
	for (ll i = n - 1; i >= 0; --i)
	{
		if (k > s[i] - 'A')
			ans -= val[s[i] - 'A'];
		else
			ans += val[s[i] - 'A'];
		k = max(k, static_cast<ll>(s[i] - 'A'));
	}
	return ans;
}

signed main()
{
	for (ll i = 1, v = 1; i < 26; ++i)
	{
		if (i % 2)
		{
			val[i] = 5 * v;
			v *= 10;
		}
		else
		{
			val[i] = v;
		}
	}
	ll t; cin >> t;
	while (t--)
	{
		string s; cin >> s;
		ll n = s.size();
		vector<vector<ll>> dp(n, vector<ll>(26, 0)), prev(n, vector<ll>(26, 0));

		for (int i = 0; i < n; ++i)
		{
			for (int k = 0; k < 26; ++k)
			{
				if (s[i] != '?')
				{
					if (i > 0)
						dp[i][k] = dp[i - 1][max(k, s[i] - 'A')];
					if (k > s[i] - 'A')
						dp[i][k] -= val[s[i] - 'A'];
					else
						dp[i][k] += val[s[i] - 'A'];
				}
				else
				{
					if (i > 0)
						dp[i][k] = dp[i - 1][max(k, 0)];
					if (k > 0)
						dp[i][k] -= val[0];
					else
						dp[i][k] += val[0];
					prev[i][k] = 0;
					for (int t = 0; t < 26; ++t)
					{
						ll v = 0;
						if (i > 0)
							v = dp[i - 1][max(k, t)];
						if (k > t)
							v -= val[t];
						else
							v += val[t];
						if (v >= dp[i][k])
						{
							dp[i][k] = v;
							prev[i][k] = t;
						}
					}
				}
			}
		}
		cout << dp[n - 1][0] << '\n';
		int k = 0;
		string ans = s;
		for (int i = n - 1; i >= 0; --i)
		{
			if (s[i] == '?')
			{
				ans[i] = prev[i][k] + 'A';
			}
			k = max(k, s[i] - 'A');
		}
		cout << ans << '\n';
		cout << valofstr(ans) << '\n';
	}



	return 0;
}