#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
vector<ll> p;
vector<ll> h, used;
void dfs(ll v, ll pr, vector<vector<ll>>& gg)
{
	used[v] = 1;
	p[v] = pr;
	for (auto mem : gg[v])
	{
		if (mem != pr)
		{
			h[mem] = h[v] - 1;
			dfs(mem, v, gg);
		}
	}

}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m; cin >> n >> m;
	vector<ll> deg(n, 0);
	p.resize(n);
	h.resize(n,0);
	used.resize(n,0);

	set<pair<ll, pair<ll, ll>>> que;
	vector<set<ll>> g(n);
	vector<vector<ll>> gg(n);
	for (int i = 0; i < m; ++i)
	{
		ll a, b; cin >> a >> b; --a; --b;
		g[a].insert(b);
		gg[a].push_back(b);
		gg[b].push_back(a);
		if (!g[b].count(a))
		{
			++deg[a];
			++deg[b];
		}
	}

	for (int i = n- 1; i >= 0; --i)
		dfs(i, -1, gg);

	for (int i = 0; i < n; ++i)
		que.insert({ deg[i],{h[i],i } });
	vector<vector<ll>> ans;
	ll cnt = 2 * n;
	while (cnt-- && !que.empty())
	{
		pair<ll, pair<ll, ll>> q = *que.begin();
		if (q.first == 0)
		{
			que.erase(q);
			continue;
		}
		else if (q.first >= 2)
		{
			cout << "No\n";
			return 0;
		}
		else
		{
			bool may = false;
			ll v = q.second.second;
			ll pr = p[v];
			if (pr == -1)
			{
				return -1;
			}
			else
			{
				if (g[pr].count(v) && g[v].count(pr))
				{
					ans.push_back({ v,pr,pr,v });
					g[pr].erase(v);
					g[v].erase(pr);

					que.erase({ deg[pr],{h[pr],pr } });
					que.erase({ deg[v],{h[v],v } });
					--deg[v];
					--deg[pr];
					que.insert({ deg[v],{h[v],v } });
					que.insert({ deg[pr],{h[pr],pr } });

					may = true;
				}
				else if (g[pr].count(v))
				{
					for (auto mem : g[pr])
					{
						if (mem != p[pr])
						{
							if (g[mem].count(pr))
							{
								ans.push_back({ mem,pr,pr,v });

								g[pr].erase(v);
								if (!g[v].count(pr))
								{
									que.erase({ deg[v],{h[v],v } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[v];
									--deg[pr];
									que.insert({ deg[v],{h[v],v } });
									que.insert({ deg[pr],{h[pr],pr } });
								}

								g[mem].erase(pr);
								if (!g[pr].count(mem))
								{
									que.erase({ deg[mem],{h[mem],mem } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[mem];
									--deg[pr];
									que.insert({ deg[mem],{h[mem],mem } });
									que.insert({ deg[pr],{h[pr],pr } });
								}
								may = true;
								break;
							}
						}
					}
					if (!may)
					{
						if (p[pr] == -1)
							may = false;
						else
						{
							ll u = p[pr];
							if (g[u].count(pr))
							{
								ans.push_back({ u,pr,pr,v });

								g[pr].erase(v);
								if (!g[v].count(pr))
								{
									que.erase({ deg[v],{h[v],v } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[v];
									--deg[pr];
									que.insert({ deg[v],{h[v],v } });
									que.insert({ deg[pr],{h[pr],pr } });
								}

								g[u].erase(pr);
								if (!g[pr].count(u))
								{
									que.erase({ deg[u],{h[u],u } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[u];
									--deg[pr];
									que.insert({ deg[u],{h[u],u } });
									que.insert({ deg[pr],{h[pr],pr } });
								}
								may = true;
							}
							else
								may = false;
						}
					}
				}
				else if (g[v].count(pr))
				{
					for (auto mem : g[pr])
					{
						if (mem != p[pr])
						{

							ans.push_back({ v,pr,pr,mem });

							g[v].erase(pr);
							if (!g[pr].count(v))
							{
								que.erase({ deg[v],{h[v],v } });
								que.erase({ deg[pr],{h[pr],pr } });
								--deg[v];
								--deg[pr];
								que.insert({ deg[v],{h[v],v } });
								que.insert({ deg[pr],{h[pr],pr } });
							}

							g[pr].erase(mem);
							if (!g[mem].count(pr))
							{
								que.erase({ deg[mem],{h[mem],mem } });
								que.erase({ deg[pr],{h[pr],pr } });
								--deg[mem];
								--deg[pr];
								que.insert({ deg[mem],{h[mem],mem } });
								que.insert({ deg[pr],{h[pr],pr } });
							}
							may = true;
							break;
							
						}
					}
					if (!may)
					{
						if (p[pr] == -1)
							may = false;
						else
						{
							ll u = p[pr];
							if (g[pr].count(u))
							{
								ans.push_back({ v,pr,pr,u });

								g[v].erase(pr);
								if (!g[pr].count(v))
								{
									que.erase({ deg[v],{h[v],v } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[v];
									--deg[pr];
									que.insert({ deg[v],{h[v],v } });
									que.insert({ deg[pr],{h[pr],pr } });
								}

								g[pr].erase(u);
								if (!g[u].count(pr))
								{
									que.erase({ deg[u],{h[u],u } });
									que.erase({ deg[pr],{h[pr],pr } });
									--deg[u];
									--deg[pr];
									que.insert({ deg[u],{h[u],u } });
									que.insert({ deg[pr],{h[pr],pr } });
								}
								may = true;
							}
							else
								may = false;
						}
					}
				}
				else
				{
					may = false;
				}
			}
			if (may)
			{
				que.erase({ deg[v], {h[v],v} });
				continue;

			}
			else
			{
				cout << "No\n";
				return 0;
			}
		}
	}

	cout << "Yes\n";
	for (int i = 0; i < ans.size(); ++i)
	{
		for (auto mem : ans[i])
			cout << mem + 1 << ' ';
		cout << '\n';
	}


	return 0;
}