#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)
#define rep(i, n) for (int i = 0; i < n; i++)

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;

void solve()
{
    string s;
    cin >> s;
    ll INF = 2e18;
    vector<vll> dp(sz(s) + 1, vll(26, -INF));
    vvi prev(sz(s) + 1, vi(26, -1));
    dp[sz(s)][0] = 0;
    vll value(26, 1);
    for (int i = 1; i < 26; i++)
    {
        if (i % 2 == 1) value[i] = value[i - 1] * 5;
        else value[i] = value[i - 1] * 2;
    }
    rrep(i, sz(s))
    {
        if (s[i] == '?') {
            rep(j, 26)
            {
                for (int k = 0; k < 26; k++)
                {
                    if (k <= j) {
                        if (dp[i][j] < dp[i + 1][k] + value[j]) {
                            dp[i][j] = dp[i + 1][k] + value[j];
                            prev[i][j] = k;
                        }
                    }
                    else {
                        if (dp[i][j] < dp[i + 1][k] - value[j]) {
                            dp[i][j] = dp[i + 1][k] - value[j];
                            prev[i][j] = k;
                        }
                    }
                }
            }
        }
        else {
            for (int k = 0; k < 26; k++)
            {
                if (k <= s[i] - 'A') {
                    if (dp[i][s[i] - 'A'] < value[s[i] - 'A'] + dp[i + 1][k]) {
                        dp[i][s[i] - 'A'] = value[s[i] - 'A'] + dp[i + 1][k];
                        prev[i][s[i] - 'A'] = k;
                    }
                }
                else {
                    //dp[i][k] = max(dp[i][k], -value[s[i] - 'A'] + dp[i + 1][k]);
                    if (dp[i][k] < -value[s[i] - 'A'] + dp[i + 1][k]) {
                        dp[i][k] = -value[s[i] - 'A'] + dp[i + 1][k];
                        prev[i][k] = k;
                    }
                }
            }
        }
    }
    int c = -1;
    ll mx = -INF;
    rep(i, 26)
    {
        if (dp[0][i] > mx) {
            mx = dp[0][i];
            c = i;
        }
    }
    string ans = "";
    rep(i, sz(s))
    {
        ans += char(c + 'A');
        if (s[i] != '?') ans[i] = s[i];
        c = prev[i][c];
    }
    cout << mx << endl << ans << endl;
}

int main()
{
    ios::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}
