#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)
#define rep(i, n) for (int i = 0; i < n; i++)
#define re return
#define pb emplace_back
#define fi first
#define se second

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

void dfs(int u, int p, vector<vector<pair<int, ll>>> &gr, vll &ans)
{
    for (pair<int, ll> e : gr[u])
    {
        int v = e.fi;
        if (v == p) continue;
        ll w = e.se;
        ans[v] = ans[u] + w;
        dfs(v, u, gr, ans);
    }
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, ll>>> gr(n);
    vll ans(n, 0);
    rep(i, m)
    {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        u--; v--;
        gr[u].pb(v, w);
        gr[v].pb(u, w);
    }
    dfs(0, 0, gr, ans);
    for (int i = 1; i < n; i++)
    {
        cout << 2 * ans[i] << endl;
    }
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
