#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


int f(pair<int, int> a, int b) {
    if (a.first == b) {
        return a.second;
    } else {
        return a.first;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> E(m);
    vector<int> T(m);
    for (int i = 0; i < m; ++i) {
        cin >> E[i].first >> E[i].second >> T[i];
        --E[i].first;
        --E[i].second;
    }
    //
    vector<int> X(1 << m);
    for (int mask = 0; mask < (1 << m); ++mask) {
        int mn = inf, mx = 0;
        for (int i = 0; i < mask; ++i) {
            if ((mask >> i) & 1) {
                mn = min(mn, T[i]);
                mx = max(mx, T[i]);
            }
        }
        X[mask] = mn + mx;
    }
    vector<vector<bool>> dp(1 << m, vector<bool>(n, false));
    dp[0][0] = true;
    vector<int> res(n, inf * 2);
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int last = 0; last < n; ++last) {
            for (int i = 0; i < m; ++i) {
                if (((mask >> i) & 1) && (E[i].first == last || E[i].second == last)) {
                    if (dp[mask ^ (1 << i)][f(E[i], last)]) {
                        dp[mask][last] = true;
                        break;
                    }
                }
            }
            //
            if (dp[mask][last]) {
                res[last] = min(res[last], X[mask]);
            }
        }
    }
    //
    for (int v = 1; v < n; ++v) {
        cout << res[v] << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}