//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct edge {
    int u, v, w;
};

bool cmp(edge &a, edge &b) {
    if (a.w < b.w)return true;
    return false;
}

int n, m;
vector<edge> e;

const int maxn = 300000;
vector<int> adj[maxn];
vector<int> ans;
int us[maxn];

void dfs(int v, int mn = 1e9, int mx = 0) {
    us[v] = 1;
    ans[v] = mn + mx;
    for (auto num : adj[v]) {
        edge ed = e[num];
        int to = ed.u + ed.v - v;
        if (us[to] == 0) {
            dfs(to, min(mn, ed.w), max(mx, ed.w));
        }
    }
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    ans.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        adj[u].push_back(size(e));
        adj[v].push_back(size(e));
        e.push_back({u, v, w});
    }
    dfs(0);

    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }

}
