#include <bits/stdc++.h>

#define int long long
#define ll long long
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define x first
#define y second
#define vpi vector <pii>

using namespace std;

const int N = 3e5 + 7, inf = 1e18 + 7, K = 26;

vi v[N];
int d[N], pr[N], t[N], used[N];

vi roots;

map <pii, int> mp;

void dfs(int x, int p) {
    used[x] = 1;
    sort(all(v[x]));
    v[x].erase(unique(all(v[x])), v[x].end());
    if(p != -1) {
        auto it = lower_bound(all(v[x]), p);
        v[x].erase(it);
    }
    pr[x] = p;
    for (auto u : v[x]) {
        d[u] = d[x] + 1;
        dfs(u, x);
    }
}

vector <pair<pii, pii>> ans;

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        mp[{a, b}] = 1;
        v[a].pb(b);
        v[b].pb(a);
    }
    for (int i = 0; i < n; i++) {
        if(!used[i]) {
            roots.pb(i);
            dfs(i, -1);
        }
    }
    vi st(n); iota(all(st), 0);
    sort(all(st), [&] (int i, int j) {
        return d[i] > d[j];
    });
    for (auto x : st) {
        vpi v1, v2;
        for (auto u : v[x]) {
            if(t[u] == 0)
                continue;
            if(t[u] == 1)
                v1.pb({u, x});
            if(t[u] == 2)
                v2.pb({x, u});
        }
        if(pr[x] != -1) {
            int p = pr[x];
            if(mp.count({x, p}))
                v2.pb({x, p});
            if(mp.count({p, x}))
                v1.pb({p, x});
        }
        if(abs((int) v1.size() - (int) v2.size()) > 1) {
            cout << "No";
            return;
        }
        if(v1.size() == v2.size()) {
            t[x] = 0;
            for (int i = 0; i < v1.size(); i++) {
                ans.pb({v1[i], v2[i]});
            }
        }
        if(v1.size() == v2.size() + 1) {
            if(pr[x] == -1 || !mp.count({pr[x], x})) {
                cout << "No";
                return;
            }
            t[x] = 2;
            int j = 0;
            for (int i = 0; i < v1.size(); i++) {
                if(v1[i] == make_pair(pr[x], x))
                    continue;
                ans.pb({v1[i], v2[j]});
                j++;
            }
        }
        if(v1.size() + 1 == v2.size()) {
            if(pr[x] == -1 || !mp.count({x, pr[x]})) {
                cout << "No";
                return;
            }
            t[x] = 1;
            int j = 0;
            for (int i = 0; i < v2.size(); i++) {
                if(v2[i] == make_pair(x, pr[x]))
                    continue;
                ans.pb({v1[i], v2[j]});
                j++;
            }
        }
    }
    for (auto x : roots) {
        if(t[x]) {
            cout << "No";
            return;
        }
    }
    cout << "Yes\n";
    for (auto u : ans)
        cout << u.x.x + 1 << ' ' << u.x.y + 1 << ' ' << u.y.x + 1 << ' ' << u.y.y + 1 << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
