#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::

const int N = 21, INF = 2e9 + 7;

int t[N], res[N],ea[N], eb[N], mx[1 << N], mn[1 << N], dp[1 << N][N];
vector<pair<int, int>> graph[N];
vector<int> masks[N];

void gen(int pos, int n, int cur, int cnt) {
    if (pos == n) {
        masks[cnt].emplace_back(cur);
    }
    else {
        gen(pos + 1, n, cur, cnt);
        gen(pos + 1, n, cur | (1 << pos), cnt + 1);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x; --y;

        t[i] = w;
        ea[i] = x;
        eb[i] = y;
        graph[x].emplace_back(y, i);
        graph[y].emplace_back(x, i);
    }

    for (int msk = 0; msk < (1 << m); ++msk) {
        mn[msk] = INF;
        mx[msk] = -INF;
        for (int i = 0; i < m; ++i) {
            if ((msk >> i) & 1) {
                strain(mx[msk], t[i]);
                relax(mn[msk], t[i]);
            }
        }
    }

    for (int i = 0; i < (1 << m); ++i)
        for (int j = 0; j < n; ++j)
            dp[i][j] = INF;
    for (int i = 0; i < m; ++i) {
        if (ea[i] == 0 || eb[i] == 0) {
            if (ea[i] != 0) swap(ea[i], eb[i]);

            relax(dp[1 << i][eb[i]], 2 * t[i]);
        }
    }

    gen(0, m, 0, 0);
    for (int bc = 0; bc <= m; ++bc) {
        for (int msk : masks[bc]) {
//            err(msk);
            for (int i = 0; i < n; ++i) {
                if (dp[msk][i] == INF) continue;

//                err(msk);
//                err(i);
//                err(dp[msk][i]);
                for (auto [to, ind] : graph[i]) {
                    if (!((msk >> ind) & 1)) {
                        int nmsk = msk | (1 << ind);
                        relax(dp[nmsk][to], mx[nmsk] + mn[nmsk]);
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i)
        res[i] = INF;
    for (int msk = 0; msk < (1 << m); ++msk)
        for (int i = 0; i < n; ++i)
            relax(res[i], dp[msk][i]);
    for (int i = 1; i < n; ++i)
        cout << res[i] << ' ';
    cout << '\n';
}

/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}


