#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>

#pragma warning(disable : 4996)

using itn = int;

using namespace std;

vector <long long> val(26);

string s;

int maxim = 0;

pair <long long, string> maximal(int ind, int maxim) {
	if (ind == s.size()) {
		return { 0, "" };
	}
	if (s[ind] == '?') {
		auto res1 = maximal(ind + 1, maxim);
		res1.first -= val[0];
		res1.second += 'A';
		for (int i = max(maxim, 0); i < 26; ++i) {
			auto res2 = maximal(ind + 1, i);
			res2.first += val[i];
			if (res2.first > res1.first) {
				res1 = res2;
				res1.second += char('A' + i);
			}
		}
		return res1;
	}
	else {
		int ind2 = ind, nmax;
		string sss = "";
		long long ans = 0;
		while (ind2 < s.size() && s[ind2] != '?') {
			int vv = s[ind2] - 'A';
			if (vv < maxim) {
				ans -= val[vv];
			}
			else {
				ans += val[vv];
				maxim = vv;
			}
			sss += s[ind2];
			++ind2;
		}
		auto res1 = maximal(ind2, maxim);
		reverse(sss.begin(), sss.end());
		return { res1.first + ans, res1.second + sss };
	}
}

void solve() {
	cin >> s;
	reverse(s.begin(), s.end());
	auto res = maximal(0, -1);
	cout << res.first << "\n";
	cout << res.second << "\n";
}

int main() {
	val[0] = 1;
	for (int i = 1; i < 26; ++i) {
		if (i % 2 == 1)
			val[i] = val[i - 1] * 5;
		else
			val[i] = val[i - 1] * 2;
	}
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
}