#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <array>

#define ar array
#define int long long

using namespace std;
using ll=long long;
using ld=long double;
const ll inf=4e18;

string s; int n;
vector<int> a;
ar<int,26> b;

void solve() {
	cin >> s; n=s.length();
	a.resize(n);
	for (int i = 0; i < 26; ++i) {
		b[i]=pow(10,i/2);
		if (i%2) b[i]*=5;
	}
	for (int i = 0; i < n; ++i) {
		if (s[i] != '?') a[i]=s[i]-'A';
		else a[i]=-1;
	}
	a.push_back(-1); ++n;
	vector<ar<int,2>> sufm(n+1); sufm[n]={-1,n};
	for (int i = n - 1; i >= 0; --i) {
		if (sufm[i+1][0]<=a[i]) sufm[i]={a[i],i};
		else sufm[i]=sufm[i+1];
	}
	vector<bool> left(n,0);
	int ans=0, pos=0;
	while (pos<n) {
		pos=sufm[pos][1];
		if (a[pos]==-1) break;
		left[pos]=1;
		++pos;
	}
	for (int i = 0; i < n; ++i) {
		if (a[i]==-1) continue;
		if (!left[i]) ans-=b[a[i]];
	}
	vector<vector<ar<int,2>>> dp(n,vector<ar<int,2>>(26,{-inf,-1}));
	int prev=-1;
	vector<int> cnt(26,0);
	for (int i = 0; i < n; ++i) {
		if (a[i] > -1) {
			if (left[i]) ++cnt[a[i]];
			continue;
		}
		int sm=0, prevmax=0, cur0=-1;
		for (int i=0; i<26; ++i) sm-=cnt[i]*b[i];
		for (int cur = 25; cur >= max(0LL,sufm[i][0]); --cur) {
			sm+=cnt[cur]*b[cur]*2;
			if (prev > -1) {
				if (prevmax <= dp[prev][cur][0]) {
					prevmax=dp[prev][cur][0];
					cur0=cur;
				}
			}
			dp[i][cur]={prevmax+sm+b[cur],cur0};
		}
		cnt.assign(26,0);	
		prev=i;
	}
	ans+=dp[n-1][0][0];
	string sans="";
	int cur=0;
	for (int i = n - 1; i >= 0; --i) {
		if (a[i]==-1) {
			sans.push_back(char(static_cast<int>('A')+cur));
			cur=dp[i][cur][1];
		}
		else sans.push_back(char(static_cast<int>('A')+a[i]));
	}
	reverse(sans.begin(),sans.end());
	sans.pop_back();
	cout << ans-1 << "\n" << sans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	cin >> test_case;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}