from sys import setrecursionlimit

setrecursionlimit(3000000)


def num_to_letter(num):
    return chr(ord('A') + num)


def letter_to_num(l):
    return ord(l)-ord('A')


def calculate(word, m):
    s = 0
    for pos, i in enumerate(word):
        if i == '?':
            best = 0
            for i in range(letter_to_num(m) if m != '?' else 0, 26):
                best = max(calculate(word[pos+1:], num_to_letter(i)) + numbers[i], best)

            return s + best
        if i < m:
            s -= numbers[letter_to_num(i)]
        else:
            m = i
            s += numbers[letter_to_num(i)]

    return s

numbers = [1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000,
           100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000,
           1000000000000, 5000000000000]

t = int(input())
for _ in range(t):
    word = input()
    m = word[-1]

    print(calculate(word[::-1], m))

    print(word)

