#pragma comment(linker, "/STACK:10000000000")
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e9;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete (void *) noexcept {}

//#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(x) (x) * (x)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(386493230);

const int maxn = 150010;

unordered_set<int> g[maxn];
unordered_set<int> gt[maxn];
unordered_set<int> g2[maxn];
int n, m;
vc<pair<pi, pi>> ans;

int best = -1;

pair<pi, pi> check(int v) {
    for (auto u : g[v]) {
        for (auto x : g[u]) {
            if (sz(g2[x]) == 1) {
                return {{v, u}, {u, x}};
            }
        }
        if (sz(g[u])) {
            int x = *g[u].begin();
            return {{v, u}, {u, x}};
        }
    }
    return {{-1, -1}, {-1, -1}};
}

pair<pi, pi> checkt(int v) {
    for (auto u : gt[v]) {
        for (auto x : gt[u]) {
            if (sz(g2[x]) == 1) {
                return {{x, u}, {u, v}};
            }
        }
        if (sz(gt[u])) {
            int x = *gt[u].begin();
            return {{x, u}, {u, v}};
        }
    }
    return {{-1, -1}, {-1, -1}};
}
unordered_set<int> can;

void ins(int u, int v) {
    if (g[u].count(v) || g[v].count(u)) {
        g2[u].insert(v);
        g2[v].insert(u);
    } else {
        auto it = g2[u].find(v);
        if (g2[u].end() != it) g2[u].erase(it);
        it = g2[v].find(u);
        if (g2[v].end() != it) g2[v].erase(it);
    }
    if (sz(g2[v]) == 1) can.insert(v);
    if (sz(g2[u]) == 1) can.insert(u);
}

void del(pair<pi, pi> edge) {
    auto [v, u] = edge.x;
    auto [tmp, x] = edge.y;
    auto it = g[v].find(u);
    if (it != g[v].end()) g[v].erase(it);

    it = gt[u].find(v);
    if (it != gt[u].end()) gt[u].erase(it);

    it = g[u].find(x);
    if (it != g[u].end()) g[u].erase(it);

    it = gt[x].find(u);
    if (it != gt[x].end()) gt[x].erase(it);

    ins(u, v);
    ins(u, x);
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].insert(v);
        gt[v].insert(u);
        ins(u, v);
    }
    for (int i = 1; i <= n; i++) {
        if (sz(g2[i]) == 1) {
            can.insert(i);
        }
    }
    for (int it = 0; it < m / 2 && sz(can); it++) {
        best = *can.begin();
        can.erase(can.begin());
        auto res = check(best);
        if (res.x.x != -1) {
            ans.push_back(res);
            del(res);
            continue;
        }
        res = checkt(best);
        if (res.x.x != -1) {
            ans.push_back(res);
            del(res);
            continue;
        }
    }
    if (sz(ans) != m / 2) {
        cout << "No\n";
        return 0;
    }
    cout << "Yes\n";
    for (auto &el : ans) {
        cout << el.x.x << " " << el.x.y << " " << el.y.x << " " << el.y.y << '\n';
    }

    return 0;
}