#include <bits/stdc++.h>

#define sz(s) (int)(s).size()
#define rep(i, n) for (int i = 0; i < n; i++)
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define re return
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef pair <int, int> ii;
typedef vector <ii> vii;

const int N = 5e5 + 5;
const ll INF = 3e18;
const int mod = 1e9 + 7;

mt19937 rnd(165166164);

vii v[N];
int was[N];

int p[N];
vi pts[N];

void Makeset (int n)
{
    rep(i, n) {
        p[i] = i;
        pts[i].pb(i);
    }
}

int Find (int i)
{
    if(p[i] == i) re i;
    re p[i] = Find(p[i]);
}

void Union (int i, int j)
{
    i = Find(i), j = Find(j);
    if(i == j) re;
    if(sz(pts[i]) < sz(pts[j]))
    {
        for (int x : pts[j])
            pts[i].pb(x);
        if(rnd() % 2)
        {
            p[j] = i;
        }
        else
        {
            p[i] = j;
            swap(pts[i], pts[j]);
        }
    }
    else
    {
        for (int x : pts[i])
            pts[j].pb(x);
        if(rnd() % 2)
        {
            p[i] = j;
        }
        else
        {
            p[j] = i;
            swap(pts[i], pts[j]);
        }
    }
}

vector <pair <ii, int> > e;

bool F (pair <ii, int> a, pair <ii, int> b)
{
    re a.se < b.se;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    rep(i, m)
    {
        int l, r, t;
        cin >> l >> r >> t;
        l--; r--;
        v[l].pb(r, t);
        v[r].pb(l, t);
        e.pb(mp(mp(l, r), t));
    }

    sort(all(e), F);
    vi an(n);

    for (auto qq : e)
    {
        int l = qq.fi.fi, r = qq.fi.se, t = qq.se;
        int f = Find(0);

        if(Find(l) == Find(r)) continue;
        if(Find(l) == f)
        {
            for (int x : pts[Find(r)])
                an[x] = t;
        }
        if(Find(r) == f)
        {
            for (int x : pts[Find(l)])
                an[x] = t;
        }
        Union(l, r);
    }
    rep(i, n - 1)
        cout << an[i + 1] << ' ';

}

signed main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int qq = 1;
//    cin >> qq;
    while(qq--)
        solve();
}
//
//3 3
//1 2 2
//1 3 1
//2 3 1

