#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#include <string>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()

typedef long long ll;

ll conv[300];

ll convert(char c) {
	return conv[c];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	conv['A'] = 1;
	rep(i, 25) {
		if (i % 2 == 0) {
			conv[i + 'A' + 1] = 5 * conv[i + 'A'];
		}
		else {
			conv[i + 'A' + 1] = 2 * conv[i + 'A'];
		}
	}
	int q;
	cin >> q;
	for (; q; q--) {
		string s;
		cin >> s;
		int n = sz(s);
		ll best = -1e18;
		string best_ans;
		rep(i, n) {
			rep(c1, 26) {
				rep(c2, 26) {
					string t = s;
					for (int j = i; j < n; j++) {
						if (t[j] == '?') t[j] = c1 + 'A';
					}
					for (int j = 0; j < i; j++) {
						if (t[j] == '?') t[j] = c2 + 'A';
					}

					int mx = 0;
					ll val = 0;
					per(j, sz(t)) {
						if (t[j] >= mx) {
							val += convert(t[j]);
						}
						else {
							val -= convert(t[j]);
						}
						mx = max(mx, (int)t[j]);
					}
					if (val > best) {
						best = val;
						best_ans = t;
					}
				}
			}
		}
		cout << best << "\n";
		cout << best_ans << "\n";
	}

	return 0;
}