#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

const int N = 1000;

int g[N][N];

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    vector<ll> v;
    for (ll x; cin >> x; ) v.push_back(x);
    reverse(v.begin(), v.end());

    int n = 1000;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            g[i][j] = i ^ j;
        }
    }

    for (int k = 0; k < n; ++k) 
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j) {
        g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
    }

    for (ll x : v) cout << x << ' ';
    cout << endl;
}