//#pragma GCC optimize("Ofast")
#pragma GCC target("avx, avx2")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int maxN = 1e3 + 300;
int dist[maxN][maxN];

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    range(i, maxN) {
        range(j, maxN) {
            dist[i][j] = rng() % (int)1e9;
        }
    }
    range(k, maxN) {
        range(i, maxN) {
            range(j, maxN) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    //cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}