#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int md = 1e9 + 123;

inline int mul(const int &a, const int &b) {
    return (1ll * a * b) % md;
}

inline int add(const int &a, const int &b) {
    return a + b >= md ? a + b - md : a + b;
}

inline int sub(const int &a, const int &b) {
    return a - b < 0 ? a - b + md : a - b;
}

const int P = 1337228;

void solve1() {
    string s; cin >> s;
    int h = 0;
    int p = P;
    for(auto &c : s) {
        if (c == '1') h = add(h, p);
        p = mul(p, P);
    }
    range(j, 17) {
        if (h & (1 << j)) {
            s += '1';
        } else {
            s += '0';
        }
    }
    cout << s;
}

void solve2() {
    string y; cin >> y;
    int d = 0;
    int sz = y.size();
    int st2 = 1;
    for(int i = sz - 17; i < sz; ++i) {
        if (y[i] == '1') {
            d += st2;
        }
        st2 *= 2;
    }
    int h = 0;
    int p = P;
    range(i, sz - 17) {
        if (y[i] == '1') h = add(h, p);
        p = mul(p, P);
    }
    auto chk = [&] (int x) {
        return ((1 << 17) - 1) & x;
    };
    p = P;
    range(i, sz - 17) {
        int h2 = h;
        if (y[i] == '1') {
            h2 = sub(h2, p);
        } else {
            h2 = add(h2, p);
        }
        if (chk(h2) == d) {
            if (y[i] == '1') y[i] = '0';
            else y[i] = '1';
            cout << y.substr(0, sz - 17);
            return;
        }
        p = mul(p, P);
    }
    cout << y.substr(0, sz - 17);
}

void solve() {
    int x; cin >> x;
    if (x == 1) solve1();
    else solve2();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}