#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <math.h>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

template <class T>
istream& operator>>(istream& in, vector<T>& a) {
	for (auto& aa : a) {
		in >> aa;
	}
	return in;
}
template <class T>
ostream& operator<<(ostream& out, vector<T>& a) {
	for (auto& aa : a) {
		out << aa << ' ';
	}
	return out;
}

const int N = 1000;

int w[N][N];
void solve() {
	int n = N;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			w[i][j] = w[j][i] = rand() % 100;
		}
	}
	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				w[i][j] = min(w[i][j], w[i][k] + w[k][j]);
			}
		}
	}


	int l, r; l = 1, cin >> r;
	--l, ++r;
	while (r - l > 1) {
		int c = (l + r) / 2;
		cout << c << endl;
		int res; cin >> res;
		if (res == 0) exit(0);
		if (res == 1) l = c;
		else r = c;
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t = 1; //cin >> t;
	while (t--)
		solve();

}