#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#pragma GCC target('sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune="native"')
#define int long long


int mod1 = 8938935483, mod2 = 2301947027;


int mul1(int a, int b) {
    return (a * b) % mod1;
}

int sm1(int a, int b) {
    if (a + b < mod1) return a + b;
    return a + b - mod1;
}

int dif1(int a, int b) {
    if (a >= b) return a - b;
    return a + mod1 - b;
}

int pw1(int a, int k) {
    if (k == 0) return 1;
    if (k % 2) return mul1(pw1(a, k - 1), a);
    return pw1(mul1(a, a), k / 2);
}



int mul2(int a, int b) {
    return (a * b) % mod2;
}

int sm2(int a, int b) {
    if (a + b < mod2) return a + b;
    return a + b - mod2;
}

int dif2(int a, int b) {
    if (a >= b) return a - b;
    return a + mod2 - b;
}

int pw2(int a, int k) {
    if (k == 0) return 1;
    if (k % 2) return mul2(pw2(a, k - 1), a);
    return pw2(mul2(a, a), k / 2);
}


int hsh1(string & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm1(key, pw1(2, i));
        }
    }
    return key;
}

int hsh1(vector<char> & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm1(key, pw1(2, i));
        }
    }
    return key;
}


int hsh2(string & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm2(key, pw2(2, i));
        }
    }
    return key;
}

int hsh2(vector<char> & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm2(key, pw2(2, i));
        }
    }
    return key;
}



int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll x; string s; cin >> x >> s;
    if (s.size() <= 30) {
        // int x; cin >> x;
        if (x == 1) {
            // string s; cin >> s;
            string t;
            for (auto el : s) {
                t += el;
                t += el;
                t += el;
            }
            cout << t << endl;
        } else {
            // string s; cin >> s;
            vector<pair<int, int>> pr{{0, 1}, {0, 2}, {1, 2}};
            for (int i = 0; 3 * i < (int)s.size(); i++) {
                for (auto el : pr) {
                    if (s[3 * i + el.first] == s[3 * i + el.second]) {
                        cout << s[3 * i + el.first];
                        break;
                    }
                }
            }
            cout << endl;
        }
        return 0;
    }
    int endd = 1e5;
    int bit = 40;
    if (x == 1) {
        int n = s.size();
        if (n == endd) {
            int tt1 = hsh1(s);
            int tt2 = hsh2(s);
            cout << s;
            for (int i = 0; i < bit; i++) {
                if (tt1 & (1ll << i)) cout << 1;
                else cout << 0;
            }
            for (int i = 0; i < bit; i++) {
                if (tt1 & (1ll << i)) cout << 1;
                else cout << 0;
            }
            for (int i = 0; i < bit; i++) {
                if (tt1 & (1ll << i)) cout << 1;
                else cout << 0;
            }

            for (int i = 0; i < bit; i++) {
                if (tt2 & (1ll << i)) cout << 1;
                else cout << 0;
            }
            for (int i = 0; i < bit; i++) {
                if (tt2 & (1ll << i)) cout << 1;
                else cout << 0;
            }
            for (int i = 0; i < bit; i++) {
                if (tt2 & (1ll << i)) cout << 1;
                else cout << 0;
            }
            cout << endl;
        }
    } else {
        string t, key;
        for (int i = 0; i < endd; i++) {
            t += s[i];
        }
        ll val = 0;
        ll val1 = 0, val2 = 0, val3 = 0;
        for (int i = 0; i < bit; i++) {
            if (s[endd + i] == '1')
                val1 ^= (1ll << i);
            if (s[endd + bit + i] == '1')
                val2 ^= (1ll << i);
            if (s[endd + 2 * bit + i] == '1')
                val3 ^= (1ll << i);
        }
        ll vval = 0;
        ll vval1 = 0, vval2 = 0, vval3 = 0;
        for (int i = 0; i < bit; i++) {
            if (s[endd + 3 * bit + i] == '1')
                vval1 ^= (1ll << i);
            if (s[endd + 4 * bit + i] == '1')
                vval2 ^= (1ll << i);
            if (s[endd + 5 * bit + i] == '1')
                vval3 ^= (1ll << i);
        }
        if (val1 == val2) val = val1;
        if (val1 == val3) val = val1;
        if (val2 == val3) val = val2;
        if (vval1 == vval2) vval = vval1;
        if (vval1 == vval3) vval = vval1;
        if (vval2 == vval3) vval = vval2;

        vector<char> tt(endd);
        for (int i = 0; i < endd; i++) {
            tt[i] = t[i];
        }
        ll nval1 = hsh1(tt);
        ll nval2 = hsh2(tt);
        if (nval1 == val && nval2 == vval) {
            for (auto el : tt) cout << el;
            cout << endl;
            return 0;
        }
        if (val1 == val2 && val2 == val3 && vval1 == vval2 && vval2 == vval3) {
            for (int i = 0; i < endd; i++) {
                if (tt[i] == '0') {
                    nval1 = sm1(nval1, pw1(2, i));
                    nval2 = sm2(nval2, pw2(2, i));
                    if (nval1 == val && nval2 == vval) {
                        tt[i] == '1';
                        for (auto el : tt) cout << el;
                        cout << endl;
                        return 0;
                    }
                    nval1 = dif1(nval1, pw1(2, i));
                    nval2 = dif2(nval2, pw2(2, i));
                } else {
                    nval1 = dif1(nval1, pw1(2, i));
                    nval2 = dif2(nval2, pw2(2, i));
                    if (nval1 == val && nval2 == vval) {
                        tt[i] = '0';
                        for (auto el : tt) cout << el;
                        cout << endl;
                        return 0;
                    }
                    nval1 = sm1(nval1, pw1(2, i));
                    nval2 = sm2(nval2, pw2(2, i));
                }
            }
        }
        for (auto el : tt) cout << el;
        cout << endl;
    }
    return 0;
}
