#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <string>
#include <queue>
#include <deque>
#include <random>
#include <cassert>
#include <bitset>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve1() {
    string s;
    cin >> s;
    cout << s << s << s << '\n';
}

void solve2() {
    string s;
    cin >> s;
    int n = (int) s.size() / 2;
    string s1, s2, s3;
    for (int i = 0; i < n; ++i) {
        s1.push_back(s.back());
        s.pop_back();
    }
    for (int i = 0; i < n; ++i) {
        s2.push_back(s.back());
        s.pop_back();
    }
    for (int i = 0; i < n; ++i) {
        s3.push_back(s.back());
        s.pop_back();
    }
    if (s1 == s2) {
        reverse(all(s1));
        cout << s1 << '\n';
    } else {
        if (s1 == s3) {
            reverse(all(s1));
            cout << s1 << '\n';
        } else {
            reverse(all(s2));
            cout << s2 << '\n';
        }
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T;
    cin >> T;
    if (T == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}