#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e15;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int mode = 2;
    if (mode == 0) {
        // Floyd-Uorshell
        int sz = 950;
        vector<vector<int>> dp(sz, vector<int>(sz, 1));
        for (int i = 0; i < sz; ++i) {
            for (int j = 0; j < sz; ++j) {
                dp[i][j] = rand();
            }
        }
        for (int k = 0; k < sz; ++k) {
            for (int i = 0; i < sz; ++i) {
                for (int j = 0; j < sz; ++j) {
                    dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][i]);
                }
            }
        }
        // DONE!!!
    } else if (mode == 1) {
        // Dejkstra
        int ans = 0;
        int sz = 7000;
        ans++;
        vector<vector<int>> g(sz);
        ans++;
        for (int i = 0; i < sz; ++i) {
            for (int j = 0; j < sz; ++j) {
                if (rand() % 2) {
                    g[i].push_back(sz);
                    ans++;
                }
            }
        }
        vector<int> dp(sz, inf);
        ans++;
        dp[0] = 0;
        ans++;
        vector<int> us(sz, false);
        ans++;
        while (true) {
            int k = -1;
            ans++;
            int dst = inf;
            ans++;
            for (int i = 0; i < sz; ++i) {
                if (!us[i] && dst > dp[i]) {
                    k = i;
                    ans++;
                    dst = dp[i];
                    ans++;
                }
            }
            if (k == -1) {
                break;
            }
            us[k] = true;
            ans++;
            for (auto j : g[k]) {
                dp[j] = min(dp[k] + 1, dp[j]);
                ans++;
            }
        }
        cout << ans << "\n";
        // DONE!!!
    } else if (mode == 2) {
        // ML
        vector<char> c(600000000);
        // DONE!!!
    }
}
