#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()

const int N = 1000;

void read(int a[N]) {
	string s;
	cin >> s;
	int ptr = 0;
	for (int i = (int)s.size() - 1; i >= 0 && s[i] != '-'; --i) {
		a[ptr++] = s[i] - '0';
	}
	if (s.front() == '-') {
		for (int i = 0; i < N; ++i) {
			a[i] = 9 - a[i];
		}
		++a[0];
		int carry = 0;
		for (int i = 0; i < N; ++i) {
			carry += a[i];
			a[i] = carry % 10;
			carry /= 10;
		}
	}
}

int a[N], b[N];

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	read(a);
	read(b);
	for (int i = 0; i < N; ++i) {
		a[i] += b[i];
	}
	int carry = 0;
	for (int i = 0; i < N; ++i) {
		carry += a[i];
		a[i] = carry % 10;
		carry /= 10;
	}
	string answer;
	if (a[N - 1]) {
		cout << "-";
		for (int i = 0; i < N; ++i) {
			a[i] = 9 - a[i];
		}
		++a[0];
		carry = 0;
		for (int i = 0; i < N; ++i) {
			carry += a[i];
			a[i] = carry % 10;
			carry /= 10;
		}
	}
	for (int i = 0; i < N; ++i) {
		answer += (char)(a[i] + '0');
	}
	while (answer.size() >= 2 && answer.back() == '0') {
		answer.pop_back();
	}
	reverse(all(answer));
	cout << answer << endl;
	return 0;
}