#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree <int, null_type, less <>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int N = 1e5 + 17;

string mm;
int conv[N];
int inv[N];
int ptr = 0;
bool m[N];

void cipher()
{
    cin >> mm;
    int n = mm.size();
    for (int i = 0; i < n; ++i)
        m[i] = (mm[i] - '0');
    for (int i = 0; i < n; ++i)
        if (m[i])
        {
            for (int j = 0; j < 17; ++j)
            {
                if (conv[i] & 1)
                    m[n + j] ^= 1;
                conv[i] >>= 1;
            }
        }
    for (int i = 0; i < n + 17; ++i)
        cout << m[i];
}

void decipher()
{
    cin >> mm;
    int n = (int)mm.size() - 17;
    for (int i = 0; i < n; ++i)
        m[i] = (mm[i] - '0');
    for (int i = 0; i < n; ++i)
        if (m[i])
        {
            int cpy = conv[i];
            for (int j = 0; j < 17; ++j)
            {
                if (cpy & 1)
                    m[n + j] ^= 1;
                cpy >>= 1;
            }
        }
    vector <int> differs;
    for (int i = 0; i < 17; ++i)
        if ((mm[n + i] - '0') != m[n + i])
            differs.push_back(i);
    if (differs.size() > 1)
    {
        int msk = 0;
        for (int el : differs)
            msk |= 1 << el;
        m[inv[msk]] ^= 1;
    }
    for (int i = 0; i < n; ++i)
        cout << m[i];
}

int32_t main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int type;
    cin >> type;
    for (int mask = 3; ptr < 100000; ++mask)
        if (__builtin_popcount(mask) > 1)
        {
            inv[mask] = ptr;
            conv[ptr++] = mask;
        }
    if (type == 1)
        cipher();
    else
        decipher();

    return 0;
}