#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &p) {
    is >> p.first >> p.second;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
    return os;
}

template<typename T>
ostream &operator<<(ostream &os, pair<T, T> &p) {
    os << p.first << ' ' << p.second;
    return os;
}

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define vi vector<int>
#define pi pair<int, int>
#define vpi vector<pair<int, int>>

typedef long long ll;

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

#define int ll

void Solve() {
    int n;
    cin >> n;
    int l = 1, r = n + 1;
    while (r - l > 1) {
        int x = (l + r) / 2;
        cout << x << endl;
        int ans;
        cin >> ans;
        if (ans == 0) {
            exit(0);
        }
        if (ans == 1) {
            l = x + 1;
        } else {
            r = x;
        }
    }
    cout << l << endl;
}

signed main() {
//    IO();
    int t = 1;
//    cin >> t;
    for (int ii = 0; ii < t; ii++) {
        Solve();
    }
    return 0;
}