#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <ctime>
#include <vector>
#include <chrono>

using namespace std;

typedef long long ll;
typedef long double ld;

// GNU C++ : N = 1040 ~ 1.1e9
// MinGW GNU C++ : N = 1040 ~ 1.1e9
// Visual C++ : N = 1070 ~ 1.2e9
// local DEBUG: N = 350 ~4e7
// local RELEASE: N = 1050 on second time. First time is N ~= 900

void Guess1() {
	string s;
	cin >> s;
	cout << s + s + s;
}

void Guess2() {
	string q;
	cin >> q;
	for (int i = 0; 3 * i < q.size(); i++) {
		int zc = 0;
		if (q[i] == '0') zc++;
		if (q[i + q.size() / 3] == '0') zc++;
		if (q[i + 2 * q.size() / 3] == '0') zc++;
		if (zc > 1) cout << "0";
		else cout << 1;
	}
}

int main() {
	int type;
	cin >> type;
	if (type == 1)
		Guess1();
	else Guess2();
}