#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <random>
#include <chrono>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;

mt19937 rnd(123);

int main() {
    int n = 500;
    vvi mat(n, vi(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            mat[i][j] = rnd();
        }
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                mat[i][j] = min(mat[i][j], mat[i][k] + mat[k][j]);
            }
        }
    }
    cout << clock();
    return 0;
}