#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<list>
#include<cmath>
#include<algorithm>
using namespace std;

int N = (1 << 17), m = 17;

void code()
{
	string s; cin >> s;

	if (s.size() == 10)
	{
		cout << s << s << s << '\n';
		return;
	}

	string ans = s;
	s.resize(N, '0');

	for (int i = 0; i < m - 1; ++i)
		for (int j = 0; j < N; j += (1 << (m - i)))
		{
			int t = 0;
			for (int k = j; k < j + (1 << (m - i - 1)); ++k)
				t ^= (s[k] - '0');

			ans += (t + '0');
		}

	int t = 0;
	for (int i = 1; i < N; i += 2)
		t ^= (s[i] - '0');
	ans += (t + '0');


	cout << ans;
}

void decode()
{
	string s; cin >> s;

	if (s.size() == 30)
	{
		int n = s.size() / 3;
		for (int i = 0; i < n; ++i)
		{
			vector<char> t{ s[i], s[i + n], s[i + n + n] };
			sort(t.begin(), t.end());
			cout << t[1];
		}
		cout << '\n';
	}

	string ans = s.substr(0, 100000);
}

int main()
{
	int h; cin >> h;
	if (h == 1)
	{
		code();
	}
	if (h == 2)
	{
		decode();
	}

	return 0;
}