#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

// :::::::::::::::::::::::::::::::::::

const int MOD = 1048573, B = 19, BASE = 13;
// 131071

int add(int a, int b) {
    a += b;
    if (a >= MOD)
        a -= MOD;
    if (a < 0)
        a += MOD;
    return a;
}

int mul(int a, int b) {
    return (1LL * a * b) % MOD;
}

void solve() {
//    for (int i = MOD; i >= 0; --i) {
//        int pr = 1;
//        for (ll d = 2; d * d <= i; ++d)
//            if (i % d == 0) pr = 0;
//        if (pr) {
//            cout << i << endl;
//            return;
//        }
//    }
//    return;
    int type;
    cin >> type;

    if (type == 1) {
        string s;
        cin >> s;

        int hsh = 0, pw = 1;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1')
                hsh = add(hsh, pw);
            pw = mul(pw, BASE);
        }
        int cnt = count(s.begin(), s.end(), '1');
        if (cnt % 2 == 0)
            s += '0';
        else
            s += '1';

        s += bitset<B>(hsh).to_string();
        cout << s << '\n';
    }
    else {
        string temp;
        cin >> temp;

        string shsh(temp.end() - B, temp.end());
        string spar(temp.begin(), temp.end() - B);
        int cnt = count(spar.begin(), spar.end(), '1');
        if (cnt % 2 == 0) {
            spar.pop_back();
            cout << spar << '\n';
        }
        else {
            spar.pop_back();
            reverse(shsh.begin(), shsh.end());
            int hsh = 0;
            for (int i = 0; i < shsh.size(); ++i)
                if (shsh[i] == '1')
                    hsh += 1 << i;

            int cur = 0, pw = 1;
            for (int i = 0; i < spar.size(); ++i) {
                if (spar[i] == '1')
                    cur = add(cur, pw);
                pw = mul(pw, BASE);
            }

//            cout << hsh << endl;
//            cout << cur << endl;
            if (cur == hsh) {
                cout << spar << '\n';
                return;
            }

            pw = 1;
            for (int i = 0; i < spar.size(); ++i) {
                int ncur = cur;
                if (spar[i] == '1')
                    ncur = add(ncur, -pw);
                else
                    ncur = add(ncur, pw);

                if (ncur == hsh) {
                    spar[i] = '0' + '1' - spar[i];
                    cout << spar << '\n';
                    return;
                }
                pw = mul(pw, BASE);
            }
        }
    }
    // 10110000000000000001
    // 10000000000000000001
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}
