#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) begin(x), end(x)
typedef long long ll;

random_device rd;
mt19937 rnd(rd());

int K = 17;

string into2(int x) {
    string res;
    while (x) {
        res += '0' + (x & 1);
        x >>= 1;
    }
    while (res.size() < K) {
        res += '0';
    }
    return res;
}

int from2(string s) {
    int res = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '1') {
            res |= 1 << i;
        }
    }
    return res;
}

signed main() {
    int t;
    cin >> t;
    if (t == 1) {
        string s;
        cin >> s;
        if (s.size() <= 10) {
            K = 4;
        }
        int n = s.size();
        int res = 0;
        for (int i = 0; i < n; i++) {
            if (s[i] == '1') {
                res ^= (i + 1);
            }
        }
        cout << s << into2(res) << into2(res) << endl;
    } else {
        string s;
        cin >> s;
        if (s.size() <= 18) {
            K = 4;
        }
        int n = s.size() - K;
        int x = 0;
        for (int i = 0; i < n; i++) {
            if (s[i] == '1') {
                x ^= (i + 1);
            }
        }
        int x1 = from2(s.substr(n, K));
        int k = x ^ x1;
        if (x == x1) {
            cout << s.substr(0, n) << endl;
        }
        if (k <= n) {
            if (s[k - 1] == '0') {
                s[k - 1] = '1';
            } else {
                s[k - 1] = '0';
            }
            cout << s.substr(0, n) << endl;
        } else {
            cout << s.substr(0, n) << endl;
        }
    }
}