#include <bits/stdc++.h>

#define int long long
#define double long double
#define endl "\n"

using namespace std;

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

string to2(int n) {
    if (n == 0) {
        return "0";
    }
    string res;

    while (n > 0) {
        res += to_string(n % 2);
        n /= 2;
    }
    reverse(res.begin(), res.end());

    return res;
}

int vmod(int v, int mod) {
    return (v % mod + mod) % mod;
}

void solve() {
    int k;
    cin >> k;
    const int mod = 131071;
    const int pmm = 17;
    if (k == 1) {
        int sum = 0;
        string x;
        cin >> x;

        if (x.size() == 10) {
            cout << x + x + x << endl;
            return;
        }

        for (char ch : x) {
            sum = sum * pmm + (ch - '0' + 1);
            sum %= mod;
        }
        string m2 = to2(sum);
        while (m2.size() < 17) {
            m2 = "0" + m2;
        }
        cout << x.substr(0, 11563) << m2 << x.substr(11563) << endl;
    } else {
        string x;
        cin >> x;
        if (x.size() == 30) {
            int n = x.size();
            string a = x.substr(0, n / 3);
            string b = x.substr(n / 3, n / 3);
            string c = x.substr(2 * n / 3, n / 3);
            if (a == b || a == c) {
                cout << a << endl;
            } else {
                cout << b << endl;
            }
            return;
        }
        string m2 = x.substr(11563, 17);
        x = x.substr(0, 11563) + x.substr(11563 + 17);

        int sum = 0;
        for (char ch : x) {
            sum = sum * pmm + (ch - '0' + 1);
            sum %= mod;
        }

        int msum = 0;
        for (char ch : m2) {
            msum = msum * 2 + (ch - '0');
        }

        if (sum == msum) {
            cout << x << endl;
            throw "asdsad";
            return;
        }

        int p = 1;
        for (int i = (int) x.size() - 1; i >= 0; i--) {
            if (x[i] == '1') {
                if (msum == vmod(sum - p, mod)) {
                    x[i] = '0';
                    cout << x << endl;
                    return;
                }
            } else {
                if (msum == vmod(sum + p, mod)) {
                    x[i] = '1';
                    cout << x << endl;
                    return;
                }
            }
            p = (p * pmm) % mod;
        }
    }
}

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}
