#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx2")
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstdio>
#include <set>
#include <map>
#include <random>
#include <vector>
using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = (n-1); i >= 0; i--) 
#define mp make_pair
#define each(x, a) for (auto x : a)
#define debug(x) { cerr << #x << " = " << x << endl; }
#define pb push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef vector<int > vi;
typedef pair<int, int> pii;
typedef set<int> si;
typedef vector<pii> vpii;
typedef  vector<ll> vll;
typedef pair<ll, ll> pll;

mt19937 rng(201108);
const int n = 100000;
const int add = 17;
const int from = 75355;

namespace Solution {

	void first_sovle(string x) {
		cout << x + x + x << endl;
	}

	void second_solve(string y) {
		int nn = sz(y) / 3;
		rep(i, nn) {
			map<char, int> cnt;
			cnt[y[i]]++;
			cnt[y[i + nn]]++;
			cnt[y[i + nn + nn]]++;
			if (cnt['0'] >= 2) {
				cout << '0';
			}
			else {
				cout << '1';
			}
		}
		cout << endl;
	}
	void solve_stupid(int t, string x) {
		if (t == 1) {
			first_sovle(x);
		}
		else {
			second_solve(x);
		}
	}


	void solve_clever(int t, string x) {
		if (t == 1) {
			vi b(add);
			rep(i, n) {
				if (x[i] == '1') {
					for (int bit = 0; bit < add; bit++) {
						if ((i + 1) & (1 << bit)) {
							b[bit]++;
						}
					}
				}
			}
			rep(bit, add) {
				b[bit] %= 2;
			}
			string conv;
			rep(i, add) {
				conv.pb(b[i] + '0');
			}
			string y = x.substr(0, from) + conv + x.substr(from, sz(x) - from);
			cout << y << endl;
		}
		else {
			string conv = x.substr(from, add);
			x = x.substr(0, from) + x.substr(from + add, sz(x) - (from + add));
			vi b(add);
			rep(i, add) b[i] = conv[i] - '0';
			rep(i, n) {
				if (x[i] == '1') {
					for (int bit = 0; bit < add; bit++) {
						if ((i + 1) & (1 << bit)) {
							b[bit]++;
						}
					}
				}
			}
			rep(i, add) b[i] %= 2;
			
			int ch = -1;
			rep(i, add) if (b[i]) ch += (1 << i);
			if (ch != -1) {
				x[ch] = (x[ch] - '0' + 1) % 2 + '0';
			}
			cout << x << endl;
		}
	}



	void solve() {
		int t;
		string x;
		cin >> t >> x;
		if (sz(x) <= 30) {
			solve_stupid(t, x);
		}
		else {
			solve_clever(t, x);
		}
	}
}
//
//string gen() {
//	string x;
//	for (int i = 0; i < n; i++) {
//		x.pb(rand() % 2 + '0');
//	}
//	return x;
//}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//freopen("output.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	Solution::solve();
	
	//cout << gen();
	return 0;
}